  

Require Import Cabs.
Require Import List.



Require Import List.
Require Import Int31.
Require Import Syntax.
Require Import Tuples.
Require Import Alphabet.
Require Grammar.
Require Automaton.

Unset Elimination Schemes.

Module Import Gram <: Grammar.T.

Inductive terminal' : Set :=
  | ADD_ASSIGN't
  | ALIGNAS't
  | ALIGNOF't
  | AND't
  | ANDAND't
  | AND_ASSIGN't
  | ASM't
  | ATTRIBUTE't
  | AUTO't
  | BANG't
  | BAR't
  | BARBAR't
  | BREAK't
  | BUILTIN_VA_ARG't
  | CASE't
  | CHAR't
  | COLON't
  | COMMA't
  | CONST't
  | CONSTANT't
  | CONTINUE't
  | DEC't
  | DEFAULT't
  | DIV_ASSIGN't
  | DO't
  | DOT't
  | DOUBLE't
  | ELLIPSIS't
  | ELSE't
  | ENUM't
  | EOF't
  | EQ't
  | EQEQ't
  | EXTERN't
  | FLOAT't
  | FOR't
  | GEQ't
  | GOTO't
  | GT't
  | HAT't
  | IF't
  | INC't
  | INLINE't
  | INT't
  | LBRACE't
  | LBRACK't
  | LEFT't
  | LEFT_ASSIGN't
  | LEQ't
  | LONG't
  | LPAREN't
  | LT't
  | MINUS't
  | MOD_ASSIGN't
  | MUL_ASSIGN't
  | NEQ't
  | OR_ASSIGN't
  | OTHER_NAME't
  | PACKED't
  | PERCENT't
  | PLUS't
  | PRAGMA't
  | PTR't
  | QUESTION't
  | RBRACE't
  | RBRACK't
  | REGISTER't
  | RESTRICT't
  | RETURN't
  | RIGHT't
  | RIGHT_ASSIGN't
  | RPAREN't
  | SEMICOLON't
  | SHORT't
  | SIGNED't
  | SIZEOF't
  | SLASH't
  | STAR't
  | STATIC't
  | STRING_LITERAL't
  | STRUCT't
  | SUB_ASSIGN't
  | SWITCH't
  | TILDE't
  | TYPEDEF't
  | TYPEDEF_NAME't
  | UNDERSCORE_BOOL't
  | UNION't
  | UNSIGNED't
  | VAR_NAME't
  | VOID't
  | VOLATILE't
  | WHILE't
  | XOR_ASSIGN't.
Definition terminal := terminal'.

Program Instance terminalNum : Numbered terminal :=
  { inj := fun x => match x return _ with | ADD_ASSIGN't => Int31.On | ALIGNAS't => Int31.In | ALIGNOF't => (twice Int31.In) | AND't => (twice_plus_one Int31.In) | ANDAND't => (twice (twice Int31.In)) | AND_ASSIGN't => (twice_plus_one (twice Int31.In)) | ASM't => (twice (twice_plus_one Int31.In)) | ATTRIBUTE't => (twice_plus_one (twice_plus_one Int31.In)) | AUTO't => (twice (twice (twice Int31.In))) | BANG't => (twice_plus_one (twice (twice Int31.In))) | BAR't => (twice (twice_plus_one (twice Int31.In))) | BARBAR't => (twice_plus_one (twice_plus_one (twice Int31.In))) | BREAK't => (twice (twice (twice_plus_one Int31.In))) | BUILTIN_VA_ARG't => (twice_plus_one (twice (twice_plus_one Int31.In))) | CASE't => (twice (twice_plus_one (twice_plus_one Int31.In))) | CHAR't => (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))) | COLON't => (twice (twice (twice (twice Int31.In)))) | COMMA't => (twice_plus_one (twice (twice (twice Int31.In)))) | CONST't => (twice (twice_plus_one (twice (twice Int31.In)))) | CONSTANT't => (twice_plus_one (twice_plus_one (twice (twice Int31.In)))) | CONTINUE't => (twice (twice (twice_plus_one (twice Int31.In)))) | DEC't => (twice_plus_one (twice (twice_plus_one (twice Int31.In)))) | DEFAULT't => (twice (twice_plus_one (twice_plus_one (twice Int31.In)))) | DIV_ASSIGN't => (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))) | DO't => (twice (twice (twice (twice_plus_one Int31.In)))) | DOT't => (twice_plus_one (twice (twice (twice_plus_one Int31.In)))) | DOUBLE't => (twice (twice_plus_one (twice (twice_plus_one Int31.In)))) | ELLIPSIS't => (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))) | ELSE't => (twice (twice (twice_plus_one (twice_plus_one Int31.In)))) | ENUM't => (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))) | EOF't => (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | EQ't => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | EQEQ't => (twice (twice (twice (twice (twice Int31.In))))) | EXTERN't => (twice_plus_one (twice (twice (twice (twice Int31.In))))) | FLOAT't => (twice (twice_plus_one (twice (twice (twice Int31.In))))) | FOR't => (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))) | GEQ't => (twice (twice (twice_plus_one (twice (twice Int31.In))))) | GOTO't => (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))) | GT't => (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | HAT't => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | IF't => (twice (twice (twice (twice_plus_one (twice Int31.In))))) | INC't => (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))) | INLINE't => (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | INT't => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | LBRACE't => (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | LBRACK't => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | LEFT't => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | LEFT_ASSIGN't => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | LEQ't => (twice (twice (twice (twice (twice_plus_one Int31.In))))) | LONG't => (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))) | LPAREN't => (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | LT't => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | MINUS't => (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | MOD_ASSIGN't => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | MUL_ASSIGN't => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | NEQ't => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | OR_ASSIGN't => (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | OTHER_NAME't => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | PACKED't => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | PERCENT't => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | PLUS't => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | PRAGMA't => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | PTR't => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | QUESTION't => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | RBRACE't => (twice (twice (twice (twice (twice (twice Int31.In)))))) | RBRACK't => (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))) | REGISTER't => (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | RESTRICT't => (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | RETURN't => (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | RIGHT't => (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | RIGHT_ASSIGN't => (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | RPAREN't => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | SEMICOLON't => (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | SHORT't => (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | SIGNED't => (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | SIZEOF't => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | SLASH't => (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | STAR't => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | STATIC't => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | STRING_LITERAL't => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | STRUCT't => (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | SUB_ASSIGN't => (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | SWITCH't => (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | TILDE't => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | TYPEDEF't => (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | TYPEDEF_NAME't => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | UNDERSCORE_BOOL't => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | UNION't => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | UNSIGNED't => (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | VAR_NAME't => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | VOID't => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | VOLATILE't => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | WHILE't => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | XOR_ASSIGN't => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) end;
    surj := (fun n => match n return _ with | 0 => ADD_ASSIGN't | 1 => ALIGNAS't | 2 => ALIGNOF't | 3 => AND't | 4 => ANDAND't | 5 => AND_ASSIGN't | 6 => ASM't | 7 => ATTRIBUTE't | 8 => AUTO't | 9 => BANG't | 10 => BAR't | 11 => BARBAR't | 12 => BREAK't | 13 => BUILTIN_VA_ARG't | 14 => CASE't | 15 => CHAR't | 16 => COLON't | 17 => COMMA't | 18 => CONST't | 19 => CONSTANT't | 20 => CONTINUE't | 21 => DEC't | 22 => DEFAULT't | 23 => DIV_ASSIGN't | 24 => DO't | 25 => DOT't | 26 => DOUBLE't | 27 => ELLIPSIS't | 28 => ELSE't | 29 => ENUM't | 30 => EOF't | 31 => EQ't | 32 => EQEQ't | 33 => EXTERN't | 34 => FLOAT't | 35 => FOR't | 36 => GEQ't | 37 => GOTO't | 38 => GT't | 39 => HAT't | 40 => IF't | 41 => INC't | 42 => INLINE't | 43 => INT't | 44 => LBRACE't | 45 => LBRACK't | 46 => LEFT't | 47 => LEFT_ASSIGN't | 48 => LEQ't | 49 => LONG't | 50 => LPAREN't | 51 => LT't | 52 => MINUS't | 53 => MOD_ASSIGN't | 54 => MUL_ASSIGN't | 55 => NEQ't | 56 => OR_ASSIGN't | 57 => OTHER_NAME't | 58 => PACKED't | 59 => PERCENT't | 60 => PLUS't | 61 => PRAGMA't | 62 => PTR't | 63 => QUESTION't | 64 => RBRACE't | 65 => RBRACK't | 66 => REGISTER't | 67 => RESTRICT't | 68 => RETURN't | 69 => RIGHT't | 70 => RIGHT_ASSIGN't | 71 => RPAREN't | 72 => SEMICOLON't | 73 => SHORT't | 74 => SIGNED't | 75 => SIZEOF't | 76 => SLASH't | 77 => STAR't | 78 => STATIC't | 79 => STRING_LITERAL't | 80 => STRUCT't | 81 => SUB_ASSIGN't | 82 => SWITCH't | 83 => TILDE't | 84 => TYPEDEF't | 85 => TYPEDEF_NAME't | 86 => UNDERSCORE_BOOL't | 87 => UNION't | 88 => UNSIGNED't | 89 => VAR_NAME't | 90 => VOID't | 91 => VOLATILE't | 92 => WHILE't | 93 => XOR_ASSIGN't | _ => ADD_ASSIGN't end)%int31;
  inj_bound := 94%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance TerminalAlph : Alphabet terminal := _.

Inductive nonterminal' : Set :=
  | AND_expression'nt
  | abstract_declarator'nt
  | additive_expression'nt
  | argument_expression_list'nt
  | asm_statement'nt
  | assignment_expression'nt
  | assignment_operator'nt
  | attribute_specifier'nt
  | attribute_specifier_list'nt
  | block_item'nt
  | block_item_list'nt
  | c_initializer'nt
  | cast_expression'nt
  | compound_statement'nt
  | conditional_expression'nt
  | constant_expression'nt
  | declaration'nt
  | declaration_list'nt
  | declaration_specifiers'nt
  | declarator'nt
  | designation'nt
  | designator'nt
  | designator_list'nt
  | direct_abstract_declarator'nt
  | direct_declarator'nt
  | direct_old_function_declarator'nt
  | enum_specifier'nt
  | enumeration_constant'nt
  | enumerator'nt
  | enumerator_list'nt
  | equality_expression'nt
  | exclusive_OR_expression'nt
  | expression'nt
  | expression_statement'nt
  | external_declaration'nt
  | function_definition'nt
  | function_specifier'nt
  | gcc_attribute'nt
  | gcc_attribute_list'nt
  | gcc_attribute_word'nt
  | identifier_list'nt
  | inclusive_OR_expression'nt
  | init_declarator'nt
  | init_declarator_list'nt
  | initializer_list'nt
  | iteration_statement_statement_dangerous_'nt
  | iteration_statement_statement_safe_'nt
  | jump_statement'nt
  | labeled_statement_statement_dangerous_'nt
  | labeled_statement_statement_safe_'nt
  | logical_AND_expression'nt
  | logical_OR_expression'nt
  | multiplicative_expression'nt
  | old_function_declarator'nt
  | parameter_declaration'nt
  | parameter_list'nt
  | parameter_type_list'nt
  | pointer'nt
  | postfix_expression'nt
  | primary_expression'nt
  | relational_expression'nt
  | selection_statement_dangerous'nt
  | selection_statement_safe'nt
  | shift_expression'nt
  | specifier_qualifier_list'nt
  | statement_dangerous'nt
  | statement_safe'nt
  | storage_class_specifier'nt
  | struct_declaration'nt
  | struct_declaration_list'nt
  | struct_declarator'nt
  | struct_declarator_list'nt
  | struct_or_union'nt
  | struct_or_union_specifier'nt
  | translation_unit'nt
  | translation_unit_file'nt
  | type_name'nt
  | type_qualifier'nt
  | type_qualifier_list'nt
  | type_specifier'nt
  | unary_expression'nt
  | unary_operator'nt.
Definition nonterminal := nonterminal'.

Program Instance nonterminalNum : Numbered nonterminal :=
  { inj := fun x => match x return _ with | AND_expression'nt => Int31.On | abstract_declarator'nt => Int31.In | additive_expression'nt => (twice Int31.In) | argument_expression_list'nt => (twice_plus_one Int31.In) | asm_statement'nt => (twice (twice Int31.In)) | assignment_expression'nt => (twice_plus_one (twice Int31.In)) | assignment_operator'nt => (twice (twice_plus_one Int31.In)) | attribute_specifier'nt => (twice_plus_one (twice_plus_one Int31.In)) | attribute_specifier_list'nt => (twice (twice (twice Int31.In))) | block_item'nt => (twice_plus_one (twice (twice Int31.In))) | block_item_list'nt => (twice (twice_plus_one (twice Int31.In))) | c_initializer'nt => (twice_plus_one (twice_plus_one (twice Int31.In))) | cast_expression'nt => (twice (twice (twice_plus_one Int31.In))) | compound_statement'nt => (twice_plus_one (twice (twice_plus_one Int31.In))) | conditional_expression'nt => (twice (twice_plus_one (twice_plus_one Int31.In))) | constant_expression'nt => (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))) | declaration'nt => (twice (twice (twice (twice Int31.In)))) | declaration_list'nt => (twice_plus_one (twice (twice (twice Int31.In)))) | declaration_specifiers'nt => (twice (twice_plus_one (twice (twice Int31.In)))) | declarator'nt => (twice_plus_one (twice_plus_one (twice (twice Int31.In)))) | designation'nt => (twice (twice (twice_plus_one (twice Int31.In)))) | designator'nt => (twice_plus_one (twice (twice_plus_one (twice Int31.In)))) | designator_list'nt => (twice (twice_plus_one (twice_plus_one (twice Int31.In)))) | direct_abstract_declarator'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))) | direct_declarator'nt => (twice (twice (twice (twice_plus_one Int31.In)))) | direct_old_function_declarator'nt => (twice_plus_one (twice (twice (twice_plus_one Int31.In)))) | enum_specifier'nt => (twice (twice_plus_one (twice (twice_plus_one Int31.In)))) | enumeration_constant'nt => (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))) | enumerator'nt => (twice (twice (twice_plus_one (twice_plus_one Int31.In)))) | enumerator_list'nt => (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))) | equality_expression'nt => (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | exclusive_OR_expression'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | expression'nt => (twice (twice (twice (twice (twice Int31.In))))) | expression_statement'nt => (twice_plus_one (twice (twice (twice (twice Int31.In))))) | external_declaration'nt => (twice (twice_plus_one (twice (twice (twice Int31.In))))) | function_definition'nt => (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))) | function_specifier'nt => (twice (twice (twice_plus_one (twice (twice Int31.In))))) | gcc_attribute'nt => (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))) | gcc_attribute_list'nt => (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | gcc_attribute_word'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | identifier_list'nt => (twice (twice (twice (twice_plus_one (twice Int31.In))))) | inclusive_OR_expression'nt => (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))) | init_declarator'nt => (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | init_declarator_list'nt => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | initializer_list'nt => (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | iteration_statement_statement_dangerous_'nt => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | iteration_statement_statement_safe_'nt => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | jump_statement'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | labeled_statement_statement_dangerous_'nt => (twice (twice (twice (twice (twice_plus_one Int31.In))))) | labeled_statement_statement_safe_'nt => (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))) | logical_AND_expression'nt => (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | logical_OR_expression'nt => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | multiplicative_expression'nt => (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | old_function_declarator'nt => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | parameter_declaration'nt => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | parameter_list'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | parameter_type_list'nt => (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | pointer'nt => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | postfix_expression'nt => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | primary_expression'nt => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | relational_expression'nt => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | selection_statement_dangerous'nt => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | selection_statement_safe'nt => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | shift_expression'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | specifier_qualifier_list'nt => (twice (twice (twice (twice (twice (twice Int31.In)))))) | statement_dangerous'nt => (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))) | statement_safe'nt => (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | storage_class_specifier'nt => (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | struct_declaration'nt => (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | struct_declaration_list'nt => (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | struct_declarator'nt => (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | struct_declarator_list'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | struct_or_union'nt => (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | struct_or_union_specifier'nt => (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | translation_unit'nt => (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | translation_unit_file'nt => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | type_name'nt => (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | type_qualifier'nt => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | type_qualifier_list'nt => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | type_specifier'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | unary_expression'nt => (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | unary_operator'nt => (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))) end;
    surj := (fun n => match n return _ with | 0 => AND_expression'nt | 1 => abstract_declarator'nt | 2 => additive_expression'nt | 3 => argument_expression_list'nt | 4 => asm_statement'nt | 5 => assignment_expression'nt | 6 => assignment_operator'nt | 7 => attribute_specifier'nt | 8 => attribute_specifier_list'nt | 9 => block_item'nt | 10 => block_item_list'nt | 11 => c_initializer'nt | 12 => cast_expression'nt | 13 => compound_statement'nt | 14 => conditional_expression'nt | 15 => constant_expression'nt | 16 => declaration'nt | 17 => declaration_list'nt | 18 => declaration_specifiers'nt | 19 => declarator'nt | 20 => designation'nt | 21 => designator'nt | 22 => designator_list'nt | 23 => direct_abstract_declarator'nt | 24 => direct_declarator'nt | 25 => direct_old_function_declarator'nt | 26 => enum_specifier'nt | 27 => enumeration_constant'nt | 28 => enumerator'nt | 29 => enumerator_list'nt | 30 => equality_expression'nt | 31 => exclusive_OR_expression'nt | 32 => expression'nt | 33 => expression_statement'nt | 34 => external_declaration'nt | 35 => function_definition'nt | 36 => function_specifier'nt | 37 => gcc_attribute'nt | 38 => gcc_attribute_list'nt | 39 => gcc_attribute_word'nt | 40 => identifier_list'nt | 41 => inclusive_OR_expression'nt | 42 => init_declarator'nt | 43 => init_declarator_list'nt | 44 => initializer_list'nt | 45 => iteration_statement_statement_dangerous_'nt | 46 => iteration_statement_statement_safe_'nt | 47 => jump_statement'nt | 48 => labeled_statement_statement_dangerous_'nt | 49 => labeled_statement_statement_safe_'nt | 50 => logical_AND_expression'nt | 51 => logical_OR_expression'nt | 52 => multiplicative_expression'nt | 53 => old_function_declarator'nt | 54 => parameter_declaration'nt | 55 => parameter_list'nt | 56 => parameter_type_list'nt | 57 => pointer'nt | 58 => postfix_expression'nt | 59 => primary_expression'nt | 60 => relational_expression'nt | 61 => selection_statement_dangerous'nt | 62 => selection_statement_safe'nt | 63 => shift_expression'nt | 64 => specifier_qualifier_list'nt | 65 => statement_dangerous'nt | 66 => statement_safe'nt | 67 => storage_class_specifier'nt | 68 => struct_declaration'nt | 69 => struct_declaration_list'nt | 70 => struct_declarator'nt | 71 => struct_declarator_list'nt | 72 => struct_or_union'nt | 73 => struct_or_union_specifier'nt | 74 => translation_unit'nt | 75 => translation_unit_file'nt | 76 => type_name'nt | 77 => type_qualifier'nt | 78 => type_qualifier_list'nt | 79 => type_specifier'nt | 80 => unary_expression'nt | 81 => unary_operator'nt | _ => AND_expression'nt end)%int31;
  inj_bound := 82%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance NonTerminalAlph : Alphabet nonterminal := _.

Include Grammar.Symbol.

Definition terminal_semantic_type (t:terminal) : Type:=
  match t with
    | XOR_ASSIGN't =>       (cabsloc)%type
    | WHILE't =>       (cabsloc)%type
    | VOLATILE't =>       (cabsloc)%type
    | VOID't =>       (cabsloc)%type
    | VAR_NAME't =>       (string * cabsloc)%type
    | UNSIGNED't =>       (cabsloc)%type
    | UNION't =>       (cabsloc)%type
    | UNDERSCORE_BOOL't =>       (cabsloc)%type
    | TYPEDEF_NAME't =>       (string * cabsloc)%type
    | TYPEDEF't =>       (cabsloc)%type
    | TILDE't =>       (cabsloc)%type
    | SWITCH't =>       (cabsloc)%type
    | SUB_ASSIGN't =>       (cabsloc)%type
    | STRUCT't =>       (cabsloc)%type
    | STRING_LITERAL't =>       (bool * list char_code * cabsloc)%type
    | STATIC't =>       (cabsloc)%type
    | STAR't =>       (cabsloc)%type
    | SLASH't =>       (cabsloc)%type
    | SIZEOF't =>       (cabsloc)%type
    | SIGNED't =>       (cabsloc)%type
    | SHORT't =>       (cabsloc)%type
    | SEMICOLON't =>       (cabsloc)%type
    | RPAREN't =>       (cabsloc)%type
    | RIGHT_ASSIGN't =>       (cabsloc)%type
    | RIGHT't =>       (cabsloc)%type
    | RETURN't =>       (cabsloc)%type
    | RESTRICT't =>       (cabsloc)%type
    | REGISTER't =>       (cabsloc)%type
    | RBRACK't =>       (cabsloc)%type
    | RBRACE't =>       (cabsloc)%type
    | QUESTION't =>       (cabsloc)%type
    | PTR't =>       (cabsloc)%type
    | PRAGMA't =>       (string * cabsloc)%type
    | PLUS't =>       (cabsloc)%type
    | PERCENT't =>       (cabsloc)%type
    | PACKED't =>       (cabsloc)%type
    | OTHER_NAME't =>       (string * cabsloc)%type
    | OR_ASSIGN't =>       (cabsloc)%type
    | NEQ't =>       (cabsloc)%type
    | MUL_ASSIGN't =>       (cabsloc)%type
    | MOD_ASSIGN't =>       (cabsloc)%type
    | MINUS't =>       (cabsloc)%type
    | LT't =>       (cabsloc)%type
    | LPAREN't =>       (cabsloc)%type
    | LONG't =>       (cabsloc)%type
    | LEQ't =>       (cabsloc)%type
    | LEFT_ASSIGN't =>       (cabsloc)%type
    | LEFT't =>       (cabsloc)%type
    | LBRACK't =>       (cabsloc)%type
    | LBRACE't =>       (cabsloc)%type
    | INT't =>       (cabsloc)%type
    | INLINE't =>       (cabsloc)%type
    | INC't =>       (cabsloc)%type
    | IF't =>       (cabsloc)%type
    | HAT't =>       (cabsloc)%type
    | GT't =>       (cabsloc)%type
    | GOTO't =>       (cabsloc)%type
    | GEQ't =>       (cabsloc)%type
    | FOR't =>       (cabsloc)%type
    | FLOAT't =>       (cabsloc)%type
    | EXTERN't =>       (cabsloc)%type
    | EQEQ't =>       (cabsloc)%type
    | EQ't =>       (cabsloc)%type
    | EOF't => unit%type
    | ENUM't =>       (cabsloc)%type
    | ELSE't =>       (cabsloc)%type
    | ELLIPSIS't =>       (cabsloc)%type
    | DOUBLE't =>       (cabsloc)%type
    | DOT't =>       (cabsloc)%type
    | DO't =>       (cabsloc)%type
    | DIV_ASSIGN't =>       (cabsloc)%type
    | DEFAULT't =>       (cabsloc)%type
    | DEC't =>       (cabsloc)%type
    | CONTINUE't =>       (cabsloc)%type
    | CONSTANT't =>       (constant * cabsloc)%type
    | CONST't =>       (cabsloc)%type
    | COMMA't =>       (cabsloc)%type
    | COLON't =>       (cabsloc)%type
    | CHAR't =>       (cabsloc)%type
    | CASE't =>       (cabsloc)%type
    | BUILTIN_VA_ARG't =>       (cabsloc)%type
    | BREAK't =>       (cabsloc)%type
    | BARBAR't =>       (cabsloc)%type
    | BAR't =>       (cabsloc)%type
    | BANG't =>       (cabsloc)%type
    | AUTO't =>       (cabsloc)%type
    | ATTRIBUTE't =>       (cabsloc)%type
    | ASM't =>       (cabsloc)%type
    | AND_ASSIGN't =>       (cabsloc)%type
    | ANDAND't =>       (cabsloc)%type
    | AND't =>       (cabsloc)%type
    | ALIGNOF't =>       (cabsloc)%type
    | ALIGNAS't =>       (cabsloc)%type
    | ADD_ASSIGN't =>       (cabsloc)%type
  end.

Definition nonterminal_semantic_type (nt:nonterminal) : Type:=
  match nt with
    | unary_operator'nt =>      (unary_operator * cabsloc)%type
    | unary_expression'nt =>      (expression * cabsloc)%type
    | type_specifier'nt =>      (typeSpecifier * cabsloc)%type
    | type_qualifier_list'nt =>      (list cvspec (* Reverse order *))%type
    | type_qualifier'nt =>      (cvspec * cabsloc)%type
    | type_name'nt =>      (list spec_elem * decl_type)%type
    | translation_unit_file'nt =>       (list definition)%type
    | translation_unit'nt =>      (list definition (* Reverse order *))%type
    | struct_or_union_specifier'nt =>      (typeSpecifier * cabsloc)%type
    | struct_or_union'nt =>      (structOrUnion * cabsloc)%type
    | struct_declarator_list'nt =>      (list (option name * option expression) (* Reverse order *))%type
    | struct_declarator'nt =>      (option name * option expression)%type
    | struct_declaration_list'nt =>      (list field_group (* Reverse order *))%type
    | struct_declaration'nt =>      (field_group)%type
    | storage_class_specifier'nt =>      (storage * cabsloc)%type
    | statement_safe'nt =>      (statement)%type
    | statement_dangerous'nt =>      (statement)%type
    | specifier_qualifier_list'nt =>      (list spec_elem * cabsloc)%type
    | shift_expression'nt =>      (expression * cabsloc)%type
    | selection_statement_safe'nt =>      (statement)%type
    | selection_statement_dangerous'nt =>      (statement)%type
    | relational_expression'nt =>      (expression * cabsloc)%type
    | primary_expression'nt =>      (expression * cabsloc)%type
    | postfix_expression'nt =>      (expression * cabsloc)%type
    | pointer'nt =>      ((decl_type -> decl_type) * cabsloc)%type
    | parameter_type_list'nt =>      (list parameter * bool)%type
    | parameter_list'nt =>      (list parameter (* Reverse order *))%type
    | parameter_declaration'nt =>      (parameter)%type
    | old_function_declarator'nt =>      (name * list string)%type
    | multiplicative_expression'nt =>      (expression * cabsloc)%type
    | logical_OR_expression'nt =>      (expression * cabsloc)%type
    | logical_AND_expression'nt =>      (expression * cabsloc)%type
    | labeled_statement_statement_safe_'nt =>      (statement)%type
    | labeled_statement_statement_dangerous_'nt =>      (statement)%type
    | jump_statement'nt =>      (statement)%type
    | iteration_statement_statement_safe_'nt =>      (statement)%type
    | iteration_statement_statement_dangerous_'nt =>      (statement)%type
    | initializer_list'nt =>      (list (list initwhat * init_expression) (* Reverse order *))%type
    | init_declarator_list'nt =>      (list init_name (* Reverse order *))%type
    | init_declarator'nt =>      (init_name)%type
    | inclusive_OR_expression'nt =>      (expression * cabsloc)%type
    | identifier_list'nt =>      (list string (* Reverse order *))%type
    | gcc_attribute_word'nt =>      (gcc_attribute_word)%type
    | gcc_attribute_list'nt =>      (list gcc_attribute)%type
    | gcc_attribute'nt =>      (gcc_attribute)%type
    | function_specifier'nt =>      (cabsloc)%type
    | function_definition'nt =>      (definition)%type
    | external_declaration'nt =>      (definition)%type
    | expression_statement'nt =>      (statement)%type
    | expression'nt =>      (expression * cabsloc)%type
    | exclusive_OR_expression'nt =>      (expression * cabsloc)%type
    | equality_expression'nt =>      (expression * cabsloc)%type
    | enumerator_list'nt =>      (list (string * option expression * cabsloc) (* Reverse order *))%type
    | enumerator'nt =>      (string * option expression * cabsloc)%type
    | enumeration_constant'nt =>      (string * cabsloc)%type
    | enum_specifier'nt =>      (typeSpecifier * cabsloc)%type
    | direct_old_function_declarator'nt =>      (name * list string)%type
    | direct_declarator'nt =>      (name)%type
    | direct_abstract_declarator'nt =>      (decl_type)%type
    | designator_list'nt =>      (list initwhat (* Reverse order *))%type
    | designator'nt =>      (initwhat)%type
    | designation'nt =>      (list initwhat)%type
    | declarator'nt =>      (name)%type
    | declaration_specifiers'nt =>      (list spec_elem * cabsloc)%type
    | declaration_list'nt =>      (list definition)%type
    | declaration'nt =>      (definition)%type
    | constant_expression'nt =>      (expression * cabsloc)%type
    | conditional_expression'nt =>      (expression * cabsloc)%type
    | compound_statement'nt =>      (statement)%type
    | cast_expression'nt =>      (expression * cabsloc)%type
    | c_initializer'nt =>      (init_expression)%type
    | block_item_list'nt =>      (list statement (* Reverse order *))%type
    | block_item'nt =>      (statement)%type
    | attribute_specifier_list'nt =>      (list attribute)%type
    | attribute_specifier'nt =>      (attribute * cabsloc)%type
    | assignment_operator'nt =>      (binary_operator)%type
    | assignment_expression'nt =>      (expression * cabsloc)%type
    | asm_statement'nt =>      (statement)%type
    | argument_expression_list'nt =>      (list expression (* Reverse order *))%type
    | additive_expression'nt =>      (expression * cabsloc)%type
    | abstract_declarator'nt =>      (decl_type)%type
    | AND_expression'nt =>      (expression * cabsloc)%type
  end.

Definition symbol_semantic_type (s:symbol) : Type:=
  match s with
    | T t => terminal_semantic_type t
    | NT nt => nonterminal_semantic_type nt
  end.

Inductive production' : Set :=
  | Prod'unary_operator'5
  | Prod'unary_operator'4
  | Prod'unary_operator'3
  | Prod'unary_operator'2
  | Prod'unary_operator'1
  | Prod'unary_operator'0
  | Prod'unary_expression'7
  | Prod'unary_expression'6
  | Prod'unary_expression'5
  | Prod'unary_expression'4
  | Prod'unary_expression'3
  | Prod'unary_expression'2
  | Prod'unary_expression'1
  | Prod'unary_expression'0
  | Prod'type_specifier'12
  | Prod'type_specifier'11
  | Prod'type_specifier'10
  | Prod'type_specifier'9
  | Prod'type_specifier'8
  | Prod'type_specifier'7
  | Prod'type_specifier'6
  | Prod'type_specifier'5
  | Prod'type_specifier'4
  | Prod'type_specifier'3
  | Prod'type_specifier'2
  | Prod'type_specifier'1
  | Prod'type_specifier'0
  | Prod'type_qualifier_list'1
  | Prod'type_qualifier_list'0
  | Prod'type_qualifier'3
  | Prod'type_qualifier'2
  | Prod'type_qualifier'1
  | Prod'type_qualifier'0
  | Prod'type_name'1
  | Prod'type_name'0
  | Prod'translation_unit_file'1
  | Prod'translation_unit_file'0
  | Prod'translation_unit'1
  | Prod'translation_unit'0
  | Prod'struct_or_union_specifier'2
  | Prod'struct_or_union_specifier'1
  | Prod'struct_or_union_specifier'0
  | Prod'struct_or_union'1
  | Prod'struct_or_union'0
  | Prod'struct_declarator_list'1
  | Prod'struct_declarator_list'0
  | Prod'struct_declarator'2
  | Prod'struct_declarator'1
  | Prod'struct_declarator'0
  | Prod'struct_declaration_list'1
  | Prod'struct_declaration_list'0
  | Prod'struct_declaration'1
  | Prod'struct_declaration'0
  | Prod'storage_class_specifier'4
  | Prod'storage_class_specifier'3
  | Prod'storage_class_specifier'2
  | Prod'storage_class_specifier'1
  | Prod'storage_class_specifier'0
  | Prod'statement_safe'6
  | Prod'statement_safe'5
  | Prod'statement_safe'4
  | Prod'statement_safe'3
  | Prod'statement_safe'2
  | Prod'statement_safe'1
  | Prod'statement_safe'0
  | Prod'statement_dangerous'6
  | Prod'statement_dangerous'5
  | Prod'statement_dangerous'4
  | Prod'statement_dangerous'3
  | Prod'statement_dangerous'2
  | Prod'statement_dangerous'1
  | Prod'statement_dangerous'0
  | Prod'specifier_qualifier_list'3
  | Prod'specifier_qualifier_list'2
  | Prod'specifier_qualifier_list'1
  | Prod'specifier_qualifier_list'0
  | Prod'shift_expression'2
  | Prod'shift_expression'1
  | Prod'shift_expression'0
  | Prod'selection_statement_safe'1
  | Prod'selection_statement_safe'0
  | Prod'selection_statement_dangerous'2
  | Prod'selection_statement_dangerous'1
  | Prod'selection_statement_dangerous'0
  | Prod'relational_expression'4
  | Prod'relational_expression'3
  | Prod'relational_expression'2
  | Prod'relational_expression'1
  | Prod'relational_expression'0
  | Prod'primary_expression'3
  | Prod'primary_expression'2
  | Prod'primary_expression'1
  | Prod'primary_expression'0
  | Prod'postfix_expression'10
  | Prod'postfix_expression'9
  | Prod'postfix_expression'8
  | Prod'postfix_expression'7
  | Prod'postfix_expression'6
  | Prod'postfix_expression'5
  | Prod'postfix_expression'4
  | Prod'postfix_expression'3
  | Prod'postfix_expression'2
  | Prod'postfix_expression'1
  | Prod'postfix_expression'0
  | Prod'pointer'3
  | Prod'pointer'2
  | Prod'pointer'1
  | Prod'pointer'0
  | Prod'parameter_type_list'1
  | Prod'parameter_type_list'0
  | Prod'parameter_list'1
  | Prod'parameter_list'0
  | Prod'parameter_declaration'2
  | Prod'parameter_declaration'1
  | Prod'parameter_declaration'0
  | Prod'old_function_declarator'1
  | Prod'old_function_declarator'0
  | Prod'multiplicative_expression'3
  | Prod'multiplicative_expression'2
  | Prod'multiplicative_expression'1
  | Prod'multiplicative_expression'0
  | Prod'logical_OR_expression'1
  | Prod'logical_OR_expression'0
  | Prod'logical_AND_expression'1
  | Prod'logical_AND_expression'0
  | Prod'labeled_statement_statement_safe_'2
  | Prod'labeled_statement_statement_safe_'1
  | Prod'labeled_statement_statement_safe_'0
  | Prod'labeled_statement_statement_dangerous_'2
  | Prod'labeled_statement_statement_dangerous_'1
  | Prod'labeled_statement_statement_dangerous_'0
  | Prod'jump_statement'4
  | Prod'jump_statement'3
  | Prod'jump_statement'2
  | Prod'jump_statement'1
  | Prod'jump_statement'0
  | Prod'iteration_statement_statement_safe_'13
  | Prod'iteration_statement_statement_safe_'12
  | Prod'iteration_statement_statement_safe_'11
  | Prod'iteration_statement_statement_safe_'10
  | Prod'iteration_statement_statement_safe_'9
  | Prod'iteration_statement_statement_safe_'8
  | Prod'iteration_statement_statement_safe_'7
  | Prod'iteration_statement_statement_safe_'6
  | Prod'iteration_statement_statement_safe_'5
  | Prod'iteration_statement_statement_safe_'4
  | Prod'iteration_statement_statement_safe_'3
  | Prod'iteration_statement_statement_safe_'2
  | Prod'iteration_statement_statement_safe_'1
  | Prod'iteration_statement_statement_safe_'0
  | Prod'iteration_statement_statement_dangerous_'13
  | Prod'iteration_statement_statement_dangerous_'12
  | Prod'iteration_statement_statement_dangerous_'11
  | Prod'iteration_statement_statement_dangerous_'10
  | Prod'iteration_statement_statement_dangerous_'9
  | Prod'iteration_statement_statement_dangerous_'8
  | Prod'iteration_statement_statement_dangerous_'7
  | Prod'iteration_statement_statement_dangerous_'6
  | Prod'iteration_statement_statement_dangerous_'5
  | Prod'iteration_statement_statement_dangerous_'4
  | Prod'iteration_statement_statement_dangerous_'3
  | Prod'iteration_statement_statement_dangerous_'2
  | Prod'iteration_statement_statement_dangerous_'1
  | Prod'iteration_statement_statement_dangerous_'0
  | Prod'initializer_list'3
  | Prod'initializer_list'2
  | Prod'initializer_list'1
  | Prod'initializer_list'0
  | Prod'init_declarator_list'1
  | Prod'init_declarator_list'0
  | Prod'init_declarator'1
  | Prod'init_declarator'0
  | Prod'inclusive_OR_expression'1
  | Prod'inclusive_OR_expression'0
  | Prod'identifier_list'1
  | Prod'identifier_list'0
  | Prod'gcc_attribute_word'2
  | Prod'gcc_attribute_word'1
  | Prod'gcc_attribute_word'0
  | Prod'gcc_attribute_list'1
  | Prod'gcc_attribute_list'0
  | Prod'gcc_attribute'3
  | Prod'gcc_attribute'2
  | Prod'gcc_attribute'1
  | Prod'gcc_attribute'0
  | Prod'function_specifier'0
  | Prod'function_definition'1
  | Prod'function_definition'0
  | Prod'external_declaration'2
  | Prod'external_declaration'1
  | Prod'external_declaration'0
  | Prod'expression_statement'1
  | Prod'expression_statement'0
  | Prod'expression'1
  | Prod'expression'0
  | Prod'exclusive_OR_expression'1
  | Prod'exclusive_OR_expression'0
  | Prod'equality_expression'2
  | Prod'equality_expression'1
  | Prod'equality_expression'0
  | Prod'enumerator_list'1
  | Prod'enumerator_list'0
  | Prod'enumerator'1
  | Prod'enumerator'0
  | Prod'enumeration_constant'0
  | Prod'enum_specifier'4
  | Prod'enum_specifier'3
  | Prod'enum_specifier'2
  | Prod'enum_specifier'1
  | Prod'enum_specifier'0
  | Prod'direct_old_function_declarator'0
  | Prod'direct_declarator'7
  | Prod'direct_declarator'6
  | Prod'direct_declarator'5
  | Prod'direct_declarator'4
  | Prod'direct_declarator'3
  | Prod'direct_declarator'2
  | Prod'direct_declarator'1
  | Prod'direct_declarator'0
  | Prod'direct_abstract_declarator'12
  | Prod'direct_abstract_declarator'11
  | Prod'direct_abstract_declarator'10
  | Prod'direct_abstract_declarator'9
  | Prod'direct_abstract_declarator'8
  | Prod'direct_abstract_declarator'7
  | Prod'direct_abstract_declarator'6
  | Prod'direct_abstract_declarator'5
  | Prod'direct_abstract_declarator'4
  | Prod'direct_abstract_declarator'3
  | Prod'direct_abstract_declarator'2
  | Prod'direct_abstract_declarator'1
  | Prod'direct_abstract_declarator'0
  | Prod'designator_list'1
  | Prod'designator_list'0
  | Prod'designator'1
  | Prod'designator'0
  | Prod'designation'0
  | Prod'declarator'1
  | Prod'declarator'0
  | Prod'declaration_specifiers'7
  | Prod'declaration_specifiers'6
  | Prod'declaration_specifiers'5
  | Prod'declaration_specifiers'4
  | Prod'declaration_specifiers'3
  | Prod'declaration_specifiers'2
  | Prod'declaration_specifiers'1
  | Prod'declaration_specifiers'0
  | Prod'declaration_list'1
  | Prod'declaration_list'0
  | Prod'declaration'1
  | Prod'declaration'0
  | Prod'constant_expression'0
  | Prod'conditional_expression'1
  | Prod'conditional_expression'0
  | Prod'compound_statement'1
  | Prod'compound_statement'0
  | Prod'cast_expression'1
  | Prod'cast_expression'0
  | Prod'c_initializer'2
  | Prod'c_initializer'1
  | Prod'c_initializer'0
  | Prod'block_item_list'1
  | Prod'block_item_list'0
  | Prod'block_item'2
  | Prod'block_item'1
  | Prod'block_item'0
  | Prod'attribute_specifier_list'1
  | Prod'attribute_specifier_list'0
  | Prod'attribute_specifier'3
  | Prod'attribute_specifier'2
  | Prod'attribute_specifier'1
  | Prod'attribute_specifier'0
  | Prod'assignment_operator'10
  | Prod'assignment_operator'9
  | Prod'assignment_operator'8
  | Prod'assignment_operator'7
  | Prod'assignment_operator'6
  | Prod'assignment_operator'5
  | Prod'assignment_operator'4
  | Prod'assignment_operator'3
  | Prod'assignment_operator'2
  | Prod'assignment_operator'1
  | Prod'assignment_operator'0
  | Prod'assignment_expression'1
  | Prod'assignment_expression'0
  | Prod'asm_statement'0
  | Prod'argument_expression_list'1
  | Prod'argument_expression_list'0
  | Prod'additive_expression'2
  | Prod'additive_expression'1
  | Prod'additive_expression'0
  | Prod'abstract_declarator'2
  | Prod'abstract_declarator'1
  | Prod'abstract_declarator'0
  | Prod'AND_expression'1
  | Prod'AND_expression'0.
Definition production := production'.

Program Instance productionNum : Numbered production :=
  { inj := fun x => match x return _ with | Prod'unary_operator'5 => Int31.On | Prod'unary_operator'4 => Int31.In | Prod'unary_operator'3 => (twice Int31.In) | Prod'unary_operator'2 => (twice_plus_one Int31.In) | Prod'unary_operator'1 => (twice (twice Int31.In)) | Prod'unary_operator'0 => (twice_plus_one (twice Int31.In)) | Prod'unary_expression'7 => (twice (twice_plus_one Int31.In)) | Prod'unary_expression'6 => (twice_plus_one (twice_plus_one Int31.In)) | Prod'unary_expression'5 => (twice (twice (twice Int31.In))) | Prod'unary_expression'4 => (twice_plus_one (twice (twice Int31.In))) | Prod'unary_expression'3 => (twice (twice_plus_one (twice Int31.In))) | Prod'unary_expression'2 => (twice_plus_one (twice_plus_one (twice Int31.In))) | Prod'unary_expression'1 => (twice (twice (twice_plus_one Int31.In))) | Prod'unary_expression'0 => (twice_plus_one (twice (twice_plus_one Int31.In))) | Prod'type_specifier'12 => (twice (twice_plus_one (twice_plus_one Int31.In))) | Prod'type_specifier'11 => (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))) | Prod'type_specifier'10 => (twice (twice (twice (twice Int31.In)))) | Prod'type_specifier'9 => (twice_plus_one (twice (twice (twice Int31.In)))) | Prod'type_specifier'8 => (twice (twice_plus_one (twice (twice Int31.In)))) | Prod'type_specifier'7 => (twice_plus_one (twice_plus_one (twice (twice Int31.In)))) | Prod'type_specifier'6 => (twice (twice (twice_plus_one (twice Int31.In)))) | Prod'type_specifier'5 => (twice_plus_one (twice (twice_plus_one (twice Int31.In)))) | Prod'type_specifier'4 => (twice (twice_plus_one (twice_plus_one (twice Int31.In)))) | Prod'type_specifier'3 => (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))) | Prod'type_specifier'2 => (twice (twice (twice (twice_plus_one Int31.In)))) | Prod'type_specifier'1 => (twice_plus_one (twice (twice (twice_plus_one Int31.In)))) | Prod'type_specifier'0 => (twice (twice_plus_one (twice (twice_plus_one Int31.In)))) | Prod'type_qualifier_list'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))) | Prod'type_qualifier_list'0 => (twice (twice (twice_plus_one (twice_plus_one Int31.In)))) | Prod'type_qualifier'3 => (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))) | Prod'type_qualifier'2 => (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | Prod'type_qualifier'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | Prod'type_qualifier'0 => (twice (twice (twice (twice (twice Int31.In))))) | Prod'type_name'1 => (twice_plus_one (twice (twice (twice (twice Int31.In))))) | Prod'type_name'0 => (twice (twice_plus_one (twice (twice (twice Int31.In))))) | Prod'translation_unit_file'1 => (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))) | Prod'translation_unit_file'0 => (twice (twice (twice_plus_one (twice (twice Int31.In))))) | Prod'translation_unit'1 => (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))) | Prod'translation_unit'0 => (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | Prod'struct_or_union_specifier'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | Prod'struct_or_union_specifier'1 => (twice (twice (twice (twice_plus_one (twice Int31.In))))) | Prod'struct_or_union_specifier'0 => (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))) | Prod'struct_or_union'1 => (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | Prod'struct_or_union'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | Prod'struct_declarator_list'1 => (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | Prod'struct_declarator_list'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | Prod'struct_declarator'2 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | Prod'struct_declarator'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | Prod'struct_declarator'0 => (twice (twice (twice (twice (twice_plus_one Int31.In))))) | Prod'struct_declaration_list'1 => (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))) | Prod'struct_declaration_list'0 => (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | Prod'struct_declaration'1 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | Prod'struct_declaration'0 => (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'4 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'3 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'1 => (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'0 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'6 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'5 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'4 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'3 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'2 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'0 => (twice (twice (twice (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'6 => (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'5 => (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'4 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'3 => (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'2 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'1 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | Prod'specifier_qualifier_list'3 => (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | Prod'specifier_qualifier_list'2 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | Prod'specifier_qualifier_list'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | Prod'specifier_qualifier_list'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | Prod'shift_expression'2 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Prod'shift_expression'1 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Prod'shift_expression'0 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Prod'selection_statement_safe'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Prod'selection_statement_safe'0 => (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | Prod'selection_statement_dangerous'2 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | Prod'selection_statement_dangerous'1 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | Prod'selection_statement_dangerous'0 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'4 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'3 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'2 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'0 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'primary_expression'3 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'primary_expression'2 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'primary_expression'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'primary_expression'0 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'postfix_expression'10 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'postfix_expression'9 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'postfix_expression'8 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'postfix_expression'7 => (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'6 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'5 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'4 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'3 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'2 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'1 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Prod'pointer'3 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'pointer'2 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'pointer'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'pointer'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'parameter_type_list'1 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'parameter_type_list'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'parameter_list'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'parameter_list'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'parameter_declaration'2 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'parameter_declaration'1 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'parameter_declaration'0 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'old_function_declarator'1 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'old_function_declarator'0 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'multiplicative_expression'3 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'multiplicative_expression'2 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'multiplicative_expression'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'multiplicative_expression'0 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'logical_OR_expression'1 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'logical_OR_expression'0 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'logical_AND_expression'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'logical_AND_expression'0 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'labeled_statement_statement_safe_'2 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'labeled_statement_statement_safe_'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'labeled_statement_statement_safe_'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'labeled_statement_statement_dangerous_'2 => (twice (twice (twice (twice (twice (twice (twice Int31.In))))))) | Prod'labeled_statement_statement_dangerous_'1 => (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))) | Prod'labeled_statement_statement_dangerous_'0 => (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'4 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'3 => (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'2 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'1 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'13 => (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'12 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'11 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'10 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'9 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'8 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'7 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'6 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'5 => (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'4 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'3 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'2 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'1 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'0 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'13 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'12 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'11 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'10 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'9 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'8 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'7 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'6 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'5 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'4 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'3 => (twice (twice (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'2 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'1 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'0 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'initializer_list'3 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'initializer_list'2 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'initializer_list'1 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'initializer_list'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'init_declarator_list'1 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'init_declarator_list'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'init_declarator'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'init_declarator'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'inclusive_OR_expression'1 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'inclusive_OR_expression'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'identifier_list'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'identifier_list'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_word'2 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_word'1 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_word'0 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_list'1 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_list'0 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute'3 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute'2 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute'0 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'function_specifier'0 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'function_definition'1 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'function_definition'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'external_declaration'2 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'external_declaration'1 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'external_declaration'0 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'expression_statement'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'expression_statement'0 => (twice (twice (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'expression'1 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'expression'0 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'exclusive_OR_expression'1 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'exclusive_OR_expression'0 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'equality_expression'2 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'equality_expression'1 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'equality_expression'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumerator_list'1 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumerator_list'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumerator'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumerator'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumeration_constant'0 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'4 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'3 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'1 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'0 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_old_function_declarator'0 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'7 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'6 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'5 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'4 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'3 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'2 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'1 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'0 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'12 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'11 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'10 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'9 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'8 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'7 => (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'6 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'5 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'4 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'3 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'2 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'1 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designator_list'1 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designator_list'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designator'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designator'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designation'0 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declarator'1 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declarator'0 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'7 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'6 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'5 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'4 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'3 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'2 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'1 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'0 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_list'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_list'0 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration'1 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration'0 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'constant_expression'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'conditional_expression'1 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'conditional_expression'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'compound_statement'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'compound_statement'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'cast_expression'1 => (twice (twice (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'cast_expression'0 => (twice_plus_one (twice (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'c_initializer'2 => (twice (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'c_initializer'1 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'c_initializer'0 => (twice (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item_list'1 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item_list'0 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item'1 => (twice (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier_list'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier_list'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier'3 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier'2 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'10 => (twice (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'9 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'8 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'7 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'6 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'5 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'4 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'3 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'2 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'1 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'0 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_expression'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_expression'0 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'asm_statement'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'argument_expression_list'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'argument_expression_list'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'additive_expression'2 => (twice (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'additive_expression'1 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'additive_expression'0 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'abstract_declarator'2 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'abstract_declarator'1 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'abstract_declarator'0 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'AND_expression'1 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'AND_expression'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) end;
    surj := (fun n => match n return _ with | 0 => Prod'unary_operator'5 | 1 => Prod'unary_operator'4 | 2 => Prod'unary_operator'3 | 3 => Prod'unary_operator'2 | 4 => Prod'unary_operator'1 | 5 => Prod'unary_operator'0 | 6 => Prod'unary_expression'7 | 7 => Prod'unary_expression'6 | 8 => Prod'unary_expression'5 | 9 => Prod'unary_expression'4 | 10 => Prod'unary_expression'3 | 11 => Prod'unary_expression'2 | 12 => Prod'unary_expression'1 | 13 => Prod'unary_expression'0 | 14 => Prod'type_specifier'12 | 15 => Prod'type_specifier'11 | 16 => Prod'type_specifier'10 | 17 => Prod'type_specifier'9 | 18 => Prod'type_specifier'8 | 19 => Prod'type_specifier'7 | 20 => Prod'type_specifier'6 | 21 => Prod'type_specifier'5 | 22 => Prod'type_specifier'4 | 23 => Prod'type_specifier'3 | 24 => Prod'type_specifier'2 | 25 => Prod'type_specifier'1 | 26 => Prod'type_specifier'0 | 27 => Prod'type_qualifier_list'1 | 28 => Prod'type_qualifier_list'0 | 29 => Prod'type_qualifier'3 | 30 => Prod'type_qualifier'2 | 31 => Prod'type_qualifier'1 | 32 => Prod'type_qualifier'0 | 33 => Prod'type_name'1 | 34 => Prod'type_name'0 | 35 => Prod'translation_unit_file'1 | 36 => Prod'translation_unit_file'0 | 37 => Prod'translation_unit'1 | 38 => Prod'translation_unit'0 | 39 => Prod'struct_or_union_specifier'2 | 40 => Prod'struct_or_union_specifier'1 | 41 => Prod'struct_or_union_specifier'0 | 42 => Prod'struct_or_union'1 | 43 => Prod'struct_or_union'0 | 44 => Prod'struct_declarator_list'1 | 45 => Prod'struct_declarator_list'0 | 46 => Prod'struct_declarator'2 | 47 => Prod'struct_declarator'1 | 48 => Prod'struct_declarator'0 | 49 => Prod'struct_declaration_list'1 | 50 => Prod'struct_declaration_list'0 | 51 => Prod'struct_declaration'1 | 52 => Prod'struct_declaration'0 | 53 => Prod'storage_class_specifier'4 | 54 => Prod'storage_class_specifier'3 | 55 => Prod'storage_class_specifier'2 | 56 => Prod'storage_class_specifier'1 | 57 => Prod'storage_class_specifier'0 | 58 => Prod'statement_safe'6 | 59 => Prod'statement_safe'5 | 60 => Prod'statement_safe'4 | 61 => Prod'statement_safe'3 | 62 => Prod'statement_safe'2 | 63 => Prod'statement_safe'1 | 64 => Prod'statement_safe'0 | 65 => Prod'statement_dangerous'6 | 66 => Prod'statement_dangerous'5 | 67 => Prod'statement_dangerous'4 | 68 => Prod'statement_dangerous'3 | 69 => Prod'statement_dangerous'2 | 70 => Prod'statement_dangerous'1 | 71 => Prod'statement_dangerous'0 | 72 => Prod'specifier_qualifier_list'3 | 73 => Prod'specifier_qualifier_list'2 | 74 => Prod'specifier_qualifier_list'1 | 75 => Prod'specifier_qualifier_list'0 | 76 => Prod'shift_expression'2 | 77 => Prod'shift_expression'1 | 78 => Prod'shift_expression'0 | 79 => Prod'selection_statement_safe'1 | 80 => Prod'selection_statement_safe'0 | 81 => Prod'selection_statement_dangerous'2 | 82 => Prod'selection_statement_dangerous'1 | 83 => Prod'selection_statement_dangerous'0 | 84 => Prod'relational_expression'4 | 85 => Prod'relational_expression'3 | 86 => Prod'relational_expression'2 | 87 => Prod'relational_expression'1 | 88 => Prod'relational_expression'0 | 89 => Prod'primary_expression'3 | 90 => Prod'primary_expression'2 | 91 => Prod'primary_expression'1 | 92 => Prod'primary_expression'0 | 93 => Prod'postfix_expression'10 | 94 => Prod'postfix_expression'9 | 95 => Prod'postfix_expression'8 | 96 => Prod'postfix_expression'7 | 97 => Prod'postfix_expression'6 | 98 => Prod'postfix_expression'5 | 99 => Prod'postfix_expression'4 | 100 => Prod'postfix_expression'3 | 101 => Prod'postfix_expression'2 | 102 => Prod'postfix_expression'1 | 103 => Prod'postfix_expression'0 | 104 => Prod'pointer'3 | 105 => Prod'pointer'2 | 106 => Prod'pointer'1 | 107 => Prod'pointer'0 | 108 => Prod'parameter_type_list'1 | 109 => Prod'parameter_type_list'0 | 110 => Prod'parameter_list'1 | 111 => Prod'parameter_list'0 | 112 => Prod'parameter_declaration'2 | 113 => Prod'parameter_declaration'1 | 114 => Prod'parameter_declaration'0 | 115 => Prod'old_function_declarator'1 | 116 => Prod'old_function_declarator'0 | 117 => Prod'multiplicative_expression'3 | 118 => Prod'multiplicative_expression'2 | 119 => Prod'multiplicative_expression'1 | 120 => Prod'multiplicative_expression'0 | 121 => Prod'logical_OR_expression'1 | 122 => Prod'logical_OR_expression'0 | 123 => Prod'logical_AND_expression'1 | 124 => Prod'logical_AND_expression'0 | 125 => Prod'labeled_statement_statement_safe_'2 | 126 => Prod'labeled_statement_statement_safe_'1 | 127 => Prod'labeled_statement_statement_safe_'0 | 128 => Prod'labeled_statement_statement_dangerous_'2 | 129 => Prod'labeled_statement_statement_dangerous_'1 | 130 => Prod'labeled_statement_statement_dangerous_'0 | 131 => Prod'jump_statement'4 | 132 => Prod'jump_statement'3 | 133 => Prod'jump_statement'2 | 134 => Prod'jump_statement'1 | 135 => Prod'jump_statement'0 | 136 => Prod'iteration_statement_statement_safe_'13 | 137 => Prod'iteration_statement_statement_safe_'12 | 138 => Prod'iteration_statement_statement_safe_'11 | 139 => Prod'iteration_statement_statement_safe_'10 | 140 => Prod'iteration_statement_statement_safe_'9 | 141 => Prod'iteration_statement_statement_safe_'8 | 142 => Prod'iteration_statement_statement_safe_'7 | 143 => Prod'iteration_statement_statement_safe_'6 | 144 => Prod'iteration_statement_statement_safe_'5 | 145 => Prod'iteration_statement_statement_safe_'4 | 146 => Prod'iteration_statement_statement_safe_'3 | 147 => Prod'iteration_statement_statement_safe_'2 | 148 => Prod'iteration_statement_statement_safe_'1 | 149 => Prod'iteration_statement_statement_safe_'0 | 150 => Prod'iteration_statement_statement_dangerous_'13 | 151 => Prod'iteration_statement_statement_dangerous_'12 | 152 => Prod'iteration_statement_statement_dangerous_'11 | 153 => Prod'iteration_statement_statement_dangerous_'10 | 154 => Prod'iteration_statement_statement_dangerous_'9 | 155 => Prod'iteration_statement_statement_dangerous_'8 | 156 => Prod'iteration_statement_statement_dangerous_'7 | 157 => Prod'iteration_statement_statement_dangerous_'6 | 158 => Prod'iteration_statement_statement_dangerous_'5 | 159 => Prod'iteration_statement_statement_dangerous_'4 | 160 => Prod'iteration_statement_statement_dangerous_'3 | 161 => Prod'iteration_statement_statement_dangerous_'2 | 162 => Prod'iteration_statement_statement_dangerous_'1 | 163 => Prod'iteration_statement_statement_dangerous_'0 | 164 => Prod'initializer_list'3 | 165 => Prod'initializer_list'2 | 166 => Prod'initializer_list'1 | 167 => Prod'initializer_list'0 | 168 => Prod'init_declarator_list'1 | 169 => Prod'init_declarator_list'0 | 170 => Prod'init_declarator'1 | 171 => Prod'init_declarator'0 | 172 => Prod'inclusive_OR_expression'1 | 173 => Prod'inclusive_OR_expression'0 | 174 => Prod'identifier_list'1 | 175 => Prod'identifier_list'0 | 176 => Prod'gcc_attribute_word'2 | 177 => Prod'gcc_attribute_word'1 | 178 => Prod'gcc_attribute_word'0 | 179 => Prod'gcc_attribute_list'1 | 180 => Prod'gcc_attribute_list'0 | 181 => Prod'gcc_attribute'3 | 182 => Prod'gcc_attribute'2 | 183 => Prod'gcc_attribute'1 | 184 => Prod'gcc_attribute'0 | 185 => Prod'function_specifier'0 | 186 => Prod'function_definition'1 | 187 => Prod'function_definition'0 | 188 => Prod'external_declaration'2 | 189 => Prod'external_declaration'1 | 190 => Prod'external_declaration'0 | 191 => Prod'expression_statement'1 | 192 => Prod'expression_statement'0 | 193 => Prod'expression'1 | 194 => Prod'expression'0 | 195 => Prod'exclusive_OR_expression'1 | 196 => Prod'exclusive_OR_expression'0 | 197 => Prod'equality_expression'2 | 198 => Prod'equality_expression'1 | 199 => Prod'equality_expression'0 | 200 => Prod'enumerator_list'1 | 201 => Prod'enumerator_list'0 | 202 => Prod'enumerator'1 | 203 => Prod'enumerator'0 | 204 => Prod'enumeration_constant'0 | 205 => Prod'enum_specifier'4 | 206 => Prod'enum_specifier'3 | 207 => Prod'enum_specifier'2 | 208 => Prod'enum_specifier'1 | 209 => Prod'enum_specifier'0 | 210 => Prod'direct_old_function_declarator'0 | 211 => Prod'direct_declarator'7 | 212 => Prod'direct_declarator'6 | 213 => Prod'direct_declarator'5 | 214 => Prod'direct_declarator'4 | 215 => Prod'direct_declarator'3 | 216 => Prod'direct_declarator'2 | 217 => Prod'direct_declarator'1 | 218 => Prod'direct_declarator'0 | 219 => Prod'direct_abstract_declarator'12 | 220 => Prod'direct_abstract_declarator'11 | 221 => Prod'direct_abstract_declarator'10 | 222 => Prod'direct_abstract_declarator'9 | 223 => Prod'direct_abstract_declarator'8 | 224 => Prod'direct_abstract_declarator'7 | 225 => Prod'direct_abstract_declarator'6 | 226 => Prod'direct_abstract_declarator'5 | 227 => Prod'direct_abstract_declarator'4 | 228 => Prod'direct_abstract_declarator'3 | 229 => Prod'direct_abstract_declarator'2 | 230 => Prod'direct_abstract_declarator'1 | 231 => Prod'direct_abstract_declarator'0 | 232 => Prod'designator_list'1 | 233 => Prod'designator_list'0 | 234 => Prod'designator'1 | 235 => Prod'designator'0 | 236 => Prod'designation'0 | 237 => Prod'declarator'1 | 238 => Prod'declarator'0 | 239 => Prod'declaration_specifiers'7 | 240 => Prod'declaration_specifiers'6 | 241 => Prod'declaration_specifiers'5 | 242 => Prod'declaration_specifiers'4 | 243 => Prod'declaration_specifiers'3 | 244 => Prod'declaration_specifiers'2 | 245 => Prod'declaration_specifiers'1 | 246 => Prod'declaration_specifiers'0 | 247 => Prod'declaration_list'1 | 248 => Prod'declaration_list'0 | 249 => Prod'declaration'1 | 250 => Prod'declaration'0 | 251 => Prod'constant_expression'0 | 252 => Prod'conditional_expression'1 | 253 => Prod'conditional_expression'0 | 254 => Prod'compound_statement'1 | 255 => Prod'compound_statement'0 | 256 => Prod'cast_expression'1 | 257 => Prod'cast_expression'0 | 258 => Prod'c_initializer'2 | 259 => Prod'c_initializer'1 | 260 => Prod'c_initializer'0 | 261 => Prod'block_item_list'1 | 262 => Prod'block_item_list'0 | 263 => Prod'block_item'2 | 264 => Prod'block_item'1 | 265 => Prod'block_item'0 | 266 => Prod'attribute_specifier_list'1 | 267 => Prod'attribute_specifier_list'0 | 268 => Prod'attribute_specifier'3 | 269 => Prod'attribute_specifier'2 | 270 => Prod'attribute_specifier'1 | 271 => Prod'attribute_specifier'0 | 272 => Prod'assignment_operator'10 | 273 => Prod'assignment_operator'9 | 274 => Prod'assignment_operator'8 | 275 => Prod'assignment_operator'7 | 276 => Prod'assignment_operator'6 | 277 => Prod'assignment_operator'5 | 278 => Prod'assignment_operator'4 | 279 => Prod'assignment_operator'3 | 280 => Prod'assignment_operator'2 | 281 => Prod'assignment_operator'1 | 282 => Prod'assignment_operator'0 | 283 => Prod'assignment_expression'1 | 284 => Prod'assignment_expression'0 | 285 => Prod'asm_statement'0 | 286 => Prod'argument_expression_list'1 | 287 => Prod'argument_expression_list'0 | 288 => Prod'additive_expression'2 | 289 => Prod'additive_expression'1 | 290 => Prod'additive_expression'0 | 291 => Prod'abstract_declarator'2 | 292 => Prod'abstract_declarator'1 | 293 => Prod'abstract_declarator'0 | 294 => Prod'AND_expression'1 | 295 => Prod'AND_expression'0 | _ => Prod'unary_operator'5 end)%int31;
  inj_bound := 296%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance ProductionAlph : Alphabet production := _.

Definition prod_contents (p:production) :
  { p:nonterminal * list symbol &
    arrows_left (map symbol_semantic_type (rev (snd p)))
                (symbol_semantic_type (NT (fst p))) }
 :=
  let box := existT (fun p =>
    arrows_left (map symbol_semantic_type (rev (snd p)))
                (symbol_semantic_type (NT (fst p))))
  in
  match p with
    | Prod'AND_expression'0 => box
      (AND_expression'nt, [NT equality_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'AND_expression'1 => box
      (AND_expression'nt, [NT equality_expression'nt; T AND't; NT AND_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY BAND (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'abstract_declarator'0 => box
      (abstract_declarator'nt, [NT pointer'nt])
      (fun pt =>
 (fst pt) JUSTBASE 
)
    | Prod'abstract_declarator'1 => box
      (abstract_declarator'nt, [NT direct_abstract_declarator'nt; NT pointer'nt])
      (fun typ pt =>
 (fst pt) typ 
)
    | Prod'abstract_declarator'2 => box
      (abstract_declarator'nt, [NT direct_abstract_declarator'nt])
      (fun typ =>
 typ 
)
    | Prod'additive_expression'0 => box
      (additive_expression'nt, [NT multiplicative_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'additive_expression'1 => box
      (additive_expression'nt, [NT multiplicative_expression'nt; T PLUS't; NT additive_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY ADD (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'additive_expression'2 => box
      (additive_expression'nt, [NT multiplicative_expression'nt; T MINUS't; NT additive_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY SUB (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'argument_expression_list'0 => box
      (argument_expression_list'nt, [NT assignment_expression'nt])
      (fun expr =>
 [fst expr] 
)
    | Prod'argument_expression_list'1 => box
      (argument_expression_list'nt, [NT assignment_expression'nt; T COMMA't; NT argument_expression_list'nt])
      (fun exprt _2 exprq =>
 fst exprt::exprq 
)
    | Prod'asm_statement'0 => box
      (asm_statement'nt, [T SEMICOLON't; T RPAREN't; T STRING_LITERAL't; T LPAREN't; T ASM't])
      (fun _5 _4 template _2 loc =>
 let '(wide, chars, _) := template in ASM wide chars loc 
)
    | Prod'assignment_expression'0 => box
      (assignment_expression'nt, [NT conditional_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'assignment_expression'1 => box
      (assignment_expression'nt, [NT assignment_expression'nt; NT assignment_operator'nt; NT unary_expression'nt])
      (fun expr2 op expr1 =>
 (BINARY op (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'assignment_operator'0 => box
      (assignment_operator'nt, [T EQ't])
      (fun _1 =>
 ASSIGN  
)
    | Prod'assignment_operator'1 => box
      (assignment_operator'nt, [T MUL_ASSIGN't])
      (fun _1 =>
 MUL_ASSIGN 
)
    | Prod'assignment_operator'2 => box
      (assignment_operator'nt, [T DIV_ASSIGN't])
      (fun _1 =>
 DIV_ASSIGN 
)
    | Prod'assignment_operator'3 => box
      (assignment_operator'nt, [T MOD_ASSIGN't])
      (fun _1 =>
 MOD_ASSIGN 
)
    | Prod'assignment_operator'4 => box
      (assignment_operator'nt, [T ADD_ASSIGN't])
      (fun _1 =>
 ADD_ASSIGN 
)
    | Prod'assignment_operator'5 => box
      (assignment_operator'nt, [T SUB_ASSIGN't])
      (fun _1 =>
 SUB_ASSIGN 
)
    | Prod'assignment_operator'6 => box
      (assignment_operator'nt, [T LEFT_ASSIGN't])
      (fun _1 =>
 SHL_ASSIGN 
)
    | Prod'assignment_operator'7 => box
      (assignment_operator'nt, [T RIGHT_ASSIGN't])
      (fun _1 =>
 SHR_ASSIGN 
)
    | Prod'assignment_operator'8 => box
      (assignment_operator'nt, [T XOR_ASSIGN't])
      (fun _1 =>
 XOR_ASSIGN 
)
    | Prod'assignment_operator'9 => box
      (assignment_operator'nt, [T OR_ASSIGN't])
      (fun _1 =>
 BOR_ASSIGN 
)
    | Prod'assignment_operator'10 => box
      (assignment_operator'nt, [T AND_ASSIGN't])
      (fun _1 =>
 BAND_ASSIGN 
)
    | Prod'attribute_specifier'0 => box
      (attribute_specifier'nt, [T RPAREN't; T RPAREN't; NT gcc_attribute_list'nt; T LPAREN't; T LPAREN't; T ATTRIBUTE't])
      (fun _6 _5 attr _3 _2 loc =>
 (GCC_ATTR (rev' attr) loc, loc) 
)
    | Prod'attribute_specifier'1 => box
      (attribute_specifier'nt, [T RPAREN't; NT argument_expression_list'nt; T LPAREN't; T PACKED't])
      (fun _4 args _2 loc =>
 (PACKED_ATTR (rev' args) loc, loc) 
)
    | Prod'attribute_specifier'2 => box
      (attribute_specifier'nt, [T RPAREN't; NT argument_expression_list'nt; T LPAREN't; T ALIGNAS't])
      (fun _4 args _2 loc =>
 (ALIGNAS_ATTR (rev' args) loc, loc) 
)
    | Prod'attribute_specifier'3 => box
      (attribute_specifier'nt, [T RPAREN't; NT type_name'nt; T LPAREN't; T ALIGNAS't])
      (fun _4 typ _2 loc =>
 (ALIGNAS_ATTR [TYPE_ALIGNOF typ] loc, loc) 
)
    | Prod'attribute_specifier_list'0 => box
      (attribute_specifier_list'nt, [])
      (
 [] 
)
    | Prod'attribute_specifier_list'1 => box
      (attribute_specifier_list'nt, [NT attribute_specifier'nt; NT attribute_specifier_list'nt])
      (fun attr attrs =>
 fst attr :: attrs 
)
    | Prod'block_item'0 => box
      (block_item'nt, [NT declaration'nt])
      (fun decl =>
 DEFINITION decl 
)
    | Prod'block_item'1 => box
      (block_item'nt, [NT statement_dangerous'nt])
      (fun stmt =>
 stmt 
)
    | Prod'block_item'2 => box
      (block_item'nt, [T PRAGMA't])
      (fun p =>
 DEFINITION (PRAGMA (fst p) (snd p)) 
)
    | Prod'block_item_list'0 => box
      (block_item_list'nt, [NT block_item'nt])
      (fun stmt =>
 [stmt] 
)
    | Prod'block_item_list'1 => box
      (block_item_list'nt, [NT block_item'nt; NT block_item_list'nt])
      (fun stmtt stmtq =>
 stmtt::stmtq 
)
    | Prod'c_initializer'0 => box
      (c_initializer'nt, [NT assignment_expression'nt])
      (fun expr =>
 SINGLE_INIT (fst expr) 
)
    | Prod'c_initializer'1 => box
      (c_initializer'nt, [T RBRACE't; NT initializer_list'nt; T LBRACE't])
      (fun _3 init _1 =>
 COMPOUND_INIT (rev' init) 
)
    | Prod'c_initializer'2 => box
      (c_initializer'nt, [T RBRACE't; T COMMA't; NT initializer_list'nt; T LBRACE't])
      (fun _4 _3 init _1 =>
 COMPOUND_INIT (rev' init) 
)
    | Prod'cast_expression'0 => box
      (cast_expression'nt, [NT unary_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'cast_expression'1 => box
      (cast_expression'nt, [NT cast_expression'nt; T RPAREN't; NT type_name'nt; T LPAREN't])
      (fun expr _3 typ loc =>
 (CAST typ (SINGLE_INIT (fst expr)), loc) 
)
    | Prod'compound_statement'0 => box
      (compound_statement'nt, [T RBRACE't; NT block_item_list'nt; T LBRACE't])
      (fun _3 lst loc =>
 BLOCK (rev' lst) loc 
)
    | Prod'compound_statement'1 => box
      (compound_statement'nt, [T RBRACE't; T LBRACE't])
      (fun _2 loc =>
 BLOCK [] loc 
)
    | Prod'conditional_expression'0 => box
      (conditional_expression'nt, [NT logical_OR_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'conditional_expression'1 => box
      (conditional_expression'nt, [NT conditional_expression'nt; T COLON't; NT expression'nt; T QUESTION't; NT logical_OR_expression'nt])
      (fun expr3 _4 expr2 _2 expr1 =>
 (QUESTION (fst expr1) (fst expr2) (fst expr3), snd expr1) 
)
    | Prod'constant_expression'0 => box
      (constant_expression'nt, [NT conditional_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'declaration'0 => box
      (declaration'nt, [T SEMICOLON't; NT init_declarator_list'nt; NT declaration_specifiers'nt])
      (fun _3 decls decspec =>
 DECDEF (fst decspec, rev' decls) (snd decspec) 
)
    | Prod'declaration'1 => box
      (declaration'nt, [T SEMICOLON't; NT declaration_specifiers'nt])
      (fun _2 decspec =>
 DECDEF (fst decspec, []) (snd decspec) 
)
    | Prod'declaration_list'0 => box
      (declaration_list'nt, [])
      (
 [] 
)
    | Prod'declaration_list'1 => box
      (declaration_list'nt, [NT declaration'nt; NT declaration_list'nt])
      (fun d dl =>
 d :: dl 
)
    | Prod'declaration_specifiers'0 => box
      (declaration_specifiers'nt, [NT declaration_specifiers'nt; NT storage_class_specifier'nt])
      (fun rest storage =>
 (SpecStorage (fst storage)::fst rest, snd storage) 
)
    | Prod'declaration_specifiers'1 => box
      (declaration_specifiers'nt, [NT storage_class_specifier'nt])
      (fun storage =>
 ([SpecStorage (fst storage)], snd storage) 
)
    | Prod'declaration_specifiers'2 => box
      (declaration_specifiers'nt, [NT declaration_specifiers'nt; NT type_specifier'nt])
      (fun rest typ =>
 (SpecType (fst typ)::fst rest, snd typ) 
)
    | Prod'declaration_specifiers'3 => box
      (declaration_specifiers'nt, [NT type_specifier'nt])
      (fun typ =>
 ([SpecType (fst typ)], snd typ) 
)
    | Prod'declaration_specifiers'4 => box
      (declaration_specifiers'nt, [NT declaration_specifiers'nt; NT type_qualifier'nt])
      (fun rest qual =>
 (SpecCV (fst qual)::fst rest, snd qual) 
)
    | Prod'declaration_specifiers'5 => box
      (declaration_specifiers'nt, [NT type_qualifier'nt])
      (fun qual =>
 ([SpecCV (fst qual)], snd qual) 
)
    | Prod'declaration_specifiers'6 => box
      (declaration_specifiers'nt, [NT declaration_specifiers'nt; NT function_specifier'nt])
      (fun rest loc =>
 (SpecInline::fst rest, loc) 
)
    | Prod'declaration_specifiers'7 => box
      (declaration_specifiers'nt, [NT function_specifier'nt])
      (fun loc =>
 ([SpecInline], loc) 
)
    | Prod'declarator'0 => box
      (declarator'nt, [NT attribute_specifier_list'nt; NT direct_declarator'nt])
      (fun attrs decl =>
 match decl with Name name typ attr loc =>
        Name name typ (List.app attr attrs) loc end 
)
    | Prod'declarator'1 => box
      (declarator'nt, [NT attribute_specifier_list'nt; NT direct_declarator'nt; NT pointer'nt])
      (fun attrs decl pt =>
 match decl with Name name typ attr _ =>
        Name name ((fst pt) typ) (List.app attr attrs) (snd pt) end 
)
    | Prod'designation'0 => box
      (designation'nt, [T EQ't; NT designator_list'nt])
      (fun _2 design =>
 rev' design 
)
    | Prod'designator'0 => box
      (designator'nt, [T RBRACK't; NT constant_expression'nt; T LBRACK't])
      (fun _3 expr _1 =>
 ATINDEX_INIT (fst expr) 
)
    | Prod'designator'1 => box
      (designator'nt, [T OTHER_NAME't; T DOT't])
      (fun id _1 =>
 INFIELD_INIT (fst id) 
)
    | Prod'designator_list'0 => box
      (designator_list'nt, [NT designator'nt])
      (fun design =>
 [design] 
)
    | Prod'designator_list'1 => box
      (designator_list'nt, [NT designator'nt; NT designator_list'nt])
      (fun designt designq =>
 designt::designq 
)
    | Prod'direct_abstract_declarator'0 => box
      (direct_abstract_declarator'nt, [T RPAREN't; NT abstract_declarator'nt; T LPAREN't])
      (fun _3 typ _1 =>
 typ 
)
    | Prod'direct_abstract_declarator'1 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt])
      (fun _5 expr cvspec _2 typ =>
 ARRAY typ cvspec (Some (fst expr)) 
)
    | Prod'direct_abstract_declarator'2 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't])
      (fun _4 expr cvspec _1 =>
 ARRAY JUSTBASE cvspec (Some (fst expr)) 
)
    | Prod'direct_abstract_declarator'3 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT assignment_expression'nt; T LBRACK't; NT direct_abstract_declarator'nt])
      (fun _4 expr _2 typ =>
 ARRAY typ [] (Some (fst expr)) 
)
    | Prod'direct_abstract_declarator'4 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT assignment_expression'nt; T LBRACK't])
      (fun _3 expr _1 =>
 ARRAY JUSTBASE [] (Some (fst expr)) 
)
    | Prod'direct_abstract_declarator'5 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt])
      (fun _4 cvspec _2 typ =>
 ARRAY typ cvspec None 
)
    | Prod'direct_abstract_declarator'6 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT type_qualifier_list'nt; T LBRACK't])
      (fun _3 cvspec _1 =>
 ARRAY JUSTBASE cvspec None 
)
    | Prod'direct_abstract_declarator'7 => box
      (direct_abstract_declarator'nt, [T RBRACK't; T LBRACK't; NT direct_abstract_declarator'nt])
      (fun _3 _2 typ =>
 ARRAY typ [] None 
)
    | Prod'direct_abstract_declarator'8 => box
      (direct_abstract_declarator'nt, [T RBRACK't; T LBRACK't])
      (fun _2 _1 =>
 ARRAY JUSTBASE [] None 
)
    | Prod'direct_abstract_declarator'9 => box
      (direct_abstract_declarator'nt, [T RPAREN't; NT parameter_type_list'nt; T LPAREN't; NT direct_abstract_declarator'nt])
      (fun _4 params _2 typ =>
 PROTO typ params 
)
    | Prod'direct_abstract_declarator'10 => box
      (direct_abstract_declarator'nt, [T RPAREN't; NT parameter_type_list'nt; T LPAREN't])
      (fun _3 params _1 =>
 PROTO JUSTBASE params 
)
    | Prod'direct_abstract_declarator'11 => box
      (direct_abstract_declarator'nt, [T RPAREN't; T LPAREN't; NT direct_abstract_declarator'nt])
      (fun _3 _2 typ =>
 PROTO typ ([], false) 
)
    | Prod'direct_abstract_declarator'12 => box
      (direct_abstract_declarator'nt, [T RPAREN't; T LPAREN't])
      (fun _2 _1 =>
 PROTO JUSTBASE ([], false) 
)
    | Prod'direct_declarator'0 => box
      (direct_declarator'nt, [T VAR_NAME't])
      (fun id =>
 Name (fst id) JUSTBASE [] (snd id) 
)
    | Prod'direct_declarator'1 => box
      (direct_declarator'nt, [T RPAREN't; NT declarator'nt; T LPAREN't])
      (fun _3 decl _1 =>
 decl 
)
    | Prod'direct_declarator'2 => box
      (direct_declarator'nt, [T RBRACK't; NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt])
      (fun _5 expr quallst _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (ARRAY typ (rev' quallst) (Some (fst expr))) attr loc end 
)
    | Prod'direct_declarator'3 => box
      (direct_declarator'nt, [T RBRACK't; NT assignment_expression'nt; T LBRACK't; NT direct_declarator'nt])
      (fun _4 expr _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (ARRAY typ [] (Some (fst expr))) attr loc end 
)
    | Prod'direct_declarator'4 => box
      (direct_declarator'nt, [T RBRACK't; NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt])
      (fun _4 quallst _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (ARRAY typ (rev' quallst) None) attr loc end 
)
    | Prod'direct_declarator'5 => box
      (direct_declarator'nt, [T RBRACK't; T LBRACK't; NT direct_declarator'nt])
      (fun _3 _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (ARRAY typ [] None) attr loc end 
)
    | Prod'direct_declarator'6 => box
      (direct_declarator'nt, [T RPAREN't; NT parameter_type_list'nt; T LPAREN't; NT direct_declarator'nt])
      (fun _4 params _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (PROTO typ params) attr loc end 
)
    | Prod'direct_declarator'7 => box
      (direct_declarator'nt, [T RPAREN't; T LPAREN't; NT direct_declarator'nt])
      (fun _3 _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (PROTO typ ([], false)) attr loc end 
)
    | Prod'direct_old_function_declarator'0 => box
      (direct_old_function_declarator'nt, [T RPAREN't; NT identifier_list'nt; T LPAREN't; NT direct_declarator'nt])
      (fun _4 params _2 decl =>
 (decl, List.rev' params) 
)
    | Prod'enum_specifier'0 => box
      (enum_specifier'nt, [T RBRACE't; NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't])
      (fun _6 enum_list _4 name attrs loc =>
 (Tenum (Some (fst name)) (Some (rev' enum_list)) (rev' attrs), loc) 
)
    | Prod'enum_specifier'1 => box
      (enum_specifier'nt, [T RBRACE't; NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't])
      (fun _5 enum_list _3 attrs loc =>
 (Tenum None (Some (rev' enum_list)) (rev' attrs), loc) 
)
    | Prod'enum_specifier'2 => box
      (enum_specifier'nt, [T RBRACE't; T COMMA't; NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't])
      (fun _7 _6 enum_list _4 name attrs loc =>
 (Tenum (Some (fst name)) (Some (rev' enum_list)) (rev' attrs), loc) 
)
    | Prod'enum_specifier'3 => box
      (enum_specifier'nt, [T RBRACE't; T COMMA't; NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't])
      (fun _6 _5 enum_list _3 attrs loc =>
 (Tenum None (Some (rev' enum_list)) (rev' attrs), loc) 
)
    | Prod'enum_specifier'4 => box
      (enum_specifier'nt, [T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't])
      (fun name attrs loc =>
 (Tenum (Some (fst name)) None (rev' attrs), loc) 
)
    | Prod'enumeration_constant'0 => box
      (enumeration_constant'nt, [T VAR_NAME't])
      (fun cst =>
 cst 
)
    | Prod'enumerator'0 => box
      (enumerator'nt, [NT enumeration_constant'nt])
      (fun cst =>
 (fst cst, None, snd cst) 
)
    | Prod'enumerator'1 => box
      (enumerator'nt, [NT constant_expression'nt; T EQ't; NT enumeration_constant'nt])
      (fun expr _2 cst =>
 (fst cst, Some (fst expr), snd cst) 
)
    | Prod'enumerator_list'0 => box
      (enumerator_list'nt, [NT enumerator'nt])
      (fun enum =>
 [enum] 
)
    | Prod'enumerator_list'1 => box
      (enumerator_list'nt, [NT enumerator'nt; T COMMA't; NT enumerator_list'nt])
      (fun enumst _2 enumsq =>
 enumst::enumsq 
)
    | Prod'equality_expression'0 => box
      (equality_expression'nt, [NT relational_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'equality_expression'1 => box
      (equality_expression'nt, [NT relational_expression'nt; T EQEQ't; NT equality_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY EQ (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'equality_expression'2 => box
      (equality_expression'nt, [NT relational_expression'nt; T NEQ't; NT equality_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY NE (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'exclusive_OR_expression'0 => box
      (exclusive_OR_expression'nt, [NT AND_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'exclusive_OR_expression'1 => box
      (exclusive_OR_expression'nt, [NT AND_expression'nt; T HAT't; NT exclusive_OR_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY XOR (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'expression'0 => box
      (expression'nt, [NT assignment_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'expression'1 => box
      (expression'nt, [NT assignment_expression'nt; T COMMA't; NT expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY COMMA (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'expression_statement'0 => box
      (expression_statement'nt, [T SEMICOLON't; NT expression'nt])
      (fun _2 expr =>
 COMPUTATION (fst expr) (snd expr) 
)
    | Prod'expression_statement'1 => box
      (expression_statement'nt, [T SEMICOLON't])
      (fun loc =>
 NOP loc 
)
    | Prod'external_declaration'0 => box
      (external_declaration'nt, [NT function_definition'nt])
      (fun def =>
 def 
)
    | Prod'external_declaration'1 => box
      (external_declaration'nt, [NT declaration'nt])
      (fun def =>
 def 
)
    | Prod'external_declaration'2 => box
      (external_declaration'nt, [T PRAGMA't])
      (fun p =>
 PRAGMA (fst p) (snd p) 
)
    | Prod'function_definition'0 => box
      (function_definition'nt, [NT compound_statement'nt; NT declarator'nt; NT declaration_specifiers'nt])
      (fun stmt decl specs =>
 FUNDEF (fst specs) decl stmt (snd specs) 
)
    | Prod'function_definition'1 => box
      (function_definition'nt, [NT compound_statement'nt; NT declaration_list'nt; NT old_function_declarator'nt; NT declaration_specifiers'nt])
      (fun stmt dlist decl specs =>
 KRFUNDEF (fst specs) (fst decl) (snd decl) (List.rev' dlist) stmt (snd specs) 
)
    | Prod'function_specifier'0 => box
      (function_specifier'nt, [T INLINE't])
      (fun loc =>
 loc 
)
    | Prod'gcc_attribute'0 => box
      (gcc_attribute'nt, [])
      (
 GCC_ATTR_EMPTY 
)
    | Prod'gcc_attribute'1 => box
      (gcc_attribute'nt, [NT gcc_attribute_word'nt])
      (fun w =>
 GCC_ATTR_NOARGS w 
)
    | Prod'gcc_attribute'2 => box
      (gcc_attribute'nt, [T RPAREN't; T LPAREN't; NT gcc_attribute_word'nt])
      (fun _3 _2 w =>
 GCC_ATTR_ARGS w [] 
)
    | Prod'gcc_attribute'3 => box
      (gcc_attribute'nt, [T RPAREN't; NT argument_expression_list'nt; T LPAREN't; NT gcc_attribute_word'nt])
      (fun _4 args _2 w =>
 GCC_ATTR_ARGS w args 
)
    | Prod'gcc_attribute_list'0 => box
      (gcc_attribute_list'nt, [NT gcc_attribute'nt])
      (fun a =>
 [a] 
)
    | Prod'gcc_attribute_list'1 => box
      (gcc_attribute_list'nt, [NT gcc_attribute'nt; T COMMA't; NT gcc_attribute_list'nt])
      (fun t _2 q =>
 t::q 
)
    | Prod'gcc_attribute_word'0 => box
      (gcc_attribute_word'nt, [T OTHER_NAME't])
      (fun i =>
 GCC_ATTR_IDENT (fst i) 
)
    | Prod'gcc_attribute_word'1 => box
      (gcc_attribute_word'nt, [T CONST't])
      (fun _1 =>
 GCC_ATTR_CONST 
)
    | Prod'gcc_attribute_word'2 => box
      (gcc_attribute_word'nt, [T PACKED't])
      (fun _1 =>
 GCC_ATTR_PACKED 
)
    | Prod'identifier_list'0 => box
      (identifier_list'nt, [T VAR_NAME't])
      (fun id =>
 [fst id] 
)
    | Prod'identifier_list'1 => box
      (identifier_list'nt, [T VAR_NAME't; T COMMA't; NT identifier_list'nt])
      (fun id _2 idl =>
 fst id :: idl 
)
    | Prod'inclusive_OR_expression'0 => box
      (inclusive_OR_expression'nt, [NT exclusive_OR_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'inclusive_OR_expression'1 => box
      (inclusive_OR_expression'nt, [NT exclusive_OR_expression'nt; T BAR't; NT inclusive_OR_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY BOR (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'init_declarator'0 => box
      (init_declarator'nt, [NT declarator'nt])
      (fun name =>
 Init_name name NO_INIT 
)
    | Prod'init_declarator'1 => box
      (init_declarator'nt, [NT c_initializer'nt; T EQ't; NT declarator'nt])
      (fun init _2 name =>
 Init_name name init 
)
    | Prod'init_declarator_list'0 => box
      (init_declarator_list'nt, [NT init_declarator'nt])
      (fun init =>
 [init] 
)
    | Prod'init_declarator_list'1 => box
      (init_declarator_list'nt, [NT init_declarator'nt; T COMMA't; NT init_declarator_list'nt])
      (fun initt _2 initq =>
 initt::initq 
)
    | Prod'initializer_list'0 => box
      (initializer_list'nt, [NT c_initializer'nt; NT designation'nt])
      (fun init design =>
 [(design, init)] 
)
    | Prod'initializer_list'1 => box
      (initializer_list'nt, [NT c_initializer'nt])
      (fun init =>
 [([], init)] 
)
    | Prod'initializer_list'2 => box
      (initializer_list'nt, [NT c_initializer'nt; NT designation'nt; T COMMA't; NT initializer_list'nt])
      (fun init design _2 initq =>
 (design, init)::initq 
)
    | Prod'initializer_list'3 => box
      (initializer_list'nt, [NT c_initializer'nt; T COMMA't; NT initializer_list'nt])
      (fun init _2 initq =>
 ([], init)::initq 
)
    | Prod'iteration_statement_statement_dangerous_'0 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't])
      (fun stmt _4 expr _2 loc =>
 WHILE (fst expr) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'1 => box
      (iteration_statement_statement_dangerous_'nt, [T SEMICOLON't; T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't])
      (fun _7 _6 expr _4 _3 stmt loc =>
 DOWHILE (fst expr) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'2 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _8 expr3 _6 expr2 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'3 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 expr2 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'4 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 expr2 _3 _2 loc =>
 FOR None (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'5 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'6 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _6 expr3 _4 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'7 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _6 expr3 _4 _3 _2 loc =>
 FOR None None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'8 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _7 _6 expr2 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'9 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _6 _5 expr2 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'10 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _6 _5 expr2 _3 _2 loc =>
 FOR None (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'11 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _6 _5 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) None None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'12 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _5 _4 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) None None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'13 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _5 _4 _3 _2 loc =>
 FOR None None None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'0 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't])
      (fun stmt _4 expr _2 loc =>
 WHILE (fst expr) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'1 => box
      (iteration_statement_statement_safe_'nt, [T SEMICOLON't; T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't])
      (fun _7 _6 expr _4 _3 stmt loc =>
 DOWHILE (fst expr) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'2 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _8 expr3 _6 expr2 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'3 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 expr2 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'4 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 expr2 _3 _2 loc =>
 FOR None (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'5 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'6 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _6 expr3 _4 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'7 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _6 expr3 _4 _3 _2 loc =>
 FOR None None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'8 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _7 _6 expr2 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'9 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _6 _5 expr2 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'10 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _6 _5 expr2 _3 _2 loc =>
 FOR None (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'11 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _6 _5 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) None None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'12 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _5 _4 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) None None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'13 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _5 _4 _3 _2 loc =>
 FOR None None None stmt loc 
)
    | Prod'jump_statement'0 => box
      (jump_statement'nt, [T SEMICOLON't; T OTHER_NAME't; T GOTO't])
      (fun _3 id loc =>
 GOTO (fst id) loc 
)
    | Prod'jump_statement'1 => box
      (jump_statement'nt, [T SEMICOLON't; T CONTINUE't])
      (fun _2 loc =>
 CONTINUE loc 
)
    | Prod'jump_statement'2 => box
      (jump_statement'nt, [T SEMICOLON't; T BREAK't])
      (fun _2 loc =>
 BREAK loc 
)
    | Prod'jump_statement'3 => box
      (jump_statement'nt, [T SEMICOLON't; NT expression'nt; T RETURN't])
      (fun _3 expr loc =>
 RETURN (Some (fst expr)) loc 
)
    | Prod'jump_statement'4 => box
      (jump_statement'nt, [T SEMICOLON't; T RETURN't])
      (fun _2 loc =>
 RETURN None loc 
)
    | Prod'labeled_statement_statement_dangerous_'0 => box
      (labeled_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T COLON't; T OTHER_NAME't])
      (fun stmt _2 lbl =>
 LABEL (fst lbl) stmt (snd lbl) 
)
    | Prod'labeled_statement_statement_dangerous_'1 => box
      (labeled_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T COLON't; NT constant_expression'nt; T CASE't])
      (fun stmt _3 expr loc =>
 CASE (fst expr) stmt loc 
)
    | Prod'labeled_statement_statement_dangerous_'2 => box
      (labeled_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T COLON't; T DEFAULT't])
      (fun stmt _2 loc =>
 DEFAULT stmt loc 
)
    | Prod'labeled_statement_statement_safe_'0 => box
      (labeled_statement_statement_safe_'nt, [NT statement_safe'nt; T COLON't; T OTHER_NAME't])
      (fun stmt _2 lbl =>
 LABEL (fst lbl) stmt (snd lbl) 
)
    | Prod'labeled_statement_statement_safe_'1 => box
      (labeled_statement_statement_safe_'nt, [NT statement_safe'nt; T COLON't; NT constant_expression'nt; T CASE't])
      (fun stmt _3 expr loc =>
 CASE (fst expr) stmt loc 
)
    | Prod'labeled_statement_statement_safe_'2 => box
      (labeled_statement_statement_safe_'nt, [NT statement_safe'nt; T COLON't; T DEFAULT't])
      (fun stmt _2 loc =>
 DEFAULT stmt loc 
)
    | Prod'logical_AND_expression'0 => box
      (logical_AND_expression'nt, [NT inclusive_OR_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'logical_AND_expression'1 => box
      (logical_AND_expression'nt, [NT inclusive_OR_expression'nt; T ANDAND't; NT logical_AND_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY AND (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'logical_OR_expression'0 => box
      (logical_OR_expression'nt, [NT logical_AND_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'logical_OR_expression'1 => box
      (logical_OR_expression'nt, [NT logical_AND_expression'nt; T BARBAR't; NT logical_OR_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY OR (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'multiplicative_expression'0 => box
      (multiplicative_expression'nt, [NT cast_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'multiplicative_expression'1 => box
      (multiplicative_expression'nt, [NT cast_expression'nt; T STAR't; NT multiplicative_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY MUL (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'multiplicative_expression'2 => box
      (multiplicative_expression'nt, [NT cast_expression'nt; T SLASH't; NT multiplicative_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY DIV (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'multiplicative_expression'3 => box
      (multiplicative_expression'nt, [NT cast_expression'nt; T PERCENT't; NT multiplicative_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY MOD (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'old_function_declarator'0 => box
      (old_function_declarator'nt, [NT direct_old_function_declarator'nt])
      (fun decl =>
 decl 
)
    | Prod'old_function_declarator'1 => box
      (old_function_declarator'nt, [NT direct_old_function_declarator'nt; NT pointer'nt])
      (fun decl pt =>
 match decl with (Name name typ attr _, params) =>
        (Name name ((fst pt) typ) attr (snd pt), params) end 
)
    | Prod'parameter_declaration'0 => box
      (parameter_declaration'nt, [NT declarator'nt; NT declaration_specifiers'nt])
      (fun decl specs =>
 match decl with Name name typ attr _ =>
        PARAM (fst specs) (Some name) typ attr (snd specs) end 
)
    | Prod'parameter_declaration'1 => box
      (parameter_declaration'nt, [NT abstract_declarator'nt; NT declaration_specifiers'nt])
      (fun decl specs =>
 PARAM (fst specs) None decl [] (snd specs) 
)
    | Prod'parameter_declaration'2 => box
      (parameter_declaration'nt, [NT declaration_specifiers'nt])
      (fun specs =>
 PARAM (fst specs) None JUSTBASE [] (snd specs) 
)
    | Prod'parameter_list'0 => box
      (parameter_list'nt, [NT parameter_declaration'nt])
      (fun param =>
 [param] 
)
    | Prod'parameter_list'1 => box
      (parameter_list'nt, [NT parameter_declaration'nt; T COMMA't; NT parameter_list'nt])
      (fun paramt _2 paramq =>
 paramt::paramq 
)
    | Prod'parameter_type_list'0 => box
      (parameter_type_list'nt, [NT parameter_list'nt])
      (fun lst =>
 (rev' lst, false) 
)
    | Prod'parameter_type_list'1 => box
      (parameter_type_list'nt, [T ELLIPSIS't; T COMMA't; NT parameter_list'nt])
      (fun _3 _2 lst =>
 (rev' lst, true) 
)
    | Prod'pointer'0 => box
      (pointer'nt, [T STAR't])
      (fun loc =>
 (fun typ => PTR [] typ, loc) 
)
    | Prod'pointer'1 => box
      (pointer'nt, [NT type_qualifier_list'nt; T STAR't])
      (fun quallst loc =>
 (fun typ => PTR (rev' quallst) typ, loc) 
)
    | Prod'pointer'2 => box
      (pointer'nt, [NT pointer'nt; T STAR't])
      (fun pt loc =>
 (fun typ => PTR [] ((fst pt) typ), loc) 
)
    | Prod'pointer'3 => box
      (pointer'nt, [NT pointer'nt; NT type_qualifier_list'nt; T STAR't])
      (fun pt quallst loc =>
 (fun typ => PTR (rev' quallst) ((fst pt) typ), loc) 
)
    | Prod'postfix_expression'0 => box
      (postfix_expression'nt, [NT primary_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'postfix_expression'1 => box
      (postfix_expression'nt, [T RBRACK't; NT expression'nt; T LBRACK't; NT postfix_expression'nt])
      (fun _4 index _2 expr =>
 (INDEX (fst expr) (fst index), snd expr) 
)
    | Prod'postfix_expression'2 => box
      (postfix_expression'nt, [T RPAREN't; NT argument_expression_list'nt; T LPAREN't; NT postfix_expression'nt])
      (fun _4 args _2 expr =>
 (CALL (fst expr) (rev' args), snd expr) 
)
    | Prod'postfix_expression'3 => box
      (postfix_expression'nt, [T RPAREN't; T LPAREN't; NT postfix_expression'nt])
      (fun _3 _2 expr =>
 (CALL (fst expr) [], snd expr) 
)
    | Prod'postfix_expression'4 => box
      (postfix_expression'nt, [T RPAREN't; NT type_name'nt; T COMMA't; NT assignment_expression'nt; T LPAREN't; T BUILTIN_VA_ARG't])
      (fun _6 ty _4 expr _2 loc =>
 (BUILTIN_VA_ARG (fst expr) ty, loc) 
)
    | Prod'postfix_expression'5 => box
      (postfix_expression'nt, [T OTHER_NAME't; T DOT't; NT postfix_expression'nt])
      (fun mem _2 expr =>
 (MEMBEROF (fst expr) (fst mem), snd expr) 
)
    | Prod'postfix_expression'6 => box
      (postfix_expression'nt, [T OTHER_NAME't; T PTR't; NT postfix_expression'nt])
      (fun mem _2 expr =>
 (MEMBEROFPTR (fst expr) (fst mem), snd expr) 
)
    | Prod'postfix_expression'7 => box
      (postfix_expression'nt, [T INC't; NT postfix_expression'nt])
      (fun _2 expr =>
 (UNARY POSINCR (fst expr), snd expr) 
)
    | Prod'postfix_expression'8 => box
      (postfix_expression'nt, [T DEC't; NT postfix_expression'nt])
      (fun _2 expr =>
 (UNARY POSDECR (fst expr), snd expr) 
)
    | Prod'postfix_expression'9 => box
      (postfix_expression'nt, [T RBRACE't; NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't])
      (fun _6 init _4 _3 typ loc =>
 (CAST typ (COMPOUND_INIT (rev' init)), loc) 
)
    | Prod'postfix_expression'10 => box
      (postfix_expression'nt, [T RBRACE't; T COMMA't; NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't])
      (fun _7 _6 init _4 _3 typ loc =>
 (CAST typ (COMPOUND_INIT (rev' init)), loc) 
)
    | Prod'primary_expression'0 => box
      (primary_expression'nt, [T VAR_NAME't])
      (fun var =>
 (VARIABLE (fst var), snd var) 
)
    | Prod'primary_expression'1 => box
      (primary_expression'nt, [T CONSTANT't])
      (fun cst =>
 (CONSTANT (fst cst), snd cst) 
)
    | Prod'primary_expression'2 => box
      (primary_expression'nt, [T STRING_LITERAL't])
      (fun str =>
 let '((wide, chars), loc) := str in
      (CONSTANT (CONST_STRING wide chars), loc) 
)
    | Prod'primary_expression'3 => box
      (primary_expression'nt, [T RPAREN't; NT expression'nt; T LPAREN't])
      (fun _3 expr loc =>
 (fst expr, loc)
)
    | Prod'relational_expression'0 => box
      (relational_expression'nt, [NT shift_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'relational_expression'1 => box
      (relational_expression'nt, [NT shift_expression'nt; T LT't; NT relational_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY LT (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'relational_expression'2 => box
      (relational_expression'nt, [NT shift_expression'nt; T GT't; NT relational_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY GT (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'relational_expression'3 => box
      (relational_expression'nt, [NT shift_expression'nt; T LEQ't; NT relational_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY LE (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'relational_expression'4 => box
      (relational_expression'nt, [NT shift_expression'nt; T GEQ't; NT relational_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY GE (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'selection_statement_dangerous'0 => box
      (selection_statement_dangerous'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't])
      (fun stmt _4 expr _2 loc =>
 If (fst expr) stmt None loc 
)
    | Prod'selection_statement_dangerous'1 => box
      (selection_statement_dangerous'nt, [NT statement_dangerous'nt; T ELSE't; NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't])
      (fun stmt2 _6 stmt1 _4 expr _2 loc =>
 If (fst expr) stmt1 (Some stmt2) loc 
)
    | Prod'selection_statement_dangerous'2 => box
      (selection_statement_dangerous'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T LPAREN't; T SWITCH't])
      (fun stmt _4 expr _2 loc =>
 SWITCH (fst expr) stmt loc 
)
    | Prod'selection_statement_safe'0 => box
      (selection_statement_safe'nt, [NT statement_safe'nt; T ELSE't; NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't])
      (fun stmt2 _6 stmt1 _4 expr _2 loc =>
 If (fst expr) stmt1 (Some stmt2) loc 
)
    | Prod'selection_statement_safe'1 => box
      (selection_statement_safe'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T SWITCH't])
      (fun stmt _4 expr _2 loc =>
 SWITCH (fst expr) stmt loc 
)
    | Prod'shift_expression'0 => box
      (shift_expression'nt, [NT additive_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'shift_expression'1 => box
      (shift_expression'nt, [NT additive_expression'nt; T LEFT't; NT shift_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY SHL (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'shift_expression'2 => box
      (shift_expression'nt, [NT additive_expression'nt; T RIGHT't; NT shift_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY SHR (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'specifier_qualifier_list'0 => box
      (specifier_qualifier_list'nt, [NT specifier_qualifier_list'nt; NT type_specifier'nt])
      (fun rest typ =>
 (SpecType (fst typ)::fst rest, snd typ) 
)
    | Prod'specifier_qualifier_list'1 => box
      (specifier_qualifier_list'nt, [NT type_specifier'nt])
      (fun typ =>
 ([SpecType (fst typ)], snd typ) 
)
    | Prod'specifier_qualifier_list'2 => box
      (specifier_qualifier_list'nt, [NT specifier_qualifier_list'nt; NT type_qualifier'nt])
      (fun rest qual =>
 (SpecCV (fst qual)::fst rest, snd qual) 
)
    | Prod'specifier_qualifier_list'3 => box
      (specifier_qualifier_list'nt, [NT type_qualifier'nt])
      (fun qual =>
 ([SpecCV (fst qual)], snd qual) 
)
    | Prod'statement_dangerous'0 => box
      (statement_dangerous'nt, [NT labeled_statement_statement_dangerous_'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'1 => box
      (statement_dangerous'nt, [NT compound_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'2 => box
      (statement_dangerous'nt, [NT expression_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'3 => box
      (statement_dangerous'nt, [NT selection_statement_dangerous'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'4 => box
      (statement_dangerous'nt, [NT iteration_statement_statement_dangerous_'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'5 => box
      (statement_dangerous'nt, [NT jump_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'6 => box
      (statement_dangerous'nt, [NT asm_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'0 => box
      (statement_safe'nt, [NT labeled_statement_statement_safe_'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'1 => box
      (statement_safe'nt, [NT compound_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'2 => box
      (statement_safe'nt, [NT expression_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'3 => box
      (statement_safe'nt, [NT selection_statement_safe'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'4 => box
      (statement_safe'nt, [NT iteration_statement_statement_safe_'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'5 => box
      (statement_safe'nt, [NT jump_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'6 => box
      (statement_safe'nt, [NT asm_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'storage_class_specifier'0 => box
      (storage_class_specifier'nt, [T TYPEDEF't])
      (fun loc =>
 (TYPEDEF, loc) 
)
    | Prod'storage_class_specifier'1 => box
      (storage_class_specifier'nt, [T EXTERN't])
      (fun loc =>
 (EXTERN, loc) 
)
    | Prod'storage_class_specifier'2 => box
      (storage_class_specifier'nt, [T STATIC't])
      (fun loc =>
 (STATIC, loc) 
)
    | Prod'storage_class_specifier'3 => box
      (storage_class_specifier'nt, [T AUTO't])
      (fun loc =>
 (AUTO, loc) 
)
    | Prod'storage_class_specifier'4 => box
      (storage_class_specifier'nt, [T REGISTER't])
      (fun loc =>
 (REGISTER, loc) 
)
    | Prod'struct_declaration'0 => box
      (struct_declaration'nt, [T SEMICOLON't; NT struct_declarator_list'nt; NT specifier_qualifier_list'nt])
      (fun _3 decls decspec =>
 Field_group (fst decspec) (rev' decls) (snd decspec) 
)
    | Prod'struct_declaration'1 => box
      (struct_declaration'nt, [T SEMICOLON't; NT specifier_qualifier_list'nt])
      (fun _2 decspec =>
 Field_group (fst decspec) [] (snd decspec) 
)
    | Prod'struct_declaration_list'0 => box
      (struct_declaration_list'nt, [])
      (
 nil 
)
    | Prod'struct_declaration_list'1 => box
      (struct_declaration_list'nt, [NT struct_declaration'nt; NT struct_declaration_list'nt])
      (fun tdecls qdecls =>
 tdecls::qdecls 
)
    | Prod'struct_declarator'0 => box
      (struct_declarator'nt, [NT declarator'nt])
      (fun decl =>
 (Some decl, None) 
)
    | Prod'struct_declarator'1 => box
      (struct_declarator'nt, [NT constant_expression'nt; T COLON't; NT declarator'nt])
      (fun expr _2 decl =>
 (Some decl, Some (fst expr)) 
)
    | Prod'struct_declarator'2 => box
      (struct_declarator'nt, [NT constant_expression'nt; T COLON't])
      (fun expr _1 =>
 (None, Some (fst expr)) 
)
    | Prod'struct_declarator_list'0 => box
      (struct_declarator_list'nt, [NT struct_declarator'nt])
      (fun decl =>
 [decl] 
)
    | Prod'struct_declarator_list'1 => box
      (struct_declarator_list'nt, [NT struct_declarator'nt; T COMMA't; NT struct_declarator_list'nt])
      (fun declt _2 declq =>
 declt::declq 
)
    | Prod'struct_or_union'0 => box
      (struct_or_union'nt, [T STRUCT't])
      (fun loc =>
 (STRUCT, loc) 
)
    | Prod'struct_or_union'1 => box
      (struct_or_union'nt, [T UNION't])
      (fun loc =>
 (UNION, loc) 
)
    | Prod'struct_or_union_specifier'0 => box
      (struct_or_union_specifier'nt, [T RBRACE't; NT struct_declaration_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt])
      (fun _6 decls _4 id attrs str_uni =>
 (Tstruct_union (fst str_uni) (Some (fst id)) (Some (rev' decls)) (rev' attrs), snd str_uni) 
)
    | Prod'struct_or_union_specifier'1 => box
      (struct_or_union_specifier'nt, [T RBRACE't; NT struct_declaration_list'nt; T LBRACE't; NT attribute_specifier_list'nt; NT struct_or_union'nt])
      (fun _5 decls _3 attrs str_uni =>
 (Tstruct_union (fst str_uni) None (Some (rev' decls)) (rev' attrs),            snd str_uni) 
)
    | Prod'struct_or_union_specifier'2 => box
      (struct_or_union_specifier'nt, [T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt])
      (fun id attrs str_uni =>
 (Tstruct_union (fst str_uni) (Some (fst id)) None (rev' attrs),         snd str_uni) 
)
    | Prod'translation_unit'0 => box
      (translation_unit'nt, [NT external_declaration'nt])
      (fun def =>
 [def] 
)
    | Prod'translation_unit'1 => box
      (translation_unit'nt, [NT external_declaration'nt; NT translation_unit'nt])
      (fun deft defq =>
 deft::defq 
)
    | Prod'translation_unit_file'0 => box
      (translation_unit_file'nt, [T EOF't; NT translation_unit'nt])
      (fun _2 lst =>
 rev' lst 
)
    | Prod'translation_unit_file'1 => box
      (translation_unit_file'nt, [T EOF't])
      (fun _1 =>
 [] 
)
    | Prod'type_name'0 => box
      (type_name'nt, [NT specifier_qualifier_list'nt])
      (fun specqual =>
 (fst specqual, JUSTBASE) 
)
    | Prod'type_name'1 => box
      (type_name'nt, [NT abstract_declarator'nt; NT specifier_qualifier_list'nt])
      (fun typ specqual =>
 (fst specqual, typ) 
)
    | Prod'type_qualifier'0 => box
      (type_qualifier'nt, [T CONST't])
      (fun loc =>
 (CV_CONST, loc) 
)
    | Prod'type_qualifier'1 => box
      (type_qualifier'nt, [T RESTRICT't])
      (fun loc =>
 (CV_RESTRICT, loc) 
)
    | Prod'type_qualifier'2 => box
      (type_qualifier'nt, [T VOLATILE't])
      (fun loc =>
 (CV_VOLATILE, loc) 
)
    | Prod'type_qualifier'3 => box
      (type_qualifier'nt, [NT attribute_specifier'nt])
      (fun attr =>
 (CV_ATTR (fst attr), snd attr) 
)
    | Prod'type_qualifier_list'0 => box
      (type_qualifier_list'nt, [NT type_qualifier'nt])
      (fun qual =>
 [fst qual] 
)
    | Prod'type_qualifier_list'1 => box
      (type_qualifier_list'nt, [NT type_qualifier'nt; NT type_qualifier_list'nt])
      (fun qualt qualq =>
 fst qualt::qualq 
)
    | Prod'type_specifier'0 => box
      (type_specifier'nt, [T VOID't])
      (fun loc =>
 (Tvoid, loc) 
)
    | Prod'type_specifier'1 => box
      (type_specifier'nt, [T CHAR't])
      (fun loc =>
 (Tchar, loc) 
)
    | Prod'type_specifier'2 => box
      (type_specifier'nt, [T SHORT't])
      (fun loc =>
 (Tshort, loc) 
)
    | Prod'type_specifier'3 => box
      (type_specifier'nt, [T INT't])
      (fun loc =>
 (Tint, loc) 
)
    | Prod'type_specifier'4 => box
      (type_specifier'nt, [T LONG't])
      (fun loc =>
 (Tlong, loc) 
)
    | Prod'type_specifier'5 => box
      (type_specifier'nt, [T FLOAT't])
      (fun loc =>
 (Tfloat, loc) 
)
    | Prod'type_specifier'6 => box
      (type_specifier'nt, [T DOUBLE't])
      (fun loc =>
 (Tdouble, loc) 
)
    | Prod'type_specifier'7 => box
      (type_specifier'nt, [T SIGNED't])
      (fun loc =>
 (Tsigned, loc) 
)
    | Prod'type_specifier'8 => box
      (type_specifier'nt, [T UNSIGNED't])
      (fun loc =>
 (Tunsigned, loc) 
)
    | Prod'type_specifier'9 => box
      (type_specifier'nt, [T UNDERSCORE_BOOL't])
      (fun loc =>
 (T_Bool, loc) 
)
    | Prod'type_specifier'10 => box
      (type_specifier'nt, [NT struct_or_union_specifier'nt])
      (fun spec =>
 spec 
)
    | Prod'type_specifier'11 => box
      (type_specifier'nt, [NT enum_specifier'nt])
      (fun spec =>
 spec 
)
    | Prod'type_specifier'12 => box
      (type_specifier'nt, [T TYPEDEF_NAME't])
      (fun id =>
 (Tnamed (fst id), snd id) 
)
    | Prod'unary_expression'0 => box
      (unary_expression'nt, [NT postfix_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'unary_expression'1 => box
      (unary_expression'nt, [NT unary_expression'nt; T INC't])
      (fun expr loc =>
 (UNARY PREINCR (fst expr), loc) 
)
    | Prod'unary_expression'2 => box
      (unary_expression'nt, [NT unary_expression'nt; T DEC't])
      (fun expr loc =>
 (UNARY PREDECR (fst expr), loc) 
)
    | Prod'unary_expression'3 => box
      (unary_expression'nt, [NT cast_expression'nt; NT unary_operator'nt])
      (fun expr op =>
 (UNARY (fst op) (fst expr), snd op) 
)
    | Prod'unary_expression'4 => box
      (unary_expression'nt, [NT unary_expression'nt; T SIZEOF't])
      (fun expr loc =>
 (EXPR_SIZEOF (fst expr), loc) 
)
    | Prod'unary_expression'5 => box
      (unary_expression'nt, [T RPAREN't; NT type_name'nt; T LPAREN't; T SIZEOF't])
      (fun _4 typ _2 loc =>
 (TYPE_SIZEOF typ, loc) 
)
    | Prod'unary_expression'6 => box
      (unary_expression'nt, [NT unary_expression'nt; T ALIGNOF't])
      (fun expr loc =>
 (EXPR_ALIGNOF (fst expr), loc) 
)
    | Prod'unary_expression'7 => box
      (unary_expression'nt, [T RPAREN't; NT type_name'nt; T LPAREN't; T ALIGNOF't])
      (fun _4 typ _2 loc =>
 (TYPE_ALIGNOF typ, loc) 
)
    | Prod'unary_operator'0 => box
      (unary_operator'nt, [T AND't])
      (fun loc =>
 (ADDROF, loc) 
)
    | Prod'unary_operator'1 => box
      (unary_operator'nt, [T STAR't])
      (fun loc =>
 (MEMOF, loc) 
)
    | Prod'unary_operator'2 => box
      (unary_operator'nt, [T PLUS't])
      (fun loc =>
 (PLUS, loc) 
)
    | Prod'unary_operator'3 => box
      (unary_operator'nt, [T MINUS't])
      (fun loc =>
 (MINUS, loc) 
)
    | Prod'unary_operator'4 => box
      (unary_operator'nt, [T TILDE't])
      (fun loc =>
 (BNOT, loc) 
)
    | Prod'unary_operator'5 => box
      (unary_operator'nt, [T BANG't])
      (fun loc =>
 (NOT, loc) 
)
  end.

Definition prod_lhs (p:production) :=
  fst (projT1 (prod_contents p)).
Definition prod_rhs_rev (p:production) :=
  snd (projT1 (prod_contents p)).
Definition prod_action (p:production) :=
  projT2 (prod_contents p).

Include Grammar.Defs.

End Gram.

Module Aut <: Automaton.T.

Module Gram := Gram.
Module GramDefs := Gram.

Definition nullable_nterm (nt:nonterminal) : bool :=
  match nt with
    | unary_operator'nt => false
    | unary_expression'nt => false
    | type_specifier'nt => false
    | type_qualifier_list'nt => false
    | type_qualifier'nt => false
    | type_name'nt => false
    | translation_unit_file'nt => false
    | translation_unit'nt => false
    | struct_or_union_specifier'nt => false
    | struct_or_union'nt => false
    | struct_declarator_list'nt => false
    | struct_declarator'nt => false
    | struct_declaration_list'nt => true
    | struct_declaration'nt => false
    | storage_class_specifier'nt => false
    | statement_safe'nt => false
    | statement_dangerous'nt => false
    | specifier_qualifier_list'nt => false
    | shift_expression'nt => false
    | selection_statement_safe'nt => false
    | selection_statement_dangerous'nt => false
    | relational_expression'nt => false
    | primary_expression'nt => false
    | postfix_expression'nt => false
    | pointer'nt => false
    | parameter_type_list'nt => false
    | parameter_list'nt => false
    | parameter_declaration'nt => false
    | old_function_declarator'nt => false
    | multiplicative_expression'nt => false
    | logical_OR_expression'nt => false
    | logical_AND_expression'nt => false
    | labeled_statement_statement_safe_'nt => false
    | labeled_statement_statement_dangerous_'nt => false
    | jump_statement'nt => false
    | iteration_statement_statement_safe_'nt => false
    | iteration_statement_statement_dangerous_'nt => false
    | initializer_list'nt => false
    | init_declarator_list'nt => false
    | init_declarator'nt => false
    | inclusive_OR_expression'nt => false
    | identifier_list'nt => false
    | gcc_attribute_word'nt => false
    | gcc_attribute_list'nt => true
    | gcc_attribute'nt => true
    | function_specifier'nt => false
    | function_definition'nt => false
    | external_declaration'nt => false
    | expression_statement'nt => false
    | expression'nt => false
    | exclusive_OR_expression'nt => false
    | equality_expression'nt => false
    | enumerator_list'nt => false
    | enumerator'nt => false
    | enumeration_constant'nt => false
    | enum_specifier'nt => false
    | direct_old_function_declarator'nt => false
    | direct_declarator'nt => false
    | direct_abstract_declarator'nt => false
    | designator_list'nt => false
    | designator'nt => false
    | designation'nt => false
    | declarator'nt => false
    | declaration_specifiers'nt => false
    | declaration_list'nt => true
    | declaration'nt => false
    | constant_expression'nt => false
    | conditional_expression'nt => false
    | compound_statement'nt => false
    | cast_expression'nt => false
    | c_initializer'nt => false
    | block_item_list'nt => false
    | block_item'nt => false
    | attribute_specifier_list'nt => true
    | attribute_specifier'nt => false
    | assignment_operator'nt => false
    | assignment_expression'nt => false
    | asm_statement'nt => false
    | argument_expression_list'nt => false
    | additive_expression'nt => false
    | abstract_declarator'nt => false
    | AND_expression'nt => false
  end.

Definition first_nterm (nt:nonterminal) : list terminal :=
  match nt with
    | unary_operator'nt => [TILDE't; STAR't; PLUS't; MINUS't; BANG't; AND't]
    | unary_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | type_specifier'nt => [VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CHAR't]
    | type_qualifier_list'nt => [VOLATILE't; RESTRICT't; PACKED't; CONST't; ATTRIBUTE't; ALIGNAS't]
    | type_qualifier'nt => [VOLATILE't; RESTRICT't; PACKED't; CONST't; ATTRIBUTE't; ALIGNAS't]
    | type_name'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't]
    | translation_unit_file'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | translation_unit'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | struct_or_union_specifier'nt => [UNION't; STRUCT't]
    | struct_or_union'nt => [UNION't; STRUCT't]
    | struct_declarator_list'nt => [VAR_NAME't; STAR't; LPAREN't; COLON't]
    | struct_declarator'nt => [VAR_NAME't; STAR't; LPAREN't; COLON't]
    | struct_declaration_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't]
    | struct_declaration'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't]
    | storage_class_specifier'nt => [TYPEDEF't; STATIC't; REGISTER't; EXTERN't; AUTO't]
    | statement_safe'nt => [WHILE't; VAR_NAME't; TILDE't; SWITCH't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; RETURN't; PLUS't; OTHER_NAME't; MINUS't; LPAREN't; LBRACE't; INC't; IF't; GOTO't; FOR't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; ASM't; AND't; ALIGNOF't]
    | statement_dangerous'nt => [WHILE't; VAR_NAME't; TILDE't; SWITCH't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; RETURN't; PLUS't; OTHER_NAME't; MINUS't; LPAREN't; LBRACE't; INC't; IF't; GOTO't; FOR't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; ASM't; AND't; ALIGNOF't]
    | specifier_qualifier_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't]
    | shift_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | selection_statement_safe'nt => [SWITCH't; IF't]
    | selection_statement_dangerous'nt => [SWITCH't; IF't]
    | relational_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | primary_expression'nt => [VAR_NAME't; STRING_LITERAL't; LPAREN't; CONSTANT't]
    | postfix_expression'nt => [VAR_NAME't; STRING_LITERAL't; LPAREN't; CONSTANT't; BUILTIN_VA_ARG't]
    | pointer'nt => [STAR't]
    | parameter_type_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | parameter_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | parameter_declaration'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | old_function_declarator'nt => [VAR_NAME't; STAR't; LPAREN't]
    | multiplicative_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | logical_OR_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | logical_AND_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | labeled_statement_statement_safe_'nt => [OTHER_NAME't; DEFAULT't; CASE't]
    | labeled_statement_statement_dangerous_'nt => [OTHER_NAME't; DEFAULT't; CASE't]
    | jump_statement'nt => [RETURN't; GOTO't; CONTINUE't; BREAK't]
    | iteration_statement_statement_safe_'nt => [WHILE't; FOR't; DO't]
    | iteration_statement_statement_dangerous_'nt => [WHILE't; FOR't; DO't]
    | initializer_list'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACK't; LBRACE't; INC't; DOT't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | init_declarator_list'nt => [VAR_NAME't; STAR't; LPAREN't]
    | init_declarator'nt => [VAR_NAME't; STAR't; LPAREN't]
    | inclusive_OR_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | identifier_list'nt => [VAR_NAME't]
    | gcc_attribute_word'nt => [PACKED't; OTHER_NAME't; CONST't]
    | gcc_attribute_list'nt => [PACKED't; OTHER_NAME't; CONST't; COMMA't]
    | gcc_attribute'nt => [PACKED't; OTHER_NAME't; CONST't]
    | function_specifier'nt => [INLINE't]
    | function_definition'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | external_declaration'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | expression_statement'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | exclusive_OR_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | equality_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | enumerator_list'nt => [VAR_NAME't]
    | enumerator'nt => [VAR_NAME't]
    | enumeration_constant'nt => [VAR_NAME't]
    | enum_specifier'nt => [ENUM't]
    | direct_old_function_declarator'nt => [VAR_NAME't; LPAREN't]
    | direct_declarator'nt => [VAR_NAME't; LPAREN't]
    | direct_abstract_declarator'nt => [LPAREN't; LBRACK't]
    | designator_list'nt => [LBRACK't; DOT't]
    | designator'nt => [LBRACK't; DOT't]
    | designation'nt => [LBRACK't; DOT't]
    | declarator'nt => [VAR_NAME't; STAR't; LPAREN't]
    | declaration_specifiers'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | declaration_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | declaration'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | constant_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | conditional_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | compound_statement'nt => [LBRACE't]
    | cast_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | c_initializer'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | block_item_list'nt => [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't]
    | block_item'nt => [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't]
    | attribute_specifier_list'nt => [PACKED't; ATTRIBUTE't; ALIGNAS't]
    | attribute_specifier'nt => [PACKED't; ATTRIBUTE't; ALIGNAS't]
    | assignment_operator'nt => [XOR_ASSIGN't; SUB_ASSIGN't; RIGHT_ASSIGN't; OR_ASSIGN't; MUL_ASSIGN't; MOD_ASSIGN't; LEFT_ASSIGN't; EQ't; DIV_ASSIGN't; AND_ASSIGN't; ADD_ASSIGN't]
    | assignment_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | asm_statement'nt => [ASM't]
    | argument_expression_list'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | additive_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | abstract_declarator'nt => [STAR't; LPAREN't; LBRACK't]
    | AND_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
  end.

Inductive noninitstate' : Set :=
  | Nis'567
  | Nis'566
  | Nis'565
  | Nis'564
  | Nis'563
  | Nis'562
  | Nis'561
  | Nis'560
  | Nis'559
  | Nis'558
  | Nis'557
  | Nis'556
  | Nis'555
  | Nis'554
  | Nis'553
  | Nis'552
  | Nis'551
  | Nis'550
  | Nis'549
  | Nis'548
  | Nis'547
  | Nis'546
  | Nis'545
  | Nis'544
  | Nis'543
  | Nis'542
  | Nis'541
  | Nis'540
  | Nis'539
  | Nis'538
  | Nis'537
  | Nis'536
  | Nis'535
  | Nis'534
  | Nis'533
  | Nis'532
  | Nis'531
  | Nis'530
  | Nis'529
  | Nis'528
  | Nis'527
  | Nis'526
  | Nis'525
  | Nis'524
  | Nis'523
  | Nis'522
  | Nis'521
  | Nis'520
  | Nis'519
  | Nis'518
  | Nis'517
  | Nis'516
  | Nis'515
  | Nis'514
  | Nis'513
  | Nis'512
  | Nis'511
  | Nis'510
  | Nis'509
  | Nis'508
  | Nis'507
  | Nis'506
  | Nis'505
  | Nis'504
  | Nis'503
  | Nis'502
  | Nis'501
  | Nis'500
  | Nis'499
  | Nis'498
  | Nis'497
  | Nis'496
  | Nis'495
  | Nis'494
  | Nis'493
  | Nis'492
  | Nis'491
  | Nis'490
  | Nis'489
  | Nis'488
  | Nis'487
  | Nis'486
  | Nis'485
  | Nis'484
  | Nis'483
  | Nis'482
  | Nis'481
  | Nis'480
  | Nis'479
  | Nis'478
  | Nis'477
  | Nis'476
  | Nis'475
  | Nis'474
  | Nis'473
  | Nis'472
  | Nis'471
  | Nis'470
  | Nis'469
  | Nis'468
  | Nis'467
  | Nis'466
  | Nis'465
  | Nis'464
  | Nis'463
  | Nis'462
  | Nis'461
  | Nis'460
  | Nis'459
  | Nis'458
  | Nis'457
  | Nis'456
  | Nis'455
  | Nis'454
  | Nis'453
  | Nis'452
  | Nis'451
  | Nis'450
  | Nis'449
  | Nis'448
  | Nis'447
  | Nis'446
  | Nis'445
  | Nis'444
  | Nis'443
  | Nis'442
  | Nis'441
  | Nis'440
  | Nis'439
  | Nis'438
  | Nis'437
  | Nis'436
  | Nis'435
  | Nis'434
  | Nis'433
  | Nis'432
  | Nis'431
  | Nis'430
  | Nis'429
  | Nis'428
  | Nis'427
  | Nis'426
  | Nis'425
  | Nis'424
  | Nis'423
  | Nis'422
  | Nis'421
  | Nis'420
  | Nis'419
  | Nis'418
  | Nis'417
  | Nis'416
  | Nis'415
  | Nis'414
  | Nis'413
  | Nis'412
  | Nis'411
  | Nis'410
  | Nis'409
  | Nis'408
  | Nis'407
  | Nis'406
  | Nis'405
  | Nis'404
  | Nis'403
  | Nis'402
  | Nis'401
  | Nis'400
  | Nis'399
  | Nis'398
  | Nis'397
  | Nis'396
  | Nis'395
  | Nis'394
  | Nis'393
  | Nis'392
  | Nis'391
  | Nis'390
  | Nis'389
  | Nis'388
  | Nis'387
  | Nis'386
  | Nis'385
  | Nis'384
  | Nis'383
  | Nis'382
  | Nis'381
  | Nis'380
  | Nis'379
  | Nis'378
  | Nis'377
  | Nis'376
  | Nis'375
  | Nis'374
  | Nis'373
  | Nis'372
  | Nis'371
  | Nis'370
  | Nis'369
  | Nis'368
  | Nis'367
  | Nis'366
  | Nis'365
  | Nis'364
  | Nis'363
  | Nis'362
  | Nis'361
  | Nis'360
  | Nis'359
  | Nis'358
  | Nis'357
  | Nis'356
  | Nis'355
  | Nis'354
  | Nis'353
  | Nis'352
  | Nis'351
  | Nis'350
  | Nis'349
  | Nis'348
  | Nis'347
  | Nis'346
  | Nis'345
  | Nis'344
  | Nis'343
  | Nis'342
  | Nis'341
  | Nis'340
  | Nis'339
  | Nis'338
  | Nis'337
  | Nis'336
  | Nis'335
  | Nis'334
  | Nis'333
  | Nis'331
  | Nis'330
  | Nis'329
  | Nis'328
  | Nis'327
  | Nis'326
  | Nis'325
  | Nis'324
  | Nis'323
  | Nis'322
  | Nis'321
  | Nis'320
  | Nis'319
  | Nis'318
  | Nis'317
  | Nis'316
  | Nis'315
  | Nis'314
  | Nis'313
  | Nis'312
  | Nis'311
  | Nis'310
  | Nis'309
  | Nis'308
  | Nis'307
  | Nis'306
  | Nis'305
  | Nis'304
  | Nis'303
  | Nis'302
  | Nis'301
  | Nis'300
  | Nis'299
  | Nis'298
  | Nis'297
  | Nis'296
  | Nis'295
  | Nis'294
  | Nis'293
  | Nis'292
  | Nis'291
  | Nis'290
  | Nis'289
  | Nis'288
  | Nis'287
  | Nis'286
  | Nis'285
  | Nis'284
  | Nis'283
  | Nis'282
  | Nis'281
  | Nis'280
  | Nis'279
  | Nis'278
  | Nis'277
  | Nis'276
  | Nis'275
  | Nis'274
  | Nis'273
  | Nis'272
  | Nis'271
  | Nis'270
  | Nis'269
  | Nis'268
  | Nis'267
  | Nis'266
  | Nis'265
  | Nis'264
  | Nis'263
  | Nis'262
  | Nis'261
  | Nis'260
  | Nis'259
  | Nis'258
  | Nis'257
  | Nis'256
  | Nis'255
  | Nis'254
  | Nis'253
  | Nis'252
  | Nis'251
  | Nis'250
  | Nis'249
  | Nis'248
  | Nis'247
  | Nis'246
  | Nis'245
  | Nis'244
  | Nis'243
  | Nis'242
  | Nis'241
  | Nis'240
  | Nis'239
  | Nis'238
  | Nis'237
  | Nis'236
  | Nis'235
  | Nis'234
  | Nis'233
  | Nis'232
  | Nis'231
  | Nis'230
  | Nis'229
  | Nis'228
  | Nis'227
  | Nis'226
  | Nis'225
  | Nis'224
  | Nis'223
  | Nis'222
  | Nis'221
  | Nis'220
  | Nis'219
  | Nis'218
  | Nis'217
  | Nis'216
  | Nis'215
  | Nis'214
  | Nis'213
  | Nis'212
  | Nis'211
  | Nis'210
  | Nis'209
  | Nis'208
  | Nis'207
  | Nis'206
  | Nis'205
  | Nis'204
  | Nis'203
  | Nis'202
  | Nis'201
  | Nis'200
  | Nis'199
  | Nis'198
  | Nis'197
  | Nis'196
  | Nis'195
  | Nis'194
  | Nis'193
  | Nis'192
  | Nis'191
  | Nis'190
  | Nis'189
  | Nis'188
  | Nis'187
  | Nis'186
  | Nis'185
  | Nis'184
  | Nis'183
  | Nis'182
  | Nis'181
  | Nis'180
  | Nis'179
  | Nis'178
  | Nis'177
  | Nis'176
  | Nis'175
  | Nis'174
  | Nis'173
  | Nis'172
  | Nis'171
  | Nis'170
  | Nis'169
  | Nis'168
  | Nis'167
  | Nis'166
  | Nis'165
  | Nis'164
  | Nis'163
  | Nis'162
  | Nis'161
  | Nis'160
  | Nis'159
  | Nis'158
  | Nis'157
  | Nis'156
  | Nis'155
  | Nis'154
  | Nis'153
  | Nis'152
  | Nis'151
  | Nis'150
  | Nis'149
  | Nis'148
  | Nis'147
  | Nis'146
  | Nis'145
  | Nis'144
  | Nis'143
  | Nis'142
  | Nis'141
  | Nis'140
  | Nis'139
  | Nis'138
  | Nis'137
  | Nis'136
  | Nis'135
  | Nis'134
  | Nis'133
  | Nis'132
  | Nis'131
  | Nis'130
  | Nis'129
  | Nis'128
  | Nis'127
  | Nis'126
  | Nis'125
  | Nis'124
  | Nis'123
  | Nis'122
  | Nis'121
  | Nis'120
  | Nis'119
  | Nis'118
  | Nis'117
  | Nis'116
  | Nis'115
  | Nis'114
  | Nis'113
  | Nis'112
  | Nis'111
  | Nis'110
  | Nis'109
  | Nis'108
  | Nis'107
  | Nis'106
  | Nis'105
  | Nis'104
  | Nis'103
  | Nis'102
  | Nis'101
  | Nis'100
  | Nis'99
  | Nis'98
  | Nis'97
  | Nis'96
  | Nis'95
  | Nis'94
  | Nis'93
  | Nis'92
  | Nis'91
  | Nis'90
  | Nis'89
  | Nis'88
  | Nis'87
  | Nis'86
  | Nis'85
  | Nis'84
  | Nis'83
  | Nis'82
  | Nis'81
  | Nis'80
  | Nis'79
  | Nis'78
  | Nis'77
  | Nis'76
  | Nis'75
  | Nis'74
  | Nis'73
  | Nis'72
  | Nis'71
  | Nis'70
  | Nis'69
  | Nis'68
  | Nis'67
  | Nis'66
  | Nis'65
  | Nis'64
  | Nis'63
  | Nis'62
  | Nis'61
  | Nis'60
  | Nis'59
  | Nis'58
  | Nis'57
  | Nis'56
  | Nis'55
  | Nis'54
  | Nis'53
  | Nis'52
  | Nis'51
  | Nis'50
  | Nis'49
  | Nis'48
  | Nis'47
  | Nis'46
  | Nis'45
  | Nis'44
  | Nis'43
  | Nis'42
  | Nis'41
  | Nis'40
  | Nis'39
  | Nis'38
  | Nis'37
  | Nis'36
  | Nis'35
  | Nis'34
  | Nis'33
  | Nis'32
  | Nis'31
  | Nis'30
  | Nis'29
  | Nis'28
  | Nis'27
  | Nis'26
  | Nis'25
  | Nis'24
  | Nis'23
  | Nis'22
  | Nis'21
  | Nis'20
  | Nis'19
  | Nis'18
  | Nis'17
  | Nis'16
  | Nis'15
  | Nis'14
  | Nis'13
  | Nis'12
  | Nis'11
  | Nis'10
  | Nis'9
  | Nis'8
  | Nis'7
  | Nis'6
  | Nis'5
  | Nis'4
  | Nis'3
  | Nis'2
  | Nis'1.
Definition noninitstate := noninitstate'.

Program Instance noninitstateNum : Numbered noninitstate :=
  { inj := fun x => match x return _ with | Nis'567 => Int31.On | Nis'566 => Int31.In | Nis'565 => (twice Int31.In) | Nis'564 => (twice_plus_one Int31.In) | Nis'563 => (twice (twice Int31.In)) | Nis'562 => (twice_plus_one (twice Int31.In)) | Nis'561 => (twice (twice_plus_one Int31.In)) | Nis'560 => (twice_plus_one (twice_plus_one Int31.In)) | Nis'559 => (twice (twice (twice Int31.In))) | Nis'558 => (twice_plus_one (twice (twice Int31.In))) | Nis'557 => (twice (twice_plus_one (twice Int31.In))) | Nis'556 => (twice_plus_one (twice_plus_one (twice Int31.In))) | Nis'555 => (twice (twice (twice_plus_one Int31.In))) | Nis'554 => (twice_plus_one (twice (twice_plus_one Int31.In))) | Nis'553 => (twice (twice_plus_one (twice_plus_one Int31.In))) | Nis'552 => (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))) | Nis'551 => (twice (twice (twice (twice Int31.In)))) | Nis'550 => (twice_plus_one (twice (twice (twice Int31.In)))) | Nis'549 => (twice (twice_plus_one (twice (twice Int31.In)))) | Nis'548 => (twice_plus_one (twice_plus_one (twice (twice Int31.In)))) | Nis'547 => (twice (twice (twice_plus_one (twice Int31.In)))) | Nis'546 => (twice_plus_one (twice (twice_plus_one (twice Int31.In)))) | Nis'545 => (twice (twice_plus_one (twice_plus_one (twice Int31.In)))) | Nis'544 => (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))) | Nis'543 => (twice (twice (twice (twice_plus_one Int31.In)))) | Nis'542 => (twice_plus_one (twice (twice (twice_plus_one Int31.In)))) | Nis'541 => (twice (twice_plus_one (twice (twice_plus_one Int31.In)))) | Nis'540 => (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))) | Nis'539 => (twice (twice (twice_plus_one (twice_plus_one Int31.In)))) | Nis'538 => (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))) | Nis'537 => (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | Nis'536 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | Nis'535 => (twice (twice (twice (twice (twice Int31.In))))) | Nis'534 => (twice_plus_one (twice (twice (twice (twice Int31.In))))) | Nis'533 => (twice (twice_plus_one (twice (twice (twice Int31.In))))) | Nis'532 => (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))) | Nis'531 => (twice (twice (twice_plus_one (twice (twice Int31.In))))) | Nis'530 => (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))) | Nis'529 => (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | Nis'528 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | Nis'527 => (twice (twice (twice (twice_plus_one (twice Int31.In))))) | Nis'526 => (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))) | Nis'525 => (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | Nis'524 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | Nis'523 => (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | Nis'522 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | Nis'521 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | Nis'520 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | Nis'519 => (twice (twice (twice (twice (twice_plus_one Int31.In))))) | Nis'518 => (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))) | Nis'517 => (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | Nis'516 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | Nis'515 => (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | Nis'514 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | Nis'513 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | Nis'512 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | Nis'511 => (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | Nis'510 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | Nis'509 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | Nis'508 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | Nis'507 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Nis'506 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Nis'505 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Nis'504 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Nis'503 => (twice (twice (twice (twice (twice (twice Int31.In)))))) | Nis'502 => (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))) | Nis'501 => (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | Nis'500 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | Nis'499 => (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | Nis'498 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | Nis'497 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | Nis'496 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | Nis'495 => (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | Nis'494 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | Nis'493 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | Nis'492 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | Nis'491 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Nis'490 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Nis'489 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Nis'488 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Nis'487 => (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | Nis'486 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | Nis'485 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | Nis'484 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | Nis'483 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Nis'482 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Nis'481 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Nis'480 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Nis'479 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'478 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'477 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'476 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'475 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'474 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'473 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'472 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'471 => (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))) | Nis'470 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))) | Nis'469 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))) | Nis'468 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))) | Nis'467 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Nis'466 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Nis'465 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Nis'464 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Nis'463 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'462 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'461 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'460 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'459 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'458 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'457 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'456 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'455 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'454 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'453 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'452 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'451 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'450 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'449 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'448 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'447 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'446 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'445 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'444 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'443 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'442 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'441 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'440 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'439 => (twice (twice (twice (twice (twice (twice (twice Int31.In))))))) | Nis'438 => (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))) | Nis'437 => (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))) | Nis'436 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))) | Nis'435 => (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Nis'434 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Nis'433 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Nis'432 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Nis'431 => (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'430 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'429 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'428 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'427 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'426 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'425 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'424 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'423 => (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'422 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'421 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'420 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'419 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'418 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'417 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'416 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'415 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'414 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'413 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'412 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'411 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'410 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'409 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'408 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'407 => (twice (twice (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'406 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'405 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'404 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'403 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'402 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'401 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'400 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'399 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'398 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'397 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'396 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'395 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'394 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'393 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'392 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'391 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'390 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'389 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'388 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'387 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'386 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'385 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'384 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'383 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'382 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'381 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'380 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'379 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'378 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'377 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'376 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'375 => (twice (twice (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'374 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'373 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'372 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'371 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'370 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'369 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'368 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'367 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'366 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'365 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'364 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'363 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'362 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'361 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'360 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'359 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'358 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'357 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'356 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'355 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'354 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'353 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'352 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'351 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'350 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'349 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'348 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'347 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'346 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'345 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'344 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'343 => (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'342 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'341 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'340 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'339 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'338 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'337 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'336 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'335 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'334 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'333 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'331 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'330 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'329 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'328 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'327 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'326 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'325 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'324 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'323 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'322 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'321 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'320 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'319 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'318 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'317 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'316 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'315 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'314 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'313 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'312 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'311 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'310 => (twice (twice (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'309 => (twice_plus_one (twice (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'308 => (twice (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'307 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'306 => (twice (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'305 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'304 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'303 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'302 => (twice (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'301 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'300 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'299 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'298 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'297 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'296 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'295 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'294 => (twice (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'293 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'292 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'291 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'290 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'289 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'288 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'287 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'286 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'285 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'284 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'283 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'282 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'281 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'280 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'279 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'278 => (twice (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'277 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'276 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'275 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'274 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'273 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'272 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'271 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'270 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'269 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'268 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'267 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'266 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'265 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'264 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'263 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'262 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'261 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'260 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'259 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'258 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'257 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'256 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'255 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'254 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'253 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'252 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'251 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'250 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'249 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'248 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'247 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'246 => (twice (twice (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'245 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'244 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'243 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'242 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'241 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'240 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'239 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'238 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'237 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'236 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'235 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'234 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'233 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'232 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'231 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'230 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'229 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'228 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'227 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'226 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'225 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'224 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'223 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'222 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'221 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'220 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'219 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'218 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'217 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'216 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'215 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'214 => (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'213 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'212 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'211 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'210 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'209 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'208 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'207 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'206 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'205 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'204 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'203 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'202 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'201 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'200 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'199 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'198 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'197 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'196 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'195 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'194 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'193 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'192 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'191 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'190 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'189 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'188 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'187 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'186 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'185 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'184 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'183 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'182 => (twice (twice (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'181 => (twice_plus_one (twice (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'180 => (twice (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'179 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'178 => (twice (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'177 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'176 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'175 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'174 => (twice (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'173 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'172 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'171 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'170 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'169 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'168 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'167 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'166 => (twice (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'165 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'164 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'163 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'162 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'161 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'160 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'159 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'158 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'157 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'156 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'155 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'154 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'153 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'152 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'151 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'150 => (twice (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'149 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'148 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'147 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'146 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'145 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'144 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'143 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'142 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'141 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'140 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'139 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'138 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'137 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'136 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'135 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'134 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'133 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'132 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'131 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'130 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'129 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'128 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'127 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'126 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'125 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'124 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'123 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'122 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'121 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'120 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'119 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'118 => (twice (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'117 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'116 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'115 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'114 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'113 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'112 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'111 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'110 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'109 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'108 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'107 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'106 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'105 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'104 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'103 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'102 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'101 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'100 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'99 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'98 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'97 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'96 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'95 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'94 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'93 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'92 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'91 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'90 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'89 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'88 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'87 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'86 => (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'85 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'84 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'83 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'82 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'81 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'80 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'79 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'78 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'77 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'76 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'75 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'74 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'73 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'72 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'71 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'70 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'69 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'68 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'67 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'66 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'65 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'64 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'63 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'62 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'61 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'60 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'59 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'58 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'57 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'56 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'55 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'54 => (twice (twice (twice (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'53 => (twice_plus_one (twice (twice (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'52 => (twice (twice_plus_one (twice (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'51 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'50 => (twice (twice (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'49 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'48 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'47 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'46 => (twice (twice (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'45 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'44 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'43 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'42 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'41 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'40 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'39 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'38 => (twice (twice (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'37 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'36 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'35 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'34 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'33 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'32 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'31 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'30 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'29 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'28 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'27 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'26 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'25 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'24 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'23 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'22 => (twice (twice (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'21 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'20 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'19 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'18 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'17 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'16 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'15 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'14 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'13 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'12 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'11 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'10 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'9 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'8 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'7 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'6 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'5 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'4 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'3 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'2 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'1 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) end;
    surj := (fun n => match n return _ with | 0 => Nis'567 | 1 => Nis'566 | 2 => Nis'565 | 3 => Nis'564 | 4 => Nis'563 | 5 => Nis'562 | 6 => Nis'561 | 7 => Nis'560 | 8 => Nis'559 | 9 => Nis'558 | 10 => Nis'557 | 11 => Nis'556 | 12 => Nis'555 | 13 => Nis'554 | 14 => Nis'553 | 15 => Nis'552 | 16 => Nis'551 | 17 => Nis'550 | 18 => Nis'549 | 19 => Nis'548 | 20 => Nis'547 | 21 => Nis'546 | 22 => Nis'545 | 23 => Nis'544 | 24 => Nis'543 | 25 => Nis'542 | 26 => Nis'541 | 27 => Nis'540 | 28 => Nis'539 | 29 => Nis'538 | 30 => Nis'537 | 31 => Nis'536 | 32 => Nis'535 | 33 => Nis'534 | 34 => Nis'533 | 35 => Nis'532 | 36 => Nis'531 | 37 => Nis'530 | 38 => Nis'529 | 39 => Nis'528 | 40 => Nis'527 | 41 => Nis'526 | 42 => Nis'525 | 43 => Nis'524 | 44 => Nis'523 | 45 => Nis'522 | 46 => Nis'521 | 47 => Nis'520 | 48 => Nis'519 | 49 => Nis'518 | 50 => Nis'517 | 51 => Nis'516 | 52 => Nis'515 | 53 => Nis'514 | 54 => Nis'513 | 55 => Nis'512 | 56 => Nis'511 | 57 => Nis'510 | 58 => Nis'509 | 59 => Nis'508 | 60 => Nis'507 | 61 => Nis'506 | 62 => Nis'505 | 63 => Nis'504 | 64 => Nis'503 | 65 => Nis'502 | 66 => Nis'501 | 67 => Nis'500 | 68 => Nis'499 | 69 => Nis'498 | 70 => Nis'497 | 71 => Nis'496 | 72 => Nis'495 | 73 => Nis'494 | 74 => Nis'493 | 75 => Nis'492 | 76 => Nis'491 | 77 => Nis'490 | 78 => Nis'489 | 79 => Nis'488 | 80 => Nis'487 | 81 => Nis'486 | 82 => Nis'485 | 83 => Nis'484 | 84 => Nis'483 | 85 => Nis'482 | 86 => Nis'481 | 87 => Nis'480 | 88 => Nis'479 | 89 => Nis'478 | 90 => Nis'477 | 91 => Nis'476 | 92 => Nis'475 | 93 => Nis'474 | 94 => Nis'473 | 95 => Nis'472 | 96 => Nis'471 | 97 => Nis'470 | 98 => Nis'469 | 99 => Nis'468 | 100 => Nis'467 | 101 => Nis'466 | 102 => Nis'465 | 103 => Nis'464 | 104 => Nis'463 | 105 => Nis'462 | 106 => Nis'461 | 107 => Nis'460 | 108 => Nis'459 | 109 => Nis'458 | 110 => Nis'457 | 111 => Nis'456 | 112 => Nis'455 | 113 => Nis'454 | 114 => Nis'453 | 115 => Nis'452 | 116 => Nis'451 | 117 => Nis'450 | 118 => Nis'449 | 119 => Nis'448 | 120 => Nis'447 | 121 => Nis'446 | 122 => Nis'445 | 123 => Nis'444 | 124 => Nis'443 | 125 => Nis'442 | 126 => Nis'441 | 127 => Nis'440 | 128 => Nis'439 | 129 => Nis'438 | 130 => Nis'437 | 131 => Nis'436 | 132 => Nis'435 | 133 => Nis'434 | 134 => Nis'433 | 135 => Nis'432 | 136 => Nis'431 | 137 => Nis'430 | 138 => Nis'429 | 139 => Nis'428 | 140 => Nis'427 | 141 => Nis'426 | 142 => Nis'425 | 143 => Nis'424 | 144 => Nis'423 | 145 => Nis'422 | 146 => Nis'421 | 147 => Nis'420 | 148 => Nis'419 | 149 => Nis'418 | 150 => Nis'417 | 151 => Nis'416 | 152 => Nis'415 | 153 => Nis'414 | 154 => Nis'413 | 155 => Nis'412 | 156 => Nis'411 | 157 => Nis'410 | 158 => Nis'409 | 159 => Nis'408 | 160 => Nis'407 | 161 => Nis'406 | 162 => Nis'405 | 163 => Nis'404 | 164 => Nis'403 | 165 => Nis'402 | 166 => Nis'401 | 167 => Nis'400 | 168 => Nis'399 | 169 => Nis'398 | 170 => Nis'397 | 171 => Nis'396 | 172 => Nis'395 | 173 => Nis'394 | 174 => Nis'393 | 175 => Nis'392 | 176 => Nis'391 | 177 => Nis'390 | 178 => Nis'389 | 179 => Nis'388 | 180 => Nis'387 | 181 => Nis'386 | 182 => Nis'385 | 183 => Nis'384 | 184 => Nis'383 | 185 => Nis'382 | 186 => Nis'381 | 187 => Nis'380 | 188 => Nis'379 | 189 => Nis'378 | 190 => Nis'377 | 191 => Nis'376 | 192 => Nis'375 | 193 => Nis'374 | 194 => Nis'373 | 195 => Nis'372 | 196 => Nis'371 | 197 => Nis'370 | 198 => Nis'369 | 199 => Nis'368 | 200 => Nis'367 | 201 => Nis'366 | 202 => Nis'365 | 203 => Nis'364 | 204 => Nis'363 | 205 => Nis'362 | 206 => Nis'361 | 207 => Nis'360 | 208 => Nis'359 | 209 => Nis'358 | 210 => Nis'357 | 211 => Nis'356 | 212 => Nis'355 | 213 => Nis'354 | 214 => Nis'353 | 215 => Nis'352 | 216 => Nis'351 | 217 => Nis'350 | 218 => Nis'349 | 219 => Nis'348 | 220 => Nis'347 | 221 => Nis'346 | 222 => Nis'345 | 223 => Nis'344 | 224 => Nis'343 | 225 => Nis'342 | 226 => Nis'341 | 227 => Nis'340 | 228 => Nis'339 | 229 => Nis'338 | 230 => Nis'337 | 231 => Nis'336 | 232 => Nis'335 | 233 => Nis'334 | 234 => Nis'333 | 235 => Nis'331 | 236 => Nis'330 | 237 => Nis'329 | 238 => Nis'328 | 239 => Nis'327 | 240 => Nis'326 | 241 => Nis'325 | 242 => Nis'324 | 243 => Nis'323 | 244 => Nis'322 | 245 => Nis'321 | 246 => Nis'320 | 247 => Nis'319 | 248 => Nis'318 | 249 => Nis'317 | 250 => Nis'316 | 251 => Nis'315 | 252 => Nis'314 | 253 => Nis'313 | 254 => Nis'312 | 255 => Nis'311 | 256 => Nis'310 | 257 => Nis'309 | 258 => Nis'308 | 259 => Nis'307 | 260 => Nis'306 | 261 => Nis'305 | 262 => Nis'304 | 263 => Nis'303 | 264 => Nis'302 | 265 => Nis'301 | 266 => Nis'300 | 267 => Nis'299 | 268 => Nis'298 | 269 => Nis'297 | 270 => Nis'296 | 271 => Nis'295 | 272 => Nis'294 | 273 => Nis'293 | 274 => Nis'292 | 275 => Nis'291 | 276 => Nis'290 | 277 => Nis'289 | 278 => Nis'288 | 279 => Nis'287 | 280 => Nis'286 | 281 => Nis'285 | 282 => Nis'284 | 283 => Nis'283 | 284 => Nis'282 | 285 => Nis'281 | 286 => Nis'280 | 287 => Nis'279 | 288 => Nis'278 | 289 => Nis'277 | 290 => Nis'276 | 291 => Nis'275 | 292 => Nis'274 | 293 => Nis'273 | 294 => Nis'272 | 295 => Nis'271 | 296 => Nis'270 | 297 => Nis'269 | 298 => Nis'268 | 299 => Nis'267 | 300 => Nis'266 | 301 => Nis'265 | 302 => Nis'264 | 303 => Nis'263 | 304 => Nis'262 | 305 => Nis'261 | 306 => Nis'260 | 307 => Nis'259 | 308 => Nis'258 | 309 => Nis'257 | 310 => Nis'256 | 311 => Nis'255 | 312 => Nis'254 | 313 => Nis'253 | 314 => Nis'252 | 315 => Nis'251 | 316 => Nis'250 | 317 => Nis'249 | 318 => Nis'248 | 319 => Nis'247 | 320 => Nis'246 | 321 => Nis'245 | 322 => Nis'244 | 323 => Nis'243 | 324 => Nis'242 | 325 => Nis'241 | 326 => Nis'240 | 327 => Nis'239 | 328 => Nis'238 | 329 => Nis'237 | 330 => Nis'236 | 331 => Nis'235 | 332 => Nis'234 | 333 => Nis'233 | 334 => Nis'232 | 335 => Nis'231 | 336 => Nis'230 | 337 => Nis'229 | 338 => Nis'228 | 339 => Nis'227 | 340 => Nis'226 | 341 => Nis'225 | 342 => Nis'224 | 343 => Nis'223 | 344 => Nis'222 | 345 => Nis'221 | 346 => Nis'220 | 347 => Nis'219 | 348 => Nis'218 | 349 => Nis'217 | 350 => Nis'216 | 351 => Nis'215 | 352 => Nis'214 | 353 => Nis'213 | 354 => Nis'212 | 355 => Nis'211 | 356 => Nis'210 | 357 => Nis'209 | 358 => Nis'208 | 359 => Nis'207 | 360 => Nis'206 | 361 => Nis'205 | 362 => Nis'204 | 363 => Nis'203 | 364 => Nis'202 | 365 => Nis'201 | 366 => Nis'200 | 367 => Nis'199 | 368 => Nis'198 | 369 => Nis'197 | 370 => Nis'196 | 371 => Nis'195 | 372 => Nis'194 | 373 => Nis'193 | 374 => Nis'192 | 375 => Nis'191 | 376 => Nis'190 | 377 => Nis'189 | 378 => Nis'188 | 379 => Nis'187 | 380 => Nis'186 | 381 => Nis'185 | 382 => Nis'184 | 383 => Nis'183 | 384 => Nis'182 | 385 => Nis'181 | 386 => Nis'180 | 387 => Nis'179 | 388 => Nis'178 | 389 => Nis'177 | 390 => Nis'176 | 391 => Nis'175 | 392 => Nis'174 | 393 => Nis'173 | 394 => Nis'172 | 395 => Nis'171 | 396 => Nis'170 | 397 => Nis'169 | 398 => Nis'168 | 399 => Nis'167 | 400 => Nis'166 | 401 => Nis'165 | 402 => Nis'164 | 403 => Nis'163 | 404 => Nis'162 | 405 => Nis'161 | 406 => Nis'160 | 407 => Nis'159 | 408 => Nis'158 | 409 => Nis'157 | 410 => Nis'156 | 411 => Nis'155 | 412 => Nis'154 | 413 => Nis'153 | 414 => Nis'152 | 415 => Nis'151 | 416 => Nis'150 | 417 => Nis'149 | 418 => Nis'148 | 419 => Nis'147 | 420 => Nis'146 | 421 => Nis'145 | 422 => Nis'144 | 423 => Nis'143 | 424 => Nis'142 | 425 => Nis'141 | 426 => Nis'140 | 427 => Nis'139 | 428 => Nis'138 | 429 => Nis'137 | 430 => Nis'136 | 431 => Nis'135 | 432 => Nis'134 | 433 => Nis'133 | 434 => Nis'132 | 435 => Nis'131 | 436 => Nis'130 | 437 => Nis'129 | 438 => Nis'128 | 439 => Nis'127 | 440 => Nis'126 | 441 => Nis'125 | 442 => Nis'124 | 443 => Nis'123 | 444 => Nis'122 | 445 => Nis'121 | 446 => Nis'120 | 447 => Nis'119 | 448 => Nis'118 | 449 => Nis'117 | 450 => Nis'116 | 451 => Nis'115 | 452 => Nis'114 | 453 => Nis'113 | 454 => Nis'112 | 455 => Nis'111 | 456 => Nis'110 | 457 => Nis'109 | 458 => Nis'108 | 459 => Nis'107 | 460 => Nis'106 | 461 => Nis'105 | 462 => Nis'104 | 463 => Nis'103 | 464 => Nis'102 | 465 => Nis'101 | 466 => Nis'100 | 467 => Nis'99 | 468 => Nis'98 | 469 => Nis'97 | 470 => Nis'96 | 471 => Nis'95 | 472 => Nis'94 | 473 => Nis'93 | 474 => Nis'92 | 475 => Nis'91 | 476 => Nis'90 | 477 => Nis'89 | 478 => Nis'88 | 479 => Nis'87 | 480 => Nis'86 | 481 => Nis'85 | 482 => Nis'84 | 483 => Nis'83 | 484 => Nis'82 | 485 => Nis'81 | 486 => Nis'80 | 487 => Nis'79 | 488 => Nis'78 | 489 => Nis'77 | 490 => Nis'76 | 491 => Nis'75 | 492 => Nis'74 | 493 => Nis'73 | 494 => Nis'72 | 495 => Nis'71 | 496 => Nis'70 | 497 => Nis'69 | 498 => Nis'68 | 499 => Nis'67 | 500 => Nis'66 | 501 => Nis'65 | 502 => Nis'64 | 503 => Nis'63 | 504 => Nis'62 | 505 => Nis'61 | 506 => Nis'60 | 507 => Nis'59 | 508 => Nis'58 | 509 => Nis'57 | 510 => Nis'56 | 511 => Nis'55 | 512 => Nis'54 | 513 => Nis'53 | 514 => Nis'52 | 515 => Nis'51 | 516 => Nis'50 | 517 => Nis'49 | 518 => Nis'48 | 519 => Nis'47 | 520 => Nis'46 | 521 => Nis'45 | 522 => Nis'44 | 523 => Nis'43 | 524 => Nis'42 | 525 => Nis'41 | 526 => Nis'40 | 527 => Nis'39 | 528 => Nis'38 | 529 => Nis'37 | 530 => Nis'36 | 531 => Nis'35 | 532 => Nis'34 | 533 => Nis'33 | 534 => Nis'32 | 535 => Nis'31 | 536 => Nis'30 | 537 => Nis'29 | 538 => Nis'28 | 539 => Nis'27 | 540 => Nis'26 | 541 => Nis'25 | 542 => Nis'24 | 543 => Nis'23 | 544 => Nis'22 | 545 => Nis'21 | 546 => Nis'20 | 547 => Nis'19 | 548 => Nis'18 | 549 => Nis'17 | 550 => Nis'16 | 551 => Nis'15 | 552 => Nis'14 | 553 => Nis'13 | 554 => Nis'12 | 555 => Nis'11 | 556 => Nis'10 | 557 => Nis'9 | 558 => Nis'8 | 559 => Nis'7 | 560 => Nis'6 | 561 => Nis'5 | 562 => Nis'4 | 563 => Nis'3 | 564 => Nis'2 | 565 => Nis'1 | _ => Nis'567 end)%int31;
  inj_bound := 566%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance NonInitStateAlph : Alphabet noninitstate := _.

Definition last_symb_of_non_init_state (noninitstate:noninitstate) : symbol :=
  match noninitstate with
    | Nis'1 => T VOLATILE't
    | Nis'2 => T VOID't
    | Nis'3 => T UNSIGNED't
    | Nis'4 => T UNION't
    | Nis'5 => T UNDERSCORE_BOOL't
    | Nis'6 => T TYPEDEF_NAME't
    | Nis'7 => T TYPEDEF't
    | Nis'8 => T STRUCT't
    | Nis'9 => T STATIC't
    | Nis'10 => T SIGNED't
    | Nis'11 => T SHORT't
    | Nis'12 => T RESTRICT't
    | Nis'13 => T REGISTER't
    | Nis'14 => T PRAGMA't
    | Nis'15 => T PACKED't
    | Nis'16 => T LPAREN't
    | Nis'17 => T VAR_NAME't
    | Nis'18 => T TILDE't
    | Nis'19 => T STRING_LITERAL't
    | Nis'20 => T STAR't
    | Nis'21 => T SIZEOF't
    | Nis'22 => T PLUS't
    | Nis'23 => T MINUS't
    | Nis'24 => T LPAREN't
    | Nis'25 => T LPAREN't
    | Nis'26 => T LONG't
    | Nis'27 => T INT't
    | Nis'28 => T INC't
    | Nis'29 => T LPAREN't
    | Nis'30 => T FLOAT't
    | Nis'31 => T ENUM't
    | Nis'32 => NT attribute_specifier_list'nt
    | Nis'33 => T OTHER_NAME't
    | Nis'34 => T LBRACE't
    | Nis'35 => T VAR_NAME't
    | Nis'36 => NT enumerator_list'nt
    | Nis'37 => T RBRACE't
    | Nis'38 => T COMMA't
    | Nis'39 => T RBRACE't
    | Nis'40 => NT enumerator'nt
    | Nis'41 => NT enumeration_constant'nt
    | Nis'42 => T EQ't
    | Nis'43 => T DEC't
    | Nis'44 => T CONSTANT't
    | Nis'45 => T BUILTIN_VA_ARG't
    | Nis'46 => T LPAREN't
    | Nis'47 => T BANG't
    | Nis'48 => T AND't
    | Nis'49 => T ALIGNOF't
    | Nis'50 => T LPAREN't
    | Nis'51 => T DOUBLE't
    | Nis'52 => T CONST't
    | Nis'53 => T CHAR't
    | Nis'54 => T ATTRIBUTE't
    | Nis'55 => T LPAREN't
    | Nis'56 => T LPAREN't
    | Nis'57 => T PACKED't
    | Nis'58 => T OTHER_NAME't
    | Nis'59 => T CONST't
    | Nis'60 => NT gcc_attribute_word'nt
    | Nis'61 => T LPAREN't
    | Nis'62 => T RPAREN't
    | Nis'63 => NT unary_operator'nt
    | Nis'64 => NT unary_expression'nt
    | Nis'65 => NT primary_expression'nt
    | Nis'66 => NT postfix_expression'nt
    | Nis'67 => T PTR't
    | Nis'68 => T OTHER_NAME't
    | Nis'69 => T LPAREN't
    | Nis'70 => T RPAREN't
    | Nis'71 => NT unary_expression'nt
    | Nis'72 => T XOR_ASSIGN't
    | Nis'73 => T SUB_ASSIGN't
    | Nis'74 => T RIGHT_ASSIGN't
    | Nis'75 => T OR_ASSIGN't
    | Nis'76 => T MUL_ASSIGN't
    | Nis'77 => T MOD_ASSIGN't
    | Nis'78 => T LEFT_ASSIGN't
    | Nis'79 => T EQ't
    | Nis'80 => T DIV_ASSIGN't
    | Nis'81 => T AND_ASSIGN't
    | Nis'82 => T ADD_ASSIGN't
    | Nis'83 => NT assignment_operator'nt
    | Nis'84 => NT shift_expression'nt
    | Nis'85 => T RIGHT't
    | Nis'86 => NT multiplicative_expression'nt
    | Nis'87 => T STAR't
    | Nis'88 => NT cast_expression'nt
    | Nis'89 => T SLASH't
    | Nis'90 => NT cast_expression'nt
    | Nis'91 => T PERCENT't
    | Nis'92 => NT cast_expression'nt
    | Nis'93 => NT cast_expression'nt
    | Nis'94 => NT additive_expression'nt
    | Nis'95 => T PLUS't
    | Nis'96 => NT multiplicative_expression'nt
    | Nis'97 => T MINUS't
    | Nis'98 => NT multiplicative_expression'nt
    | Nis'99 => T LEFT't
    | Nis'100 => NT additive_expression'nt
    | Nis'101 => NT relational_expression'nt
    | Nis'102 => T LT't
    | Nis'103 => NT shift_expression'nt
    | Nis'104 => NT additive_expression'nt
    | Nis'105 => T LEQ't
    | Nis'106 => NT shift_expression'nt
    | Nis'107 => T GT't
    | Nis'108 => NT shift_expression'nt
    | Nis'109 => T GEQ't
    | Nis'110 => NT shift_expression'nt
    | Nis'111 => NT logical_OR_expression'nt
    | Nis'112 => T QUESTION't
    | Nis'113 => NT logical_AND_expression'nt
    | Nis'114 => T ANDAND't
    | Nis'115 => NT inclusive_OR_expression'nt
    | Nis'116 => T BAR't
    | Nis'117 => NT exclusive_OR_expression'nt
    | Nis'118 => T HAT't
    | Nis'119 => NT equality_expression'nt
    | Nis'120 => T NEQ't
    | Nis'121 => NT relational_expression'nt
    | Nis'122 => T EQEQ't
    | Nis'123 => NT relational_expression'nt
    | Nis'124 => NT AND_expression'nt
    | Nis'125 => T AND't
    | Nis'126 => NT equality_expression'nt
    | Nis'127 => NT AND_expression'nt
    | Nis'128 => NT exclusive_OR_expression'nt
    | Nis'129 => NT inclusive_OR_expression'nt
    | Nis'130 => NT expression'nt
    | Nis'131 => T COMMA't
    | Nis'132 => NT conditional_expression'nt
    | Nis'133 => NT assignment_expression'nt
    | Nis'134 => T COLON't
    | Nis'135 => NT conditional_expression'nt
    | Nis'136 => NT assignment_expression'nt
    | Nis'137 => T BARBAR't
    | Nis'138 => NT logical_AND_expression'nt
    | Nis'139 => NT assignment_expression'nt
    | Nis'140 => NT assignment_expression'nt
    | Nis'141 => NT argument_expression_list'nt
    | Nis'142 => T RPAREN't
    | Nis'143 => T COMMA't
    | Nis'144 => NT assignment_expression'nt
    | Nis'145 => T LBRACK't
    | Nis'146 => NT expression'nt
    | Nis'147 => T RBRACK't
    | Nis'148 => T INC't
    | Nis'149 => T DOT't
    | Nis'150 => T OTHER_NAME't
    | Nis'151 => T DEC't
    | Nis'152 => NT cast_expression'nt
    | Nis'153 => NT argument_expression_list'nt
    | Nis'154 => T RPAREN't
    | Nis'155 => NT gcc_attribute_list'nt
    | Nis'156 => T RPAREN't
    | Nis'157 => T RPAREN't
    | Nis'158 => T COMMA't
    | Nis'159 => NT gcc_attribute'nt
    | Nis'160 => NT gcc_attribute'nt
    | Nis'161 => T ALIGNAS't
    | Nis'162 => T LPAREN't
    | Nis'163 => NT type_specifier'nt
    | Nis'164 => NT type_qualifier'nt
    | Nis'165 => NT struct_or_union_specifier'nt
    | Nis'166 => NT struct_or_union'nt
    | Nis'167 => NT attribute_specifier_list'nt
    | Nis'168 => T OTHER_NAME't
    | Nis'169 => T LBRACE't
    | Nis'170 => NT struct_declaration_list'nt
    | Nis'171 => T RBRACE't
    | Nis'172 => NT struct_declaration'nt
    | Nis'173 => NT specifier_qualifier_list'nt
    | Nis'174 => T VAR_NAME't
    | Nis'175 => T STAR't
    | Nis'176 => NT type_qualifier_list'nt
    | Nis'177 => NT type_qualifier'nt
    | Nis'178 => NT pointer'nt
    | Nis'179 => NT attribute_specifier'nt
    | Nis'180 => NT type_qualifier'nt
    | Nis'181 => NT pointer'nt
    | Nis'182 => T SEMICOLON't
    | Nis'183 => T LPAREN't
    | Nis'184 => NT pointer'nt
    | Nis'185 => NT direct_declarator'nt
    | Nis'186 => T LPAREN't
    | Nis'187 => T RPAREN't
    | Nis'188 => T INLINE't
    | Nis'189 => T EXTERN't
    | Nis'190 => T AUTO't
    | Nis'191 => NT type_specifier'nt
    | Nis'192 => NT type_qualifier'nt
    | Nis'193 => NT storage_class_specifier'nt
    | Nis'194 => NT function_specifier'nt
    | Nis'195 => NT enum_specifier'nt
    | Nis'196 => NT declaration_specifiers'nt
    | Nis'197 => NT declaration_specifiers'nt
    | Nis'198 => NT declaration_specifiers'nt
    | Nis'199 => NT declaration_specifiers'nt
    | Nis'200 => NT parameter_type_list'nt
    | Nis'201 => T RPAREN't
    | Nis'202 => NT parameter_list'nt
    | Nis'203 => T COMMA't
    | Nis'204 => T ELLIPSIS't
    | Nis'205 => NT parameter_declaration'nt
    | Nis'206 => NT declaration_specifiers'nt
    | Nis'207 => T LPAREN't
    | Nis'208 => T RPAREN't
    | Nis'209 => T LBRACK't
    | Nis'210 => T RBRACK't
    | Nis'211 => NT type_qualifier_list'nt
    | Nis'212 => T RBRACK't
    | Nis'213 => NT assignment_expression'nt
    | Nis'214 => T RBRACK't
    | Nis'215 => NT assignment_expression'nt
    | Nis'216 => T RBRACK't
    | Nis'217 => NT pointer'nt
    | Nis'218 => NT direct_abstract_declarator'nt
    | Nis'219 => T LPAREN't
    | Nis'220 => T RPAREN't
    | Nis'221 => NT parameter_type_list'nt
    | Nis'222 => T RPAREN't
    | Nis'223 => NT parameter_declaration'nt
    | Nis'224 => T LBRACK't
    | Nis'225 => T RBRACK't
    | Nis'226 => NT type_qualifier_list'nt
    | Nis'227 => T RBRACK't
    | Nis'228 => NT assignment_expression'nt
    | Nis'229 => T RBRACK't
    | Nis'230 => NT assignment_expression'nt
    | Nis'231 => T RBRACK't
    | Nis'232 => NT parameter_type_list'nt
    | Nis'233 => T RPAREN't
    | Nis'234 => NT direct_declarator'nt
    | Nis'235 => T LBRACK't
    | Nis'236 => T RBRACK't
    | Nis'237 => NT type_qualifier_list'nt
    | Nis'238 => T RBRACK't
    | Nis'239 => NT assignment_expression'nt
    | Nis'240 => T RBRACK't
    | Nis'241 => NT assignment_expression'nt
    | Nis'242 => T RBRACK't
    | Nis'243 => NT attribute_specifier_list'nt
    | Nis'244 => NT attribute_specifier'nt
    | Nis'245 => NT direct_abstract_declarator'nt
    | Nis'246 => NT declarator'nt
    | Nis'247 => T RPAREN't
    | Nis'248 => NT abstract_declarator'nt
    | Nis'249 => T RPAREN't
    | Nis'250 => NT declarator'nt
    | Nis'251 => NT abstract_declarator'nt
    | Nis'252 => NT attribute_specifier_list'nt
    | Nis'253 => T COLON't
    | Nis'254 => NT constant_expression'nt
    | Nis'255 => NT conditional_expression'nt
    | Nis'256 => NT struct_declarator_list'nt
    | Nis'257 => T SEMICOLON't
    | Nis'258 => T COMMA't
    | Nis'259 => NT struct_declarator'nt
    | Nis'260 => NT declarator'nt
    | Nis'261 => T COLON't
    | Nis'262 => NT constant_expression'nt
    | Nis'263 => NT struct_declarator'nt
    | Nis'264 => T LBRACE't
    | Nis'265 => NT struct_declaration_list'nt
    | Nis'266 => T RBRACE't
    | Nis'267 => NT specifier_qualifier_list'nt
    | Nis'268 => NT specifier_qualifier_list'nt
    | Nis'269 => NT type_name'nt
    | Nis'270 => T RPAREN't
    | Nis'271 => NT specifier_qualifier_list'nt
    | Nis'272 => T LPAREN't
    | Nis'273 => NT pointer'nt
    | Nis'274 => NT abstract_declarator'nt
    | Nis'275 => NT argument_expression_list'nt
    | Nis'276 => T RPAREN't
    | Nis'277 => NT type_name'nt
    | Nis'278 => T RPAREN't
    | Nis'279 => T LBRACE't
    | Nis'280 => T LBRACK't
    | Nis'281 => NT constant_expression'nt
    | Nis'282 => T RBRACK't
    | Nis'283 => T LBRACE't
    | Nis'284 => T DOT't
    | Nis'285 => T OTHER_NAME't
    | Nis'286 => NT initializer_list'nt
    | Nis'287 => T RBRACE't
    | Nis'288 => T COMMA't
    | Nis'289 => T RBRACE't
    | Nis'290 => NT designator_list'nt
    | Nis'291 => T EQ't
    | Nis'292 => NT designator'nt
    | Nis'293 => NT designator'nt
    | Nis'294 => NT designation'nt
    | Nis'295 => NT c_initializer'nt
    | Nis'296 => NT assignment_expression'nt
    | Nis'297 => NT c_initializer'nt
    | Nis'298 => NT designation'nt
    | Nis'299 => NT c_initializer'nt
    | Nis'300 => NT c_initializer'nt
    | Nis'301 => NT initializer_list'nt
    | Nis'302 => T RBRACE't
    | Nis'303 => T COMMA't
    | Nis'304 => T RBRACE't
    | Nis'305 => NT expression'nt
    | Nis'306 => T RPAREN't
    | Nis'307 => NT unary_expression'nt
    | Nis'308 => NT assignment_expression'nt
    | Nis'309 => T COMMA't
    | Nis'310 => NT type_name'nt
    | Nis'311 => T RPAREN't
    | Nis'312 => NT unary_expression'nt
    | Nis'313 => NT constant_expression'nt
    | Nis'314 => NT enumerator'nt
    | Nis'315 => T LBRACE't
    | Nis'316 => NT enumerator_list'nt
    | Nis'317 => T RBRACE't
    | Nis'318 => T COMMA't
    | Nis'319 => T RBRACE't
    | Nis'320 => NT type_name'nt
    | Nis'321 => T RPAREN't
    | Nis'322 => NT unary_expression'nt
    | Nis'323 => NT type_name'nt
    | Nis'324 => T RPAREN't
    | Nis'325 => NT cast_expression'nt
    | Nis'326 => NT type_name'nt
    | Nis'327 => T RPAREN't
    | Nis'328 => NT unary_expression'nt
    | Nis'329 => NT argument_expression_list'nt
    | Nis'330 => T RPAREN't
    | Nis'331 => T EOF't
    | Nis'333 => NT translation_unit'nt
    | Nis'334 => T EOF't
    | Nis'335 => NT function_definition'nt
    | Nis'336 => NT external_declaration'nt
    | Nis'337 => NT declaration_specifiers'nt
    | Nis'338 => T SEMICOLON't
    | Nis'339 => NT pointer'nt
    | Nis'340 => NT direct_old_function_declarator'nt
    | Nis'341 => NT direct_declarator'nt
    | Nis'342 => T LPAREN't
    | Nis'343 => T VAR_NAME't
    | Nis'344 => NT identifier_list'nt
    | Nis'345 => T RPAREN't
    | Nis'346 => T COMMA't
    | Nis'347 => T VAR_NAME't
    | Nis'348 => NT old_function_declarator'nt
    | Nis'349 => NT declaration_list'nt
    | Nis'350 => T LBRACE't
    | Nis'351 => T WHILE't
    | Nis'352 => T LPAREN't
    | Nis'353 => NT expression'nt
    | Nis'354 => T RPAREN't
    | Nis'355 => T SWITCH't
    | Nis'356 => T LPAREN't
    | Nis'357 => NT expression'nt
    | Nis'358 => T RPAREN't
    | Nis'359 => T SEMICOLON't
    | Nis'360 => T RETURN't
    | Nis'361 => T SEMICOLON't
    | Nis'362 => NT expression'nt
    | Nis'363 => T SEMICOLON't
    | Nis'364 => T OTHER_NAME't
    | Nis'365 => T COLON't
    | Nis'366 => T IF't
    | Nis'367 => T LPAREN't
    | Nis'368 => NT expression'nt
    | Nis'369 => T RPAREN't
    | Nis'370 => T WHILE't
    | Nis'371 => T LPAREN't
    | Nis'372 => NT expression'nt
    | Nis'373 => T RPAREN't
    | Nis'374 => T SWITCH't
    | Nis'375 => T LPAREN't
    | Nis'376 => NT expression'nt
    | Nis'377 => T RPAREN't
    | Nis'378 => T OTHER_NAME't
    | Nis'379 => T COLON't
    | Nis'380 => T IF't
    | Nis'381 => T LPAREN't
    | Nis'382 => NT expression'nt
    | Nis'383 => T RPAREN't
    | Nis'384 => T GOTO't
    | Nis'385 => T OTHER_NAME't
    | Nis'386 => T SEMICOLON't
    | Nis'387 => T FOR't
    | Nis'388 => T LPAREN't
    | Nis'389 => T SEMICOLON't
    | Nis'390 => T SEMICOLON't
    | Nis'391 => T RPAREN't
    | Nis'392 => T DO't
    | Nis'393 => T FOR't
    | Nis'394 => T LPAREN't
    | Nis'395 => T SEMICOLON't
    | Nis'396 => T SEMICOLON't
    | Nis'397 => T RPAREN't
    | Nis'398 => T DO't
    | Nis'399 => T DEFAULT't
    | Nis'400 => T COLON't
    | Nis'401 => T CONTINUE't
    | Nis'402 => T SEMICOLON't
    | Nis'403 => T CASE't
    | Nis'404 => NT constant_expression'nt
    | Nis'405 => T COLON't
    | Nis'406 => T BREAK't
    | Nis'407 => T SEMICOLON't
    | Nis'408 => T ASM't
    | Nis'409 => T LPAREN't
    | Nis'410 => T STRING_LITERAL't
    | Nis'411 => T RPAREN't
    | Nis'412 => T SEMICOLON't
    | Nis'413 => NT statement_dangerous'nt
    | Nis'414 => NT selection_statement_dangerous'nt
    | Nis'415 => NT labeled_statement_statement_dangerous_'nt
    | Nis'416 => NT jump_statement'nt
    | Nis'417 => NT iteration_statement_statement_dangerous_'nt
    | Nis'418 => NT expression_statement'nt
    | Nis'419 => NT expression'nt
    | Nis'420 => T SEMICOLON't
    | Nis'421 => NT compound_statement'nt
    | Nis'422 => NT asm_statement'nt
    | Nis'423 => NT statement_dangerous'nt
    | Nis'424 => NT statement_dangerous'nt
    | Nis'425 => T WHILE't
    | Nis'426 => T LPAREN't
    | Nis'427 => NT expression'nt
    | Nis'428 => T RPAREN't
    | Nis'429 => T SEMICOLON't
    | Nis'430 => NT statement_dangerous'nt
    | Nis'431 => NT expression'nt
    | Nis'432 => T RPAREN't
    | Nis'433 => NT statement_dangerous'nt
    | Nis'434 => NT expression'nt
    | Nis'435 => T SEMICOLON't
    | Nis'436 => T RPAREN't
    | Nis'437 => NT statement_dangerous'nt
    | Nis'438 => NT expression'nt
    | Nis'439 => T RPAREN't
    | Nis'440 => NT statement_dangerous'nt
    | Nis'441 => NT expression'nt
    | Nis'442 => T SEMICOLON't
    | Nis'443 => T SEMICOLON't
    | Nis'444 => T RPAREN't
    | Nis'445 => NT statement_dangerous'nt
    | Nis'446 => NT expression'nt
    | Nis'447 => T RPAREN't
    | Nis'448 => NT statement_dangerous'nt
    | Nis'449 => NT expression'nt
    | Nis'450 => T SEMICOLON't
    | Nis'451 => T RPAREN't
    | Nis'452 => NT statement_dangerous'nt
    | Nis'453 => NT expression'nt
    | Nis'454 => T RPAREN't
    | Nis'455 => NT statement_dangerous'nt
    | Nis'456 => NT declaration_specifiers'nt
    | Nis'457 => NT init_declarator_list'nt
    | Nis'458 => T SEMICOLON't
    | Nis'459 => T COMMA't
    | Nis'460 => NT init_declarator'nt
    | Nis'461 => NT declarator'nt
    | Nis'462 => T EQ't
    | Nis'463 => NT c_initializer'nt
    | Nis'464 => NT init_declarator'nt
    | Nis'465 => NT declaration'nt
    | Nis'466 => T SEMICOLON't
    | Nis'467 => T RPAREN't
    | Nis'468 => NT statement_dangerous'nt
    | Nis'469 => NT expression'nt
    | Nis'470 => T RPAREN't
    | Nis'471 => NT statement_dangerous'nt
    | Nis'472 => NT expression'nt
    | Nis'473 => T SEMICOLON't
    | Nis'474 => T RPAREN't
    | Nis'475 => NT statement_dangerous'nt
    | Nis'476 => NT expression'nt
    | Nis'477 => T RPAREN't
    | Nis'478 => NT statement_dangerous'nt
    | Nis'479 => NT statement_dangerous'nt
    | Nis'480 => T WHILE't
    | Nis'481 => T LPAREN't
    | Nis'482 => NT expression'nt
    | Nis'483 => T RPAREN't
    | Nis'484 => T SEMICOLON't
    | Nis'485 => T DEFAULT't
    | Nis'486 => T COLON't
    | Nis'487 => T CASE't
    | Nis'488 => NT constant_expression'nt
    | Nis'489 => T COLON't
    | Nis'490 => NT statement_safe'nt
    | Nis'491 => NT selection_statement_safe'nt
    | Nis'492 => NT labeled_statement_statement_safe_'nt
    | Nis'493 => NT jump_statement'nt
    | Nis'494 => NT iteration_statement_statement_safe_'nt
    | Nis'495 => NT expression_statement'nt
    | Nis'496 => NT compound_statement'nt
    | Nis'497 => NT asm_statement'nt
    | Nis'498 => NT statement_safe'nt
    | Nis'499 => NT statement_safe'nt
    | Nis'500 => NT expression'nt
    | Nis'501 => T RPAREN't
    | Nis'502 => NT statement_safe'nt
    | Nis'503 => NT expression'nt
    | Nis'504 => T SEMICOLON't
    | Nis'505 => T RPAREN't
    | Nis'506 => NT statement_safe'nt
    | Nis'507 => NT expression'nt
    | Nis'508 => T RPAREN't
    | Nis'509 => NT statement_safe'nt
    | Nis'510 => NT expression'nt
    | Nis'511 => T SEMICOLON't
    | Nis'512 => T SEMICOLON't
    | Nis'513 => T RPAREN't
    | Nis'514 => NT statement_safe'nt
    | Nis'515 => NT expression'nt
    | Nis'516 => T RPAREN't
    | Nis'517 => NT statement_safe'nt
    | Nis'518 => NT expression'nt
    | Nis'519 => T SEMICOLON't
    | Nis'520 => T RPAREN't
    | Nis'521 => NT statement_safe'nt
    | Nis'522 => NT expression'nt
    | Nis'523 => T RPAREN't
    | Nis'524 => NT statement_safe'nt
    | Nis'525 => NT declaration'nt
    | Nis'526 => T SEMICOLON't
    | Nis'527 => T RPAREN't
    | Nis'528 => NT statement_safe'nt
    | Nis'529 => NT expression'nt
    | Nis'530 => T RPAREN't
    | Nis'531 => NT statement_safe'nt
    | Nis'532 => NT expression'nt
    | Nis'533 => T SEMICOLON't
    | Nis'534 => T RPAREN't
    | Nis'535 => NT statement_safe'nt
    | Nis'536 => NT expression'nt
    | Nis'537 => T RPAREN't
    | Nis'538 => NT statement_safe'nt
    | Nis'539 => NT statement_safe'nt
    | Nis'540 => T ELSE't
    | Nis'541 => NT statement_safe'nt
    | Nis'542 => NT statement_dangerous'nt
    | Nis'543 => NT statement_dangerous'nt
    | Nis'544 => NT statement_safe'nt
    | Nis'545 => NT statement_dangerous'nt
    | Nis'546 => NT statement_safe'nt
    | Nis'547 => NT statement_dangerous'nt
    | Nis'548 => NT statement_safe'nt
    | Nis'549 => NT statement_dangerous'nt
    | Nis'550 => NT statement_safe'nt
    | Nis'551 => T ELSE't
    | Nis'552 => T RBRACE't
    | Nis'553 => T PRAGMA't
    | Nis'554 => NT statement_dangerous'nt
    | Nis'555 => NT declaration'nt
    | Nis'556 => NT block_item_list'nt
    | Nis'557 => T RBRACE't
    | Nis'558 => NT block_item'nt
    | Nis'559 => NT block_item'nt
    | Nis'560 => NT declaration'nt
    | Nis'561 => NT compound_statement'nt
    | Nis'562 => NT direct_old_function_declarator'nt
    | Nis'563 => NT direct_declarator'nt
    | Nis'564 => NT declarator'nt
    | Nis'565 => NT compound_statement'nt
    | Nis'566 => NT declaration'nt
    | Nis'567 => NT external_declaration'nt
  end.

Inductive initstate' : Set :=
  | Init'0.
Definition initstate := initstate'.

Program Instance initstateNum : Numbered initstate :=
  { inj := fun x => match x return _ with | Init'0 => Int31.On end;
    surj := (fun n => match n return _ with | 0 => Init'0 | _ => Init'0 end)%int31;
  inj_bound := 1%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance InitStateAlph : Alphabet initstate := _.

Include Automaton.Types.

Definition start_nt (init:initstate) : nonterminal :=
  match init with
    | Init'0 => translation_unit_file'nt
  end.

Definition action_table (state:state) : action :=
  match state with
    | Init Init'0 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PRAGMA't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | EOF't => Shift_act Nis'331 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'1 => Default_reduce_act Prod'type_qualifier'2
    | Ninit Nis'2 => Default_reduce_act Prod'type_specifier'0
    | Ninit Nis'3 => Default_reduce_act Prod'type_specifier'8
    | Ninit Nis'4 => Default_reduce_act Prod'struct_or_union'1
    | Ninit Nis'5 => Default_reduce_act Prod'type_specifier'9
    | Ninit Nis'6 => Default_reduce_act Prod'type_specifier'12
    | Ninit Nis'7 => Default_reduce_act Prod'storage_class_specifier'0
    | Ninit Nis'8 => Default_reduce_act Prod'struct_or_union'0
    | Ninit Nis'9 => Default_reduce_act Prod'storage_class_specifier'2
    | Ninit Nis'10 => Default_reduce_act Prod'type_specifier'7
    | Ninit Nis'11 => Default_reduce_act Prod'type_specifier'2
    | Ninit Nis'12 => Default_reduce_act Prod'type_qualifier'1
    | Ninit Nis'13 => Default_reduce_act Prod'storage_class_specifier'4
    | Ninit Nis'14 => Default_reduce_act Prod'external_declaration'2
    | Ninit Nis'15 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'16 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'16 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'17 => Default_reduce_act Prod'primary_expression'0
    | Ninit Nis'18 => Default_reduce_act Prod'unary_operator'4
    | Ninit Nis'19 => Default_reduce_act Prod'primary_expression'2
    | Ninit Nis'20 => Default_reduce_act Prod'unary_operator'1
    | Ninit Nis'21 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'24 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'22 => Default_reduce_act Prod'unary_operator'2
    | Ninit Nis'23 => Default_reduce_act Prod'unary_operator'3
    | Ninit Nis'24 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'25 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'26 => Default_reduce_act Prod'type_specifier'4
    | Ninit Nis'27 => Default_reduce_act Prod'type_specifier'3
    | Ninit Nis'28 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'29 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'29 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'30 => Default_reduce_act Prod'type_specifier'5
    | Ninit Nis'31 => Default_reduce_act Prod'attribute_specifier_list'0
    | Ninit Nis'32 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'33 (eq_refl _)
        | LBRACE't => Shift_act Nis'315 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'33 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Reduce_act Prod'enum_specifier'4
        | VOID't => Reduce_act Prod'enum_specifier'4
        | VAR_NAME't => Reduce_act Prod'enum_specifier'4
        | UNSIGNED't => Reduce_act Prod'enum_specifier'4
        | UNION't => Reduce_act Prod'enum_specifier'4
        | UNDERSCORE_BOOL't => Reduce_act Prod'enum_specifier'4
        | TYPEDEF_NAME't => Reduce_act Prod'enum_specifier'4
        | TYPEDEF't => Reduce_act Prod'enum_specifier'4
        | STRUCT't => Reduce_act Prod'enum_specifier'4
        | STATIC't => Reduce_act Prod'enum_specifier'4
        | STAR't => Reduce_act Prod'enum_specifier'4
        | SIGNED't => Reduce_act Prod'enum_specifier'4
        | SHORT't => Reduce_act Prod'enum_specifier'4
        | SEMICOLON't => Reduce_act Prod'enum_specifier'4
        | RPAREN't => Reduce_act Prod'enum_specifier'4
        | RESTRICT't => Reduce_act Prod'enum_specifier'4
        | REGISTER't => Reduce_act Prod'enum_specifier'4
        | PACKED't => Reduce_act Prod'enum_specifier'4
        | LPAREN't => Reduce_act Prod'enum_specifier'4
        | LONG't => Reduce_act Prod'enum_specifier'4
        | LBRACK't => Reduce_act Prod'enum_specifier'4
        | LBRACE't => Shift_act Nis'34 (eq_refl _)
        | INT't => Reduce_act Prod'enum_specifier'4
        | INLINE't => Reduce_act Prod'enum_specifier'4
        | FLOAT't => Reduce_act Prod'enum_specifier'4
        | EXTERN't => Reduce_act Prod'enum_specifier'4
        | ENUM't => Reduce_act Prod'enum_specifier'4
        | DOUBLE't => Reduce_act Prod'enum_specifier'4
        | CONST't => Reduce_act Prod'enum_specifier'4
        | COMMA't => Reduce_act Prod'enum_specifier'4
        | COLON't => Reduce_act Prod'enum_specifier'4
        | CHAR't => Reduce_act Prod'enum_specifier'4
        | AUTO't => Reduce_act Prod'enum_specifier'4
        | ATTRIBUTE't => Reduce_act Prod'enum_specifier'4
        | ALIGNAS't => Reduce_act Prod'enum_specifier'4
        | _ => Fail_act
      end)
    | Ninit Nis'34 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'35 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'35 => Default_reduce_act Prod'enumeration_constant'0
    | Ninit Nis'36 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Shift_act Nis'37 (eq_refl _)
        | COMMA't => Shift_act Nis'38 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'37 => Default_reduce_act Prod'enum_specifier'0
    | Ninit Nis'38 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'35 (eq_refl _)
        | RBRACE't => Shift_act Nis'39 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'39 => Default_reduce_act Prod'enum_specifier'2
    | Ninit Nis'40 => Default_reduce_act Prod'enumerator_list'1
    | Ninit Nis'41 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Reduce_act Prod'enumerator'0
        | EQ't => Shift_act Nis'42 (eq_refl _)
        | COMMA't => Reduce_act Prod'enumerator'0
        | _ => Fail_act
      end)
    | Ninit Nis'42 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'43 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'29 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'44 => Default_reduce_act Prod'primary_expression'1
    | Ninit Nis'45 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'46 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'46 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'47 => Default_reduce_act Prod'unary_operator'5
    | Ninit Nis'48 => Default_reduce_act Prod'unary_operator'0
    | Ninit Nis'49 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'50 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'50 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'51 => Default_reduce_act Prod'type_specifier'6
    | Ninit Nis'52 => Default_reduce_act Prod'type_qualifier'0
    | Ninit Nis'53 => Default_reduce_act Prod'type_specifier'1
    | Ninit Nis'54 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'55 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'55 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'56 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'56 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'gcc_attribute'0
        | PACKED't => Shift_act Nis'57 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'58 (eq_refl _)
        | CONST't => Shift_act Nis'59 (eq_refl _)
        | COMMA't => Reduce_act Prod'gcc_attribute'0
        | _ => Fail_act
      end)
    | Ninit Nis'57 => Default_reduce_act Prod'gcc_attribute_word'2
    | Ninit Nis'58 => Default_reduce_act Prod'gcc_attribute_word'0
    | Ninit Nis'59 => Default_reduce_act Prod'gcc_attribute_word'1
    | Ninit Nis'60 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'gcc_attribute'1
        | LPAREN't => Shift_act Nis'61 (eq_refl _)
        | COMMA't => Reduce_act Prod'gcc_attribute'1
        | _ => Fail_act
      end)
    | Ninit Nis'61 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'62 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'62 => Default_reduce_act Prod'gcc_attribute'2
    | Ninit Nis'63 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'64 => Default_reduce_act Prod'cast_expression'0
    | Ninit Nis'65 => Default_reduce_act Prod'postfix_expression'0
    | Ninit Nis'66 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | XOR_ASSIGN't => Reduce_act Prod'unary_expression'0
        | SUB_ASSIGN't => Reduce_act Prod'unary_expression'0
        | STAR't => Reduce_act Prod'unary_expression'0
        | SLASH't => Reduce_act Prod'unary_expression'0
        | SEMICOLON't => Reduce_act Prod'unary_expression'0
        | RPAREN't => Reduce_act Prod'unary_expression'0
        | RIGHT_ASSIGN't => Reduce_act Prod'unary_expression'0
        | RIGHT't => Reduce_act Prod'unary_expression'0
        | RBRACK't => Reduce_act Prod'unary_expression'0
        | RBRACE't => Reduce_act Prod'unary_expression'0
        | QUESTION't => Reduce_act Prod'unary_expression'0
        | PTR't => Shift_act Nis'67 (eq_refl _)
        | PLUS't => Reduce_act Prod'unary_expression'0
        | PERCENT't => Reduce_act Prod'unary_expression'0
        | OR_ASSIGN't => Reduce_act Prod'unary_expression'0
        | NEQ't => Reduce_act Prod'unary_expression'0
        | MUL_ASSIGN't => Reduce_act Prod'unary_expression'0
        | MOD_ASSIGN't => Reduce_act Prod'unary_expression'0
        | MINUS't => Reduce_act Prod'unary_expression'0
        | LT't => Reduce_act Prod'unary_expression'0
        | LPAREN't => Shift_act Nis'69 (eq_refl _)
        | LEQ't => Reduce_act Prod'unary_expression'0
        | LEFT_ASSIGN't => Reduce_act Prod'unary_expression'0
        | LEFT't => Reduce_act Prod'unary_expression'0
        | LBRACK't => Shift_act Nis'145 (eq_refl _)
        | INC't => Shift_act Nis'148 (eq_refl _)
        | HAT't => Reduce_act Prod'unary_expression'0
        | GT't => Reduce_act Prod'unary_expression'0
        | GEQ't => Reduce_act Prod'unary_expression'0
        | EQEQ't => Reduce_act Prod'unary_expression'0
        | EQ't => Reduce_act Prod'unary_expression'0
        | DOT't => Shift_act Nis'149 (eq_refl _)
        | DIV_ASSIGN't => Reduce_act Prod'unary_expression'0
        | DEC't => Shift_act Nis'151 (eq_refl _)
        | COMMA't => Reduce_act Prod'unary_expression'0
        | COLON't => Reduce_act Prod'unary_expression'0
        | BARBAR't => Reduce_act Prod'unary_expression'0
        | BAR't => Reduce_act Prod'unary_expression'0
        | AND_ASSIGN't => Reduce_act Prod'unary_expression'0
        | ANDAND't => Reduce_act Prod'unary_expression'0
        | AND't => Reduce_act Prod'unary_expression'0
        | ADD_ASSIGN't => Reduce_act Prod'unary_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'67 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'68 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'68 => Default_reduce_act Prod'postfix_expression'6
    | Ninit Nis'69 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'70 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'70 => Default_reduce_act Prod'postfix_expression'3
    | Ninit Nis'71 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | XOR_ASSIGN't => Shift_act Nis'72 (eq_refl _)
        | SUB_ASSIGN't => Shift_act Nis'73 (eq_refl _)
        | STAR't => Reduce_act Prod'cast_expression'0
        | SLASH't => Reduce_act Prod'cast_expression'0
        | SEMICOLON't => Reduce_act Prod'cast_expression'0
        | RPAREN't => Reduce_act Prod'cast_expression'0
        | RIGHT_ASSIGN't => Shift_act Nis'74 (eq_refl _)
        | RIGHT't => Reduce_act Prod'cast_expression'0
        | RBRACK't => Reduce_act Prod'cast_expression'0
        | RBRACE't => Reduce_act Prod'cast_expression'0
        | QUESTION't => Reduce_act Prod'cast_expression'0
        | PLUS't => Reduce_act Prod'cast_expression'0
        | PERCENT't => Reduce_act Prod'cast_expression'0
        | OR_ASSIGN't => Shift_act Nis'75 (eq_refl _)
        | NEQ't => Reduce_act Prod'cast_expression'0
        | MUL_ASSIGN't => Shift_act Nis'76 (eq_refl _)
        | MOD_ASSIGN't => Shift_act Nis'77 (eq_refl _)
        | MINUS't => Reduce_act Prod'cast_expression'0
        | LT't => Reduce_act Prod'cast_expression'0
        | LEQ't => Reduce_act Prod'cast_expression'0
        | LEFT_ASSIGN't => Shift_act Nis'78 (eq_refl _)
        | LEFT't => Reduce_act Prod'cast_expression'0
        | HAT't => Reduce_act Prod'cast_expression'0
        | GT't => Reduce_act Prod'cast_expression'0
        | GEQ't => Reduce_act Prod'cast_expression'0
        | EQEQ't => Reduce_act Prod'cast_expression'0
        | EQ't => Shift_act Nis'79 (eq_refl _)
        | DIV_ASSIGN't => Shift_act Nis'80 (eq_refl _)
        | COMMA't => Reduce_act Prod'cast_expression'0
        | COLON't => Reduce_act Prod'cast_expression'0
        | BARBAR't => Reduce_act Prod'cast_expression'0
        | BAR't => Reduce_act Prod'cast_expression'0
        | AND_ASSIGN't => Shift_act Nis'81 (eq_refl _)
        | ANDAND't => Reduce_act Prod'cast_expression'0
        | AND't => Reduce_act Prod'cast_expression'0
        | ADD_ASSIGN't => Shift_act Nis'82 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'72 => Default_reduce_act Prod'assignment_operator'8
    | Ninit Nis'73 => Default_reduce_act Prod'assignment_operator'5
    | Ninit Nis'74 => Default_reduce_act Prod'assignment_operator'7
    | Ninit Nis'75 => Default_reduce_act Prod'assignment_operator'9
    | Ninit Nis'76 => Default_reduce_act Prod'assignment_operator'1
    | Ninit Nis'77 => Default_reduce_act Prod'assignment_operator'3
    | Ninit Nis'78 => Default_reduce_act Prod'assignment_operator'6
    | Ninit Nis'79 => Default_reduce_act Prod'assignment_operator'0
    | Ninit Nis'80 => Default_reduce_act Prod'assignment_operator'2
    | Ninit Nis'81 => Default_reduce_act Prod'assignment_operator'10
    | Ninit Nis'82 => Default_reduce_act Prod'assignment_operator'4
    | Ninit Nis'83 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'84 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'0
        | RPAREN't => Reduce_act Prod'relational_expression'0
        | RIGHT't => Shift_act Nis'85 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'0
        | RBRACE't => Reduce_act Prod'relational_expression'0
        | QUESTION't => Reduce_act Prod'relational_expression'0
        | NEQ't => Reduce_act Prod'relational_expression'0
        | LT't => Reduce_act Prod'relational_expression'0
        | LEQ't => Reduce_act Prod'relational_expression'0
        | LEFT't => Shift_act Nis'99 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'0
        | GT't => Reduce_act Prod'relational_expression'0
        | GEQ't => Reduce_act Prod'relational_expression'0
        | EQEQ't => Reduce_act Prod'relational_expression'0
        | COMMA't => Reduce_act Prod'relational_expression'0
        | COLON't => Reduce_act Prod'relational_expression'0
        | BARBAR't => Reduce_act Prod'relational_expression'0
        | BAR't => Reduce_act Prod'relational_expression'0
        | ANDAND't => Reduce_act Prod'relational_expression'0
        | AND't => Reduce_act Prod'relational_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'85 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'86 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STAR't => Shift_act Nis'87 (eq_refl _)
        | SLASH't => Shift_act Nis'89 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'additive_expression'0
        | RPAREN't => Reduce_act Prod'additive_expression'0
        | RIGHT't => Reduce_act Prod'additive_expression'0
        | RBRACK't => Reduce_act Prod'additive_expression'0
        | RBRACE't => Reduce_act Prod'additive_expression'0
        | QUESTION't => Reduce_act Prod'additive_expression'0
        | PLUS't => Reduce_act Prod'additive_expression'0
        | PERCENT't => Shift_act Nis'91 (eq_refl _)
        | NEQ't => Reduce_act Prod'additive_expression'0
        | MINUS't => Reduce_act Prod'additive_expression'0
        | LT't => Reduce_act Prod'additive_expression'0
        | LEQ't => Reduce_act Prod'additive_expression'0
        | LEFT't => Reduce_act Prod'additive_expression'0
        | HAT't => Reduce_act Prod'additive_expression'0
        | GT't => Reduce_act Prod'additive_expression'0
        | GEQ't => Reduce_act Prod'additive_expression'0
        | EQEQ't => Reduce_act Prod'additive_expression'0
        | COMMA't => Reduce_act Prod'additive_expression'0
        | COLON't => Reduce_act Prod'additive_expression'0
        | BARBAR't => Reduce_act Prod'additive_expression'0
        | BAR't => Reduce_act Prod'additive_expression'0
        | ANDAND't => Reduce_act Prod'additive_expression'0
        | AND't => Reduce_act Prod'additive_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'87 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'88 => Default_reduce_act Prod'multiplicative_expression'1
    | Ninit Nis'89 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'90 => Default_reduce_act Prod'multiplicative_expression'2
    | Ninit Nis'91 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'92 => Default_reduce_act Prod'multiplicative_expression'3
    | Ninit Nis'93 => Default_reduce_act Prod'multiplicative_expression'0
    | Ninit Nis'94 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'shift_expression'2
        | RPAREN't => Reduce_act Prod'shift_expression'2
        | RIGHT't => Reduce_act Prod'shift_expression'2
        | RBRACK't => Reduce_act Prod'shift_expression'2
        | RBRACE't => Reduce_act Prod'shift_expression'2
        | QUESTION't => Reduce_act Prod'shift_expression'2
        | PLUS't => Shift_act Nis'95 (eq_refl _)
        | NEQ't => Reduce_act Prod'shift_expression'2
        | MINUS't => Shift_act Nis'97 (eq_refl _)
        | LT't => Reduce_act Prod'shift_expression'2
        | LEQ't => Reduce_act Prod'shift_expression'2
        | LEFT't => Reduce_act Prod'shift_expression'2
        | HAT't => Reduce_act Prod'shift_expression'2
        | GT't => Reduce_act Prod'shift_expression'2
        | GEQ't => Reduce_act Prod'shift_expression'2
        | EQEQ't => Reduce_act Prod'shift_expression'2
        | COMMA't => Reduce_act Prod'shift_expression'2
        | COLON't => Reduce_act Prod'shift_expression'2
        | BARBAR't => Reduce_act Prod'shift_expression'2
        | BAR't => Reduce_act Prod'shift_expression'2
        | ANDAND't => Reduce_act Prod'shift_expression'2
        | AND't => Reduce_act Prod'shift_expression'2
        | _ => Fail_act
      end)
    | Ninit Nis'95 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'96 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STAR't => Shift_act Nis'87 (eq_refl _)
        | SLASH't => Shift_act Nis'89 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'additive_expression'1
        | RPAREN't => Reduce_act Prod'additive_expression'1
        | RIGHT't => Reduce_act Prod'additive_expression'1
        | RBRACK't => Reduce_act Prod'additive_expression'1
        | RBRACE't => Reduce_act Prod'additive_expression'1
        | QUESTION't => Reduce_act Prod'additive_expression'1
        | PLUS't => Reduce_act Prod'additive_expression'1
        | PERCENT't => Shift_act Nis'91 (eq_refl _)
        | NEQ't => Reduce_act Prod'additive_expression'1
        | MINUS't => Reduce_act Prod'additive_expression'1
        | LT't => Reduce_act Prod'additive_expression'1
        | LEQ't => Reduce_act Prod'additive_expression'1
        | LEFT't => Reduce_act Prod'additive_expression'1
        | HAT't => Reduce_act Prod'additive_expression'1
        | GT't => Reduce_act Prod'additive_expression'1
        | GEQ't => Reduce_act Prod'additive_expression'1
        | EQEQ't => Reduce_act Prod'additive_expression'1
        | COMMA't => Reduce_act Prod'additive_expression'1
        | COLON't => Reduce_act Prod'additive_expression'1
        | BARBAR't => Reduce_act Prod'additive_expression'1
        | BAR't => Reduce_act Prod'additive_expression'1
        | ANDAND't => Reduce_act Prod'additive_expression'1
        | AND't => Reduce_act Prod'additive_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'97 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'98 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STAR't => Shift_act Nis'87 (eq_refl _)
        | SLASH't => Shift_act Nis'89 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'additive_expression'2
        | RPAREN't => Reduce_act Prod'additive_expression'2
        | RIGHT't => Reduce_act Prod'additive_expression'2
        | RBRACK't => Reduce_act Prod'additive_expression'2
        | RBRACE't => Reduce_act Prod'additive_expression'2
        | QUESTION't => Reduce_act Prod'additive_expression'2
        | PLUS't => Reduce_act Prod'additive_expression'2
        | PERCENT't => Shift_act Nis'91 (eq_refl _)
        | NEQ't => Reduce_act Prod'additive_expression'2
        | MINUS't => Reduce_act Prod'additive_expression'2
        | LT't => Reduce_act Prod'additive_expression'2
        | LEQ't => Reduce_act Prod'additive_expression'2
        | LEFT't => Reduce_act Prod'additive_expression'2
        | HAT't => Reduce_act Prod'additive_expression'2
        | GT't => Reduce_act Prod'additive_expression'2
        | GEQ't => Reduce_act Prod'additive_expression'2
        | EQEQ't => Reduce_act Prod'additive_expression'2
        | COMMA't => Reduce_act Prod'additive_expression'2
        | COLON't => Reduce_act Prod'additive_expression'2
        | BARBAR't => Reduce_act Prod'additive_expression'2
        | BAR't => Reduce_act Prod'additive_expression'2
        | ANDAND't => Reduce_act Prod'additive_expression'2
        | AND't => Reduce_act Prod'additive_expression'2
        | _ => Fail_act
      end)
    | Ninit Nis'99 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'100 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'shift_expression'1
        | RPAREN't => Reduce_act Prod'shift_expression'1
        | RIGHT't => Reduce_act Prod'shift_expression'1
        | RBRACK't => Reduce_act Prod'shift_expression'1
        | RBRACE't => Reduce_act Prod'shift_expression'1
        | QUESTION't => Reduce_act Prod'shift_expression'1
        | PLUS't => Shift_act Nis'95 (eq_refl _)
        | NEQ't => Reduce_act Prod'shift_expression'1
        | MINUS't => Shift_act Nis'97 (eq_refl _)
        | LT't => Reduce_act Prod'shift_expression'1
        | LEQ't => Reduce_act Prod'shift_expression'1
        | LEFT't => Reduce_act Prod'shift_expression'1
        | HAT't => Reduce_act Prod'shift_expression'1
        | GT't => Reduce_act Prod'shift_expression'1
        | GEQ't => Reduce_act Prod'shift_expression'1
        | EQEQ't => Reduce_act Prod'shift_expression'1
        | COMMA't => Reduce_act Prod'shift_expression'1
        | COLON't => Reduce_act Prod'shift_expression'1
        | BARBAR't => Reduce_act Prod'shift_expression'1
        | BAR't => Reduce_act Prod'shift_expression'1
        | ANDAND't => Reduce_act Prod'shift_expression'1
        | AND't => Reduce_act Prod'shift_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'101 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'equality_expression'0
        | RPAREN't => Reduce_act Prod'equality_expression'0
        | RBRACK't => Reduce_act Prod'equality_expression'0
        | RBRACE't => Reduce_act Prod'equality_expression'0
        | QUESTION't => Reduce_act Prod'equality_expression'0
        | NEQ't => Reduce_act Prod'equality_expression'0
        | LT't => Shift_act Nis'102 (eq_refl _)
        | LEQ't => Shift_act Nis'105 (eq_refl _)
        | HAT't => Reduce_act Prod'equality_expression'0
        | GT't => Shift_act Nis'107 (eq_refl _)
        | GEQ't => Shift_act Nis'109 (eq_refl _)
        | EQEQ't => Reduce_act Prod'equality_expression'0
        | COMMA't => Reduce_act Prod'equality_expression'0
        | COLON't => Reduce_act Prod'equality_expression'0
        | BARBAR't => Reduce_act Prod'equality_expression'0
        | BAR't => Reduce_act Prod'equality_expression'0
        | ANDAND't => Reduce_act Prod'equality_expression'0
        | AND't => Reduce_act Prod'equality_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'102 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'103 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'1
        | RPAREN't => Reduce_act Prod'relational_expression'1
        | RIGHT't => Shift_act Nis'85 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'1
        | RBRACE't => Reduce_act Prod'relational_expression'1
        | QUESTION't => Reduce_act Prod'relational_expression'1
        | NEQ't => Reduce_act Prod'relational_expression'1
        | LT't => Reduce_act Prod'relational_expression'1
        | LEQ't => Reduce_act Prod'relational_expression'1
        | LEFT't => Shift_act Nis'99 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'1
        | GT't => Reduce_act Prod'relational_expression'1
        | GEQ't => Reduce_act Prod'relational_expression'1
        | EQEQ't => Reduce_act Prod'relational_expression'1
        | COMMA't => Reduce_act Prod'relational_expression'1
        | COLON't => Reduce_act Prod'relational_expression'1
        | BARBAR't => Reduce_act Prod'relational_expression'1
        | BAR't => Reduce_act Prod'relational_expression'1
        | ANDAND't => Reduce_act Prod'relational_expression'1
        | AND't => Reduce_act Prod'relational_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'104 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'shift_expression'0
        | RPAREN't => Reduce_act Prod'shift_expression'0
        | RIGHT't => Reduce_act Prod'shift_expression'0
        | RBRACK't => Reduce_act Prod'shift_expression'0
        | RBRACE't => Reduce_act Prod'shift_expression'0
        | QUESTION't => Reduce_act Prod'shift_expression'0
        | PLUS't => Shift_act Nis'95 (eq_refl _)
        | NEQ't => Reduce_act Prod'shift_expression'0
        | MINUS't => Shift_act Nis'97 (eq_refl _)
        | LT't => Reduce_act Prod'shift_expression'0
        | LEQ't => Reduce_act Prod'shift_expression'0
        | LEFT't => Reduce_act Prod'shift_expression'0
        | HAT't => Reduce_act Prod'shift_expression'0
        | GT't => Reduce_act Prod'shift_expression'0
        | GEQ't => Reduce_act Prod'shift_expression'0
        | EQEQ't => Reduce_act Prod'shift_expression'0
        | COMMA't => Reduce_act Prod'shift_expression'0
        | COLON't => Reduce_act Prod'shift_expression'0
        | BARBAR't => Reduce_act Prod'shift_expression'0
        | BAR't => Reduce_act Prod'shift_expression'0
        | ANDAND't => Reduce_act Prod'shift_expression'0
        | AND't => Reduce_act Prod'shift_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'105 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'106 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'3
        | RPAREN't => Reduce_act Prod'relational_expression'3
        | RIGHT't => Shift_act Nis'85 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'3
        | RBRACE't => Reduce_act Prod'relational_expression'3
        | QUESTION't => Reduce_act Prod'relational_expression'3
        | NEQ't => Reduce_act Prod'relational_expression'3
        | LT't => Reduce_act Prod'relational_expression'3
        | LEQ't => Reduce_act Prod'relational_expression'3
        | LEFT't => Shift_act Nis'99 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'3
        | GT't => Reduce_act Prod'relational_expression'3
        | GEQ't => Reduce_act Prod'relational_expression'3
        | EQEQ't => Reduce_act Prod'relational_expression'3
        | COMMA't => Reduce_act Prod'relational_expression'3
        | COLON't => Reduce_act Prod'relational_expression'3
        | BARBAR't => Reduce_act Prod'relational_expression'3
        | BAR't => Reduce_act Prod'relational_expression'3
        | ANDAND't => Reduce_act Prod'relational_expression'3
        | AND't => Reduce_act Prod'relational_expression'3
        | _ => Fail_act
      end)
    | Ninit Nis'107 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'108 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'2
        | RPAREN't => Reduce_act Prod'relational_expression'2
        | RIGHT't => Shift_act Nis'85 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'2
        | RBRACE't => Reduce_act Prod'relational_expression'2
        | QUESTION't => Reduce_act Prod'relational_expression'2
        | NEQ't => Reduce_act Prod'relational_expression'2
        | LT't => Reduce_act Prod'relational_expression'2
        | LEQ't => Reduce_act Prod'relational_expression'2
        | LEFT't => Shift_act Nis'99 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'2
        | GT't => Reduce_act Prod'relational_expression'2
        | GEQ't => Reduce_act Prod'relational_expression'2
        | EQEQ't => Reduce_act Prod'relational_expression'2
        | COMMA't => Reduce_act Prod'relational_expression'2
        | COLON't => Reduce_act Prod'relational_expression'2
        | BARBAR't => Reduce_act Prod'relational_expression'2
        | BAR't => Reduce_act Prod'relational_expression'2
        | ANDAND't => Reduce_act Prod'relational_expression'2
        | AND't => Reduce_act Prod'relational_expression'2
        | _ => Fail_act
      end)
    | Ninit Nis'109 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'110 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'4
        | RPAREN't => Reduce_act Prod'relational_expression'4
        | RIGHT't => Shift_act Nis'85 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'4
        | RBRACE't => Reduce_act Prod'relational_expression'4
        | QUESTION't => Reduce_act Prod'relational_expression'4
        | NEQ't => Reduce_act Prod'relational_expression'4
        | LT't => Reduce_act Prod'relational_expression'4
        | LEQ't => Reduce_act Prod'relational_expression'4
        | LEFT't => Shift_act Nis'99 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'4
        | GT't => Reduce_act Prod'relational_expression'4
        | GEQ't => Reduce_act Prod'relational_expression'4
        | EQEQ't => Reduce_act Prod'relational_expression'4
        | COMMA't => Reduce_act Prod'relational_expression'4
        | COLON't => Reduce_act Prod'relational_expression'4
        | BARBAR't => Reduce_act Prod'relational_expression'4
        | BAR't => Reduce_act Prod'relational_expression'4
        | ANDAND't => Reduce_act Prod'relational_expression'4
        | AND't => Reduce_act Prod'relational_expression'4
        | _ => Fail_act
      end)
    | Ninit Nis'111 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'conditional_expression'0
        | RPAREN't => Reduce_act Prod'conditional_expression'0
        | RBRACK't => Reduce_act Prod'conditional_expression'0
        | RBRACE't => Reduce_act Prod'conditional_expression'0
        | QUESTION't => Shift_act Nis'112 (eq_refl _)
        | COMMA't => Reduce_act Prod'conditional_expression'0
        | COLON't => Reduce_act Prod'conditional_expression'0
        | BARBAR't => Shift_act Nis'137 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'112 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'113 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'logical_OR_expression'0
        | RPAREN't => Reduce_act Prod'logical_OR_expression'0
        | RBRACK't => Reduce_act Prod'logical_OR_expression'0
        | RBRACE't => Reduce_act Prod'logical_OR_expression'0
        | QUESTION't => Reduce_act Prod'logical_OR_expression'0
        | COMMA't => Reduce_act Prod'logical_OR_expression'0
        | COLON't => Reduce_act Prod'logical_OR_expression'0
        | BARBAR't => Reduce_act Prod'logical_OR_expression'0
        | ANDAND't => Shift_act Nis'114 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'114 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'115 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'logical_AND_expression'1
        | RPAREN't => Reduce_act Prod'logical_AND_expression'1
        | RBRACK't => Reduce_act Prod'logical_AND_expression'1
        | RBRACE't => Reduce_act Prod'logical_AND_expression'1
        | QUESTION't => Reduce_act Prod'logical_AND_expression'1
        | COMMA't => Reduce_act Prod'logical_AND_expression'1
        | COLON't => Reduce_act Prod'logical_AND_expression'1
        | BARBAR't => Reduce_act Prod'logical_AND_expression'1
        | BAR't => Shift_act Nis'116 (eq_refl _)
        | ANDAND't => Reduce_act Prod'logical_AND_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'116 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'117 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'inclusive_OR_expression'1
        | RPAREN't => Reduce_act Prod'inclusive_OR_expression'1
        | RBRACK't => Reduce_act Prod'inclusive_OR_expression'1
        | RBRACE't => Reduce_act Prod'inclusive_OR_expression'1
        | QUESTION't => Reduce_act Prod'inclusive_OR_expression'1
        | HAT't => Shift_act Nis'118 (eq_refl _)
        | COMMA't => Reduce_act Prod'inclusive_OR_expression'1
        | COLON't => Reduce_act Prod'inclusive_OR_expression'1
        | BARBAR't => Reduce_act Prod'inclusive_OR_expression'1
        | BAR't => Reduce_act Prod'inclusive_OR_expression'1
        | ANDAND't => Reduce_act Prod'inclusive_OR_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'118 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'119 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'AND_expression'0
        | RPAREN't => Reduce_act Prod'AND_expression'0
        | RBRACK't => Reduce_act Prod'AND_expression'0
        | RBRACE't => Reduce_act Prod'AND_expression'0
        | QUESTION't => Reduce_act Prod'AND_expression'0
        | NEQ't => Shift_act Nis'120 (eq_refl _)
        | HAT't => Reduce_act Prod'AND_expression'0
        | EQEQ't => Shift_act Nis'122 (eq_refl _)
        | COMMA't => Reduce_act Prod'AND_expression'0
        | COLON't => Reduce_act Prod'AND_expression'0
        | BARBAR't => Reduce_act Prod'AND_expression'0
        | BAR't => Reduce_act Prod'AND_expression'0
        | ANDAND't => Reduce_act Prod'AND_expression'0
        | AND't => Reduce_act Prod'AND_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'120 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'121 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'equality_expression'2
        | RPAREN't => Reduce_act Prod'equality_expression'2
        | RBRACK't => Reduce_act Prod'equality_expression'2
        | RBRACE't => Reduce_act Prod'equality_expression'2
        | QUESTION't => Reduce_act Prod'equality_expression'2
        | NEQ't => Reduce_act Prod'equality_expression'2
        | LT't => Shift_act Nis'102 (eq_refl _)
        | LEQ't => Shift_act Nis'105 (eq_refl _)
        | HAT't => Reduce_act Prod'equality_expression'2
        | GT't => Shift_act Nis'107 (eq_refl _)
        | GEQ't => Shift_act Nis'109 (eq_refl _)
        | EQEQ't => Reduce_act Prod'equality_expression'2
        | COMMA't => Reduce_act Prod'equality_expression'2
        | COLON't => Reduce_act Prod'equality_expression'2
        | BARBAR't => Reduce_act Prod'equality_expression'2
        | BAR't => Reduce_act Prod'equality_expression'2
        | ANDAND't => Reduce_act Prod'equality_expression'2
        | AND't => Reduce_act Prod'equality_expression'2
        | _ => Fail_act
      end)
    | Ninit Nis'122 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'123 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'equality_expression'1
        | RPAREN't => Reduce_act Prod'equality_expression'1
        | RBRACK't => Reduce_act Prod'equality_expression'1
        | RBRACE't => Reduce_act Prod'equality_expression'1
        | QUESTION't => Reduce_act Prod'equality_expression'1
        | NEQ't => Reduce_act Prod'equality_expression'1
        | LT't => Shift_act Nis'102 (eq_refl _)
        | LEQ't => Shift_act Nis'105 (eq_refl _)
        | HAT't => Reduce_act Prod'equality_expression'1
        | GT't => Shift_act Nis'107 (eq_refl _)
        | GEQ't => Shift_act Nis'109 (eq_refl _)
        | EQEQ't => Reduce_act Prod'equality_expression'1
        | COMMA't => Reduce_act Prod'equality_expression'1
        | COLON't => Reduce_act Prod'equality_expression'1
        | BARBAR't => Reduce_act Prod'equality_expression'1
        | BAR't => Reduce_act Prod'equality_expression'1
        | ANDAND't => Reduce_act Prod'equality_expression'1
        | AND't => Reduce_act Prod'equality_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'124 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'exclusive_OR_expression'1
        | RPAREN't => Reduce_act Prod'exclusive_OR_expression'1
        | RBRACK't => Reduce_act Prod'exclusive_OR_expression'1
        | RBRACE't => Reduce_act Prod'exclusive_OR_expression'1
        | QUESTION't => Reduce_act Prod'exclusive_OR_expression'1
        | HAT't => Reduce_act Prod'exclusive_OR_expression'1
        | COMMA't => Reduce_act Prod'exclusive_OR_expression'1
        | COLON't => Reduce_act Prod'exclusive_OR_expression'1
        | BARBAR't => Reduce_act Prod'exclusive_OR_expression'1
        | BAR't => Reduce_act Prod'exclusive_OR_expression'1
        | ANDAND't => Reduce_act Prod'exclusive_OR_expression'1
        | AND't => Shift_act Nis'125 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'125 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'126 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'AND_expression'1
        | RPAREN't => Reduce_act Prod'AND_expression'1
        | RBRACK't => Reduce_act Prod'AND_expression'1
        | RBRACE't => Reduce_act Prod'AND_expression'1
        | QUESTION't => Reduce_act Prod'AND_expression'1
        | NEQ't => Shift_act Nis'120 (eq_refl _)
        | HAT't => Reduce_act Prod'AND_expression'1
        | EQEQ't => Shift_act Nis'122 (eq_refl _)
        | COMMA't => Reduce_act Prod'AND_expression'1
        | COLON't => Reduce_act Prod'AND_expression'1
        | BARBAR't => Reduce_act Prod'AND_expression'1
        | BAR't => Reduce_act Prod'AND_expression'1
        | ANDAND't => Reduce_act Prod'AND_expression'1
        | AND't => Reduce_act Prod'AND_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'127 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'exclusive_OR_expression'0
        | RPAREN't => Reduce_act Prod'exclusive_OR_expression'0
        | RBRACK't => Reduce_act Prod'exclusive_OR_expression'0
        | RBRACE't => Reduce_act Prod'exclusive_OR_expression'0
        | QUESTION't => Reduce_act Prod'exclusive_OR_expression'0
        | HAT't => Reduce_act Prod'exclusive_OR_expression'0
        | COMMA't => Reduce_act Prod'exclusive_OR_expression'0
        | COLON't => Reduce_act Prod'exclusive_OR_expression'0
        | BARBAR't => Reduce_act Prod'exclusive_OR_expression'0
        | BAR't => Reduce_act Prod'exclusive_OR_expression'0
        | ANDAND't => Reduce_act Prod'exclusive_OR_expression'0
        | AND't => Shift_act Nis'125 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'128 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'inclusive_OR_expression'0
        | RPAREN't => Reduce_act Prod'inclusive_OR_expression'0
        | RBRACK't => Reduce_act Prod'inclusive_OR_expression'0
        | RBRACE't => Reduce_act Prod'inclusive_OR_expression'0
        | QUESTION't => Reduce_act Prod'inclusive_OR_expression'0
        | HAT't => Shift_act Nis'118 (eq_refl _)
        | COMMA't => Reduce_act Prod'inclusive_OR_expression'0
        | COLON't => Reduce_act Prod'inclusive_OR_expression'0
        | BARBAR't => Reduce_act Prod'inclusive_OR_expression'0
        | BAR't => Reduce_act Prod'inclusive_OR_expression'0
        | ANDAND't => Reduce_act Prod'inclusive_OR_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'129 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'logical_AND_expression'0
        | RPAREN't => Reduce_act Prod'logical_AND_expression'0
        | RBRACK't => Reduce_act Prod'logical_AND_expression'0
        | RBRACE't => Reduce_act Prod'logical_AND_expression'0
        | QUESTION't => Reduce_act Prod'logical_AND_expression'0
        | COMMA't => Reduce_act Prod'logical_AND_expression'0
        | COLON't => Reduce_act Prod'logical_AND_expression'0
        | BARBAR't => Reduce_act Prod'logical_AND_expression'0
        | BAR't => Shift_act Nis'116 (eq_refl _)
        | ANDAND't => Reduce_act Prod'logical_AND_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'130 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | COLON't => Shift_act Nis'134 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'131 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'132 => Default_reduce_act Prod'assignment_expression'0
    | Ninit Nis'133 => Default_reduce_act Prod'expression'1
    | Ninit Nis'134 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'135 => Default_reduce_act Prod'conditional_expression'1
    | Ninit Nis'136 => Default_reduce_act Prod'expression'0
    | Ninit Nis'137 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'138 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'logical_OR_expression'1
        | RPAREN't => Reduce_act Prod'logical_OR_expression'1
        | RBRACK't => Reduce_act Prod'logical_OR_expression'1
        | RBRACE't => Reduce_act Prod'logical_OR_expression'1
        | QUESTION't => Reduce_act Prod'logical_OR_expression'1
        | COMMA't => Reduce_act Prod'logical_OR_expression'1
        | COLON't => Reduce_act Prod'logical_OR_expression'1
        | BARBAR't => Reduce_act Prod'logical_OR_expression'1
        | ANDAND't => Shift_act Nis'114 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'139 => Default_reduce_act Prod'assignment_expression'1
    | Ninit Nis'140 => Default_reduce_act Prod'argument_expression_list'0
    | Ninit Nis'141 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'142 (eq_refl _)
        | COMMA't => Shift_act Nis'143 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'142 => Default_reduce_act Prod'postfix_expression'2
    | Ninit Nis'143 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'144 => Default_reduce_act Prod'argument_expression_list'1
    | Ninit Nis'145 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'146 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'147 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'147 => Default_reduce_act Prod'postfix_expression'1
    | Ninit Nis'148 => Default_reduce_act Prod'postfix_expression'7
    | Ninit Nis'149 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'150 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'150 => Default_reduce_act Prod'postfix_expression'5
    | Ninit Nis'151 => Default_reduce_act Prod'postfix_expression'8
    | Ninit Nis'152 => Default_reduce_act Prod'unary_expression'3
    | Ninit Nis'153 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'154 (eq_refl _)
        | COMMA't => Shift_act Nis'143 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'154 => Default_reduce_act Prod'gcc_attribute'3
    | Ninit Nis'155 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'156 (eq_refl _)
        | COMMA't => Shift_act Nis'158 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'156 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'157 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'157 => Default_reduce_act Prod'attribute_specifier'0
    | Ninit Nis'158 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'gcc_attribute'0
        | PACKED't => Shift_act Nis'57 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'58 (eq_refl _)
        | CONST't => Shift_act Nis'59 (eq_refl _)
        | COMMA't => Reduce_act Prod'gcc_attribute'0
        | _ => Fail_act
      end)
    | Ninit Nis'159 => Default_reduce_act Prod'gcc_attribute_list'1
    | Ninit Nis'160 => Default_reduce_act Prod'gcc_attribute_list'0
    | Ninit Nis'161 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'162 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'163 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'specifier_qualifier_list'1
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STAR't => Reduce_act Prod'specifier_qualifier_list'1
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'specifier_qualifier_list'1
        | RPAREN't => Reduce_act Prod'specifier_qualifier_list'1
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Reduce_act Prod'specifier_qualifier_list'1
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Reduce_act Prod'specifier_qualifier_list'1
        | INT't => Shift_act Nis'27 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | COLON't => Reduce_act Prod'specifier_qualifier_list'1
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'164 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'specifier_qualifier_list'3
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STAR't => Reduce_act Prod'specifier_qualifier_list'3
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'specifier_qualifier_list'3
        | RPAREN't => Reduce_act Prod'specifier_qualifier_list'3
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Reduce_act Prod'specifier_qualifier_list'3
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Reduce_act Prod'specifier_qualifier_list'3
        | INT't => Shift_act Nis'27 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | COLON't => Reduce_act Prod'specifier_qualifier_list'3
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'165 => Default_reduce_act Prod'type_specifier'10
    | Ninit Nis'166 => Default_reduce_act Prod'attribute_specifier_list'0
    | Ninit Nis'167 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'168 (eq_refl _)
        | LBRACE't => Shift_act Nis'264 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'168 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Reduce_act Prod'struct_or_union_specifier'2
        | VOID't => Reduce_act Prod'struct_or_union_specifier'2
        | VAR_NAME't => Reduce_act Prod'struct_or_union_specifier'2
        | UNSIGNED't => Reduce_act Prod'struct_or_union_specifier'2
        | UNION't => Reduce_act Prod'struct_or_union_specifier'2
        | UNDERSCORE_BOOL't => Reduce_act Prod'struct_or_union_specifier'2
        | TYPEDEF_NAME't => Reduce_act Prod'struct_or_union_specifier'2
        | TYPEDEF't => Reduce_act Prod'struct_or_union_specifier'2
        | STRUCT't => Reduce_act Prod'struct_or_union_specifier'2
        | STATIC't => Reduce_act Prod'struct_or_union_specifier'2
        | STAR't => Reduce_act Prod'struct_or_union_specifier'2
        | SIGNED't => Reduce_act Prod'struct_or_union_specifier'2
        | SHORT't => Reduce_act Prod'struct_or_union_specifier'2
        | SEMICOLON't => Reduce_act Prod'struct_or_union_specifier'2
        | RPAREN't => Reduce_act Prod'struct_or_union_specifier'2
        | RESTRICT't => Reduce_act Prod'struct_or_union_specifier'2
        | REGISTER't => Reduce_act Prod'struct_or_union_specifier'2
        | PACKED't => Reduce_act Prod'struct_or_union_specifier'2
        | LPAREN't => Reduce_act Prod'struct_or_union_specifier'2
        | LONG't => Reduce_act Prod'struct_or_union_specifier'2
        | LBRACK't => Reduce_act Prod'struct_or_union_specifier'2
        | LBRACE't => Shift_act Nis'169 (eq_refl _)
        | INT't => Reduce_act Prod'struct_or_union_specifier'2
        | INLINE't => Reduce_act Prod'struct_or_union_specifier'2
        | FLOAT't => Reduce_act Prod'struct_or_union_specifier'2
        | EXTERN't => Reduce_act Prod'struct_or_union_specifier'2
        | ENUM't => Reduce_act Prod'struct_or_union_specifier'2
        | DOUBLE't => Reduce_act Prod'struct_or_union_specifier'2
        | CONST't => Reduce_act Prod'struct_or_union_specifier'2
        | COMMA't => Reduce_act Prod'struct_or_union_specifier'2
        | COLON't => Reduce_act Prod'struct_or_union_specifier'2
        | CHAR't => Reduce_act Prod'struct_or_union_specifier'2
        | AUTO't => Reduce_act Prod'struct_or_union_specifier'2
        | ATTRIBUTE't => Reduce_act Prod'struct_or_union_specifier'2
        | ALIGNAS't => Reduce_act Prod'struct_or_union_specifier'2
        | _ => Fail_act
      end)
    | Ninit Nis'169 => Default_reduce_act Prod'struct_declaration_list'0
    | Ninit Nis'170 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | RBRACE't => Shift_act Nis'171 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'171 => Default_reduce_act Prod'struct_or_union_specifier'0
    | Ninit Nis'172 => Default_reduce_act Prod'struct_declaration_list'1
    | Ninit Nis'173 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'182 (eq_refl _)
        | LPAREN't => Shift_act Nis'183 (eq_refl _)
        | COLON't => Shift_act Nis'253 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'174 => Default_reduce_act Prod'direct_declarator'0
    | Ninit Nis'175 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'pointer'0
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | RPAREN't => Reduce_act Prod'pointer'0
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Reduce_act Prod'pointer'0
        | LBRACK't => Reduce_act Prod'pointer'0
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | COMMA't => Reduce_act Prod'pointer'0
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'176 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'pointer'1
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | RPAREN't => Reduce_act Prod'pointer'1
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Reduce_act Prod'pointer'1
        | LBRACK't => Reduce_act Prod'pointer'1
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | COMMA't => Reduce_act Prod'pointer'1
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'177 => Default_reduce_act Prod'type_qualifier_list'1
    | Ninit Nis'178 => Default_reduce_act Prod'pointer'3
    | Ninit Nis'179 => Default_reduce_act Prod'type_qualifier'3
    | Ninit Nis'180 => Default_reduce_act Prod'type_qualifier_list'0
    | Ninit Nis'181 => Default_reduce_act Prod'pointer'2
    | Ninit Nis'182 => Default_reduce_act Prod'struct_declaration'1
    | Ninit Nis'183 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | LPAREN't => Shift_act Nis'183 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'184 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | LPAREN't => Shift_act Nis'183 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'185 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'attribute_specifier_list'0
        | RPAREN't => Reduce_act Prod'attribute_specifier_list'0
        | PACKED't => Reduce_act Prod'attribute_specifier_list'0
        | LPAREN't => Shift_act Nis'186 (eq_refl _)
        | LBRACK't => Shift_act Nis'235 (eq_refl _)
        | EQ't => Reduce_act Prod'attribute_specifier_list'0
        | COMMA't => Reduce_act Prod'attribute_specifier_list'0
        | COLON't => Reduce_act Prod'attribute_specifier_list'0
        | ATTRIBUTE't => Reduce_act Prod'attribute_specifier_list'0
        | ALIGNAS't => Reduce_act Prod'attribute_specifier_list'0
        | _ => Fail_act
      end)
    | Ninit Nis'186 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'187 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'187 => Default_reduce_act Prod'direct_declarator'7
    | Ninit Nis'188 => Default_reduce_act Prod'function_specifier'0
    | Ninit Nis'189 => Default_reduce_act Prod'storage_class_specifier'1
    | Ninit Nis'190 => Default_reduce_act Prod'storage_class_specifier'3
    | Ninit Nis'191 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'declaration_specifiers'3
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Reduce_act Prod'declaration_specifiers'3
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'declaration_specifiers'3
        | RPAREN't => Reduce_act Prod'declaration_specifiers'3
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Reduce_act Prod'declaration_specifiers'3
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Reduce_act Prod'declaration_specifiers'3
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | COMMA't => Reduce_act Prod'declaration_specifiers'3
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'192 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'declaration_specifiers'5
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Reduce_act Prod'declaration_specifiers'5
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'declaration_specifiers'5
        | RPAREN't => Reduce_act Prod'declaration_specifiers'5
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Reduce_act Prod'declaration_specifiers'5
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Reduce_act Prod'declaration_specifiers'5
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | COMMA't => Reduce_act Prod'declaration_specifiers'5
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'193 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'declaration_specifiers'1
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Reduce_act Prod'declaration_specifiers'1
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'declaration_specifiers'1
        | RPAREN't => Reduce_act Prod'declaration_specifiers'1
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Reduce_act Prod'declaration_specifiers'1
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Reduce_act Prod'declaration_specifiers'1
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | COMMA't => Reduce_act Prod'declaration_specifiers'1
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'194 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'declaration_specifiers'7
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Reduce_act Prod'declaration_specifiers'7
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'declaration_specifiers'7
        | RPAREN't => Reduce_act Prod'declaration_specifiers'7
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Reduce_act Prod'declaration_specifiers'7
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Reduce_act Prod'declaration_specifiers'7
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | COMMA't => Reduce_act Prod'declaration_specifiers'7
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'195 => Default_reduce_act Prod'type_specifier'11
    | Ninit Nis'196 => Default_reduce_act Prod'declaration_specifiers'6
    | Ninit Nis'197 => Default_reduce_act Prod'declaration_specifiers'0
    | Ninit Nis'198 => Default_reduce_act Prod'declaration_specifiers'4
    | Ninit Nis'199 => Default_reduce_act Prod'declaration_specifiers'2
    | Ninit Nis'200 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'201 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'201 => Default_reduce_act Prod'direct_declarator'6
    | Ninit Nis'202 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'parameter_type_list'0
        | COMMA't => Shift_act Nis'203 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'203 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | ELLIPSIS't => Shift_act Nis'204 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'204 => Default_reduce_act Prod'parameter_type_list'1
    | Ninit Nis'205 => Default_reduce_act Prod'parameter_list'1
    | Ninit Nis'206 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | RPAREN't => Reduce_act Prod'parameter_declaration'2
        | LPAREN't => Shift_act Nis'207 (eq_refl _)
        | LBRACK't => Shift_act Nis'209 (eq_refl _)
        | COMMA't => Reduce_act Prod'parameter_declaration'2
        | _ => Fail_act
      end)
    | Ninit Nis'207 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'208 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Shift_act Nis'207 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Shift_act Nis'209 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'208 => Default_reduce_act Prod'direct_abstract_declarator'12
    | Ninit Nis'209 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | RBRACK't => Shift_act Nis'210 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'210 => Default_reduce_act Prod'direct_abstract_declarator'8
    | Ninit Nis'211 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | RBRACK't => Shift_act Nis'212 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'212 => Default_reduce_act Prod'direct_abstract_declarator'6
    | Ninit Nis'213 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'214 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'214 => Default_reduce_act Prod'direct_abstract_declarator'2
    | Ninit Nis'215 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'216 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'216 => Default_reduce_act Prod'direct_abstract_declarator'4
    | Ninit Nis'217 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | RPAREN't => Reduce_act Prod'abstract_declarator'0
        | LPAREN't => Shift_act Nis'207 (eq_refl _)
        | LBRACK't => Shift_act Nis'209 (eq_refl _)
        | COMMA't => Reduce_act Prod'abstract_declarator'0
        | _ => Fail_act
      end)
    | Ninit Nis'218 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'abstract_declarator'1
        | LPAREN't => Shift_act Nis'219 (eq_refl _)
        | LBRACK't => Shift_act Nis'224 (eq_refl _)
        | COMMA't => Reduce_act Prod'abstract_declarator'1
        | _ => Fail_act
      end)
    | Ninit Nis'219 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'220 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'220 => Default_reduce_act Prod'direct_abstract_declarator'11
    | Ninit Nis'221 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'222 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'222 => Default_reduce_act Prod'direct_abstract_declarator'9
    | Ninit Nis'223 => Default_reduce_act Prod'parameter_list'0
    | Ninit Nis'224 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | RBRACK't => Shift_act Nis'225 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'225 => Default_reduce_act Prod'direct_abstract_declarator'7
    | Ninit Nis'226 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | RBRACK't => Shift_act Nis'227 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'227 => Default_reduce_act Prod'direct_abstract_declarator'5
    | Ninit Nis'228 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'229 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'229 => Default_reduce_act Prod'direct_abstract_declarator'1
    | Ninit Nis'230 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'231 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'231 => Default_reduce_act Prod'direct_abstract_declarator'3
    | Ninit Nis'232 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'233 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'233 => Default_reduce_act Prod'direct_abstract_declarator'10
    | Ninit Nis'234 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'attribute_specifier_list'0
        | RPAREN't => Reduce_act Prod'attribute_specifier_list'0
        | PACKED't => Reduce_act Prod'attribute_specifier_list'0
        | LPAREN't => Shift_act Nis'186 (eq_refl _)
        | LBRACK't => Shift_act Nis'235 (eq_refl _)
        | EQ't => Reduce_act Prod'attribute_specifier_list'0
        | COMMA't => Reduce_act Prod'attribute_specifier_list'0
        | COLON't => Reduce_act Prod'attribute_specifier_list'0
        | ATTRIBUTE't => Reduce_act Prod'attribute_specifier_list'0
        | ALIGNAS't => Reduce_act Prod'attribute_specifier_list'0
        | _ => Fail_act
      end)
    | Ninit Nis'235 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | RBRACK't => Shift_act Nis'236 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'236 => Default_reduce_act Prod'direct_declarator'5
    | Ninit Nis'237 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | RBRACK't => Shift_act Nis'238 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'238 => Default_reduce_act Prod'direct_declarator'4
    | Ninit Nis'239 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'240 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'240 => Default_reduce_act Prod'direct_declarator'2
    | Ninit Nis'241 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'242 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'242 => Default_reduce_act Prod'direct_declarator'3
    | Ninit Nis'243 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'declarator'0
        | RPAREN't => Reduce_act Prod'declarator'0
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LBRACE't => Reduce_act Prod'declarator'0
        | EQ't => Reduce_act Prod'declarator'0
        | COMMA't => Reduce_act Prod'declarator'0
        | COLON't => Reduce_act Prod'declarator'0
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'244 => Default_reduce_act Prod'attribute_specifier_list'1
    | Ninit Nis'245 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'abstract_declarator'2
        | LPAREN't => Shift_act Nis'219 (eq_refl _)
        | LBRACK't => Shift_act Nis'224 (eq_refl _)
        | COMMA't => Reduce_act Prod'abstract_declarator'2
        | _ => Fail_act
      end)
    | Ninit Nis'246 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'247 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'247 => Default_reduce_act Prod'direct_declarator'1
    | Ninit Nis'248 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'249 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'249 => Default_reduce_act Prod'direct_abstract_declarator'0
    | Ninit Nis'250 => Default_reduce_act Prod'parameter_declaration'0
    | Ninit Nis'251 => Default_reduce_act Prod'parameter_declaration'1
    | Ninit Nis'252 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'declarator'1
        | RPAREN't => Reduce_act Prod'declarator'1
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LBRACE't => Reduce_act Prod'declarator'1
        | EQ't => Reduce_act Prod'declarator'1
        | COMMA't => Reduce_act Prod'declarator'1
        | COLON't => Reduce_act Prod'declarator'1
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'253 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'254 => Default_reduce_act Prod'struct_declarator'2
    | Ninit Nis'255 => Default_reduce_act Prod'constant_expression'0
    | Ninit Nis'256 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'257 (eq_refl _)
        | COMMA't => Shift_act Nis'258 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'257 => Default_reduce_act Prod'struct_declaration'0
    | Ninit Nis'258 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | LPAREN't => Shift_act Nis'183 (eq_refl _)
        | COLON't => Shift_act Nis'253 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'259 => Default_reduce_act Prod'struct_declarator_list'1
    | Ninit Nis'260 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'struct_declarator'0
        | COMMA't => Reduce_act Prod'struct_declarator'0
        | COLON't => Shift_act Nis'261 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'261 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'262 => Default_reduce_act Prod'struct_declarator'1
    | Ninit Nis'263 => Default_reduce_act Prod'struct_declarator_list'0
    | Ninit Nis'264 => Default_reduce_act Prod'struct_declaration_list'0
    | Ninit Nis'265 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | RBRACE't => Shift_act Nis'266 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'266 => Default_reduce_act Prod'struct_or_union_specifier'1
    | Ninit Nis'267 => Default_reduce_act Prod'specifier_qualifier_list'2
    | Ninit Nis'268 => Default_reduce_act Prod'specifier_qualifier_list'0
    | Ninit Nis'269 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'270 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'270 => Default_reduce_act Prod'attribute_specifier'3
    | Ninit Nis'271 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | RPAREN't => Reduce_act Prod'type_name'0
        | LPAREN't => Shift_act Nis'272 (eq_refl _)
        | LBRACK't => Shift_act Nis'209 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'272 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'208 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LPAREN't => Shift_act Nis'272 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Shift_act Nis'209 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'273 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'abstract_declarator'0
        | LPAREN't => Shift_act Nis'272 (eq_refl _)
        | LBRACK't => Shift_act Nis'209 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'274 => Default_reduce_act Prod'type_name'1
    | Ninit Nis'275 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'276 (eq_refl _)
        | COMMA't => Shift_act Nis'143 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'276 => Default_reduce_act Prod'attribute_specifier'2
    | Ninit Nis'277 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'278 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'278 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | XOR_ASSIGN't => Reduce_act Prod'unary_expression'7
        | SUB_ASSIGN't => Reduce_act Prod'unary_expression'7
        | STAR't => Reduce_act Prod'unary_expression'7
        | SLASH't => Reduce_act Prod'unary_expression'7
        | SEMICOLON't => Reduce_act Prod'unary_expression'7
        | RPAREN't => Reduce_act Prod'unary_expression'7
        | RIGHT_ASSIGN't => Reduce_act Prod'unary_expression'7
        | RIGHT't => Reduce_act Prod'unary_expression'7
        | RBRACK't => Reduce_act Prod'unary_expression'7
        | RBRACE't => Reduce_act Prod'unary_expression'7
        | QUESTION't => Reduce_act Prod'unary_expression'7
        | PLUS't => Reduce_act Prod'unary_expression'7
        | PERCENT't => Reduce_act Prod'unary_expression'7
        | OR_ASSIGN't => Reduce_act Prod'unary_expression'7
        | NEQ't => Reduce_act Prod'unary_expression'7
        | MUL_ASSIGN't => Reduce_act Prod'unary_expression'7
        | MOD_ASSIGN't => Reduce_act Prod'unary_expression'7
        | MINUS't => Reduce_act Prod'unary_expression'7
        | LT't => Reduce_act Prod'unary_expression'7
        | LEQ't => Reduce_act Prod'unary_expression'7
        | LEFT_ASSIGN't => Reduce_act Prod'unary_expression'7
        | LEFT't => Reduce_act Prod'unary_expression'7
        | LBRACE't => Shift_act Nis'279 (eq_refl _)
        | HAT't => Reduce_act Prod'unary_expression'7
        | GT't => Reduce_act Prod'unary_expression'7
        | GEQ't => Reduce_act Prod'unary_expression'7
        | EQEQ't => Reduce_act Prod'unary_expression'7
        | EQ't => Reduce_act Prod'unary_expression'7
        | DIV_ASSIGN't => Reduce_act Prod'unary_expression'7
        | COMMA't => Reduce_act Prod'unary_expression'7
        | COLON't => Reduce_act Prod'unary_expression'7
        | BARBAR't => Reduce_act Prod'unary_expression'7
        | BAR't => Reduce_act Prod'unary_expression'7
        | AND_ASSIGN't => Reduce_act Prod'unary_expression'7
        | ANDAND't => Reduce_act Prod'unary_expression'7
        | AND't => Reduce_act Prod'unary_expression'7
        | ADD_ASSIGN't => Reduce_act Prod'unary_expression'7
        | _ => Fail_act
      end)
    | Ninit Nis'279 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACK't => Shift_act Nis'280 (eq_refl _)
        | LBRACE't => Shift_act Nis'283 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DOT't => Shift_act Nis'284 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'280 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'281 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'282 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'282 => Default_reduce_act Prod'designator'0
    | Ninit Nis'283 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACK't => Shift_act Nis'280 (eq_refl _)
        | LBRACE't => Shift_act Nis'283 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DOT't => Shift_act Nis'284 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'284 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'285 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'285 => Default_reduce_act Prod'designator'1
    | Ninit Nis'286 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Shift_act Nis'287 (eq_refl _)
        | COMMA't => Shift_act Nis'288 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'287 => Default_reduce_act Prod'c_initializer'1
    | Ninit Nis'288 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RBRACE't => Shift_act Nis'289 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACK't => Shift_act Nis'280 (eq_refl _)
        | LBRACE't => Shift_act Nis'283 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DOT't => Shift_act Nis'284 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'289 => Default_reduce_act Prod'c_initializer'2
    | Ninit Nis'290 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LBRACK't => Shift_act Nis'280 (eq_refl _)
        | EQ't => Shift_act Nis'291 (eq_refl _)
        | DOT't => Shift_act Nis'284 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'291 => Default_reduce_act Prod'designation'0
    | Ninit Nis'292 => Default_reduce_act Prod'designator_list'1
    | Ninit Nis'293 => Default_reduce_act Prod'designator_list'0
    | Ninit Nis'294 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'283 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'295 => Default_reduce_act Prod'initializer_list'2
    | Ninit Nis'296 => Default_reduce_act Prod'c_initializer'0
    | Ninit Nis'297 => Default_reduce_act Prod'initializer_list'3
    | Ninit Nis'298 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'283 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'299 => Default_reduce_act Prod'initializer_list'0
    | Ninit Nis'300 => Default_reduce_act Prod'initializer_list'1
    | Ninit Nis'301 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Shift_act Nis'302 (eq_refl _)
        | COMMA't => Shift_act Nis'303 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'302 => Default_reduce_act Prod'postfix_expression'9
    | Ninit Nis'303 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RBRACE't => Shift_act Nis'304 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACK't => Shift_act Nis'280 (eq_refl _)
        | LBRACE't => Shift_act Nis'283 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DOT't => Shift_act Nis'284 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'304 => Default_reduce_act Prod'postfix_expression'10
    | Ninit Nis'305 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'306 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'306 => Default_reduce_act Prod'primary_expression'3
    | Ninit Nis'307 => Default_reduce_act Prod'unary_expression'6
    | Ninit Nis'308 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COMMA't => Shift_act Nis'309 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'309 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'310 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'311 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'311 => Default_reduce_act Prod'postfix_expression'4
    | Ninit Nis'312 => Default_reduce_act Prod'unary_expression'2
    | Ninit Nis'313 => Default_reduce_act Prod'enumerator'1
    | Ninit Nis'314 => Default_reduce_act Prod'enumerator_list'0
    | Ninit Nis'315 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'35 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'316 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Shift_act Nis'317 (eq_refl _)
        | COMMA't => Shift_act Nis'318 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'317 => Default_reduce_act Prod'enum_specifier'1
    | Ninit Nis'318 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'35 (eq_refl _)
        | RBRACE't => Shift_act Nis'319 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'319 => Default_reduce_act Prod'enum_specifier'3
    | Ninit Nis'320 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'321 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'321 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LBRACE't => Shift_act Nis'279 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'322 => Default_reduce_act Prod'unary_expression'1
    | Ninit Nis'323 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'324 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'324 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'279 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'325 => Default_reduce_act Prod'cast_expression'1
    | Ninit Nis'326 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'327 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'327 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | XOR_ASSIGN't => Reduce_act Prod'unary_expression'5
        | SUB_ASSIGN't => Reduce_act Prod'unary_expression'5
        | STAR't => Reduce_act Prod'unary_expression'5
        | SLASH't => Reduce_act Prod'unary_expression'5
        | SEMICOLON't => Reduce_act Prod'unary_expression'5
        | RPAREN't => Reduce_act Prod'unary_expression'5
        | RIGHT_ASSIGN't => Reduce_act Prod'unary_expression'5
        | RIGHT't => Reduce_act Prod'unary_expression'5
        | RBRACK't => Reduce_act Prod'unary_expression'5
        | RBRACE't => Reduce_act Prod'unary_expression'5
        | QUESTION't => Reduce_act Prod'unary_expression'5
        | PLUS't => Reduce_act Prod'unary_expression'5
        | PERCENT't => Reduce_act Prod'unary_expression'5
        | OR_ASSIGN't => Reduce_act Prod'unary_expression'5
        | NEQ't => Reduce_act Prod'unary_expression'5
        | MUL_ASSIGN't => Reduce_act Prod'unary_expression'5
        | MOD_ASSIGN't => Reduce_act Prod'unary_expression'5
        | MINUS't => Reduce_act Prod'unary_expression'5
        | LT't => Reduce_act Prod'unary_expression'5
        | LEQ't => Reduce_act Prod'unary_expression'5
        | LEFT_ASSIGN't => Reduce_act Prod'unary_expression'5
        | LEFT't => Reduce_act Prod'unary_expression'5
        | LBRACE't => Shift_act Nis'279 (eq_refl _)
        | HAT't => Reduce_act Prod'unary_expression'5
        | GT't => Reduce_act Prod'unary_expression'5
        | GEQ't => Reduce_act Prod'unary_expression'5
        | EQEQ't => Reduce_act Prod'unary_expression'5
        | EQ't => Reduce_act Prod'unary_expression'5
        | DIV_ASSIGN't => Reduce_act Prod'unary_expression'5
        | COMMA't => Reduce_act Prod'unary_expression'5
        | COLON't => Reduce_act Prod'unary_expression'5
        | BARBAR't => Reduce_act Prod'unary_expression'5
        | BAR't => Reduce_act Prod'unary_expression'5
        | AND_ASSIGN't => Reduce_act Prod'unary_expression'5
        | ANDAND't => Reduce_act Prod'unary_expression'5
        | AND't => Reduce_act Prod'unary_expression'5
        | ADD_ASSIGN't => Reduce_act Prod'unary_expression'5
        | _ => Fail_act
      end)
    | Ninit Nis'328 => Default_reduce_act Prod'unary_expression'4
    | Ninit Nis'329 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'330 (eq_refl _)
        | COMMA't => Shift_act Nis'143 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'330 => Default_reduce_act Prod'attribute_specifier'1
    | Ninit Nis'331 => Default_reduce_act Prod'translation_unit_file'1
    | Ninit Nis'333 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PRAGMA't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | EOF't => Shift_act Nis'334 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'334 => Default_reduce_act Prod'translation_unit_file'0
    | Ninit Nis'335 => Default_reduce_act Prod'external_declaration'0
    | Ninit Nis'336 => Default_reduce_act Prod'translation_unit'1
    | Ninit Nis'337 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'338 (eq_refl _)
        | LPAREN't => Shift_act Nis'183 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'338 => Default_reduce_act Prod'declaration'1
    | Ninit Nis'339 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | LPAREN't => Shift_act Nis'183 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'340 => Default_reduce_act Prod'old_function_declarator'1
    | Ninit Nis'341 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'attribute_specifier_list'0
        | PACKED't => Reduce_act Prod'attribute_specifier_list'0
        | LPAREN't => Shift_act Nis'342 (eq_refl _)
        | LBRACK't => Shift_act Nis'235 (eq_refl _)
        | LBRACE't => Reduce_act Prod'attribute_specifier_list'0
        | EQ't => Reduce_act Prod'attribute_specifier_list'0
        | COMMA't => Reduce_act Prod'attribute_specifier_list'0
        | ATTRIBUTE't => Reduce_act Prod'attribute_specifier_list'0
        | ALIGNAS't => Reduce_act Prod'attribute_specifier_list'0
        | _ => Fail_act
      end)
    | Ninit Nis'342 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'343 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'187 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'343 => Default_reduce_act Prod'identifier_list'0
    | Ninit Nis'344 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'345 (eq_refl _)
        | COMMA't => Shift_act Nis'346 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'345 => Default_reduce_act Prod'direct_old_function_declarator'0
    | Ninit Nis'346 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'347 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'347 => Default_reduce_act Prod'identifier_list'1
    | Ninit Nis'348 => Default_reduce_act Prod'declaration_list'0
    | Ninit Nis'349 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'350 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | RBRACE't => Shift_act Nis'552 (eq_refl _)
        | PRAGMA't => Shift_act Nis'553 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'351 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'352 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'352 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'353 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'354 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'354 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'355 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'356 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'356 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'357 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'358 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'358 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'359 => Default_reduce_act Prod'expression_statement'1
    | Ninit Nis'360 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'361 => Default_reduce_act Prod'jump_statement'4
    | Ninit Nis'362 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'363 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'363 => Default_reduce_act Prod'jump_statement'3
    | Ninit Nis'364 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'365 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'365 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'366 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'367 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'367 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'368 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'369 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'369 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'370 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'371 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'371 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'372 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'373 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'373 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'374 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'375 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'375 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'376 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'377 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'377 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'378 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'379 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'379 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'380 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'381 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'381 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'382 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'383 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'383 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'384 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'385 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'385 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'386 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'386 => Default_reduce_act Prod'jump_statement'0
    | Ninit Nis'387 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'388 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'388 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'389 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'389 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'390 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'390 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'391 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'391 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'392 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'393 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'394 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'394 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'395 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'395 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'396 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'396 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'397 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'397 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'398 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'399 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'400 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'400 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'401 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'402 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'402 => Default_reduce_act Prod'jump_statement'1
    | Ninit Nis'403 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'404 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'405 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'405 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'406 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'407 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'407 => Default_reduce_act Prod'jump_statement'2
    | Ninit Nis'408 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'409 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'409 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STRING_LITERAL't => Shift_act Nis'410 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'410 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'411 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'411 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'412 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'412 => Default_reduce_act Prod'asm_statement'0
    | Ninit Nis'413 => Default_reduce_act Prod'labeled_statement_statement_dangerous_'1
    | Ninit Nis'414 => Default_reduce_act Prod'statement_dangerous'3
    | Ninit Nis'415 => Default_reduce_act Prod'statement_dangerous'0
    | Ninit Nis'416 => Default_reduce_act Prod'statement_dangerous'5
    | Ninit Nis'417 => Default_reduce_act Prod'statement_dangerous'4
    | Ninit Nis'418 => Default_reduce_act Prod'statement_dangerous'2
    | Ninit Nis'419 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'420 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'420 => Default_reduce_act Prod'expression_statement'0
    | Ninit Nis'421 => Default_reduce_act Prod'statement_dangerous'1
    | Ninit Nis'422 => Default_reduce_act Prod'statement_dangerous'6
    | Ninit Nis'423 => Default_reduce_act Prod'labeled_statement_statement_dangerous_'2
    | Ninit Nis'424 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'425 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'425 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'426 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'426 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'427 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'428 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'428 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'429 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'429 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'1
    | Ninit Nis'430 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'13
    | Ninit Nis'431 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'432 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'432 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'433 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'7
    | Ninit Nis'434 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'435 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'435 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'436 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'436 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'437 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'10
    | Ninit Nis'438 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'439 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'439 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'440 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'4
    | Ninit Nis'441 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'442 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'442 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'443 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'443 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'444 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'444 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'445 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'11
    | Ninit Nis'446 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'447 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'447 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'448 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'5
    | Ninit Nis'449 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'450 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'450 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'451 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'451 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'452 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'8
    | Ninit Nis'453 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'454 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'454 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'455 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'2
    | Ninit Nis'456 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'338 (eq_refl _)
        | LPAREN't => Shift_act Nis'183 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'457 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'458 (eq_refl _)
        | COMMA't => Shift_act Nis'459 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'458 => Default_reduce_act Prod'declaration'0
    | Ninit Nis'459 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'174 (eq_refl _)
        | STAR't => Shift_act Nis'175 (eq_refl _)
        | LPAREN't => Shift_act Nis'183 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'460 => Default_reduce_act Prod'init_declarator_list'1
    | Ninit Nis'461 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'init_declarator'0
        | EQ't => Shift_act Nis'462 (eq_refl _)
        | COMMA't => Reduce_act Prod'init_declarator'0
        | _ => Fail_act
      end)
    | Ninit Nis'462 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'283 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'463 => Default_reduce_act Prod'init_declarator'1
    | Ninit Nis'464 => Default_reduce_act Prod'init_declarator_list'0
    | Ninit Nis'465 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'466 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'466 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'467 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'467 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'468 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'12
    | Ninit Nis'469 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'470 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'470 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'471 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'6
    | Ninit Nis'472 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'473 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'473 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'474 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'474 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'475 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'9
    | Ninit Nis'476 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'477 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'477 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'478 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'3
    | Ninit Nis'479 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'480 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'480 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'481 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'481 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'482 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'483 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'483 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'484 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'484 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | VOLATILE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | VOID't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | VAR_NAME't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | UNSIGNED't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | UNION't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | UNDERSCORE_BOOL't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | TYPEDEF_NAME't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | TYPEDEF't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | TILDE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SWITCH't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | STRUCT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | STRING_LITERAL't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | STATIC't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | STAR't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SIZEOF't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SIGNED't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SHORT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SEMICOLON't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | RETURN't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | RESTRICT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | REGISTER't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | RBRACE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | PRAGMA't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | PLUS't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | PACKED't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | OTHER_NAME't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | MINUS't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | LPAREN't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | LONG't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | LBRACE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | INT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | INLINE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | INC't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | IF't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | GOTO't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | FOR't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | FLOAT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | EXTERN't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ENUM't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ELSE't => Reduce_act Prod'iteration_statement_statement_safe_'1
        | DOUBLE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | DO't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | DEFAULT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | DEC't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CONTINUE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CONSTANT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CONST't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CHAR't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CASE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | BUILTIN_VA_ARG't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | BREAK't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | BANG't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | AUTO't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ATTRIBUTE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ASM't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | AND't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ALIGNOF't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ALIGNAS't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | _ => Fail_act
      end)
    | Ninit Nis'485 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'486 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'486 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'487 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'488 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'489 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'489 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'490 => Default_reduce_act Prod'labeled_statement_statement_safe_'1
    | Ninit Nis'491 => Default_reduce_act Prod'statement_safe'3
    | Ninit Nis'492 => Default_reduce_act Prod'statement_safe'0
    | Ninit Nis'493 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'statement_dangerous'5
        | VOLATILE't => Reduce_act Prod'statement_dangerous'5
        | VOID't => Reduce_act Prod'statement_dangerous'5
        | VAR_NAME't => Reduce_act Prod'statement_dangerous'5
        | UNSIGNED't => Reduce_act Prod'statement_dangerous'5
        | UNION't => Reduce_act Prod'statement_dangerous'5
        | UNDERSCORE_BOOL't => Reduce_act Prod'statement_dangerous'5
        | TYPEDEF_NAME't => Reduce_act Prod'statement_dangerous'5
        | TYPEDEF't => Reduce_act Prod'statement_dangerous'5
        | TILDE't => Reduce_act Prod'statement_dangerous'5
        | SWITCH't => Reduce_act Prod'statement_dangerous'5
        | STRUCT't => Reduce_act Prod'statement_dangerous'5
        | STRING_LITERAL't => Reduce_act Prod'statement_dangerous'5
        | STATIC't => Reduce_act Prod'statement_dangerous'5
        | STAR't => Reduce_act Prod'statement_dangerous'5
        | SIZEOF't => Reduce_act Prod'statement_dangerous'5
        | SIGNED't => Reduce_act Prod'statement_dangerous'5
        | SHORT't => Reduce_act Prod'statement_dangerous'5
        | SEMICOLON't => Reduce_act Prod'statement_dangerous'5
        | RETURN't => Reduce_act Prod'statement_dangerous'5
        | RESTRICT't => Reduce_act Prod'statement_dangerous'5
        | REGISTER't => Reduce_act Prod'statement_dangerous'5
        | RBRACE't => Reduce_act Prod'statement_dangerous'5
        | PRAGMA't => Reduce_act Prod'statement_dangerous'5
        | PLUS't => Reduce_act Prod'statement_dangerous'5
        | PACKED't => Reduce_act Prod'statement_dangerous'5
        | OTHER_NAME't => Reduce_act Prod'statement_dangerous'5
        | MINUS't => Reduce_act Prod'statement_dangerous'5
        | LPAREN't => Reduce_act Prod'statement_dangerous'5
        | LONG't => Reduce_act Prod'statement_dangerous'5
        | LBRACE't => Reduce_act Prod'statement_dangerous'5
        | INT't => Reduce_act Prod'statement_dangerous'5
        | INLINE't => Reduce_act Prod'statement_dangerous'5
        | INC't => Reduce_act Prod'statement_dangerous'5
        | IF't => Reduce_act Prod'statement_dangerous'5
        | GOTO't => Reduce_act Prod'statement_dangerous'5
        | FOR't => Reduce_act Prod'statement_dangerous'5
        | FLOAT't => Reduce_act Prod'statement_dangerous'5
        | EXTERN't => Reduce_act Prod'statement_dangerous'5
        | ENUM't => Reduce_act Prod'statement_dangerous'5
        | ELSE't => Reduce_act Prod'statement_safe'5
        | DOUBLE't => Reduce_act Prod'statement_dangerous'5
        | DO't => Reduce_act Prod'statement_dangerous'5
        | DEFAULT't => Reduce_act Prod'statement_dangerous'5
        | DEC't => Reduce_act Prod'statement_dangerous'5
        | CONTINUE't => Reduce_act Prod'statement_dangerous'5
        | CONSTANT't => Reduce_act Prod'statement_dangerous'5
        | CONST't => Reduce_act Prod'statement_dangerous'5
        | CHAR't => Reduce_act Prod'statement_dangerous'5
        | CASE't => Reduce_act Prod'statement_dangerous'5
        | BUILTIN_VA_ARG't => Reduce_act Prod'statement_dangerous'5
        | BREAK't => Reduce_act Prod'statement_dangerous'5
        | BANG't => Reduce_act Prod'statement_dangerous'5
        | AUTO't => Reduce_act Prod'statement_dangerous'5
        | ATTRIBUTE't => Reduce_act Prod'statement_dangerous'5
        | ASM't => Reduce_act Prod'statement_dangerous'5
        | AND't => Reduce_act Prod'statement_dangerous'5
        | ALIGNOF't => Reduce_act Prod'statement_dangerous'5
        | ALIGNAS't => Reduce_act Prod'statement_dangerous'5
        | _ => Fail_act
      end)
    | Ninit Nis'494 => Default_reduce_act Prod'statement_safe'4
    | Ninit Nis'495 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'statement_dangerous'2
        | VOLATILE't => Reduce_act Prod'statement_dangerous'2
        | VOID't => Reduce_act Prod'statement_dangerous'2
        | VAR_NAME't => Reduce_act Prod'statement_dangerous'2
        | UNSIGNED't => Reduce_act Prod'statement_dangerous'2
        | UNION't => Reduce_act Prod'statement_dangerous'2
        | UNDERSCORE_BOOL't => Reduce_act Prod'statement_dangerous'2
        | TYPEDEF_NAME't => Reduce_act Prod'statement_dangerous'2
        | TYPEDEF't => Reduce_act Prod'statement_dangerous'2
        | TILDE't => Reduce_act Prod'statement_dangerous'2
        | SWITCH't => Reduce_act Prod'statement_dangerous'2
        | STRUCT't => Reduce_act Prod'statement_dangerous'2
        | STRING_LITERAL't => Reduce_act Prod'statement_dangerous'2
        | STATIC't => Reduce_act Prod'statement_dangerous'2
        | STAR't => Reduce_act Prod'statement_dangerous'2
        | SIZEOF't => Reduce_act Prod'statement_dangerous'2
        | SIGNED't => Reduce_act Prod'statement_dangerous'2
        | SHORT't => Reduce_act Prod'statement_dangerous'2
        | SEMICOLON't => Reduce_act Prod'statement_dangerous'2
        | RETURN't => Reduce_act Prod'statement_dangerous'2
        | RESTRICT't => Reduce_act Prod'statement_dangerous'2
        | REGISTER't => Reduce_act Prod'statement_dangerous'2
        | RBRACE't => Reduce_act Prod'statement_dangerous'2
        | PRAGMA't => Reduce_act Prod'statement_dangerous'2
        | PLUS't => Reduce_act Prod'statement_dangerous'2
        | PACKED't => Reduce_act Prod'statement_dangerous'2
        | OTHER_NAME't => Reduce_act Prod'statement_dangerous'2
        | MINUS't => Reduce_act Prod'statement_dangerous'2
        | LPAREN't => Reduce_act Prod'statement_dangerous'2
        | LONG't => Reduce_act Prod'statement_dangerous'2
        | LBRACE't => Reduce_act Prod'statement_dangerous'2
        | INT't => Reduce_act Prod'statement_dangerous'2
        | INLINE't => Reduce_act Prod'statement_dangerous'2
        | INC't => Reduce_act Prod'statement_dangerous'2
        | IF't => Reduce_act Prod'statement_dangerous'2
        | GOTO't => Reduce_act Prod'statement_dangerous'2
        | FOR't => Reduce_act Prod'statement_dangerous'2
        | FLOAT't => Reduce_act Prod'statement_dangerous'2
        | EXTERN't => Reduce_act Prod'statement_dangerous'2
        | ENUM't => Reduce_act Prod'statement_dangerous'2
        | ELSE't => Reduce_act Prod'statement_safe'2
        | DOUBLE't => Reduce_act Prod'statement_dangerous'2
        | DO't => Reduce_act Prod'statement_dangerous'2
        | DEFAULT't => Reduce_act Prod'statement_dangerous'2
        | DEC't => Reduce_act Prod'statement_dangerous'2
        | CONTINUE't => Reduce_act Prod'statement_dangerous'2
        | CONSTANT't => Reduce_act Prod'statement_dangerous'2
        | CONST't => Reduce_act Prod'statement_dangerous'2
        | CHAR't => Reduce_act Prod'statement_dangerous'2
        | CASE't => Reduce_act Prod'statement_dangerous'2
        | BUILTIN_VA_ARG't => Reduce_act Prod'statement_dangerous'2
        | BREAK't => Reduce_act Prod'statement_dangerous'2
        | BANG't => Reduce_act Prod'statement_dangerous'2
        | AUTO't => Reduce_act Prod'statement_dangerous'2
        | ATTRIBUTE't => Reduce_act Prod'statement_dangerous'2
        | ASM't => Reduce_act Prod'statement_dangerous'2
        | AND't => Reduce_act Prod'statement_dangerous'2
        | ALIGNOF't => Reduce_act Prod'statement_dangerous'2
        | ALIGNAS't => Reduce_act Prod'statement_dangerous'2
        | _ => Fail_act
      end)
    | Ninit Nis'496 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'statement_dangerous'1
        | VOLATILE't => Reduce_act Prod'statement_dangerous'1
        | VOID't => Reduce_act Prod'statement_dangerous'1
        | VAR_NAME't => Reduce_act Prod'statement_dangerous'1
        | UNSIGNED't => Reduce_act Prod'statement_dangerous'1
        | UNION't => Reduce_act Prod'statement_dangerous'1
        | UNDERSCORE_BOOL't => Reduce_act Prod'statement_dangerous'1
        | TYPEDEF_NAME't => Reduce_act Prod'statement_dangerous'1
        | TYPEDEF't => Reduce_act Prod'statement_dangerous'1
        | TILDE't => Reduce_act Prod'statement_dangerous'1
        | SWITCH't => Reduce_act Prod'statement_dangerous'1
        | STRUCT't => Reduce_act Prod'statement_dangerous'1
        | STRING_LITERAL't => Reduce_act Prod'statement_dangerous'1
        | STATIC't => Reduce_act Prod'statement_dangerous'1
        | STAR't => Reduce_act Prod'statement_dangerous'1
        | SIZEOF't => Reduce_act Prod'statement_dangerous'1
        | SIGNED't => Reduce_act Prod'statement_dangerous'1
        | SHORT't => Reduce_act Prod'statement_dangerous'1
        | SEMICOLON't => Reduce_act Prod'statement_dangerous'1
        | RETURN't => Reduce_act Prod'statement_dangerous'1
        | RESTRICT't => Reduce_act Prod'statement_dangerous'1
        | REGISTER't => Reduce_act Prod'statement_dangerous'1
        | RBRACE't => Reduce_act Prod'statement_dangerous'1
        | PRAGMA't => Reduce_act Prod'statement_dangerous'1
        | PLUS't => Reduce_act Prod'statement_dangerous'1
        | PACKED't => Reduce_act Prod'statement_dangerous'1
        | OTHER_NAME't => Reduce_act Prod'statement_dangerous'1
        | MINUS't => Reduce_act Prod'statement_dangerous'1
        | LPAREN't => Reduce_act Prod'statement_dangerous'1
        | LONG't => Reduce_act Prod'statement_dangerous'1
        | LBRACE't => Reduce_act Prod'statement_dangerous'1
        | INT't => Reduce_act Prod'statement_dangerous'1
        | INLINE't => Reduce_act Prod'statement_dangerous'1
        | INC't => Reduce_act Prod'statement_dangerous'1
        | IF't => Reduce_act Prod'statement_dangerous'1
        | GOTO't => Reduce_act Prod'statement_dangerous'1
        | FOR't => Reduce_act Prod'statement_dangerous'1
        | FLOAT't => Reduce_act Prod'statement_dangerous'1
        | EXTERN't => Reduce_act Prod'statement_dangerous'1
        | ENUM't => Reduce_act Prod'statement_dangerous'1
        | ELSE't => Reduce_act Prod'statement_safe'1
        | DOUBLE't => Reduce_act Prod'statement_dangerous'1
        | DO't => Reduce_act Prod'statement_dangerous'1
        | DEFAULT't => Reduce_act Prod'statement_dangerous'1
        | DEC't => Reduce_act Prod'statement_dangerous'1
        | CONTINUE't => Reduce_act Prod'statement_dangerous'1
        | CONSTANT't => Reduce_act Prod'statement_dangerous'1
        | CONST't => Reduce_act Prod'statement_dangerous'1
        | CHAR't => Reduce_act Prod'statement_dangerous'1
        | CASE't => Reduce_act Prod'statement_dangerous'1
        | BUILTIN_VA_ARG't => Reduce_act Prod'statement_dangerous'1
        | BREAK't => Reduce_act Prod'statement_dangerous'1
        | BANG't => Reduce_act Prod'statement_dangerous'1
        | AUTO't => Reduce_act Prod'statement_dangerous'1
        | ATTRIBUTE't => Reduce_act Prod'statement_dangerous'1
        | ASM't => Reduce_act Prod'statement_dangerous'1
        | AND't => Reduce_act Prod'statement_dangerous'1
        | ALIGNOF't => Reduce_act Prod'statement_dangerous'1
        | ALIGNAS't => Reduce_act Prod'statement_dangerous'1
        | _ => Fail_act
      end)
    | Ninit Nis'497 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'statement_dangerous'6
        | VOLATILE't => Reduce_act Prod'statement_dangerous'6
        | VOID't => Reduce_act Prod'statement_dangerous'6
        | VAR_NAME't => Reduce_act Prod'statement_dangerous'6
        | UNSIGNED't => Reduce_act Prod'statement_dangerous'6
        | UNION't => Reduce_act Prod'statement_dangerous'6
        | UNDERSCORE_BOOL't => Reduce_act Prod'statement_dangerous'6
        | TYPEDEF_NAME't => Reduce_act Prod'statement_dangerous'6
        | TYPEDEF't => Reduce_act Prod'statement_dangerous'6
        | TILDE't => Reduce_act Prod'statement_dangerous'6
        | SWITCH't => Reduce_act Prod'statement_dangerous'6
        | STRUCT't => Reduce_act Prod'statement_dangerous'6
        | STRING_LITERAL't => Reduce_act Prod'statement_dangerous'6
        | STATIC't => Reduce_act Prod'statement_dangerous'6
        | STAR't => Reduce_act Prod'statement_dangerous'6
        | SIZEOF't => Reduce_act Prod'statement_dangerous'6
        | SIGNED't => Reduce_act Prod'statement_dangerous'6
        | SHORT't => Reduce_act Prod'statement_dangerous'6
        | SEMICOLON't => Reduce_act Prod'statement_dangerous'6
        | RETURN't => Reduce_act Prod'statement_dangerous'6
        | RESTRICT't => Reduce_act Prod'statement_dangerous'6
        | REGISTER't => Reduce_act Prod'statement_dangerous'6
        | RBRACE't => Reduce_act Prod'statement_dangerous'6
        | PRAGMA't => Reduce_act Prod'statement_dangerous'6
        | PLUS't => Reduce_act Prod'statement_dangerous'6
        | PACKED't => Reduce_act Prod'statement_dangerous'6
        | OTHER_NAME't => Reduce_act Prod'statement_dangerous'6
        | MINUS't => Reduce_act Prod'statement_dangerous'6
        | LPAREN't => Reduce_act Prod'statement_dangerous'6
        | LONG't => Reduce_act Prod'statement_dangerous'6
        | LBRACE't => Reduce_act Prod'statement_dangerous'6
        | INT't => Reduce_act Prod'statement_dangerous'6
        | INLINE't => Reduce_act Prod'statement_dangerous'6
        | INC't => Reduce_act Prod'statement_dangerous'6
        | IF't => Reduce_act Prod'statement_dangerous'6
        | GOTO't => Reduce_act Prod'statement_dangerous'6
        | FOR't => Reduce_act Prod'statement_dangerous'6
        | FLOAT't => Reduce_act Prod'statement_dangerous'6
        | EXTERN't => Reduce_act Prod'statement_dangerous'6
        | ENUM't => Reduce_act Prod'statement_dangerous'6
        | ELSE't => Reduce_act Prod'statement_safe'6
        | DOUBLE't => Reduce_act Prod'statement_dangerous'6
        | DO't => Reduce_act Prod'statement_dangerous'6
        | DEFAULT't => Reduce_act Prod'statement_dangerous'6
        | DEC't => Reduce_act Prod'statement_dangerous'6
        | CONTINUE't => Reduce_act Prod'statement_dangerous'6
        | CONSTANT't => Reduce_act Prod'statement_dangerous'6
        | CONST't => Reduce_act Prod'statement_dangerous'6
        | CHAR't => Reduce_act Prod'statement_dangerous'6
        | CASE't => Reduce_act Prod'statement_dangerous'6
        | BUILTIN_VA_ARG't => Reduce_act Prod'statement_dangerous'6
        | BREAK't => Reduce_act Prod'statement_dangerous'6
        | BANG't => Reduce_act Prod'statement_dangerous'6
        | AUTO't => Reduce_act Prod'statement_dangerous'6
        | ATTRIBUTE't => Reduce_act Prod'statement_dangerous'6
        | ASM't => Reduce_act Prod'statement_dangerous'6
        | AND't => Reduce_act Prod'statement_dangerous'6
        | ALIGNOF't => Reduce_act Prod'statement_dangerous'6
        | ALIGNAS't => Reduce_act Prod'statement_dangerous'6
        | _ => Fail_act
      end)
    | Ninit Nis'498 => Default_reduce_act Prod'labeled_statement_statement_safe_'2
    | Ninit Nis'499 => Default_reduce_act Prod'iteration_statement_statement_safe_'13
    | Ninit Nis'500 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'501 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'501 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'502 => Default_reduce_act Prod'iteration_statement_statement_safe_'7
    | Ninit Nis'503 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'504 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'504 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'505 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'505 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'506 => Default_reduce_act Prod'iteration_statement_statement_safe_'10
    | Ninit Nis'507 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'508 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'508 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'509 => Default_reduce_act Prod'iteration_statement_statement_safe_'4
    | Ninit Nis'510 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'511 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'511 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'512 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'512 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'513 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'513 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'514 => Default_reduce_act Prod'iteration_statement_statement_safe_'11
    | Ninit Nis'515 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'516 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'516 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'517 => Default_reduce_act Prod'iteration_statement_statement_safe_'5
    | Ninit Nis'518 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'519 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'519 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'520 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'520 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'521 => Default_reduce_act Prod'iteration_statement_statement_safe_'8
    | Ninit Nis'522 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'523 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'523 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'524 => Default_reduce_act Prod'iteration_statement_statement_safe_'2
    | Ninit Nis'525 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'526 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'526 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'527 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'527 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'528 => Default_reduce_act Prod'iteration_statement_statement_safe_'12
    | Ninit Nis'529 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'530 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'530 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'531 => Default_reduce_act Prod'iteration_statement_statement_safe_'6
    | Ninit Nis'532 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'533 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'533 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | RPAREN't => Shift_act Nis'534 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'534 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'535 => Default_reduce_act Prod'iteration_statement_statement_safe_'9
    | Ninit Nis'536 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'537 (eq_refl _)
        | COMMA't => Shift_act Nis'131 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'537 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'538 => Default_reduce_act Prod'iteration_statement_statement_safe_'3
    | Ninit Nis'539 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | ELSE't => Shift_act Nis'540 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'540 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'370 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'374 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'378 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'380 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'387 (eq_refl _)
        | DO't => Shift_act Nis'392 (eq_refl _)
        | DEFAULT't => Shift_act Nis'485 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'487 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'541 => Default_reduce_act Prod'selection_statement_safe'0
    | Ninit Nis'542 => Default_reduce_act Prod'selection_statement_dangerous'1
    | Ninit Nis'543 => Default_reduce_act Prod'selection_statement_dangerous'0
    | Ninit Nis'544 => Default_reduce_act Prod'labeled_statement_statement_safe_'0
    | Ninit Nis'545 => Default_reduce_act Prod'labeled_statement_statement_dangerous_'0
    | Ninit Nis'546 => Default_reduce_act Prod'selection_statement_safe'1
    | Ninit Nis'547 => Default_reduce_act Prod'selection_statement_dangerous'2
    | Ninit Nis'548 => Default_reduce_act Prod'iteration_statement_statement_safe_'0
    | Ninit Nis'549 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'0
    | Ninit Nis'550 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | ELSE't => Shift_act Nis'551 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'551 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'552 => Default_reduce_act Prod'compound_statement'1
    | Ninit Nis'553 => Default_reduce_act Prod'block_item'2
    | Ninit Nis'554 => Default_reduce_act Prod'block_item'1
    | Ninit Nis'555 => Default_reduce_act Prod'block_item'0
    | Ninit Nis'556 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'351 (eq_refl _)
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'17 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | TILDE't => Shift_act Nis'18 (eq_refl _)
        | SWITCH't => Shift_act Nis'355 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'19 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'20 (eq_refl _)
        | SIZEOF't => Shift_act Nis'21 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'359 (eq_refl _)
        | RETURN't => Shift_act Nis'360 (eq_refl _)
        | RESTRICT't => Shift_act Nis'12 (eq_refl _)
        | REGISTER't => Shift_act Nis'13 (eq_refl _)
        | RBRACE't => Shift_act Nis'557 (eq_refl _)
        | PRAGMA't => Shift_act Nis'553 (eq_refl _)
        | PLUS't => Shift_act Nis'22 (eq_refl _)
        | PACKED't => Shift_act Nis'15 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'364 (eq_refl _)
        | MINUS't => Shift_act Nis'23 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | LONG't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | INT't => Shift_act Nis'27 (eq_refl _)
        | INLINE't => Shift_act Nis'188 (eq_refl _)
        | INC't => Shift_act Nis'28 (eq_refl _)
        | IF't => Shift_act Nis'366 (eq_refl _)
        | GOTO't => Shift_act Nis'384 (eq_refl _)
        | FOR't => Shift_act Nis'393 (eq_refl _)
        | FLOAT't => Shift_act Nis'30 (eq_refl _)
        | EXTERN't => Shift_act Nis'189 (eq_refl _)
        | ENUM't => Shift_act Nis'31 (eq_refl _)
        | DOUBLE't => Shift_act Nis'51 (eq_refl _)
        | DO't => Shift_act Nis'398 (eq_refl _)
        | DEFAULT't => Shift_act Nis'399 (eq_refl _)
        | DEC't => Shift_act Nis'43 (eq_refl _)
        | CONTINUE't => Shift_act Nis'401 (eq_refl _)
        | CONSTANT't => Shift_act Nis'44 (eq_refl _)
        | CONST't => Shift_act Nis'52 (eq_refl _)
        | CHAR't => Shift_act Nis'53 (eq_refl _)
        | CASE't => Shift_act Nis'403 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'45 (eq_refl _)
        | BREAK't => Shift_act Nis'406 (eq_refl _)
        | BANG't => Shift_act Nis'47 (eq_refl _)
        | AUTO't => Shift_act Nis'190 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'54 (eq_refl _)
        | ASM't => Shift_act Nis'408 (eq_refl _)
        | AND't => Shift_act Nis'48 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'49 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'161 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'557 => Default_reduce_act Prod'compound_statement'0
    | Ninit Nis'558 => Default_reduce_act Prod'block_item_list'1
    | Ninit Nis'559 => Default_reduce_act Prod'block_item_list'0
    | Ninit Nis'560 => Default_reduce_act Prod'declaration_list'1
    | Ninit Nis'561 => Default_reduce_act Prod'function_definition'1
    | Ninit Nis'562 => Default_reduce_act Prod'old_function_declarator'0
    | Ninit Nis'563 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'attribute_specifier_list'0
        | PACKED't => Reduce_act Prod'attribute_specifier_list'0
        | LPAREN't => Shift_act Nis'342 (eq_refl _)
        | LBRACK't => Shift_act Nis'235 (eq_refl _)
        | LBRACE't => Reduce_act Prod'attribute_specifier_list'0
        | EQ't => Reduce_act Prod'attribute_specifier_list'0
        | COMMA't => Reduce_act Prod'attribute_specifier_list'0
        | ATTRIBUTE't => Reduce_act Prod'attribute_specifier_list'0
        | ALIGNAS't => Reduce_act Prod'attribute_specifier_list'0
        | _ => Fail_act
      end)
    | Ninit Nis'564 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'init_declarator'0
        | LBRACE't => Shift_act Nis'350 (eq_refl _)
        | EQ't => Shift_act Nis'462 (eq_refl _)
        | COMMA't => Reduce_act Prod'init_declarator'0
        | _ => Fail_act
      end)
    | Ninit Nis'565 => Default_reduce_act Prod'function_definition'0
    | Ninit Nis'566 => Default_reduce_act Prod'external_declaration'1
    | Ninit Nis'567 => Default_reduce_act Prod'translation_unit'0
  end.

Definition goto_table (state:state) (nt:nonterminal) :=
  match state, nt return option { s:noninitstate | NT nt = last_symb_of_non_init_state s } with
    | Init Init'0, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Init Init'0, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Init Init'0, translation_unit_file'nt => None    | Init Init'0, translation_unit'nt => Some (exist _ Nis'333 (eq_refl _))
    | Init Init'0, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Init Init'0, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Init Init'0, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Init Init'0, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Init Init'0, function_definition'nt => Some (exist _ Nis'335 (eq_refl _))
    | Init Init'0, external_declaration'nt => Some (exist _ Nis'567 (eq_refl _))
    | Init Init'0, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Init Init'0, declaration_specifiers'nt => Some (exist _ Nis'337 (eq_refl _))
    | Init Init'0, declaration'nt => Some (exist _ Nis'566 (eq_refl _))
    | Init Init'0, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'16, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'16, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'16, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'16, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'16, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'16, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'16, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'16, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'16, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'16, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'16, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'16, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'16, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'16, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'16, assignment_expression'nt => Some (exist _ Nis'140 (eq_refl _))
    | Ninit Nis'16, argument_expression_list'nt => Some (exist _ Nis'329 (eq_refl _))
    | Ninit Nis'16, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'16, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'21, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'21, unary_expression'nt => Some (exist _ Nis'328 (eq_refl _))
    | Ninit Nis'21, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'21, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'24, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'24, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'24, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'24, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'24, type_name'nt => Some (exist _ Nis'326 (eq_refl _))
    | Ninit Nis'24, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'24, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'24, specifier_qualifier_list'nt => Some (exist _ Nis'271 (eq_refl _))
    | Ninit Nis'24, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'24, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'24, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'24, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'24, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'24, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'24, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'24, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'24, expression'nt => Some (exist _ Nis'305 (eq_refl _))
    | Ninit Nis'24, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'24, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'24, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'24, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'24, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'24, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'24, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'24, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'24, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'25, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'25, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'25, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'25, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'25, type_name'nt => Some (exist _ Nis'323 (eq_refl _))
    | Ninit Nis'25, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'25, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'25, specifier_qualifier_list'nt => Some (exist _ Nis'271 (eq_refl _))
    | Ninit Nis'25, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'25, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'25, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'25, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'25, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'25, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'25, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'25, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'25, expression'nt => Some (exist _ Nis'305 (eq_refl _))
    | Ninit Nis'25, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'25, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'25, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'25, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'25, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'25, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'25, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'25, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'25, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'28, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'28, unary_expression'nt => Some (exist _ Nis'322 (eq_refl _))
    | Ninit Nis'28, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'28, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'29, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'29, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'29, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'29, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'29, type_name'nt => Some (exist _ Nis'320 (eq_refl _))
    | Ninit Nis'29, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'29, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'29, specifier_qualifier_list'nt => Some (exist _ Nis'271 (eq_refl _))
    | Ninit Nis'29, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'29, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'29, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'29, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'29, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'29, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'29, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'29, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'29, expression'nt => Some (exist _ Nis'305 (eq_refl _))
    | Ninit Nis'29, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'29, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'29, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'29, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'29, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'29, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'29, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'29, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'29, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'31, attribute_specifier_list'nt => Some (exist _ Nis'32 (eq_refl _))
    | Ninit Nis'32, attribute_specifier'nt => Some (exist _ Nis'244 (eq_refl _))
    | Ninit Nis'34, enumerator_list'nt => Some (exist _ Nis'36 (eq_refl _))
    | Ninit Nis'34, enumerator'nt => Some (exist _ Nis'314 (eq_refl _))
    | Ninit Nis'34, enumeration_constant'nt => Some (exist _ Nis'41 (eq_refl _))
    | Ninit Nis'38, enumerator'nt => Some (exist _ Nis'40 (eq_refl _))
    | Ninit Nis'38, enumeration_constant'nt => Some (exist _ Nis'41 (eq_refl _))
    | Ninit Nis'42, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'42, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'42, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'42, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'42, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'42, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'42, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'42, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'42, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'42, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'42, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'42, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'42, constant_expression'nt => Some (exist _ Nis'313 (eq_refl _))
    | Ninit Nis'42, conditional_expression'nt => Some (exist _ Nis'255 (eq_refl _))
    | Ninit Nis'42, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'42, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'42, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'43, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'43, unary_expression'nt => Some (exist _ Nis'312 (eq_refl _))
    | Ninit Nis'43, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'43, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'46, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'46, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'46, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'46, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'46, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'46, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'46, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'46, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'46, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'46, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'46, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'46, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'46, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'46, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'46, assignment_expression'nt => Some (exist _ Nis'308 (eq_refl _))
    | Ninit Nis'46, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'46, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'49, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'49, unary_expression'nt => Some (exist _ Nis'307 (eq_refl _))
    | Ninit Nis'49, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'49, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'50, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'50, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'50, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'50, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'50, type_name'nt => Some (exist _ Nis'277 (eq_refl _))
    | Ninit Nis'50, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'50, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'50, specifier_qualifier_list'nt => Some (exist _ Nis'271 (eq_refl _))
    | Ninit Nis'50, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'50, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'50, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'50, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'50, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'50, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'50, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'50, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'50, expression'nt => Some (exist _ Nis'305 (eq_refl _))
    | Ninit Nis'50, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'50, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'50, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'50, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'50, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'50, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'50, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'50, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'50, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'56, gcc_attribute_word'nt => Some (exist _ Nis'60 (eq_refl _))
    | Ninit Nis'56, gcc_attribute_list'nt => Some (exist _ Nis'155 (eq_refl _))
    | Ninit Nis'56, gcc_attribute'nt => Some (exist _ Nis'160 (eq_refl _))
    | Ninit Nis'61, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'61, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'61, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'61, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'61, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'61, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'61, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'61, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'61, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'61, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'61, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'61, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'61, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'61, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'61, assignment_expression'nt => Some (exist _ Nis'140 (eq_refl _))
    | Ninit Nis'61, argument_expression_list'nt => Some (exist _ Nis'153 (eq_refl _))
    | Ninit Nis'61, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'61, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'63, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'63, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'63, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'63, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'63, cast_expression'nt => Some (exist _ Nis'152 (eq_refl _))
    | Ninit Nis'69, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'69, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'69, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'69, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'69, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'69, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'69, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'69, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'69, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'69, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'69, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'69, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'69, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'69, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'69, assignment_expression'nt => Some (exist _ Nis'140 (eq_refl _))
    | Ninit Nis'69, argument_expression_list'nt => Some (exist _ Nis'141 (eq_refl _))
    | Ninit Nis'69, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'69, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'71, assignment_operator'nt => Some (exist _ Nis'83 (eq_refl _))
    | Ninit Nis'83, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'83, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'83, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'83, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'83, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'83, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'83, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'83, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'83, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'83, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'83, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'83, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'83, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'83, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'83, assignment_expression'nt => Some (exist _ Nis'139 (eq_refl _))
    | Ninit Nis'83, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'83, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'85, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'85, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'85, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'85, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'85, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'85, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'85, additive_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'87, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'87, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'87, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'87, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'87, cast_expression'nt => Some (exist _ Nis'88 (eq_refl _))
    | Ninit Nis'89, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'89, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'89, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'89, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'89, cast_expression'nt => Some (exist _ Nis'90 (eq_refl _))
    | Ninit Nis'91, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'91, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'91, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'91, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'91, cast_expression'nt => Some (exist _ Nis'92 (eq_refl _))
    | Ninit Nis'95, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'95, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'95, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'95, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'95, multiplicative_expression'nt => Some (exist _ Nis'96 (eq_refl _))
    | Ninit Nis'95, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'97, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'97, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'97, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'97, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'97, multiplicative_expression'nt => Some (exist _ Nis'98 (eq_refl _))
    | Ninit Nis'97, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'99, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'99, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'99, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'99, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'99, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'99, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'99, additive_expression'nt => Some (exist _ Nis'100 (eq_refl _))
    | Ninit Nis'102, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'102, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'102, shift_expression'nt => Some (exist _ Nis'103 (eq_refl _))
    | Ninit Nis'102, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'102, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'102, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'102, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'102, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'105, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'105, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'105, shift_expression'nt => Some (exist _ Nis'106 (eq_refl _))
    | Ninit Nis'105, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'105, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'105, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'105, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'105, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'107, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'107, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'107, shift_expression'nt => Some (exist _ Nis'108 (eq_refl _))
    | Ninit Nis'107, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'107, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'107, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'107, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'107, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'109, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'109, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'109, shift_expression'nt => Some (exist _ Nis'110 (eq_refl _))
    | Ninit Nis'109, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'109, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'109, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'109, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'109, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'112, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'112, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'112, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'112, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'112, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'112, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'112, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'112, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'112, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'112, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'112, expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'112, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'112, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'112, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'112, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'112, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'112, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'112, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'114, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'114, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'114, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'114, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'114, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'114, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'114, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'114, inclusive_OR_expression'nt => Some (exist _ Nis'115 (eq_refl _))
    | Ninit Nis'114, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'114, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'114, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'114, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'114, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'116, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'116, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'116, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'116, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'116, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'116, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'116, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'116, exclusive_OR_expression'nt => Some (exist _ Nis'117 (eq_refl _))
    | Ninit Nis'116, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'116, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'116, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'116, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'118, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'118, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'118, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'118, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'118, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'118, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'118, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'118, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'118, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'118, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'118, AND_expression'nt => Some (exist _ Nis'124 (eq_refl _))
    | Ninit Nis'120, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'120, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'120, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'120, relational_expression'nt => Some (exist _ Nis'121 (eq_refl _))
    | Ninit Nis'120, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'120, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'120, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'120, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'120, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'122, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'122, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'122, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'122, relational_expression'nt => Some (exist _ Nis'123 (eq_refl _))
    | Ninit Nis'122, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'122, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'122, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'122, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'122, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'125, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'125, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'125, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'125, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'125, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'125, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'125, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'125, equality_expression'nt => Some (exist _ Nis'126 (eq_refl _))
    | Ninit Nis'125, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'125, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'131, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'131, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'131, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'131, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'131, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'131, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'131, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'131, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'131, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'131, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'131, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'131, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'131, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'131, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'131, assignment_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'131, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'131, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'134, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'134, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'134, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'134, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'134, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'134, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'134, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'134, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'134, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'134, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'134, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'134, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'134, conditional_expression'nt => Some (exist _ Nis'135 (eq_refl _))
    | Ninit Nis'134, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'134, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'134, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'137, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'137, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'137, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'137, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'137, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'137, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'137, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'137, logical_AND_expression'nt => Some (exist _ Nis'138 (eq_refl _))
    | Ninit Nis'137, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'137, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'137, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'137, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'137, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'137, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'143, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'143, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'143, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'143, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'143, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'143, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'143, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'143, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'143, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'143, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'143, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'143, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'143, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'143, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'143, assignment_expression'nt => Some (exist _ Nis'144 (eq_refl _))
    | Ninit Nis'143, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'143, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'145, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'145, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'145, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'145, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'145, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'145, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'145, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'145, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'145, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'145, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'145, expression'nt => Some (exist _ Nis'146 (eq_refl _))
    | Ninit Nis'145, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'145, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'145, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'145, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'145, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'145, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'145, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'158, gcc_attribute_word'nt => Some (exist _ Nis'60 (eq_refl _))
    | Ninit Nis'158, gcc_attribute'nt => Some (exist _ Nis'159 (eq_refl _))
    | Ninit Nis'162, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'162, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'162, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'162, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'162, type_name'nt => Some (exist _ Nis'269 (eq_refl _))
    | Ninit Nis'162, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'162, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'162, specifier_qualifier_list'nt => Some (exist _ Nis'271 (eq_refl _))
    | Ninit Nis'162, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'162, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'162, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'162, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'162, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'162, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'162, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'162, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'162, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'162, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'162, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'162, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'162, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'162, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'162, assignment_expression'nt => Some (exist _ Nis'140 (eq_refl _))
    | Ninit Nis'162, argument_expression_list'nt => Some (exist _ Nis'275 (eq_refl _))
    | Ninit Nis'162, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'162, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'163, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'163, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'163, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'163, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'163, specifier_qualifier_list'nt => Some (exist _ Nis'268 (eq_refl _))
    | Ninit Nis'163, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'163, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'164, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'164, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'164, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'164, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'164, specifier_qualifier_list'nt => Some (exist _ Nis'267 (eq_refl _))
    | Ninit Nis'164, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'164, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'166, attribute_specifier_list'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'167, attribute_specifier'nt => Some (exist _ Nis'244 (eq_refl _))
    | Ninit Nis'169, struct_declaration_list'nt => Some (exist _ Nis'170 (eq_refl _))
    | Ninit Nis'170, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'170, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'170, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'170, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'170, struct_declaration'nt => Some (exist _ Nis'172 (eq_refl _))
    | Ninit Nis'170, specifier_qualifier_list'nt => Some (exist _ Nis'173 (eq_refl _))
    | Ninit Nis'170, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'170, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'173, struct_declarator_list'nt => Some (exist _ Nis'256 (eq_refl _))
    | Ninit Nis'173, struct_declarator'nt => Some (exist _ Nis'263 (eq_refl _))
    | Ninit Nis'173, pointer'nt => Some (exist _ Nis'184 (eq_refl _))
    | Ninit Nis'173, direct_declarator'nt => Some (exist _ Nis'234 (eq_refl _))
    | Ninit Nis'173, declarator'nt => Some (exist _ Nis'260 (eq_refl _))
    | Ninit Nis'175, type_qualifier_list'nt => Some (exist _ Nis'176 (eq_refl _))
    | Ninit Nis'175, type_qualifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'175, pointer'nt => Some (exist _ Nis'181 (eq_refl _))
    | Ninit Nis'175, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'176, type_qualifier'nt => Some (exist _ Nis'177 (eq_refl _))
    | Ninit Nis'176, pointer'nt => Some (exist _ Nis'178 (eq_refl _))
    | Ninit Nis'176, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'183, pointer'nt => Some (exist _ Nis'184 (eq_refl _))
    | Ninit Nis'183, direct_declarator'nt => Some (exist _ Nis'234 (eq_refl _))
    | Ninit Nis'183, declarator'nt => Some (exist _ Nis'246 (eq_refl _))
    | Ninit Nis'184, direct_declarator'nt => Some (exist _ Nis'185 (eq_refl _))
    | Ninit Nis'185, attribute_specifier_list'nt => Some (exist _ Nis'252 (eq_refl _))
    | Ninit Nis'186, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'186, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'186, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'186, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'186, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'186, parameter_type_list'nt => Some (exist _ Nis'200 (eq_refl _))
    | Ninit Nis'186, parameter_list'nt => Some (exist _ Nis'202 (eq_refl _))
    | Ninit Nis'186, parameter_declaration'nt => Some (exist _ Nis'223 (eq_refl _))
    | Ninit Nis'186, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'186, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'186, declaration_specifiers'nt => Some (exist _ Nis'206 (eq_refl _))
    | Ninit Nis'186, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'191, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'191, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'191, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'191, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'191, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'191, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'191, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'191, declaration_specifiers'nt => Some (exist _ Nis'199 (eq_refl _))
    | Ninit Nis'191, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'192, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'192, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'192, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'192, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'192, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'192, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'192, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'192, declaration_specifiers'nt => Some (exist _ Nis'198 (eq_refl _))
    | Ninit Nis'192, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'193, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'193, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'193, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'193, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'193, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'193, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'193, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'193, declaration_specifiers'nt => Some (exist _ Nis'197 (eq_refl _))
    | Ninit Nis'193, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'194, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'194, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'194, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'194, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'194, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'194, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'194, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'194, declaration_specifiers'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'194, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'203, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'203, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'203, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'203, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'203, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'203, parameter_declaration'nt => Some (exist _ Nis'205 (eq_refl _))
    | Ninit Nis'203, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'203, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'203, declaration_specifiers'nt => Some (exist _ Nis'206 (eq_refl _))
    | Ninit Nis'203, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'206, pointer'nt => Some (exist _ Nis'217 (eq_refl _))
    | Ninit Nis'206, direct_declarator'nt => Some (exist _ Nis'234 (eq_refl _))
    | Ninit Nis'206, direct_abstract_declarator'nt => Some (exist _ Nis'245 (eq_refl _))
    | Ninit Nis'206, declarator'nt => Some (exist _ Nis'250 (eq_refl _))
    | Ninit Nis'206, abstract_declarator'nt => Some (exist _ Nis'251 (eq_refl _))
    | Ninit Nis'207, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'207, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'207, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'207, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'207, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'207, pointer'nt => Some (exist _ Nis'217 (eq_refl _))
    | Ninit Nis'207, parameter_type_list'nt => Some (exist _ Nis'232 (eq_refl _))
    | Ninit Nis'207, parameter_list'nt => Some (exist _ Nis'202 (eq_refl _))
    | Ninit Nis'207, parameter_declaration'nt => Some (exist _ Nis'223 (eq_refl _))
    | Ninit Nis'207, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'207, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'207, direct_declarator'nt => Some (exist _ Nis'234 (eq_refl _))
    | Ninit Nis'207, direct_abstract_declarator'nt => Some (exist _ Nis'245 (eq_refl _))
    | Ninit Nis'207, declarator'nt => Some (exist _ Nis'246 (eq_refl _))
    | Ninit Nis'207, declaration_specifiers'nt => Some (exist _ Nis'206 (eq_refl _))
    | Ninit Nis'207, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'207, abstract_declarator'nt => Some (exist _ Nis'248 (eq_refl _))
    | Ninit Nis'209, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'209, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'209, type_qualifier_list'nt => Some (exist _ Nis'211 (eq_refl _))
    | Ninit Nis'209, type_qualifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'209, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'209, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'209, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'209, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'209, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'209, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'209, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'209, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'209, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'209, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'209, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'209, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'209, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'209, assignment_expression'nt => Some (exist _ Nis'215 (eq_refl _))
    | Ninit Nis'209, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'209, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'211, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'211, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'211, type_qualifier'nt => Some (exist _ Nis'177 (eq_refl _))
    | Ninit Nis'211, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'211, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'211, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'211, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'211, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'211, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'211, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'211, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'211, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'211, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'211, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'211, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'211, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'211, assignment_expression'nt => Some (exist _ Nis'213 (eq_refl _))
    | Ninit Nis'211, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'211, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'217, direct_declarator'nt => Some (exist _ Nis'185 (eq_refl _))
    | Ninit Nis'217, direct_abstract_declarator'nt => Some (exist _ Nis'218 (eq_refl _))
    | Ninit Nis'219, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'219, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'219, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'219, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'219, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'219, parameter_type_list'nt => Some (exist _ Nis'221 (eq_refl _))
    | Ninit Nis'219, parameter_list'nt => Some (exist _ Nis'202 (eq_refl _))
    | Ninit Nis'219, parameter_declaration'nt => Some (exist _ Nis'223 (eq_refl _))
    | Ninit Nis'219, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'219, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'219, declaration_specifiers'nt => Some (exist _ Nis'206 (eq_refl _))
    | Ninit Nis'219, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'224, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'224, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'224, type_qualifier_list'nt => Some (exist _ Nis'226 (eq_refl _))
    | Ninit Nis'224, type_qualifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'224, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'224, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'224, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'224, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'224, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'224, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'224, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'224, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'224, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'224, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'224, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'224, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'224, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'224, assignment_expression'nt => Some (exist _ Nis'230 (eq_refl _))
    | Ninit Nis'224, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'224, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'226, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'226, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'226, type_qualifier'nt => Some (exist _ Nis'177 (eq_refl _))
    | Ninit Nis'226, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'226, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'226, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'226, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'226, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'226, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'226, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'226, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'226, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'226, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'226, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'226, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'226, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'226, assignment_expression'nt => Some (exist _ Nis'228 (eq_refl _))
    | Ninit Nis'226, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'226, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'234, attribute_specifier_list'nt => Some (exist _ Nis'243 (eq_refl _))
    | Ninit Nis'235, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'235, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'235, type_qualifier_list'nt => Some (exist _ Nis'237 (eq_refl _))
    | Ninit Nis'235, type_qualifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'235, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'235, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'235, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'235, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'235, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'235, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'235, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'235, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'235, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'235, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'235, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'235, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'235, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'235, assignment_expression'nt => Some (exist _ Nis'241 (eq_refl _))
    | Ninit Nis'235, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'235, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'237, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'237, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'237, type_qualifier'nt => Some (exist _ Nis'177 (eq_refl _))
    | Ninit Nis'237, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'237, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'237, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'237, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'237, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'237, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'237, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'237, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'237, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'237, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'237, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'237, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'237, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'237, assignment_expression'nt => Some (exist _ Nis'239 (eq_refl _))
    | Ninit Nis'237, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'237, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'243, attribute_specifier'nt => Some (exist _ Nis'244 (eq_refl _))
    | Ninit Nis'252, attribute_specifier'nt => Some (exist _ Nis'244 (eq_refl _))
    | Ninit Nis'253, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'253, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'253, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'253, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'253, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'253, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'253, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'253, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'253, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'253, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'253, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'253, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'253, constant_expression'nt => Some (exist _ Nis'254 (eq_refl _))
    | Ninit Nis'253, conditional_expression'nt => Some (exist _ Nis'255 (eq_refl _))
    | Ninit Nis'253, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'253, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'253, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'258, struct_declarator'nt => Some (exist _ Nis'259 (eq_refl _))
    | Ninit Nis'258, pointer'nt => Some (exist _ Nis'184 (eq_refl _))
    | Ninit Nis'258, direct_declarator'nt => Some (exist _ Nis'234 (eq_refl _))
    | Ninit Nis'258, declarator'nt => Some (exist _ Nis'260 (eq_refl _))
    | Ninit Nis'261, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'261, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'261, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'261, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'261, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'261, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'261, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'261, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'261, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'261, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'261, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'261, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'261, constant_expression'nt => Some (exist _ Nis'262 (eq_refl _))
    | Ninit Nis'261, conditional_expression'nt => Some (exist _ Nis'255 (eq_refl _))
    | Ninit Nis'261, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'261, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'261, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'264, struct_declaration_list'nt => Some (exist _ Nis'265 (eq_refl _))
    | Ninit Nis'265, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'265, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'265, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'265, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'265, struct_declaration'nt => Some (exist _ Nis'172 (eq_refl _))
    | Ninit Nis'265, specifier_qualifier_list'nt => Some (exist _ Nis'173 (eq_refl _))
    | Ninit Nis'265, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'265, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'271, pointer'nt => Some (exist _ Nis'273 (eq_refl _))
    | Ninit Nis'271, direct_abstract_declarator'nt => Some (exist _ Nis'245 (eq_refl _))
    | Ninit Nis'271, abstract_declarator'nt => Some (exist _ Nis'274 (eq_refl _))
    | Ninit Nis'272, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'272, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'272, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'272, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'272, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'272, pointer'nt => Some (exist _ Nis'273 (eq_refl _))
    | Ninit Nis'272, parameter_type_list'nt => Some (exist _ Nis'232 (eq_refl _))
    | Ninit Nis'272, parameter_list'nt => Some (exist _ Nis'202 (eq_refl _))
    | Ninit Nis'272, parameter_declaration'nt => Some (exist _ Nis'223 (eq_refl _))
    | Ninit Nis'272, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'272, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'272, direct_abstract_declarator'nt => Some (exist _ Nis'245 (eq_refl _))
    | Ninit Nis'272, declaration_specifiers'nt => Some (exist _ Nis'206 (eq_refl _))
    | Ninit Nis'272, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'272, abstract_declarator'nt => Some (exist _ Nis'248 (eq_refl _))
    | Ninit Nis'273, direct_abstract_declarator'nt => Some (exist _ Nis'218 (eq_refl _))
    | Ninit Nis'279, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'279, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'279, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'279, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'279, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'279, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'279, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'279, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'279, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'279, initializer_list'nt => Some (exist _ Nis'301 (eq_refl _))
    | Ninit Nis'279, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'279, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'279, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'279, designator_list'nt => Some (exist _ Nis'290 (eq_refl _))
    | Ninit Nis'279, designator'nt => Some (exist _ Nis'293 (eq_refl _))
    | Ninit Nis'279, designation'nt => Some (exist _ Nis'298 (eq_refl _))
    | Ninit Nis'279, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'279, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'279, c_initializer'nt => Some (exist _ Nis'300 (eq_refl _))
    | Ninit Nis'279, assignment_expression'nt => Some (exist _ Nis'296 (eq_refl _))
    | Ninit Nis'279, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'279, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'280, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'280, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'280, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'280, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'280, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'280, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'280, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'280, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'280, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'280, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'280, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'280, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'280, constant_expression'nt => Some (exist _ Nis'281 (eq_refl _))
    | Ninit Nis'280, conditional_expression'nt => Some (exist _ Nis'255 (eq_refl _))
    | Ninit Nis'280, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'280, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'280, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'283, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'283, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'283, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'283, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'283, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'283, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'283, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'283, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'283, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'283, initializer_list'nt => Some (exist _ Nis'286 (eq_refl _))
    | Ninit Nis'283, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'283, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'283, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'283, designator_list'nt => Some (exist _ Nis'290 (eq_refl _))
    | Ninit Nis'283, designator'nt => Some (exist _ Nis'293 (eq_refl _))
    | Ninit Nis'283, designation'nt => Some (exist _ Nis'298 (eq_refl _))
    | Ninit Nis'283, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'283, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'283, c_initializer'nt => Some (exist _ Nis'300 (eq_refl _))
    | Ninit Nis'283, assignment_expression'nt => Some (exist _ Nis'296 (eq_refl _))
    | Ninit Nis'283, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'283, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'288, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'288, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'288, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'288, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'288, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'288, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'288, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'288, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'288, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'288, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'288, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'288, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'288, designator_list'nt => Some (exist _ Nis'290 (eq_refl _))
    | Ninit Nis'288, designator'nt => Some (exist _ Nis'293 (eq_refl _))
    | Ninit Nis'288, designation'nt => Some (exist _ Nis'294 (eq_refl _))
    | Ninit Nis'288, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'288, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'288, c_initializer'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'288, assignment_expression'nt => Some (exist _ Nis'296 (eq_refl _))
    | Ninit Nis'288, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'288, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'290, designator'nt => Some (exist _ Nis'292 (eq_refl _))
    | Ninit Nis'294, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'294, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'294, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'294, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'294, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'294, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'294, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'294, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'294, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'294, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'294, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'294, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'294, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'294, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'294, c_initializer'nt => Some (exist _ Nis'295 (eq_refl _))
    | Ninit Nis'294, assignment_expression'nt => Some (exist _ Nis'296 (eq_refl _))
    | Ninit Nis'294, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'294, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'298, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'298, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'298, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'298, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'298, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'298, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'298, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'298, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'298, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'298, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'298, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'298, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'298, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'298, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'298, c_initializer'nt => Some (exist _ Nis'299 (eq_refl _))
    | Ninit Nis'298, assignment_expression'nt => Some (exist _ Nis'296 (eq_refl _))
    | Ninit Nis'298, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'298, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'303, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'303, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'303, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'303, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'303, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'303, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'303, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'303, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'303, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'303, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'303, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'303, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'303, designator_list'nt => Some (exist _ Nis'290 (eq_refl _))
    | Ninit Nis'303, designator'nt => Some (exist _ Nis'293 (eq_refl _))
    | Ninit Nis'303, designation'nt => Some (exist _ Nis'294 (eq_refl _))
    | Ninit Nis'303, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'303, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'303, c_initializer'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'303, assignment_expression'nt => Some (exist _ Nis'296 (eq_refl _))
    | Ninit Nis'303, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'303, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'309, type_specifier'nt => Some (exist _ Nis'163 (eq_refl _))
    | Ninit Nis'309, type_qualifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'309, type_name'nt => Some (exist _ Nis'310 (eq_refl _))
    | Ninit Nis'309, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'309, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'309, specifier_qualifier_list'nt => Some (exist _ Nis'271 (eq_refl _))
    | Ninit Nis'309, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'309, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'315, enumerator_list'nt => Some (exist _ Nis'316 (eq_refl _))
    | Ninit Nis'315, enumerator'nt => Some (exist _ Nis'314 (eq_refl _))
    | Ninit Nis'315, enumeration_constant'nt => Some (exist _ Nis'41 (eq_refl _))
    | Ninit Nis'318, enumerator'nt => Some (exist _ Nis'40 (eq_refl _))
    | Ninit Nis'318, enumeration_constant'nt => Some (exist _ Nis'41 (eq_refl _))
    | Ninit Nis'324, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'324, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'324, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'324, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'324, cast_expression'nt => Some (exist _ Nis'325 (eq_refl _))
    | Ninit Nis'333, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'333, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'333, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'333, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'333, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'333, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'333, function_definition'nt => Some (exist _ Nis'335 (eq_refl _))
    | Ninit Nis'333, external_declaration'nt => Some (exist _ Nis'336 (eq_refl _))
    | Ninit Nis'333, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'333, declaration_specifiers'nt => Some (exist _ Nis'337 (eq_refl _))
    | Ninit Nis'333, declaration'nt => Some (exist _ Nis'566 (eq_refl _))
    | Ninit Nis'333, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'337, pointer'nt => Some (exist _ Nis'339 (eq_refl _))
    | Ninit Nis'337, old_function_declarator'nt => Some (exist _ Nis'348 (eq_refl _))
    | Ninit Nis'337, init_declarator_list'nt => Some (exist _ Nis'457 (eq_refl _))
    | Ninit Nis'337, init_declarator'nt => Some (exist _ Nis'464 (eq_refl _))
    | Ninit Nis'337, direct_old_function_declarator'nt => Some (exist _ Nis'562 (eq_refl _))
    | Ninit Nis'337, direct_declarator'nt => Some (exist _ Nis'563 (eq_refl _))
    | Ninit Nis'337, declarator'nt => Some (exist _ Nis'564 (eq_refl _))
    | Ninit Nis'339, direct_old_function_declarator'nt => Some (exist _ Nis'340 (eq_refl _))
    | Ninit Nis'339, direct_declarator'nt => Some (exist _ Nis'341 (eq_refl _))
    | Ninit Nis'341, attribute_specifier_list'nt => Some (exist _ Nis'252 (eq_refl _))
    | Ninit Nis'342, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'342, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'342, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'342, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'342, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'342, parameter_type_list'nt => Some (exist _ Nis'200 (eq_refl _))
    | Ninit Nis'342, parameter_list'nt => Some (exist _ Nis'202 (eq_refl _))
    | Ninit Nis'342, parameter_declaration'nt => Some (exist _ Nis'223 (eq_refl _))
    | Ninit Nis'342, identifier_list'nt => Some (exist _ Nis'344 (eq_refl _))
    | Ninit Nis'342, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'342, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'342, declaration_specifiers'nt => Some (exist _ Nis'206 (eq_refl _))
    | Ninit Nis'342, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'348, declaration_list'nt => Some (exist _ Nis'349 (eq_refl _))
    | Ninit Nis'349, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'349, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'349, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'349, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'349, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'349, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'349, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'349, declaration_specifiers'nt => Some (exist _ Nis'456 (eq_refl _))
    | Ninit Nis'349, declaration'nt => Some (exist _ Nis'560 (eq_refl _))
    | Ninit Nis'349, compound_statement'nt => Some (exist _ Nis'561 (eq_refl _))
    | Ninit Nis'349, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'350, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'350, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'350, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'350, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'350, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'350, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'350, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'350, statement_dangerous'nt => Some (exist _ Nis'554 (eq_refl _))
    | Ninit Nis'350, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'350, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'350, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'350, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'350, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'350, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'350, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'350, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'350, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'350, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'350, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'350, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'350, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'350, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'350, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'350, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'350, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'350, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'350, declaration_specifiers'nt => Some (exist _ Nis'456 (eq_refl _))
    | Ninit Nis'350, declaration'nt => Some (exist _ Nis'555 (eq_refl _))
    | Ninit Nis'350, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'350, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'350, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'350, block_item_list'nt => Some (exist _ Nis'556 (eq_refl _))
    | Ninit Nis'350, block_item'nt => Some (exist _ Nis'559 (eq_refl _))
    | Ninit Nis'350, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'350, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'350, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'350, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'350, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'352, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'352, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'352, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'352, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'352, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'352, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'352, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'352, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'352, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'352, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'352, expression'nt => Some (exist _ Nis'353 (eq_refl _))
    | Ninit Nis'352, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'352, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'352, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'352, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'352, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'352, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'352, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'354, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'354, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'354, statement_dangerous'nt => Some (exist _ Nis'549 (eq_refl _))
    | Ninit Nis'354, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'354, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'354, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'354, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'354, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'354, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'354, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'354, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'354, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'354, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'354, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'354, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'354, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'354, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'354, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'354, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'354, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'354, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'354, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'354, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'354, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'354, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'354, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'356, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'356, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'356, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'356, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'356, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'356, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'356, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'356, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'356, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'356, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'356, expression'nt => Some (exist _ Nis'357 (eq_refl _))
    | Ninit Nis'356, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'356, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'356, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'356, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'356, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'356, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'356, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'358, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'358, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'358, statement_dangerous'nt => Some (exist _ Nis'547 (eq_refl _))
    | Ninit Nis'358, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'358, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'358, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'358, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'358, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'358, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'358, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'358, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'358, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'358, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'358, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'358, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'358, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'358, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'358, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'358, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'358, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'358, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'358, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'358, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'358, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'358, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'358, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'360, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'360, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'360, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'360, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'360, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'360, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'360, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'360, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'360, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'360, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'360, expression'nt => Some (exist _ Nis'362 (eq_refl _))
    | Ninit Nis'360, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'360, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'360, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'360, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'360, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'360, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'360, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'365, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'365, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'365, statement_dangerous'nt => Some (exist _ Nis'545 (eq_refl _))
    | Ninit Nis'365, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'365, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'365, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'365, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'365, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'365, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'365, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'365, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'365, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'365, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'365, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'365, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'365, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'365, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'365, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'365, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'365, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'365, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'365, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'365, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'365, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'365, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'365, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'367, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'367, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'367, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'367, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'367, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'367, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'367, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'367, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'367, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'367, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'367, expression'nt => Some (exist _ Nis'368 (eq_refl _))
    | Ninit Nis'367, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'367, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'367, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'367, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'367, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'367, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'367, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'369, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'369, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'369, statement_safe'nt => Some (exist _ Nis'550 (eq_refl _))
    | Ninit Nis'369, statement_dangerous'nt => Some (exist _ Nis'543 (eq_refl _))
    | Ninit Nis'369, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'369, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'369, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'369, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'369, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'369, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'369, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'369, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'369, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'369, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'369, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'369, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'369, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'369, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'369, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'369, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'369, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'369, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'369, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'369, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'369, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'369, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'369, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'369, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'369, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'369, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'371, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'371, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'371, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'371, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'371, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'371, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'371, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'371, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'371, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'371, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'371, expression'nt => Some (exist _ Nis'372 (eq_refl _))
    | Ninit Nis'371, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'371, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'371, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'371, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'371, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'371, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'371, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'373, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'373, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'373, statement_safe'nt => Some (exist _ Nis'548 (eq_refl _))
    | Ninit Nis'373, statement_dangerous'nt => Some (exist _ Nis'549 (eq_refl _))
    | Ninit Nis'373, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'373, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'373, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'373, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'373, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'373, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'373, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'373, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'373, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'373, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'373, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'373, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'373, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'373, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'373, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'373, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'373, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'373, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'373, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'373, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'373, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'373, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'373, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'373, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'373, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'373, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'375, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'375, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'375, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'375, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'375, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'375, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'375, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'375, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'375, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'375, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'375, expression'nt => Some (exist _ Nis'376 (eq_refl _))
    | Ninit Nis'375, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'375, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'375, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'375, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'375, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'375, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'375, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'377, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'377, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'377, statement_safe'nt => Some (exist _ Nis'546 (eq_refl _))
    | Ninit Nis'377, statement_dangerous'nt => Some (exist _ Nis'547 (eq_refl _))
    | Ninit Nis'377, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'377, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'377, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'377, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'377, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'377, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'377, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'377, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'377, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'377, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'377, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'377, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'377, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'377, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'377, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'377, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'377, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'377, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'377, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'377, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'377, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'377, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'377, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'377, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'377, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'377, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'379, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'379, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'379, statement_safe'nt => Some (exist _ Nis'544 (eq_refl _))
    | Ninit Nis'379, statement_dangerous'nt => Some (exist _ Nis'545 (eq_refl _))
    | Ninit Nis'379, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'379, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'379, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'379, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'379, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'379, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'379, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'379, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'379, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'379, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'379, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'379, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'379, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'379, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'379, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'379, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'379, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'379, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'379, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'379, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'379, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'379, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'379, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'379, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'379, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'379, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'381, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'381, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'381, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'381, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'381, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'381, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'381, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'381, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'381, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'381, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'381, expression'nt => Some (exist _ Nis'382 (eq_refl _))
    | Ninit Nis'381, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'381, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'381, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'381, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'381, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'381, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'381, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'383, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'383, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'383, statement_safe'nt => Some (exist _ Nis'539 (eq_refl _))
    | Ninit Nis'383, statement_dangerous'nt => Some (exist _ Nis'543 (eq_refl _))
    | Ninit Nis'383, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'383, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'383, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'383, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'383, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'383, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'383, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'383, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'383, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'383, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'383, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'383, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'383, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'383, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'383, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'383, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'383, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'383, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'383, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'383, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'383, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'383, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'383, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'383, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'383, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'383, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'388, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'388, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'388, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'388, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'388, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'388, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'388, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'388, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'388, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'388, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'388, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'388, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'388, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'388, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'388, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'388, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'388, expression'nt => Some (exist _ Nis'510 (eq_refl _))
    | Ninit Nis'388, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'388, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'388, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'388, declaration_specifiers'nt => Some (exist _ Nis'456 (eq_refl _))
    | Ninit Nis'388, declaration'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'388, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'388, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'388, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'388, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'388, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'388, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'389, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'389, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'389, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'389, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'389, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'389, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'389, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'389, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'389, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'389, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'389, expression'nt => Some (exist _ Nis'503 (eq_refl _))
    | Ninit Nis'389, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'389, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'389, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'389, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'389, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'389, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'389, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'390, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'390, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'390, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'390, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'390, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'390, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'390, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'390, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'390, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'390, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'390, expression'nt => Some (exist _ Nis'500 (eq_refl _))
    | Ninit Nis'390, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'390, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'390, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'390, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'390, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'390, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'390, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'391, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'391, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'391, statement_safe'nt => Some (exist _ Nis'499 (eq_refl _))
    | Ninit Nis'391, statement_dangerous'nt => Some (exist _ Nis'430 (eq_refl _))
    | Ninit Nis'391, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'391, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'391, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'391, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'391, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'391, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'391, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'391, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'391, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'391, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'391, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'391, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'391, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'391, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'391, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'391, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'391, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'391, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'391, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'391, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'391, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'391, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'391, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'391, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'391, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'391, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'392, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'392, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'392, statement_dangerous'nt => Some (exist _ Nis'479 (eq_refl _))
    | Ninit Nis'392, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'392, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'392, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'392, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'392, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'392, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'392, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'392, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'392, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'392, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'392, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'392, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'392, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'392, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'392, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'392, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'392, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'392, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'392, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'392, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'392, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'392, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'392, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'394, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'394, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'394, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'394, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'394, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'394, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'394, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'394, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'394, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'394, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'394, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'394, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'394, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'394, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'394, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'394, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'394, expression'nt => Some (exist _ Nis'441 (eq_refl _))
    | Ninit Nis'394, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'394, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'394, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'394, declaration_specifiers'nt => Some (exist _ Nis'456 (eq_refl _))
    | Ninit Nis'394, declaration'nt => Some (exist _ Nis'465 (eq_refl _))
    | Ninit Nis'394, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'394, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'394, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'394, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'394, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'394, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'395, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'395, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'395, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'395, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'395, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'395, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'395, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'395, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'395, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'395, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'395, expression'nt => Some (exist _ Nis'434 (eq_refl _))
    | Ninit Nis'395, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'395, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'395, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'395, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'395, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'395, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'395, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'396, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'396, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'396, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'396, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'396, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'396, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'396, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'396, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'396, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'396, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'396, expression'nt => Some (exist _ Nis'431 (eq_refl _))
    | Ninit Nis'396, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'396, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'396, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'396, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'396, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'396, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'396, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'397, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'397, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'397, statement_dangerous'nt => Some (exist _ Nis'430 (eq_refl _))
    | Ninit Nis'397, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'397, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'397, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'397, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'397, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'397, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'397, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'397, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'397, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'397, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'397, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'397, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'397, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'397, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'397, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'397, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'397, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'397, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'397, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'397, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'397, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'397, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'397, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'398, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'398, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'398, statement_dangerous'nt => Some (exist _ Nis'424 (eq_refl _))
    | Ninit Nis'398, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'398, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'398, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'398, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'398, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'398, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'398, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'398, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'398, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'398, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'398, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'398, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'398, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'398, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'398, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'398, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'398, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'398, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'398, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'398, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'398, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'398, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'398, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'400, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'400, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'400, statement_dangerous'nt => Some (exist _ Nis'423 (eq_refl _))
    | Ninit Nis'400, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'400, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'400, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'400, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'400, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'400, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'400, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'400, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'400, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'400, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'400, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'400, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'400, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'400, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'400, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'400, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'400, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'400, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'400, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'400, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'400, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'400, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'400, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'403, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'403, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'403, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'403, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'403, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'403, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'403, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'403, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'403, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'403, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'403, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'403, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'403, constant_expression'nt => Some (exist _ Nis'404 (eq_refl _))
    | Ninit Nis'403, conditional_expression'nt => Some (exist _ Nis'255 (eq_refl _))
    | Ninit Nis'403, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'403, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'403, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'405, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'405, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'405, statement_dangerous'nt => Some (exist _ Nis'413 (eq_refl _))
    | Ninit Nis'405, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'405, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'405, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'405, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'405, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'405, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'405, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'405, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'405, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'405, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'405, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'405, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'405, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'405, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'405, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'405, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'405, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'405, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'405, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'405, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'405, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'405, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'405, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'426, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'426, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'426, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'426, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'426, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'426, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'426, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'426, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'426, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'426, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'426, expression'nt => Some (exist _ Nis'427 (eq_refl _))
    | Ninit Nis'426, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'426, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'426, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'426, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'426, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'426, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'426, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'432, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'432, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'432, statement_dangerous'nt => Some (exist _ Nis'433 (eq_refl _))
    | Ninit Nis'432, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'432, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'432, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'432, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'432, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'432, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'432, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'432, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'432, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'432, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'432, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'432, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'432, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'432, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'432, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'432, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'432, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'432, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'432, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'432, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'432, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'432, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'432, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'435, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'435, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'435, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'435, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'435, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'435, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'435, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'435, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'435, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'435, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'435, expression'nt => Some (exist _ Nis'438 (eq_refl _))
    | Ninit Nis'435, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'435, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'435, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'435, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'435, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'435, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'435, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'436, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'436, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'436, statement_dangerous'nt => Some (exist _ Nis'437 (eq_refl _))
    | Ninit Nis'436, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'436, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'436, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'436, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'436, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'436, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'436, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'436, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'436, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'436, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'436, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'436, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'436, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'436, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'436, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'436, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'436, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'436, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'436, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'436, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'436, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'436, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'436, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'439, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'439, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'439, statement_dangerous'nt => Some (exist _ Nis'440 (eq_refl _))
    | Ninit Nis'439, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'439, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'439, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'439, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'439, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'439, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'439, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'439, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'439, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'439, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'439, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'439, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'439, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'439, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'439, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'439, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'439, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'439, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'439, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'439, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'439, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'439, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'439, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'442, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'442, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'442, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'442, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'442, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'442, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'442, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'442, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'442, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'442, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'442, expression'nt => Some (exist _ Nis'449 (eq_refl _))
    | Ninit Nis'442, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'442, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'442, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'442, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'442, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'442, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'442, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'443, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'443, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'443, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'443, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'443, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'443, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'443, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'443, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'443, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'443, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'443, expression'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'443, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'443, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'443, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'443, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'443, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'443, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'443, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'444, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'444, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'444, statement_dangerous'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'444, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'444, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'444, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'444, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'444, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'444, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'444, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'444, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'444, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'444, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'444, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'444, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'444, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'444, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'444, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'444, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'444, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'444, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'444, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'444, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'444, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'444, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'444, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'447, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'447, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'447, statement_dangerous'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'447, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'447, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'447, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'447, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'447, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'447, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'447, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'447, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'447, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'447, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'447, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'447, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'447, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'447, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'447, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'447, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'447, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'447, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'447, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'447, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'447, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'447, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'447, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'450, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'450, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'450, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'450, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'450, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'450, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'450, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'450, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'450, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'450, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'450, expression'nt => Some (exist _ Nis'453 (eq_refl _))
    | Ninit Nis'450, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'450, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'450, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'450, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'450, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'450, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'450, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'451, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'451, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'451, statement_dangerous'nt => Some (exist _ Nis'452 (eq_refl _))
    | Ninit Nis'451, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'451, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'451, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'451, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'451, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'451, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'451, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'451, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'451, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'451, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'451, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'451, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'451, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'451, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'451, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'451, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'451, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'451, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'451, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'451, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'451, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'451, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'451, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'454, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'454, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'454, statement_dangerous'nt => Some (exist _ Nis'455 (eq_refl _))
    | Ninit Nis'454, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'454, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'454, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'454, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'454, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'454, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'454, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'454, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'454, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'454, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'454, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'454, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'454, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'454, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'454, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'454, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'454, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'454, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'454, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'454, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'454, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'454, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'454, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'456, pointer'nt => Some (exist _ Nis'184 (eq_refl _))
    | Ninit Nis'456, init_declarator_list'nt => Some (exist _ Nis'457 (eq_refl _))
    | Ninit Nis'456, init_declarator'nt => Some (exist _ Nis'464 (eq_refl _))
    | Ninit Nis'456, direct_declarator'nt => Some (exist _ Nis'234 (eq_refl _))
    | Ninit Nis'456, declarator'nt => Some (exist _ Nis'461 (eq_refl _))
    | Ninit Nis'459, pointer'nt => Some (exist _ Nis'184 (eq_refl _))
    | Ninit Nis'459, init_declarator'nt => Some (exist _ Nis'460 (eq_refl _))
    | Ninit Nis'459, direct_declarator'nt => Some (exist _ Nis'234 (eq_refl _))
    | Ninit Nis'459, declarator'nt => Some (exist _ Nis'461 (eq_refl _))
    | Ninit Nis'462, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'462, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'462, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'462, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'462, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'462, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'462, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'462, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'462, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'462, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'462, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'462, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'462, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'462, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'462, c_initializer'nt => Some (exist _ Nis'463 (eq_refl _))
    | Ninit Nis'462, assignment_expression'nt => Some (exist _ Nis'296 (eq_refl _))
    | Ninit Nis'462, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'462, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'465, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'465, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'465, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'465, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'465, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'465, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'465, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'465, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'465, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'465, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'465, expression'nt => Some (exist _ Nis'472 (eq_refl _))
    | Ninit Nis'465, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'465, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'465, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'465, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'465, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'465, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'465, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'466, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'466, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'466, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'466, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'466, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'466, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'466, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'466, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'466, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'466, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'466, expression'nt => Some (exist _ Nis'469 (eq_refl _))
    | Ninit Nis'466, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'466, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'466, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'466, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'466, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'466, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'466, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'467, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'467, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'467, statement_dangerous'nt => Some (exist _ Nis'468 (eq_refl _))
    | Ninit Nis'467, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'467, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'467, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'467, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'467, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'467, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'467, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'467, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'467, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'467, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'467, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'467, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'467, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'467, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'467, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'467, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'467, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'467, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'467, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'467, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'467, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'467, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'467, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'470, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'470, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'470, statement_dangerous'nt => Some (exist _ Nis'471 (eq_refl _))
    | Ninit Nis'470, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'470, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'470, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'470, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'470, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'470, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'470, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'470, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'470, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'470, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'470, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'470, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'470, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'470, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'470, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'470, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'470, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'470, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'470, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'470, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'470, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'470, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'470, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'473, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'473, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'473, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'473, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'473, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'473, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'473, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'473, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'473, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'473, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'473, expression'nt => Some (exist _ Nis'476 (eq_refl _))
    | Ninit Nis'473, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'473, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'473, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'473, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'473, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'473, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'473, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'474, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'474, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'474, statement_dangerous'nt => Some (exist _ Nis'475 (eq_refl _))
    | Ninit Nis'474, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'474, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'474, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'474, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'474, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'474, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'474, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'474, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'474, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'474, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'474, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'474, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'474, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'474, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'474, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'474, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'474, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'474, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'474, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'474, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'474, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'474, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'474, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'477, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'477, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'477, statement_dangerous'nt => Some (exist _ Nis'478 (eq_refl _))
    | Ninit Nis'477, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'477, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'477, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'477, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'477, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'477, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'477, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'477, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'477, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'477, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'477, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'477, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'477, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'477, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'477, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'477, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'477, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'477, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'477, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'477, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'477, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'477, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'477, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'481, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'481, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'481, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'481, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'481, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'481, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'481, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'481, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'481, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'481, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'481, expression'nt => Some (exist _ Nis'482 (eq_refl _))
    | Ninit Nis'481, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'481, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'481, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'481, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'481, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'481, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'481, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'486, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'486, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'486, statement_safe'nt => Some (exist _ Nis'498 (eq_refl _))
    | Ninit Nis'486, statement_dangerous'nt => Some (exist _ Nis'423 (eq_refl _))
    | Ninit Nis'486, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'486, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'486, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'486, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'486, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'486, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'486, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'486, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'486, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'486, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'486, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'486, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'486, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'486, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'486, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'486, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'486, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'486, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'486, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'486, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'486, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'486, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'486, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'486, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'486, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'486, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'487, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'487, unary_expression'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'487, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'487, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'487, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'487, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'487, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'487, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'487, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'487, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'487, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'487, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'487, constant_expression'nt => Some (exist _ Nis'488 (eq_refl _))
    | Ninit Nis'487, conditional_expression'nt => Some (exist _ Nis'255 (eq_refl _))
    | Ninit Nis'487, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'487, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'487, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'489, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'489, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'489, statement_safe'nt => Some (exist _ Nis'490 (eq_refl _))
    | Ninit Nis'489, statement_dangerous'nt => Some (exist _ Nis'413 (eq_refl _))
    | Ninit Nis'489, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'489, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'489, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'489, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'489, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'489, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'489, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'489, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'489, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'489, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'489, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'489, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'489, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'489, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'489, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'489, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'489, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'489, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'489, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'489, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'489, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'489, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'489, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'489, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'489, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'489, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'501, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'501, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'501, statement_safe'nt => Some (exist _ Nis'502 (eq_refl _))
    | Ninit Nis'501, statement_dangerous'nt => Some (exist _ Nis'433 (eq_refl _))
    | Ninit Nis'501, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'501, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'501, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'501, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'501, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'501, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'501, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'501, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'501, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'501, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'501, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'501, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'501, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'501, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'501, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'501, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'501, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'501, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'501, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'501, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'501, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'501, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'501, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'501, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'501, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'501, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'504, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'504, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'504, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'504, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'504, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'504, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'504, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'504, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'504, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'504, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'504, expression'nt => Some (exist _ Nis'507 (eq_refl _))
    | Ninit Nis'504, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'504, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'504, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'504, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'504, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'504, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'504, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'505, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'505, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'505, statement_safe'nt => Some (exist _ Nis'506 (eq_refl _))
    | Ninit Nis'505, statement_dangerous'nt => Some (exist _ Nis'437 (eq_refl _))
    | Ninit Nis'505, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'505, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'505, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'505, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'505, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'505, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'505, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'505, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'505, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'505, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'505, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'505, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'505, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'505, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'505, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'505, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'505, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'505, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'505, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'505, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'505, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'505, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'505, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'505, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'505, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'505, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'508, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'508, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'508, statement_safe'nt => Some (exist _ Nis'509 (eq_refl _))
    | Ninit Nis'508, statement_dangerous'nt => Some (exist _ Nis'440 (eq_refl _))
    | Ninit Nis'508, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'508, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'508, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'508, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'508, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'508, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'508, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'508, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'508, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'508, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'508, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'508, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'508, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'508, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'508, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'508, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'508, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'508, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'508, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'508, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'508, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'508, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'508, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'508, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'508, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'508, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'511, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'511, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'511, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'511, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'511, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'511, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'511, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'511, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'511, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'511, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'511, expression'nt => Some (exist _ Nis'518 (eq_refl _))
    | Ninit Nis'511, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'511, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'511, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'511, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'511, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'511, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'511, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'512, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'512, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'512, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'512, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'512, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'512, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'512, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'512, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'512, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'512, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'512, expression'nt => Some (exist _ Nis'515 (eq_refl _))
    | Ninit Nis'512, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'512, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'512, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'512, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'512, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'512, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'512, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'513, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'513, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'513, statement_safe'nt => Some (exist _ Nis'514 (eq_refl _))
    | Ninit Nis'513, statement_dangerous'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'513, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'513, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'513, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'513, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'513, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'513, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'513, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'513, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'513, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'513, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'513, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'513, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'513, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'513, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'513, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'513, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'513, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'513, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'513, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'513, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'513, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'513, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'513, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'513, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'513, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'513, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'516, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'516, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'516, statement_safe'nt => Some (exist _ Nis'517 (eq_refl _))
    | Ninit Nis'516, statement_dangerous'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'516, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'516, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'516, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'516, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'516, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'516, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'516, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'516, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'516, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'516, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'516, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'516, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'516, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'516, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'516, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'516, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'516, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'516, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'516, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'516, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'516, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'516, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'516, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'516, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'516, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'516, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'519, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'519, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'519, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'519, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'519, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'519, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'519, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'519, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'519, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'519, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'519, expression'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'519, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'519, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'519, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'519, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'519, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'519, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'519, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'520, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'520, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'520, statement_safe'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'520, statement_dangerous'nt => Some (exist _ Nis'452 (eq_refl _))
    | Ninit Nis'520, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'520, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'520, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'520, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'520, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'520, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'520, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'520, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'520, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'520, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'520, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'520, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'520, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'520, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'520, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'520, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'520, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'520, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'520, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'520, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'520, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'520, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'520, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'520, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'520, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'520, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'523, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'523, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'523, statement_safe'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'523, statement_dangerous'nt => Some (exist _ Nis'455 (eq_refl _))
    | Ninit Nis'523, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'523, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'523, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'523, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'523, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'523, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'523, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'523, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'523, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'523, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'523, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'523, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'523, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'523, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'523, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'523, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'523, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'523, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'523, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'523, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'523, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'523, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'523, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'523, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'523, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'523, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'525, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'525, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'525, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'525, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'525, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'525, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'525, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'525, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'525, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'525, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'525, expression'nt => Some (exist _ Nis'532 (eq_refl _))
    | Ninit Nis'525, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'525, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'525, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'525, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'525, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'525, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'525, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'526, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'526, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'526, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'526, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'526, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'526, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'526, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'526, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'526, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'526, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'526, expression'nt => Some (exist _ Nis'529 (eq_refl _))
    | Ninit Nis'526, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'526, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'526, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'526, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'526, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'526, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'526, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'527, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'527, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'527, statement_safe'nt => Some (exist _ Nis'528 (eq_refl _))
    | Ninit Nis'527, statement_dangerous'nt => Some (exist _ Nis'468 (eq_refl _))
    | Ninit Nis'527, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'527, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'527, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'527, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'527, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'527, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'527, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'527, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'527, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'527, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'527, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'527, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'527, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'527, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'527, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'527, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'527, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'527, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'527, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'527, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'527, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'527, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'527, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'527, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'527, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'527, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'530, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'530, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'530, statement_safe'nt => Some (exist _ Nis'531 (eq_refl _))
    | Ninit Nis'530, statement_dangerous'nt => Some (exist _ Nis'471 (eq_refl _))
    | Ninit Nis'530, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'530, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'530, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'530, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'530, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'530, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'530, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'530, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'530, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'530, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'530, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'530, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'530, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'530, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'530, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'530, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'530, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'530, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'530, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'530, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'530, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'530, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'530, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'530, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'530, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'530, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'533, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'533, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'533, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'533, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'533, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'533, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'533, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'533, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'533, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'533, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'533, expression'nt => Some (exist _ Nis'536 (eq_refl _))
    | Ninit Nis'533, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'533, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'533, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'533, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'533, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'533, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'533, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'534, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'534, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'534, statement_safe'nt => Some (exist _ Nis'535 (eq_refl _))
    | Ninit Nis'534, statement_dangerous'nt => Some (exist _ Nis'475 (eq_refl _))
    | Ninit Nis'534, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'534, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'534, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'534, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'534, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'534, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'534, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'534, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'534, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'534, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'534, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'534, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'534, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'534, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'534, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'534, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'534, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'534, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'534, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'534, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'534, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'534, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'534, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'534, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'534, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'534, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'537, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'537, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'537, statement_safe'nt => Some (exist _ Nis'538 (eq_refl _))
    | Ninit Nis'537, statement_dangerous'nt => Some (exist _ Nis'478 (eq_refl _))
    | Ninit Nis'537, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'537, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'537, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'537, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'537, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'537, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'537, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'537, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'537, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'537, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'537, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'537, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'537, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'537, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'537, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'537, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'537, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'537, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'537, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'537, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'537, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'537, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'537, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'537, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'537, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'537, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'540, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'540, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'540, statement_safe'nt => Some (exist _ Nis'541 (eq_refl _))
    | Ninit Nis'540, statement_dangerous'nt => Some (exist _ Nis'542 (eq_refl _))
    | Ninit Nis'540, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'540, selection_statement_safe'nt => Some (exist _ Nis'491 (eq_refl _))
    | Ninit Nis'540, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'540, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'540, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'540, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'540, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'540, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'540, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'540, labeled_statement_statement_safe_'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'540, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'540, jump_statement'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'540, iteration_statement_statement_safe_'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'540, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'540, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'540, expression_statement'nt => Some (exist _ Nis'495 (eq_refl _))
    | Ninit Nis'540, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'540, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'540, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'540, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'540, compound_statement'nt => Some (exist _ Nis'496 (eq_refl _))
    | Ninit Nis'540, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'540, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'540, asm_statement'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'540, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'540, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'551, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'551, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'551, statement_dangerous'nt => Some (exist _ Nis'542 (eq_refl _))
    | Ninit Nis'551, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'551, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'551, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'551, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'551, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'551, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'551, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'551, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'551, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'551, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'551, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'551, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'551, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'551, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'551, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'551, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'551, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'551, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'551, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'551, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'551, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'551, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'551, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'556, unary_operator'nt => Some (exist _ Nis'63 (eq_refl _))
    | Ninit Nis'556, unary_expression'nt => Some (exist _ Nis'71 (eq_refl _))
    | Ninit Nis'556, type_specifier'nt => Some (exist _ Nis'191 (eq_refl _))
    | Ninit Nis'556, type_qualifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'556, struct_or_union_specifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'556, struct_or_union'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'556, storage_class_specifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'556, statement_dangerous'nt => Some (exist _ Nis'554 (eq_refl _))
    | Ninit Nis'556, shift_expression'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'556, selection_statement_dangerous'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'556, relational_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'556, primary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'556, postfix_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'556, multiplicative_expression'nt => Some (exist _ Nis'86 (eq_refl _))
    | Ninit Nis'556, logical_OR_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'556, logical_AND_expression'nt => Some (exist _ Nis'113 (eq_refl _))
    | Ninit Nis'556, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'556, jump_statement'nt => Some (exist _ Nis'416 (eq_refl _))
    | Ninit Nis'556, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'417 (eq_refl _))
    | Ninit Nis'556, inclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'556, function_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'556, expression_statement'nt => Some (exist _ Nis'418 (eq_refl _))
    | Ninit Nis'556, expression'nt => Some (exist _ Nis'419 (eq_refl _))
    | Ninit Nis'556, exclusive_OR_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'556, equality_expression'nt => Some (exist _ Nis'119 (eq_refl _))
    | Ninit Nis'556, enum_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'556, declaration_specifiers'nt => Some (exist _ Nis'456 (eq_refl _))
    | Ninit Nis'556, declaration'nt => Some (exist _ Nis'555 (eq_refl _))
    | Ninit Nis'556, conditional_expression'nt => Some (exist _ Nis'132 (eq_refl _))
    | Ninit Nis'556, compound_statement'nt => Some (exist _ Nis'421 (eq_refl _))
    | Ninit Nis'556, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'556, block_item'nt => Some (exist _ Nis'558 (eq_refl _))
    | Ninit Nis'556, attribute_specifier'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'556, assignment_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'556, asm_statement'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'556, additive_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'556, AND_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'563, attribute_specifier_list'nt => Some (exist _ Nis'243 (eq_refl _))
    | Ninit Nis'564, compound_statement'nt => Some (exist _ Nis'565 (eq_refl _))
    | _, _ => None
  end.

Definition past_symb_of_non_init_state (noninitstate:noninitstate) : list symbol :=
  match noninitstate with
    | Nis'1 => []
    | Nis'2 => []
    | Nis'3 => []
    | Nis'4 => []
    | Nis'5 => []
    | Nis'6 => []
    | Nis'7 => []
    | Nis'8 => []
    | Nis'9 => []
    | Nis'10 => []
    | Nis'11 => []
    | Nis'12 => []
    | Nis'13 => []
    | Nis'14 => []
    | Nis'15 => []
    | Nis'16 => [T PACKED't]
    | Nis'17 => []
    | Nis'18 => []
    | Nis'19 => []
    | Nis'20 => []
    | Nis'21 => []
    | Nis'22 => []
    | Nis'23 => []
    | Nis'24 => [T SIZEOF't]
    | Nis'25 => []
    | Nis'26 => []
    | Nis'27 => []
    | Nis'28 => []
    | Nis'29 => []
    | Nis'30 => []
    | Nis'31 => []
    | Nis'32 => [T ENUM't]
    | Nis'33 => [NT attribute_specifier_list'nt; T ENUM't]
    | Nis'34 => [T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'35 => []
    | Nis'36 => [T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'37 => [NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'38 => [NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'39 => [T COMMA't; NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'40 => [T COMMA't; NT enumerator_list'nt]
    | Nis'41 => []
    | Nis'42 => [NT enumeration_constant'nt]
    | Nis'43 => []
    | Nis'44 => []
    | Nis'45 => []
    | Nis'46 => [T BUILTIN_VA_ARG't]
    | Nis'47 => []
    | Nis'48 => []
    | Nis'49 => []
    | Nis'50 => [T ALIGNOF't]
    | Nis'51 => []
    | Nis'52 => []
    | Nis'53 => []
    | Nis'54 => []
    | Nis'55 => [T ATTRIBUTE't]
    | Nis'56 => [T LPAREN't; T ATTRIBUTE't]
    | Nis'57 => []
    | Nis'58 => []
    | Nis'59 => []
    | Nis'60 => []
    | Nis'61 => [NT gcc_attribute_word'nt]
    | Nis'62 => [T LPAREN't; NT gcc_attribute_word'nt]
    | Nis'63 => []
    | Nis'64 => []
    | Nis'65 => []
    | Nis'66 => []
    | Nis'67 => [NT postfix_expression'nt]
    | Nis'68 => [T PTR't; NT postfix_expression'nt]
    | Nis'69 => [NT postfix_expression'nt]
    | Nis'70 => [T LPAREN't; NT postfix_expression'nt]
    | Nis'71 => []
    | Nis'72 => []
    | Nis'73 => []
    | Nis'74 => []
    | Nis'75 => []
    | Nis'76 => []
    | Nis'77 => []
    | Nis'78 => []
    | Nis'79 => []
    | Nis'80 => []
    | Nis'81 => []
    | Nis'82 => []
    | Nis'83 => [NT unary_expression'nt]
    | Nis'84 => []
    | Nis'85 => [NT shift_expression'nt]
    | Nis'86 => []
    | Nis'87 => [NT multiplicative_expression'nt]
    | Nis'88 => [T STAR't; NT multiplicative_expression'nt]
    | Nis'89 => [NT multiplicative_expression'nt]
    | Nis'90 => [T SLASH't; NT multiplicative_expression'nt]
    | Nis'91 => [NT multiplicative_expression'nt]
    | Nis'92 => [T PERCENT't; NT multiplicative_expression'nt]
    | Nis'93 => []
    | Nis'94 => [T RIGHT't; NT shift_expression'nt]
    | Nis'95 => [NT additive_expression'nt]
    | Nis'96 => [T PLUS't; NT additive_expression'nt]
    | Nis'97 => [NT additive_expression'nt]
    | Nis'98 => [T MINUS't; NT additive_expression'nt]
    | Nis'99 => [NT shift_expression'nt]
    | Nis'100 => [T LEFT't; NT shift_expression'nt]
    | Nis'101 => []
    | Nis'102 => [NT relational_expression'nt]
    | Nis'103 => [T LT't; NT relational_expression'nt]
    | Nis'104 => []
    | Nis'105 => [NT relational_expression'nt]
    | Nis'106 => [T LEQ't; NT relational_expression'nt]
    | Nis'107 => [NT relational_expression'nt]
    | Nis'108 => [T GT't; NT relational_expression'nt]
    | Nis'109 => [NT relational_expression'nt]
    | Nis'110 => [T GEQ't; NT relational_expression'nt]
    | Nis'111 => []
    | Nis'112 => [NT logical_OR_expression'nt]
    | Nis'113 => []
    | Nis'114 => [NT logical_AND_expression'nt]
    | Nis'115 => [T ANDAND't; NT logical_AND_expression'nt]
    | Nis'116 => [NT inclusive_OR_expression'nt]
    | Nis'117 => [T BAR't; NT inclusive_OR_expression'nt]
    | Nis'118 => [NT exclusive_OR_expression'nt]
    | Nis'119 => []
    | Nis'120 => [NT equality_expression'nt]
    | Nis'121 => [T NEQ't; NT equality_expression'nt]
    | Nis'122 => [NT equality_expression'nt]
    | Nis'123 => [T EQEQ't; NT equality_expression'nt]
    | Nis'124 => [T HAT't; NT exclusive_OR_expression'nt]
    | Nis'125 => [NT AND_expression'nt]
    | Nis'126 => [T AND't; NT AND_expression'nt]
    | Nis'127 => []
    | Nis'128 => []
    | Nis'129 => []
    | Nis'130 => [T QUESTION't; NT logical_OR_expression'nt]
    | Nis'131 => [NT expression'nt]
    | Nis'132 => []
    | Nis'133 => [T COMMA't; NT expression'nt]
    | Nis'134 => [NT expression'nt; T QUESTION't; NT logical_OR_expression'nt]
    | Nis'135 => [T COLON't; NT expression'nt; T QUESTION't; NT logical_OR_expression'nt]
    | Nis'136 => []
    | Nis'137 => [NT logical_OR_expression'nt]
    | Nis'138 => [T BARBAR't; NT logical_OR_expression'nt]
    | Nis'139 => [NT assignment_operator'nt; NT unary_expression'nt]
    | Nis'140 => []
    | Nis'141 => [T LPAREN't; NT postfix_expression'nt]
    | Nis'142 => [NT argument_expression_list'nt; T LPAREN't; NT postfix_expression'nt]
    | Nis'143 => [NT argument_expression_list'nt]
    | Nis'144 => [T COMMA't; NT argument_expression_list'nt]
    | Nis'145 => [NT postfix_expression'nt]
    | Nis'146 => [T LBRACK't; NT postfix_expression'nt]
    | Nis'147 => [NT expression'nt; T LBRACK't; NT postfix_expression'nt]
    | Nis'148 => [NT postfix_expression'nt]
    | Nis'149 => [NT postfix_expression'nt]
    | Nis'150 => [T DOT't; NT postfix_expression'nt]
    | Nis'151 => [NT postfix_expression'nt]
    | Nis'152 => [NT unary_operator'nt]
    | Nis'153 => [T LPAREN't; NT gcc_attribute_word'nt]
    | Nis'154 => [NT argument_expression_list'nt; T LPAREN't; NT gcc_attribute_word'nt]
    | Nis'155 => [T LPAREN't; T LPAREN't; T ATTRIBUTE't]
    | Nis'156 => [NT gcc_attribute_list'nt; T LPAREN't; T LPAREN't; T ATTRIBUTE't]
    | Nis'157 => [T RPAREN't; NT gcc_attribute_list'nt; T LPAREN't; T LPAREN't; T ATTRIBUTE't]
    | Nis'158 => [NT gcc_attribute_list'nt]
    | Nis'159 => [T COMMA't; NT gcc_attribute_list'nt]
    | Nis'160 => []
    | Nis'161 => []
    | Nis'162 => [T ALIGNAS't]
    | Nis'163 => []
    | Nis'164 => []
    | Nis'165 => []
    | Nis'166 => []
    | Nis'167 => [NT struct_or_union'nt]
    | Nis'168 => [NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'169 => [T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'170 => [T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'171 => [NT struct_declaration_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'172 => [NT struct_declaration_list'nt]
    | Nis'173 => []
    | Nis'174 => []
    | Nis'175 => []
    | Nis'176 => [T STAR't]
    | Nis'177 => [NT type_qualifier_list'nt]
    | Nis'178 => [NT type_qualifier_list'nt; T STAR't]
    | Nis'179 => []
    | Nis'180 => []
    | Nis'181 => [T STAR't]
    | Nis'182 => [NT specifier_qualifier_list'nt]
    | Nis'183 => []
    | Nis'184 => []
    | Nis'185 => [NT pointer'nt]
    | Nis'186 => [NT direct_declarator'nt]
    | Nis'187 => [T LPAREN't; NT direct_declarator'nt]
    | Nis'188 => []
    | Nis'189 => []
    | Nis'190 => []
    | Nis'191 => []
    | Nis'192 => []
    | Nis'193 => []
    | Nis'194 => []
    | Nis'195 => []
    | Nis'196 => [NT function_specifier'nt]
    | Nis'197 => [NT storage_class_specifier'nt]
    | Nis'198 => [NT type_qualifier'nt]
    | Nis'199 => [NT type_specifier'nt]
    | Nis'200 => [T LPAREN't; NT direct_declarator'nt]
    | Nis'201 => [NT parameter_type_list'nt; T LPAREN't; NT direct_declarator'nt]
    | Nis'202 => []
    | Nis'203 => [NT parameter_list'nt]
    | Nis'204 => [T COMMA't; NT parameter_list'nt]
    | Nis'205 => [T COMMA't; NT parameter_list'nt]
    | Nis'206 => []
    | Nis'207 => []
    | Nis'208 => [T LPAREN't]
    | Nis'209 => []
    | Nis'210 => [T LBRACK't]
    | Nis'211 => [T LBRACK't]
    | Nis'212 => [NT type_qualifier_list'nt; T LBRACK't]
    | Nis'213 => [NT type_qualifier_list'nt; T LBRACK't]
    | Nis'214 => [NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't]
    | Nis'215 => [T LBRACK't]
    | Nis'216 => [NT assignment_expression'nt; T LBRACK't]
    | Nis'217 => []
    | Nis'218 => [NT pointer'nt]
    | Nis'219 => [NT direct_abstract_declarator'nt]
    | Nis'220 => [T LPAREN't; NT direct_abstract_declarator'nt]
    | Nis'221 => [T LPAREN't; NT direct_abstract_declarator'nt]
    | Nis'222 => [NT parameter_type_list'nt; T LPAREN't; NT direct_abstract_declarator'nt]
    | Nis'223 => []
    | Nis'224 => [NT direct_abstract_declarator'nt]
    | Nis'225 => [T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'226 => [T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'227 => [NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'228 => [NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'229 => [NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'230 => [T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'231 => [NT assignment_expression'nt; T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'232 => [T LPAREN't]
    | Nis'233 => [NT parameter_type_list'nt; T LPAREN't]
    | Nis'234 => []
    | Nis'235 => [NT direct_declarator'nt]
    | Nis'236 => [T LBRACK't; NT direct_declarator'nt]
    | Nis'237 => [T LBRACK't; NT direct_declarator'nt]
    | Nis'238 => [NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt]
    | Nis'239 => [NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt]
    | Nis'240 => [NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt]
    | Nis'241 => [T LBRACK't; NT direct_declarator'nt]
    | Nis'242 => [NT assignment_expression'nt; T LBRACK't; NT direct_declarator'nt]
    | Nis'243 => [NT direct_declarator'nt]
    | Nis'244 => [NT attribute_specifier_list'nt]
    | Nis'245 => []
    | Nis'246 => [T LPAREN't]
    | Nis'247 => [NT declarator'nt; T LPAREN't]
    | Nis'248 => [T LPAREN't]
    | Nis'249 => [NT abstract_declarator'nt; T LPAREN't]
    | Nis'250 => [NT declaration_specifiers'nt]
    | Nis'251 => [NT declaration_specifiers'nt]
    | Nis'252 => [NT direct_declarator'nt; NT pointer'nt]
    | Nis'253 => []
    | Nis'254 => [T COLON't]
    | Nis'255 => []
    | Nis'256 => [NT specifier_qualifier_list'nt]
    | Nis'257 => [NT struct_declarator_list'nt; NT specifier_qualifier_list'nt]
    | Nis'258 => [NT struct_declarator_list'nt]
    | Nis'259 => [T COMMA't; NT struct_declarator_list'nt]
    | Nis'260 => []
    | Nis'261 => [NT declarator'nt]
    | Nis'262 => [T COLON't; NT declarator'nt]
    | Nis'263 => []
    | Nis'264 => [NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'265 => [T LBRACE't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'266 => [NT struct_declaration_list'nt; T LBRACE't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'267 => [NT type_qualifier'nt]
    | Nis'268 => [NT type_specifier'nt]
    | Nis'269 => [T LPAREN't; T ALIGNAS't]
    | Nis'270 => [NT type_name'nt; T LPAREN't; T ALIGNAS't]
    | Nis'271 => []
    | Nis'272 => []
    | Nis'273 => []
    | Nis'274 => [NT specifier_qualifier_list'nt]
    | Nis'275 => [T LPAREN't; T ALIGNAS't]
    | Nis'276 => [NT argument_expression_list'nt; T LPAREN't; T ALIGNAS't]
    | Nis'277 => [T LPAREN't; T ALIGNOF't]
    | Nis'278 => [NT type_name'nt; T LPAREN't; T ALIGNOF't]
    | Nis'279 => [T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'280 => []
    | Nis'281 => [T LBRACK't]
    | Nis'282 => [NT constant_expression'nt; T LBRACK't]
    | Nis'283 => []
    | Nis'284 => []
    | Nis'285 => [T DOT't]
    | Nis'286 => [T LBRACE't]
    | Nis'287 => [NT initializer_list'nt; T LBRACE't]
    | Nis'288 => [NT initializer_list'nt; T LBRACE't]
    | Nis'289 => [T COMMA't; NT initializer_list'nt; T LBRACE't]
    | Nis'290 => []
    | Nis'291 => [NT designator_list'nt]
    | Nis'292 => [NT designator_list'nt]
    | Nis'293 => []
    | Nis'294 => [T COMMA't; NT initializer_list'nt]
    | Nis'295 => [NT designation'nt; T COMMA't; NT initializer_list'nt]
    | Nis'296 => []
    | Nis'297 => [T COMMA't; NT initializer_list'nt]
    | Nis'298 => []
    | Nis'299 => [NT designation'nt]
    | Nis'300 => []
    | Nis'301 => [T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'302 => [NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'303 => [NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'304 => [T COMMA't; NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'305 => [T LPAREN't]
    | Nis'306 => [NT expression'nt; T LPAREN't]
    | Nis'307 => [T ALIGNOF't]
    | Nis'308 => [T LPAREN't; T BUILTIN_VA_ARG't]
    | Nis'309 => [NT assignment_expression'nt; T LPAREN't; T BUILTIN_VA_ARG't]
    | Nis'310 => [T COMMA't; NT assignment_expression'nt; T LPAREN't; T BUILTIN_VA_ARG't]
    | Nis'311 => [NT type_name'nt; T COMMA't; NT assignment_expression'nt; T LPAREN't; T BUILTIN_VA_ARG't]
    | Nis'312 => [T DEC't]
    | Nis'313 => [T EQ't; NT enumeration_constant'nt]
    | Nis'314 => []
    | Nis'315 => [NT attribute_specifier_list'nt; T ENUM't]
    | Nis'316 => [T LBRACE't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'317 => [NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'318 => [NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'319 => [T COMMA't; NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'320 => [T LPAREN't]
    | Nis'321 => [NT type_name'nt; T LPAREN't]
    | Nis'322 => [T INC't]
    | Nis'323 => [T LPAREN't]
    | Nis'324 => [NT type_name'nt; T LPAREN't]
    | Nis'325 => [T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'326 => [T LPAREN't; T SIZEOF't]
    | Nis'327 => [NT type_name'nt; T LPAREN't; T SIZEOF't]
    | Nis'328 => [T SIZEOF't]
    | Nis'329 => [T LPAREN't; T PACKED't]
    | Nis'330 => [NT argument_expression_list'nt; T LPAREN't; T PACKED't]
    | Nis'331 => []
    | Nis'333 => []
    | Nis'334 => [NT translation_unit'nt]
    | Nis'335 => []
    | Nis'336 => [NT translation_unit'nt]
    | Nis'337 => []
    | Nis'338 => [NT declaration_specifiers'nt]
    | Nis'339 => []
    | Nis'340 => [NT pointer'nt]
    | Nis'341 => [NT pointer'nt]
    | Nis'342 => [NT direct_declarator'nt]
    | Nis'343 => []
    | Nis'344 => [T LPAREN't; NT direct_declarator'nt]
    | Nis'345 => [NT identifier_list'nt; T LPAREN't; NT direct_declarator'nt]
    | Nis'346 => [NT identifier_list'nt]
    | Nis'347 => [T COMMA't; NT identifier_list'nt]
    | Nis'348 => [NT declaration_specifiers'nt]
    | Nis'349 => [NT old_function_declarator'nt; NT declaration_specifiers'nt]
    | Nis'350 => []
    | Nis'351 => []
    | Nis'352 => [T WHILE't]
    | Nis'353 => [T LPAREN't; T WHILE't]
    | Nis'354 => [NT expression'nt; T LPAREN't; T WHILE't]
    | Nis'355 => []
    | Nis'356 => [T SWITCH't]
    | Nis'357 => [T LPAREN't; T SWITCH't]
    | Nis'358 => [NT expression'nt; T LPAREN't; T SWITCH't]
    | Nis'359 => []
    | Nis'360 => []
    | Nis'361 => [T RETURN't]
    | Nis'362 => [T RETURN't]
    | Nis'363 => [NT expression'nt; T RETURN't]
    | Nis'364 => []
    | Nis'365 => [T OTHER_NAME't]
    | Nis'366 => []
    | Nis'367 => [T IF't]
    | Nis'368 => [T LPAREN't; T IF't]
    | Nis'369 => [NT expression'nt; T LPAREN't; T IF't]
    | Nis'370 => []
    | Nis'371 => [T WHILE't]
    | Nis'372 => [T LPAREN't; T WHILE't]
    | Nis'373 => [NT expression'nt; T LPAREN't; T WHILE't]
    | Nis'374 => []
    | Nis'375 => [T SWITCH't]
    | Nis'376 => [T LPAREN't; T SWITCH't]
    | Nis'377 => [NT expression'nt; T LPAREN't; T SWITCH't]
    | Nis'378 => []
    | Nis'379 => [T OTHER_NAME't]
    | Nis'380 => []
    | Nis'381 => [T IF't]
    | Nis'382 => [T LPAREN't; T IF't]
    | Nis'383 => [NT expression'nt; T LPAREN't; T IF't]
    | Nis'384 => []
    | Nis'385 => [T GOTO't]
    | Nis'386 => [T OTHER_NAME't; T GOTO't]
    | Nis'387 => []
    | Nis'388 => [T FOR't]
    | Nis'389 => [T LPAREN't; T FOR't]
    | Nis'390 => [T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'391 => [T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'392 => []
    | Nis'393 => []
    | Nis'394 => [T FOR't]
    | Nis'395 => [T LPAREN't; T FOR't]
    | Nis'396 => [T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'397 => [T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'398 => []
    | Nis'399 => []
    | Nis'400 => [T DEFAULT't]
    | Nis'401 => []
    | Nis'402 => [T CONTINUE't]
    | Nis'403 => []
    | Nis'404 => [T CASE't]
    | Nis'405 => [NT constant_expression'nt; T CASE't]
    | Nis'406 => []
    | Nis'407 => [T BREAK't]
    | Nis'408 => []
    | Nis'409 => [T ASM't]
    | Nis'410 => [T LPAREN't; T ASM't]
    | Nis'411 => [T STRING_LITERAL't; T LPAREN't; T ASM't]
    | Nis'412 => [T RPAREN't; T STRING_LITERAL't; T LPAREN't; T ASM't]
    | Nis'413 => [T COLON't; NT constant_expression'nt; T CASE't]
    | Nis'414 => []
    | Nis'415 => []
    | Nis'416 => []
    | Nis'417 => []
    | Nis'418 => []
    | Nis'419 => []
    | Nis'420 => [NT expression'nt]
    | Nis'421 => []
    | Nis'422 => []
    | Nis'423 => [T COLON't; T DEFAULT't]
    | Nis'424 => [T DO't]
    | Nis'425 => [NT statement_dangerous'nt; T DO't]
    | Nis'426 => [T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'427 => [T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'428 => [NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'429 => [T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'430 => [T RPAREN't; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'431 => [T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'432 => [NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'433 => [T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'434 => [T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'435 => [NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'436 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'437 => [T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'438 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'439 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'440 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'441 => [T LPAREN't; T FOR't]
    | Nis'442 => [NT expression'nt; T LPAREN't; T FOR't]
    | Nis'443 => [T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'444 => [T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'445 => [T RPAREN't; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'446 => [T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'447 => [NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'448 => [T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'449 => [T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'450 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'451 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'452 => [T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'453 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'454 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'455 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'456 => []
    | Nis'457 => [NT declaration_specifiers'nt]
    | Nis'458 => [NT init_declarator_list'nt; NT declaration_specifiers'nt]
    | Nis'459 => [NT init_declarator_list'nt]
    | Nis'460 => [T COMMA't; NT init_declarator_list'nt]
    | Nis'461 => []
    | Nis'462 => [NT declarator'nt]
    | Nis'463 => [T EQ't; NT declarator'nt]
    | Nis'464 => []
    | Nis'465 => [T LPAREN't; T FOR't]
    | Nis'466 => [NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'467 => [T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'468 => [T RPAREN't; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'469 => [T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'470 => [NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'471 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'472 => [NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'473 => [NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'474 => [T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'475 => [T RPAREN't; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'476 => [T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'477 => [NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'478 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'479 => [T DO't]
    | Nis'480 => [NT statement_dangerous'nt; T DO't]
    | Nis'481 => [T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'482 => [T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'483 => [NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'484 => [T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'485 => []
    | Nis'486 => [T DEFAULT't]
    | Nis'487 => []
    | Nis'488 => [T CASE't]
    | Nis'489 => [NT constant_expression'nt; T CASE't]
    | Nis'490 => [T COLON't; NT constant_expression'nt; T CASE't]
    | Nis'491 => []
    | Nis'492 => []
    | Nis'493 => []
    | Nis'494 => []
    | Nis'495 => []
    | Nis'496 => []
    | Nis'497 => []
    | Nis'498 => [T COLON't; T DEFAULT't]
    | Nis'499 => [T RPAREN't; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'500 => [T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'501 => [NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'502 => [T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'503 => [T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'504 => [NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'505 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'506 => [T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'507 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'508 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'509 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'510 => [T LPAREN't; T FOR't]
    | Nis'511 => [NT expression'nt; T LPAREN't; T FOR't]
    | Nis'512 => [T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'513 => [T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'514 => [T RPAREN't; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'515 => [T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'516 => [NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'517 => [T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'518 => [T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'519 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'520 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'521 => [T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'522 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'523 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'524 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'525 => [T LPAREN't; T FOR't]
    | Nis'526 => [NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'527 => [T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'528 => [T RPAREN't; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'529 => [T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'530 => [NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'531 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'532 => [NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'533 => [NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'534 => [T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'535 => [T RPAREN't; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'536 => [T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'537 => [NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'538 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'539 => [T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'540 => [NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'541 => [T ELSE't; NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'542 => [T ELSE't; NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'543 => [T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'544 => [T COLON't; T OTHER_NAME't]
    | Nis'545 => [T COLON't; T OTHER_NAME't]
    | Nis'546 => [T RPAREN't; NT expression'nt; T LPAREN't; T SWITCH't]
    | Nis'547 => [T RPAREN't; NT expression'nt; T LPAREN't; T SWITCH't]
    | Nis'548 => [T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't]
    | Nis'549 => [T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't]
    | Nis'550 => [T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'551 => [NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'552 => [T LBRACE't]
    | Nis'553 => []
    | Nis'554 => []
    | Nis'555 => []
    | Nis'556 => [T LBRACE't]
    | Nis'557 => [NT block_item_list'nt; T LBRACE't]
    | Nis'558 => [NT block_item_list'nt]
    | Nis'559 => []
    | Nis'560 => [NT declaration_list'nt]
    | Nis'561 => [NT declaration_list'nt; NT old_function_declarator'nt; NT declaration_specifiers'nt]
    | Nis'562 => []
    | Nis'563 => []
    | Nis'564 => [NT declaration_specifiers'nt]
    | Nis'565 => [NT declarator'nt; NT declaration_specifiers'nt]
    | Nis'566 => []
    | Nis'567 => []
  end.
Extract Constant past_symb_of_non_init_state => "fun _ -> assert false".

Definition past_state_of_non_init_state (s:noninitstate) : list (state -> bool) :=
  match s with
    | Nis'1 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'2 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'3 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'4 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'5 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'6 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'7 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'8 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'9 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'10 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'11 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'12 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'13 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'14 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'15 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'16 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'15 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'17 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'18 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'19 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'20 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'21 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'22 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'23 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'24 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'21 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'25 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'26 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'27 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'28 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'29 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'28 | Ninit Nis'43 => true
            | _ => false
          end ]
    | Nis'30 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'31 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'32 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'33 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'34 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'35 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'34 | Ninit Nis'38 | Ninit Nis'315 | Ninit Nis'318 => true
            | _ => false
          end ]
    | Nis'36 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'37 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'36 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'38 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'36 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'39 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'38 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'36 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'40 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'38 | Ninit Nis'318 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'36 | Ninit Nis'316 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 | Ninit Nis'315 => true
            | _ => false
          end ]
    | Nis'41 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'34 | Ninit Nis'38 | Ninit Nis'315 | Ninit Nis'318 => true
            | _ => false
          end ]
    | Nis'42 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'41 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 | Ninit Nis'38 | Ninit Nis'315 | Ninit Nis'318 => true
            | _ => false
          end ]
    | Nis'43 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'44 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'45 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'46 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'45 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'47 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'48 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'49 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'50 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'49 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'51 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'52 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'53 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'54 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'55 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'54 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'56 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'54 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'57 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'56 | Ninit Nis'158 => true
            | _ => false
          end ]
    | Nis'58 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'56 | Ninit Nis'158 => true
            | _ => false
          end ]
    | Nis'59 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'56 | Ninit Nis'158 => true
            | _ => false
          end ]
    | Nis'60 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'56 | Ninit Nis'158 => true
            | _ => false
          end ]
    | Nis'61 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'60 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 | Ninit Nis'158 => true
            | _ => false
          end ]
    | Nis'62 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'61 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'60 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 | Ninit Nis'158 => true
            | _ => false
          end ]
    | Nis'63 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'64 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'42 | Ninit Nis'63 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'280 | Ninit Nis'324 | Ninit Nis'403 | Ninit Nis'487 => true
            | _ => false
          end ]
    | Nis'65 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'66 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'67 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'68 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'69 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'70 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'69 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'71 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'72 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'73 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'74 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'75 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'76 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'77 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'78 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'79 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'80 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'81 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'82 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end ]
    | Nis'83 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'84 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'85 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'86 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'87 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'88 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'87 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'89 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'90 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'89 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'91 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'92 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'91 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'93 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'94 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'85 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'95 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'94 | Ninit Nis'100 | Ninit Nis'104 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'96 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'95 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'94 | Ninit Nis'100 | Ninit Nis'104 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'97 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'94 | Ninit Nis'100 | Ninit Nis'104 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'98 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'97 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'94 | Ninit Nis'100 | Ninit Nis'104 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'99 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'100 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'99 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'101 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'102 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'101 | Ninit Nis'121 | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'103 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'102 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'101 | Ninit Nis'121 | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'104 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'105 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'101 | Ninit Nis'121 | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'106 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'105 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'101 | Ninit Nis'121 | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'107 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'101 | Ninit Nis'121 | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'108 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'107 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'101 | Ninit Nis'121 | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'109 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'101 | Ninit Nis'121 | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'110 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'109 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'101 | Ninit Nis'121 | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'111 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'112 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'113 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'114 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'113 | Ninit Nis'138 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'115 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'114 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'113 | Ninit Nis'138 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'116 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'115 | Ninit Nis'129 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'117 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'116 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'115 | Ninit Nis'129 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'118 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'117 | Ninit Nis'128 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'119 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'120 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'119 | Ninit Nis'126 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'121 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'120 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'119 | Ninit Nis'126 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'122 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'119 | Ninit Nis'126 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'123 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'122 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'119 | Ninit Nis'126 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'124 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'118 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'117 | Ninit Nis'128 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'125 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'124 | Ninit Nis'127 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'126 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'125 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'124 | Ninit Nis'127 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'127 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'128 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'129 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'130 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'131 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'130 | Ninit Nis'146 | Ninit Nis'305 | Ninit Nis'353 | Ninit Nis'357 | Ninit Nis'362 | Ninit Nis'368 | Ninit Nis'372 | Ninit Nis'376 | Ninit Nis'382 | Ninit Nis'419 | Ninit Nis'427 | Ninit Nis'431 | Ninit Nis'434 | Ninit Nis'438 | Ninit Nis'441 | Ninit Nis'446 | Ninit Nis'449 | Ninit Nis'453 | Ninit Nis'469 | Ninit Nis'472 | Ninit Nis'476 | Ninit Nis'482 | Ninit Nis'500 | Ninit Nis'503 | Ninit Nis'507 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'522 | Ninit Nis'529 | Ninit Nis'532 | Ninit Nis'536 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'112 | Ninit Nis'145 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'132 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'133 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'131 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'130 | Ninit Nis'146 | Ninit Nis'305 | Ninit Nis'353 | Ninit Nis'357 | Ninit Nis'362 | Ninit Nis'368 | Ninit Nis'372 | Ninit Nis'376 | Ninit Nis'382 | Ninit Nis'419 | Ninit Nis'427 | Ninit Nis'431 | Ninit Nis'434 | Ninit Nis'438 | Ninit Nis'441 | Ninit Nis'446 | Ninit Nis'449 | Ninit Nis'453 | Ninit Nis'469 | Ninit Nis'472 | Ninit Nis'476 | Ninit Nis'482 | Ninit Nis'500 | Ninit Nis'503 | Ninit Nis'507 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'522 | Ninit Nis'529 | Ninit Nis'532 | Ninit Nis'536 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'112 | Ninit Nis'145 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'134 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'130 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'135 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'134 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'130 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'136 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'112 | Ninit Nis'145 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'137 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'138 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'137 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'139 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'83 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'71 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'112 | Ninit Nis'131 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'140 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'162 => true
            | _ => false
          end ]
    | Nis'141 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'69 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'142 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'141 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'69 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'143 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'141 | Ninit Nis'153 | Ninit Nis'275 | Ninit Nis'329 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'162 => true
            | _ => false
          end ]
    | Nis'144 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'143 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'141 | Ninit Nis'153 | Ninit Nis'275 | Ninit Nis'329 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'61 | Ninit Nis'69 | Ninit Nis'162 => true
            | _ => false
          end ]
    | Nis'145 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'146 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'145 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'147 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'146 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'145 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'148 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'149 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'150 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'149 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'151 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'66 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'152 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'63 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'153 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'61 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'60 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 | Ninit Nis'158 => true
            | _ => false
          end ]
    | Nis'154 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'153 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'61 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'60 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 | Ninit Nis'158 => true
            | _ => false
          end ]
    | Nis'155 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'54 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'156 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'155 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'54 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'157 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'156 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'155 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'54 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'158 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'155 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end ]
    | Nis'159 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'158 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'155 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end ]
    | Nis'160 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end ]
    | Nis'161 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'162 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'161 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'163 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'265 | Ninit Nis'309 => true
            | _ => false
          end ]
    | Nis'164 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'265 | Ninit Nis'309 => true
            | _ => false
          end ]
    | Nis'165 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'166 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'167 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'166 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'168 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'166 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'169 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'166 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'170 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'169 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'166 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'171 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'170 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'169 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'166 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'172 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'170 | Ninit Nis'265 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'169 | Ninit Nis'264 => true
            | _ => false
          end ]
    | Nis'173 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'170 | Ninit Nis'265 => true
            | _ => false
          end ]
    | Nis'174 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'175 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'183 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'258 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'337 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'176 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'175 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'183 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'258 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'337 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'177 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'176 | Ninit Nis'211 | Ninit Nis'226 | Ninit Nis'237 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'175 | Ninit Nis'209 | Ninit Nis'224 | Ninit Nis'235 => true
            | _ => false
          end ]
    | Nis'178 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'176 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'175 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'183 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'258 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'337 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'179 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'180 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'175 | Ninit Nis'209 | Ninit Nis'224 | Ninit Nis'235 => true
            | _ => false
          end ]
    | Nis'181 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'175 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'183 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'258 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'337 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'182 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'170 | Ninit Nis'265 => true
            | _ => false
          end ]
    | Nis'183 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'184 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'258 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'185 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'184 | Ninit Nis'217 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'258 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'186 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'187 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'342 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'188 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'189 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'190 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'191 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'192 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'193 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'194 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'195 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'196 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'194 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'197 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'193 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'198 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'192 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'199 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'191 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'200 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'342 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'201 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'200 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'342 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'202 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'203 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'202 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'204 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'203 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'202 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'205 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'203 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'202 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'206 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'207 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 => true
            | _ => false
          end ]
    | Nis'208 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'272 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'209 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'210 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'209 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'211 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'209 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'212 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'211 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'209 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'213 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'211 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'209 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'214 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'213 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'211 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'209 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'215 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'209 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'216 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'215 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'209 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'217 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 => true
            | _ => false
          end ]
    | Nis'218 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'217 | Ninit Nis'273 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'271 | Ninit Nis'272 => true
            | _ => false
          end ]
    | Nis'219 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'220 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'219 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'221 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'219 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'222 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'221 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'223 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'224 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'225 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'224 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'226 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'224 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'227 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'226 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'224 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'228 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'226 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'224 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'229 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'228 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'226 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'224 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'230 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'224 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'231 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'230 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'224 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'245 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'232 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'272 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'233 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'232 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'272 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'234 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'258 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'235 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'236 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'235 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'237 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'235 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'238 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'237 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'235 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'239 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'237 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'235 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'240 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'239 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'237 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'235 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'241 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'235 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'242 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'241 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'235 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'243 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'234 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'244 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'32 | Ninit Nis'167 | Ninit Nis'243 | Ninit Nis'252 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 | Ninit Nis'166 | Ninit Nis'185 | Ninit Nis'234 | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end ]
    | Nis'245 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'271 | Ninit Nis'272 => true
            | _ => false
          end ]
    | Nis'246 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'183 | Ninit Nis'207 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'247 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'183 | Ninit Nis'207 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'184 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'339 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'248 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'272 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'249 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'248 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'272 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'217 | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'250 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'206 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'251 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'206 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'272 | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'252 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'341 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'184 | Ninit Nis'217 | Ninit Nis'339 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'183 | Ninit Nis'206 | Ninit Nis'207 | Ninit Nis'258 | Ninit Nis'337 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'253 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'258 => true
            | _ => false
          end ]
    | Nis'254 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'253 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'258 => true
            | _ => false
          end ]
    | Nis'255 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'42 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'280 | Ninit Nis'403 | Ninit Nis'487 => true
            | _ => false
          end ]
    | Nis'256 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'170 | Ninit Nis'265 => true
            | _ => false
          end ]
    | Nis'257 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'256 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'170 | Ninit Nis'265 => true
            | _ => false
          end ]
    | Nis'258 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'256 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 => true
            | _ => false
          end ]
    | Nis'259 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'258 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'256 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 => true
            | _ => false
          end ]
    | Nis'260 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'258 => true
            | _ => false
          end ]
    | Nis'261 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'260 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'258 => true
            | _ => false
          end ]
    | Nis'262 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'261 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'260 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'173 | Ninit Nis'258 => true
            | _ => false
          end ]
    | Nis'263 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'173 => true
            | _ => false
          end ]
    | Nis'264 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'166 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'265 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'264 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'166 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'266 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'265 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'264 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'166 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'267 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'164 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'265 | Ninit Nis'309 => true
            | _ => false
          end ]
    | Nis'268 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'163 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'265 | Ninit Nis'309 => true
            | _ => false
          end ]
    | Nis'269 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'161 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'270 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'269 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'161 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'271 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'309 => true
            | _ => false
          end ]
    | Nis'272 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'271 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'273 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'271 | Ninit Nis'272 => true
            | _ => false
          end ]
    | Nis'274 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'271 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'309 => true
            | _ => false
          end ]
    | Nis'275 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'161 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'276 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'275 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'161 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'277 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'49 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'278 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'277 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'49 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'279 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'277 | Ninit Nis'320 | Ninit Nis'323 | Ninit Nis'326 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'280 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'290 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'281 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'290 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'282 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'281 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'290 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'283 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'462 => true
            | _ => false
          end ]
    | Nis'284 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'290 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'285 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'284 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'290 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'286 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'283 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'462 => true
            | _ => false
          end ]
    | Nis'287 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'286 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'283 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'462 => true
            | _ => false
          end ]
    | Nis'288 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'286 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'283 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'462 => true
            | _ => false
          end ]
    | Nis'289 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'288 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'286 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'283 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'462 => true
            | _ => false
          end ]
    | Nis'290 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'291 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'290 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'292 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'290 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'293 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'303 => true
            | _ => false
          end ]
    | Nis'294 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'288 | Ninit Nis'303 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'286 | Ninit Nis'301 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 => true
            | _ => false
          end ]
    | Nis'295 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'294 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'288 | Ninit Nis'303 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'286 | Ninit Nis'301 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 => true
            | _ => false
          end ]
    | Nis'296 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'462 => true
            | _ => false
          end ]
    | Nis'297 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'288 | Ninit Nis'303 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'286 | Ninit Nis'301 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 => true
            | _ => false
          end ]
    | Nis'298 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 => true
            | _ => false
          end ]
    | Nis'299 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'298 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 => true
            | _ => false
          end ]
    | Nis'300 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'283 => true
            | _ => false
          end ]
    | Nis'301 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'277 | Ninit Nis'320 | Ninit Nis'323 | Ninit Nis'326 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'302 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'301 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'277 | Ninit Nis'320 | Ninit Nis'323 | Ninit Nis'326 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'303 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'301 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'277 | Ninit Nis'320 | Ninit Nis'323 | Ninit Nis'326 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'304 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'303 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'301 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'277 | Ninit Nis'320 | Ninit Nis'323 | Ninit Nis'326 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'305 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'306 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'305 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'307 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'49 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'308 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'45 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'309 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'308 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'45 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'310 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'309 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'308 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'45 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'311 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'310 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'309 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'308 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'45 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'312 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'43 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'313 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'42 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'41 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 | Ninit Nis'38 | Ninit Nis'315 | Ninit Nis'318 => true
            | _ => false
          end ]
    | Nis'314 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'34 | Ninit Nis'315 => true
            | _ => false
          end ]
    | Nis'315 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'316 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'315 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'317 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'316 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'315 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'318 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'316 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'315 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'319 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'318 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'316 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'315 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'31 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'170 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'219 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'320 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'29 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'28 | Ninit Nis'43 => true
            | _ => false
          end ]
    | Nis'321 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'320 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'29 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'28 | Ninit Nis'43 => true
            | _ => false
          end ]
    | Nis'322 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'28 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'323 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'25 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'324 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'323 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'325 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'324 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'323 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'46 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'326 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'24 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'21 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'327 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'326 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'24 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'21 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'328 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'21 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 | Ninit Nis'21 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'28 | Ninit Nis'29 | Ninit Nis'42 | Ninit Nis'43 | Ninit Nis'46 | Ninit Nis'49 | Ninit Nis'50 | Ninit Nis'61 | Ninit Nis'63 | Ninit Nis'69 | Ninit Nis'83 | Ninit Nis'85 | Ninit Nis'87 | Ninit Nis'89 | Ninit Nis'91 | Ninit Nis'95 | Ninit Nis'97 | Ninit Nis'99 | Ninit Nis'102 | Ninit Nis'105 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'112 | Ninit Nis'114 | Ninit Nis'116 | Ninit Nis'118 | Ninit Nis'120 | Ninit Nis'122 | Ninit Nis'125 | Ninit Nis'131 | Ninit Nis'134 | Ninit Nis'137 | Ninit Nis'143 | Ninit Nis'145 | Ninit Nis'162 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'253 | Ninit Nis'261 | Ninit Nis'279 | Ninit Nis'280 | Ninit Nis'283 | Ninit Nis'288 | Ninit Nis'294 | Ninit Nis'298 | Ninit Nis'303 | Ninit Nis'324 | Ninit Nis'350 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'365 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'388 | Ninit Nis'389 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'394 | Ninit Nis'395 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'403 | Ninit Nis'405 | Ninit Nis'426 | Ninit Nis'432 | Ninit Nis'435 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'442 | Ninit Nis'443 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'450 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'462 | Ninit Nis'465 | Ninit Nis'466 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'473 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'481 | Ninit Nis'486 | Ninit Nis'487 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'504 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'511 | Ninit Nis'512 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'519 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'525 | Ninit Nis'526 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'329 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'15 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'330 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'329 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'15 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'24 | Ninit Nis'25 | Ninit Nis'29 | Ninit Nis'32 | Ninit Nis'50 | Ninit Nis'162 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'167 | Ninit Nis'170 | Ninit Nis'175 | Ninit Nis'176 | Ninit Nis'186 | Ninit Nis'191 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'203 | Ninit Nis'207 | Ninit Nis'209 | Ninit Nis'211 | Ninit Nis'219 | Ninit Nis'224 | Ninit Nis'226 | Ninit Nis'235 | Ninit Nis'237 | Ninit Nis'243 | Ninit Nis'252 | Ninit Nis'265 | Ninit Nis'272 | Ninit Nis'309 | Ninit Nis'333 | Ninit Nis'342 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'331 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'333 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'334 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'333 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'335 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'336 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'333 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'337 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'338 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'456 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'339 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end ]
    | Nis'340 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end ]
    | Nis'341 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end ]
    | Nis'342 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'339 => true
            | _ => false
          end ]
    | Nis'343 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'344 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'342 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'339 => true
            | _ => false
          end ]
    | Nis'345 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'344 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'342 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'341 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'339 => true
            | _ => false
          end ]
    | Nis'346 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'344 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'347 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'346 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'344 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'342 => true
            | _ => false
          end ]
    | Nis'348 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'349 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'348 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'350 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 | Ninit Nis'564 => true
            | _ => false
          end ]
    | Nis'351 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'352 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'351 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'353 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'351 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'354 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'353 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'351 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'355 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'356 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'355 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'357 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'356 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'355 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'358 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'357 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'356 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'355 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'359 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'360 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'361 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'360 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'362 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'360 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'363 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'362 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'360 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'364 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'365 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'364 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'366 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'367 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'366 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'368 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'367 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'366 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'369 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'368 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'367 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'366 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'370 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'371 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'370 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'372 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'370 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'373 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'372 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'370 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'374 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'375 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'374 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'376 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'375 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'374 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'377 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'376 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'375 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'374 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'378 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'379 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'378 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'380 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'381 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'382 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'383 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'384 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'385 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'384 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'386 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'385 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'384 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'387 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'388 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'389 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'390 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'391 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'392 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'393 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'394 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'395 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'396 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'397 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'398 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'399 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'400 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'399 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'401 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'402 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'401 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'403 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'404 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'403 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'405 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'404 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'403 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'406 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'407 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'406 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'408 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'409 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'408 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'410 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'409 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'408 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'411 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'410 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'409 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'408 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'412 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'411 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'410 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'409 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'408 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'413 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'405 | Ninit Nis'489 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'404 | Ninit Nis'488 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'403 | Ninit Nis'487 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'414 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'415 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'416 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'417 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'418 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'419 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'420 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'419 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'421 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'422 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'423 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'400 | Ninit Nis'486 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'399 | Ninit Nis'485 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'424 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'425 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'424 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'426 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'425 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'424 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'427 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'426 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'425 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'424 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'428 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'427 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'426 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'425 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'424 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'429 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'428 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'427 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'426 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'425 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'424 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'430 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'391 | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'431 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'432 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'431 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'433 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'432 | Ninit Nis'501 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'431 | Ninit Nis'500 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'434 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'435 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'434 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'436 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'435 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'434 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'437 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'436 | Ninit Nis'505 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'435 | Ninit Nis'504 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'434 | Ninit Nis'503 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'438 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'435 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'434 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'439 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'438 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'435 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'434 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'440 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'439 | Ninit Nis'508 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'438 | Ninit Nis'507 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'435 | Ninit Nis'504 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'434 | Ninit Nis'503 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'441 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'442 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'443 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'444 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'443 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'445 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'444 | Ninit Nis'513 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'443 | Ninit Nis'512 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'446 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'443 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'447 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'446 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'443 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'448 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'447 | Ninit Nis'516 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'446 | Ninit Nis'515 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'443 | Ninit Nis'512 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'449 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'450 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'449 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'451 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'450 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'449 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'452 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'451 | Ninit Nis'520 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'450 | Ninit Nis'519 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'449 | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'453 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'450 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'449 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'454 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'453 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'450 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'449 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'455 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'454 | Ninit Nis'523 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'453 | Ninit Nis'522 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'450 | Ninit Nis'519 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'449 | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'442 | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'441 | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'456 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'457 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'456 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'458 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'457 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'456 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'388 | Ninit Nis'394 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'459 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'457 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'456 => true
            | _ => false
          end ]
    | Nis'460 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'459 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'457 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'456 => true
            | _ => false
          end ]
    | Nis'461 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'462 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'461 | Ninit Nis'564 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'463 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'462 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'461 | Ninit Nis'564 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'456 | Ninit Nis'459 => true
            | _ => false
          end ]
    | Nis'464 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'337 | Ninit Nis'456 => true
            | _ => false
          end ]
    | Nis'465 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'466 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'467 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'466 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'468 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'467 | Ninit Nis'527 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'466 | Ninit Nis'526 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'469 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'466 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'470 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'469 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'466 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'471 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'470 | Ninit Nis'530 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'469 | Ninit Nis'529 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'466 | Ninit Nis'526 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'472 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'473 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'472 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'474 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'473 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'472 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'475 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'474 | Ninit Nis'534 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'473 | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'472 | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'476 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'473 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'472 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'477 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'476 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'473 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'472 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'478 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'477 | Ninit Nis'537 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'476 | Ninit Nis'536 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'473 | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'472 | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'465 | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'479 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'480 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'479 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'481 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'480 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'479 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'482 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'481 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'480 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'479 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'483 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'482 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'481 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'480 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'479 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'484 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'483 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'482 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'481 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'480 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'479 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'485 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'486 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'485 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'487 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'488 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'487 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'489 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'488 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'487 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'490 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'489 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'488 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'487 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'491 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'492 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'493 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'494 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'495 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'496 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'497 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'498 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'486 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'485 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'499 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'500 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'501 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'500 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'502 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'501 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'500 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'503 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'504 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'503 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'505 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'504 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'503 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'506 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'505 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'504 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'503 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'507 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'504 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'503 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'508 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'507 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'504 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'503 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'509 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'508 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'507 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'504 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'503 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'510 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'511 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'512 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'513 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'512 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'514 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'513 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'512 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'515 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'512 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'516 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'515 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'512 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'517 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'516 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'515 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'512 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'518 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'519 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'520 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'519 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'521 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'520 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'519 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'522 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'519 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'523 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'522 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'519 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'524 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'523 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'522 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'519 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'525 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'526 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'527 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'526 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'528 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'527 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'526 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'529 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'526 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'530 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'529 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'526 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'531 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'530 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'529 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'526 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'532 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'533 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'534 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'535 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'534 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'536 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'537 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'536 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'538 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'537 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'536 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'525 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'388 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'539 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'540 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'541 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'542 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'540 | Ninit Nis'551 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 | Ninit Nis'550 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'367 | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'366 | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'543 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'367 | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'366 | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'544 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'379 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'378 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'545 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'365 | Ninit Nis'379 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'364 | Ninit Nis'378 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'546 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'377 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'376 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'375 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'374 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'547 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'358 | Ninit Nis'377 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'357 | Ninit Nis'376 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'356 | Ninit Nis'375 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'355 | Ninit Nis'374 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'548 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'373 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'372 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'370 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 => true
            | _ => false
          end ]
    | Nis'549 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'354 | Ninit Nis'373 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'353 | Ninit Nis'372 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'371 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'351 | Ninit Nis'370 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'550 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'367 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'366 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'551 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'550 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'367 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'366 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'551 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'552 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 | Ninit Nis'564 => true
            | _ => false
          end ]
    | Nis'553 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'554 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'555 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 | Ninit Nis'556 => true
            | _ => false
          end ]
    | Nis'556 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 | Ninit Nis'564 => true
            | _ => false
          end ]
    | Nis'557 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'556 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'349 | Ninit Nis'350 | Ninit Nis'354 | Ninit Nis'358 | Ninit Nis'365 | Ninit Nis'369 | Ninit Nis'373 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'383 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'400 | Ninit Nis'405 | Ninit Nis'432 | Ninit Nis'436 | Ninit Nis'439 | Ninit Nis'444 | Ninit Nis'447 | Ninit Nis'451 | Ninit Nis'454 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'474 | Ninit Nis'477 | Ninit Nis'486 | Ninit Nis'489 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'508 | Ninit Nis'513 | Ninit Nis'516 | Ninit Nis'520 | Ninit Nis'523 | Ninit Nis'527 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'551 | Ninit Nis'556 | Ninit Nis'564 => true
            | _ => false
          end ]
    | Nis'558 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'556 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 => true
            | _ => false
          end ]
    | Nis'559 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 => true
            | _ => false
          end ]
    | Nis'560 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'349 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'348 => true
            | _ => false
          end ]
    | Nis'561 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'349 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'348 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'562 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end ]
    | Nis'563 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end ]
    | Nis'564 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'565 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'564 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'337 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'566 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'333 => true
            | _ => false
          end ]
    | Nis'567 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
  end.

Extract Constant past_state_of_non_init_state => "fun _ -> assert false".

Definition items_of_state_0 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit_file'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |};
    {| prod_item := Prod'translation_unit_file'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_0 => "assert false".

Definition items_of_state_1 : list item :=
  [ {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_1 => "assert false".

Definition items_of_state_2 : list item :=
  [ {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_2 => "assert false".

Definition items_of_state_3 : list item :=
  [ {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_3 => "assert false".

Definition items_of_state_4 : list item :=
  [ {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 1;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_4 => "assert false".

Definition items_of_state_5 : list item :=
  [ {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_5 => "assert false".

Definition items_of_state_6 : list item :=
  [ {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_6 => "assert false".

Definition items_of_state_7 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_7 => "assert false".

Definition items_of_state_8 : list item :=
  [ {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 1;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_8 => "assert false".

Definition items_of_state_9 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_9 => "assert false".

Definition items_of_state_10 : list item :=
  [ {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_10 => "assert false".

Definition items_of_state_11 : list item :=
  [ {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_11 => "assert false".

Definition items_of_state_12 : list item :=
  [ {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_12 => "assert false".

Definition items_of_state_13 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_13 => "assert false".

Definition items_of_state_14 : list item :=
  [ {| prod_item := Prod'external_declaration'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_14 => "assert false".

Definition items_of_state_15 : list item :=
  [ {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_15 => "assert false".

Definition items_of_state_16 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_16 => "assert false".

Definition items_of_state_17 : list item :=
  [ {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_17 => "assert false".

Definition items_of_state_18 : list item :=
  [ {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_18 => "assert false".

Definition items_of_state_19 : list item :=
  [ {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_19 => "assert false".

Definition items_of_state_20 : list item :=
  [ {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_20 => "assert false".

Definition items_of_state_21 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_21 => "assert false".

Definition items_of_state_22 : list item :=
  [ {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_22 => "assert false".

Definition items_of_state_23 : list item :=
  [ {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_23 => "assert false".

Definition items_of_state_24 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_24 => "assert false".

Definition items_of_state_25 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_25 => "assert false".

Definition items_of_state_26 : list item :=
  [ {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_26 => "assert false".

Definition items_of_state_27 : list item :=
  [ {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_27 => "assert false".

Definition items_of_state_28 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_28 => "assert false".

Definition items_of_state_29 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_29 => "assert false".

Definition items_of_state_30 : list item :=
  [ {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_30 => "assert false".

Definition items_of_state_31 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_31 => "assert false".

Definition items_of_state_32 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_32 => "assert false".

Definition items_of_state_33 : list item :=
  [ {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_33 => "assert false".

Definition items_of_state_34 : list item :=
  [ {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'enumerator'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_34 => "assert false".

Definition items_of_state_35 : list item :=
  [ {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |} ].
Extract Inlined Constant items_of_state_35 => "assert false".

Definition items_of_state_36 : list item :=
  [ {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_36 => "assert false".

Definition items_of_state_37 : list item :=
  [ {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_37 => "assert false".

Definition items_of_state_38 : list item :=
  [ {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'enumerator'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_38 => "assert false".

Definition items_of_state_39 : list item :=
  [ {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 7;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_39 => "assert false".

Definition items_of_state_40 : list item :=
  [ {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_40 => "assert false".

Definition items_of_state_41 : list item :=
  [ {| prod_item := Prod'enumerator'0;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_41 => "assert false".

Definition items_of_state_42 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_42 => "assert false".

Definition items_of_state_43 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_43 => "assert false".

Definition items_of_state_44 : list item :=
  [ {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_44 => "assert false".

Definition items_of_state_45 : list item :=
  [ {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_45 => "assert false".

Definition items_of_state_46 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_46 => "assert false".

Definition items_of_state_47 : list item :=
  [ {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_47 => "assert false".

Definition items_of_state_48 : list item :=
  [ {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_48 => "assert false".

Definition items_of_state_49 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_49 => "assert false".

Definition items_of_state_50 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_50 => "assert false".

Definition items_of_state_51 : list item :=
  [ {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_51 => "assert false".

Definition items_of_state_52 : list item :=
  [ {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_52 => "assert false".

Definition items_of_state_53 : list item :=
  [ {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_53 => "assert false".

Definition items_of_state_54 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_54 => "assert false".

Definition items_of_state_55 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_55 => "assert false".

Definition items_of_state_56 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'gcc_attribute'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_56 => "assert false".

Definition items_of_state_57 : list item :=
  [ {| prod_item := Prod'gcc_attribute_word'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_57 => "assert false".

Definition items_of_state_58 : list item :=
  [ {| prod_item := Prod'gcc_attribute_word'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_58 => "assert false".

Definition items_of_state_59 : list item :=
  [ {| prod_item := Prod'gcc_attribute_word'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_59 => "assert false".

Definition items_of_state_60 : list item :=
  [ {| prod_item := Prod'gcc_attribute'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_60 => "assert false".

Definition items_of_state_61 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_61 => "assert false".

Definition items_of_state_62 : list item :=
  [ {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_62 => "assert false".

Definition items_of_state_63 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_63 => "assert false".

Definition items_of_state_64 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_64 => "assert false".

Definition items_of_state_65 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_65 => "assert false".

Definition items_of_state_66 : list item :=
  [ {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_66 => "assert false".

Definition items_of_state_67 : list item :=
  [ {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_67 => "assert false".

Definition items_of_state_68 : list item :=
  [ {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_68 => "assert false".

Definition items_of_state_69 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_69 => "assert false".

Definition items_of_state_70 : list item :=
  [ {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_70 => "assert false".

Definition items_of_state_71 : list item :=
  [ {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'8;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'9;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'10;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_71 => "assert false".

Definition items_of_state_72 : list item :=
  [ {| prod_item := Prod'assignment_operator'8;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_72 => "assert false".

Definition items_of_state_73 : list item :=
  [ {| prod_item := Prod'assignment_operator'5;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_73 => "assert false".

Definition items_of_state_74 : list item :=
  [ {| prod_item := Prod'assignment_operator'7;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_74 => "assert false".

Definition items_of_state_75 : list item :=
  [ {| prod_item := Prod'assignment_operator'9;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_75 => "assert false".

Definition items_of_state_76 : list item :=
  [ {| prod_item := Prod'assignment_operator'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_76 => "assert false".

Definition items_of_state_77 : list item :=
  [ {| prod_item := Prod'assignment_operator'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_77 => "assert false".

Definition items_of_state_78 : list item :=
  [ {| prod_item := Prod'assignment_operator'6;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_78 => "assert false".

Definition items_of_state_79 : list item :=
  [ {| prod_item := Prod'assignment_operator'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_79 => "assert false".

Definition items_of_state_80 : list item :=
  [ {| prod_item := Prod'assignment_operator'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_80 => "assert false".

Definition items_of_state_81 : list item :=
  [ {| prod_item := Prod'assignment_operator'10;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_81 => "assert false".

Definition items_of_state_82 : list item :=
  [ {| prod_item := Prod'assignment_operator'4;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_82 => "assert false".

Definition items_of_state_83 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_83 => "assert false".

Definition items_of_state_84 : list item :=
  [ {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_84 => "assert false".

Definition items_of_state_85 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_85 => "assert false".

Definition items_of_state_86 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_86 => "assert false".

Definition items_of_state_87 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_87 => "assert false".

Definition items_of_state_88 : list item :=
  [ {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_88 => "assert false".

Definition items_of_state_89 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_89 => "assert false".

Definition items_of_state_90 : list item :=
  [ {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_90 => "assert false".

Definition items_of_state_91 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_91 => "assert false".

Definition items_of_state_92 : list item :=
  [ {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 3;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_92 => "assert false".

Definition items_of_state_93 : list item :=
  [ {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_93 => "assert false".

Definition items_of_state_94 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_94 => "assert false".

Definition items_of_state_95 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_95 => "assert false".

Definition items_of_state_96 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_96 => "assert false".

Definition items_of_state_97 : list item :=
  [ {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_97 => "assert false".

Definition items_of_state_98 : list item :=
  [ {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_98 => "assert false".

Definition items_of_state_99 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_99 => "assert false".

Definition items_of_state_100 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_100 => "assert false".

Definition items_of_state_101 : list item :=
  [ {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_101 => "assert false".

Definition items_of_state_102 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_102 => "assert false".

Definition items_of_state_103 : list item :=
  [ {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_103 => "assert false".

Definition items_of_state_104 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_104 => "assert false".

Definition items_of_state_105 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_105 => "assert false".

Definition items_of_state_106 : list item :=
  [ {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_106 => "assert false".

Definition items_of_state_107 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_107 => "assert false".

Definition items_of_state_108 : list item :=
  [ {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_108 => "assert false".

Definition items_of_state_109 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_109 => "assert false".

Definition items_of_state_110 : list item :=
  [ {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_110 => "assert false".

Definition items_of_state_111 : list item :=
  [ {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |} ].
Extract Inlined Constant items_of_state_111 => "assert false".

Definition items_of_state_112 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_112 => "assert false".

Definition items_of_state_113 : list item :=
  [ {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |} ].
Extract Inlined Constant items_of_state_113 => "assert false".

Definition items_of_state_114 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_114 => "assert false".

Definition items_of_state_115 : list item :=
  [ {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_115 => "assert false".

Definition items_of_state_116 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_116 => "assert false".

Definition items_of_state_117 : list item :=
  [ {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_117 => "assert false".

Definition items_of_state_118 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_118 => "assert false".

Definition items_of_state_119 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_119 => "assert false".

Definition items_of_state_120 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_120 => "assert false".

Definition items_of_state_121 : list item :=
  [ {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_121 => "assert false".

Definition items_of_state_122 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_122 => "assert false".

Definition items_of_state_123 : list item :=
  [ {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_123 => "assert false".

Definition items_of_state_124 : list item :=
  [ {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_124 => "assert false".

Definition items_of_state_125 : list item :=
  [ {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_125 => "assert false".

Definition items_of_state_126 : list item :=
  [ {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_126 => "assert false".

Definition items_of_state_127 : list item :=
  [ {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_127 => "assert false".

Definition items_of_state_128 : list item :=
  [ {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_128 => "assert false".

Definition items_of_state_129 : list item :=
  [ {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_129 => "assert false".

Definition items_of_state_130 : list item :=
  [ {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_130 => "assert false".

Definition items_of_state_131 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_131 => "assert false".

Definition items_of_state_132 : list item :=
  [ {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_132 => "assert false".

Definition items_of_state_133 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_133 => "assert false".

Definition items_of_state_134 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_134 => "assert false".

Definition items_of_state_135 : list item :=
  [ {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 5;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_135 => "assert false".

Definition items_of_state_136 : list item :=
  [ {| prod_item := Prod'expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_136 => "assert false".

Definition items_of_state_137 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_137 => "assert false".

Definition items_of_state_138 : list item :=
  [ {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |} ].
Extract Inlined Constant items_of_state_138 => "assert false".

Definition items_of_state_139 : list item :=
  [ {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_139 => "assert false".

Definition items_of_state_140 : list item :=
  [ {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_140 => "assert false".

Definition items_of_state_141 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_141 => "assert false".

Definition items_of_state_142 : list item :=
  [ {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_142 => "assert false".

Definition items_of_state_143 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_143 => "assert false".

Definition items_of_state_144 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_144 => "assert false".

Definition items_of_state_145 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_145 => "assert false".

Definition items_of_state_146 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_146 => "assert false".

Definition items_of_state_147 : list item :=
  [ {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_147 => "assert false".

Definition items_of_state_148 : list item :=
  [ {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_148 => "assert false".

Definition items_of_state_149 : list item :=
  [ {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_149 => "assert false".

Definition items_of_state_150 : list item :=
  [ {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_150 => "assert false".

Definition items_of_state_151 : list item :=
  [ {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_151 => "assert false".

Definition items_of_state_152 : list item :=
  [ {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_152 => "assert false".

Definition items_of_state_153 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_153 => "assert false".

Definition items_of_state_154 : list item :=
  [ {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_154 => "assert false".

Definition items_of_state_155 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'gcc_attribute_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_155 => "assert false".

Definition items_of_state_156 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_156 => "assert false".

Definition items_of_state_157 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_157 => "assert false".

Definition items_of_state_158 : list item :=
  [ {| prod_item := Prod'gcc_attribute'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_158 => "assert false".

Definition items_of_state_159 : list item :=
  [ {| prod_item := Prod'gcc_attribute_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_159 => "assert false".

Definition items_of_state_160 : list item :=
  [ {| prod_item := Prod'gcc_attribute_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_160 => "assert false".

Definition items_of_state_161 : list item :=
  [ {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_161 => "assert false".

Definition items_of_state_162 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_162 => "assert false".

Definition items_of_state_163 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_163 => "assert false".

Definition items_of_state_164 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_164 => "assert false".

Definition items_of_state_165 : list item :=
  [ {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_165 => "assert false".

Definition items_of_state_166 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_166 => "assert false".

Definition items_of_state_167 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_167 => "assert false".

Definition items_of_state_168 : list item :=
  [ {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_168 => "assert false".

Definition items_of_state_169 : list item :=
  [ {| prod_item := Prod'struct_declaration_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_169 => "assert false".

Definition items_of_state_170 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_170 => "assert false".

Definition items_of_state_171 : list item :=
  [ {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_171 => "assert false".

Definition items_of_state_172 : list item :=
  [ {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_172 => "assert false".

Definition items_of_state_173 : list item :=
  [ {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't; COLON't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_173 => "assert false".

Definition items_of_state_174 : list item :=
  [ {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_174 => "assert false".

Definition items_of_state_175 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_175 => "assert false".

Definition items_of_state_176 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_176 => "assert false".

Definition items_of_state_177 : list item :=
  [ {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RPAREN't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LBRACK't; INC't; DEC't; CONSTANT't; CONST't; COMMA't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_177 => "assert false".

Definition items_of_state_178 : list item :=
  [ {| prod_item := Prod'pointer'3;
      dot_pos_item := 3;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_178 => "assert false".

Definition items_of_state_179 : list item :=
  [ {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_179 => "assert false".

Definition items_of_state_180 : list item :=
  [ {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RPAREN't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LBRACK't; INC't; DEC't; CONSTANT't; CONST't; COMMA't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_180 => "assert false".

Definition items_of_state_181 : list item :=
  [ {| prod_item := Prod'pointer'2;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_181 => "assert false".

Definition items_of_state_182 : list item :=
  [ {| prod_item := Prod'struct_declaration'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_182 => "assert false".

Definition items_of_state_183 : list item :=
  [ {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |} ].
Extract Inlined Constant items_of_state_183 => "assert false".

Definition items_of_state_184 : list item :=
  [ {| prod_item := Prod'declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; EQ't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_184 => "assert false".

Definition items_of_state_185 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; EQ't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_185 => "assert false".

Definition items_of_state_186 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_186 => "assert false".

Definition items_of_state_187 : list item :=
  [ {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_187 => "assert false".

Definition items_of_state_188 : list item :=
  [ {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_188 => "assert false".

Definition items_of_state_189 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_189 => "assert false".

Definition items_of_state_190 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_190 => "assert false".

Definition items_of_state_191 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_191 => "assert false".

Definition items_of_state_192 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_192 => "assert false".

Definition items_of_state_193 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_193 => "assert false".

Definition items_of_state_194 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_194 => "assert false".

Definition items_of_state_195 : list item :=
  [ {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_195 => "assert false".

Definition items_of_state_196 : list item :=
  [ {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_196 => "assert false".

Definition items_of_state_197 : list item :=
  [ {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_197 => "assert false".

Definition items_of_state_198 : list item :=
  [ {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_198 => "assert false".

Definition items_of_state_199 : list item :=
  [ {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_199 => "assert false".

Definition items_of_state_200 : list item :=
  [ {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_200 => "assert false".

Definition items_of_state_201 : list item :=
  [ {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_201 => "assert false".

Definition items_of_state_202 : list item :=
  [ {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_202 => "assert false".

Definition items_of_state_203 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_203 => "assert false".

Definition items_of_state_204 : list item :=
  [ {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_204 => "assert false".

Definition items_of_state_205 : list item :=
  [ {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_205 => "assert false".

Definition items_of_state_206 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_206 => "assert false".

Definition items_of_state_207 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_207 => "assert false".

Definition items_of_state_208 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_208 => "assert false".

Definition items_of_state_209 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_209 => "assert false".

Definition items_of_state_210 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_210 => "assert false".

Definition items_of_state_211 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_211 => "assert false".

Definition items_of_state_212 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_212 => "assert false".

Definition items_of_state_213 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_213 => "assert false".

Definition items_of_state_214 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_214 => "assert false".

Definition items_of_state_215 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_215 => "assert false".

Definition items_of_state_216 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_216 => "assert false".

Definition items_of_state_217 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_217 => "assert false".

Definition items_of_state_218 : list item :=
  [ {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_218 => "assert false".

Definition items_of_state_219 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_219 => "assert false".

Definition items_of_state_220 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_220 => "assert false".

Definition items_of_state_221 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_221 => "assert false".

Definition items_of_state_222 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_222 => "assert false".

Definition items_of_state_223 : list item :=
  [ {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_223 => "assert false".

Definition items_of_state_224 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_224 => "assert false".

Definition items_of_state_225 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_225 => "assert false".

Definition items_of_state_226 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_226 => "assert false".

Definition items_of_state_227 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_227 => "assert false".

Definition items_of_state_228 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_228 => "assert false".

Definition items_of_state_229 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 5;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_229 => "assert false".

Definition items_of_state_230 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_230 => "assert false".

Definition items_of_state_231 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_231 => "assert false".

Definition items_of_state_232 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_232 => "assert false".

Definition items_of_state_233 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_233 => "assert false".

Definition items_of_state_234 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; EQ't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_234 => "assert false".

Definition items_of_state_235 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_235 => "assert false".

Definition items_of_state_236 : list item :=
  [ {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_236 => "assert false".

Definition items_of_state_237 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_237 => "assert false".

Definition items_of_state_238 : list item :=
  [ {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_238 => "assert false".

Definition items_of_state_239 : list item :=
  [ {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_239 => "assert false".

Definition items_of_state_240 : list item :=
  [ {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 5;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_240 => "assert false".

Definition items_of_state_241 : list item :=
  [ {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_241 => "assert false".

Definition items_of_state_242 : list item :=
  [ {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_242 => "assert false".

Definition items_of_state_243 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; LBRACE't; EQ't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_243 => "assert false".

Definition items_of_state_244 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; OTHER_NAME't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_244 => "assert false".

Definition items_of_state_245 : list item :=
  [ {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_245 => "assert false".

Definition items_of_state_246 : list item :=
  [ {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_246 => "assert false".

Definition items_of_state_247 : list item :=
  [ {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_247 => "assert false".

Definition items_of_state_248 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_248 => "assert false".

Definition items_of_state_249 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_249 => "assert false".

Definition items_of_state_250 : list item :=
  [ {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_250 => "assert false".

Definition items_of_state_251 : list item :=
  [ {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_251 => "assert false".

Definition items_of_state_252 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; LBRACE't; EQ't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_252 => "assert false".

Definition items_of_state_253 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'struct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_253 => "assert false".

Definition items_of_state_254 : list item :=
  [ {| prod_item := Prod'struct_declarator'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_254 => "assert false".

Definition items_of_state_255 : list item :=
  [ {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RBRACK't; RBRACE't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_255 => "assert false".

Definition items_of_state_256 : list item :=
  [ {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declarator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_256 => "assert false".

Definition items_of_state_257 : list item :=
  [ {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_257 => "assert false".

Definition items_of_state_258 : list item :=
  [ {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't; COLON't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'struct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_258 => "assert false".

Definition items_of_state_259 : list item :=
  [ {| prod_item := Prod'struct_declarator_list'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_259 => "assert false".

Definition items_of_state_260 : list item :=
  [ {| prod_item := Prod'struct_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_260 => "assert false".

Definition items_of_state_261 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_261 => "assert false".

Definition items_of_state_262 : list item :=
  [ {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_262 => "assert false".

Definition items_of_state_263 : list item :=
  [ {| prod_item := Prod'struct_declarator_list'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_263 => "assert false".

Definition items_of_state_264 : list item :=
  [ {| prod_item := Prod'struct_declaration_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_264 => "assert false".

Definition items_of_state_265 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_265 => "assert false".

Definition items_of_state_266 : list item :=
  [ {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_266 => "assert false".

Definition items_of_state_267 : list item :=
  [ {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |} ].
Extract Inlined Constant items_of_state_267 => "assert false".

Definition items_of_state_268 : list item :=
  [ {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |} ].
Extract Inlined Constant items_of_state_268 => "assert false".

Definition items_of_state_269 : list item :=
  [ {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_269 => "assert false".

Definition items_of_state_270 : list item :=
  [ {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_270 => "assert false".

Definition items_of_state_271 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_271 => "assert false".

Definition items_of_state_272 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_272 => "assert false".

Definition items_of_state_273 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |} ].
Extract Inlined Constant items_of_state_273 => "assert false".

Definition items_of_state_274 : list item :=
  [ {| prod_item := Prod'type_name'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_274 => "assert false".

Definition items_of_state_275 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_275 => "assert false".

Definition items_of_state_276 : list item :=
  [ {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_276 => "assert false".

Definition items_of_state_277 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_277 => "assert false".

Definition items_of_state_278 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_278 => "assert false".

Definition items_of_state_279 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'designation'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_279 => "assert false".

Definition items_of_state_280 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 1;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_280 => "assert false".

Definition items_of_state_281 : list item :=
  [ {| prod_item := Prod'designator'0;
      dot_pos_item := 2;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_281 => "assert false".

Definition items_of_state_282 : list item :=
  [ {| prod_item := Prod'designator'0;
      dot_pos_item := 3;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_282 => "assert false".

Definition items_of_state_283 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'designation'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_283 => "assert false".

Definition items_of_state_284 : list item :=
  [ {| prod_item := Prod'designator'1;
      dot_pos_item := 1;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_284 => "assert false".

Definition items_of_state_285 : list item :=
  [ {| prod_item := Prod'designator'1;
      dot_pos_item := 2;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_285 => "assert false".

Definition items_of_state_286 : list item :=
  [ {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_286 => "assert false".

Definition items_of_state_287 : list item :=
  [ {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_287 => "assert false".

Definition items_of_state_288 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'designation'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_288 => "assert false".

Definition items_of_state_289 : list item :=
  [ {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_289 => "assert false".

Definition items_of_state_290 : list item :=
  [ {| prod_item := Prod'designation'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_290 => "assert false".

Definition items_of_state_291 : list item :=
  [ {| prod_item := Prod'designation'0;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_291 => "assert false".

Definition items_of_state_292 : list item :=
  [ {| prod_item := Prod'designator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_292 => "assert false".

Definition items_of_state_293 : list item :=
  [ {| prod_item := Prod'designator_list'0;
      dot_pos_item := 1;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_293 => "assert false".

Definition items_of_state_294 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 3;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_294 => "assert false".

Definition items_of_state_295 : list item :=
  [ {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 4;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_295 => "assert false".

Definition items_of_state_296 : list item :=
  [ {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_296 => "assert false".

Definition items_of_state_297 : list item :=
  [ {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 3;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_297 => "assert false".

Definition items_of_state_298 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_298 => "assert false".

Definition items_of_state_299 : list item :=
  [ {| prod_item := Prod'initializer_list'0;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_299 => "assert false".

Definition items_of_state_300 : list item :=
  [ {| prod_item := Prod'initializer_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_300 => "assert false".

Definition items_of_state_301 : list item :=
  [ {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 5;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 5;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_301 => "assert false".

Definition items_of_state_302 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 6;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_302 => "assert false".

Definition items_of_state_303 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'designation'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 6;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_303 => "assert false".

Definition items_of_state_304 : list item :=
  [ {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 7;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_304 => "assert false".

Definition items_of_state_305 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_305 => "assert false".

Definition items_of_state_306 : list item :=
  [ {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_306 => "assert false".

Definition items_of_state_307 : list item :=
  [ {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_307 => "assert false".

Definition items_of_state_308 : list item :=
  [ {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_308 => "assert false".

Definition items_of_state_309 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_309 => "assert false".

Definition items_of_state_310 : list item :=
  [ {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 5;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_310 => "assert false".

Definition items_of_state_311 : list item :=
  [ {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 6;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_311 => "assert false".

Definition items_of_state_312 : list item :=
  [ {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_312 => "assert false".

Definition items_of_state_313 : list item :=
  [ {| prod_item := Prod'enumerator'1;
      dot_pos_item := 3;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_313 => "assert false".

Definition items_of_state_314 : list item :=
  [ {| prod_item := Prod'enumerator_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_314 => "assert false".

Definition items_of_state_315 : list item :=
  [ {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'enumerator'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_315 => "assert false".

Definition items_of_state_316 : list item :=
  [ {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_316 => "assert false".

Definition items_of_state_317 : list item :=
  [ {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_317 => "assert false".

Definition items_of_state_318 : list item :=
  [ {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'enumerator'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_318 => "assert false".

Definition items_of_state_319 : list item :=
  [ {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_319 => "assert false".

Definition items_of_state_320 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_320 => "assert false".

Definition items_of_state_321 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_321 => "assert false".

Definition items_of_state_322 : list item :=
  [ {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_322 => "assert false".

Definition items_of_state_323 : list item :=
  [ {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_323 => "assert false".

Definition items_of_state_324 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_324 => "assert false".

Definition items_of_state_325 : list item :=
  [ {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_325 => "assert false".

Definition items_of_state_326 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_326 => "assert false".

Definition items_of_state_327 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_327 => "assert false".

Definition items_of_state_328 : list item :=
  [ {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_328 => "assert false".

Definition items_of_state_329 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_329 => "assert false".

Definition items_of_state_330 : list item :=
  [ {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_330 => "assert false".

Definition items_of_state_331 : list item :=
  [ {| prod_item := Prod'translation_unit_file'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_331 => "assert false".

Definition items_of_state_333 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit_file'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_333 => "assert false".

Definition items_of_state_334 : list item :=
  [ {| prod_item := Prod'translation_unit_file'0;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_334 => "assert false".

Definition items_of_state_335 : list item :=
  [ {| prod_item := Prod'external_declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_335 => "assert false".

Definition items_of_state_336 : list item :=
  [ {| prod_item := Prod'translation_unit'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_336 => "assert false".

Definition items_of_state_337 : list item :=
  [ {| prod_item := Prod'declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'old_function_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'old_function_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |} ].
Extract Inlined Constant items_of_state_337 => "assert false".

Definition items_of_state_338 : list item :=
  [ {| prod_item := Prod'declaration'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_338 => "assert false".

Definition items_of_state_339 : list item :=
  [ {| prod_item := Prod'declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'old_function_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_339 => "assert false".

Definition items_of_state_340 : list item :=
  [ {| prod_item := Prod'old_function_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_340 => "assert false".

Definition items_of_state_341 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_341 => "assert false".

Definition items_of_state_342 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'identifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'identifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_342 => "assert false".

Definition items_of_state_343 : list item :=
  [ {| prod_item := Prod'identifier_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_343 => "assert false".

Definition items_of_state_344 : list item :=
  [ {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'identifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_344 => "assert false".

Definition items_of_state_345 : list item :=
  [ {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_345 => "assert false".

Definition items_of_state_346 : list item :=
  [ {| prod_item := Prod'identifier_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_346 => "assert false".

Definition items_of_state_347 : list item :=
  [ {| prod_item := Prod'identifier_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_347 => "assert false".

Definition items_of_state_348 : list item :=
  [ {| prod_item := Prod'declaration_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_348 => "assert false".

Definition items_of_state_349 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_349 => "assert false".

Definition items_of_state_350 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item_list'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item_list'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_350 => "assert false".

Definition items_of_state_351 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_351 => "assert false".

Definition items_of_state_352 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_352 => "assert false".

Definition items_of_state_353 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_353 => "assert false".

Definition items_of_state_354 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_354 => "assert false".

Definition items_of_state_355 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_355 => "assert false".

Definition items_of_state_356 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_356 => "assert false".

Definition items_of_state_357 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_357 => "assert false".

Definition items_of_state_358 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_358 => "assert false".

Definition items_of_state_359 : list item :=
  [ {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_359 => "assert false".

Definition items_of_state_360 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_360 => "assert false".

Definition items_of_state_361 : list item :=
  [ {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_361 => "assert false".

Definition items_of_state_362 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_362 => "assert false".

Definition items_of_state_363 : list item :=
  [ {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_363 => "assert false".

Definition items_of_state_364 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_364 => "assert false".

Definition items_of_state_365 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_365 => "assert false".

Definition items_of_state_366 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_366 => "assert false".

Definition items_of_state_367 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_367 => "assert false".

Definition items_of_state_368 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_368 => "assert false".

Definition items_of_state_369 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_369 => "assert false".

Definition items_of_state_370 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_370 => "assert false".

Definition items_of_state_371 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_371 => "assert false".

Definition items_of_state_372 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_372 => "assert false".

Definition items_of_state_373 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_373 => "assert false".

Definition items_of_state_374 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_374 => "assert false".

Definition items_of_state_375 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_375 => "assert false".

Definition items_of_state_376 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_376 => "assert false".

Definition items_of_state_377 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_377 => "assert false".

Definition items_of_state_378 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_378 => "assert false".

Definition items_of_state_379 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_379 => "assert false".

Definition items_of_state_380 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_380 => "assert false".

Definition items_of_state_381 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_381 => "assert false".

Definition items_of_state_382 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_382 => "assert false".

Definition items_of_state_383 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_383 => "assert false".

Definition items_of_state_384 : list item :=
  [ {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_384 => "assert false".

Definition items_of_state_385 : list item :=
  [ {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_385 => "assert false".

Definition items_of_state_386 : list item :=
  [ {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_386 => "assert false".

Definition items_of_state_387 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_387 => "assert false".

Definition items_of_state_388 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_388 => "assert false".

Definition items_of_state_389 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_389 => "assert false".

Definition items_of_state_390 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_390 => "assert false".

Definition items_of_state_391 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_391 => "assert false".

Definition items_of_state_392 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_392 => "assert false".

Definition items_of_state_393 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_393 => "assert false".

Definition items_of_state_394 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_394 => "assert false".

Definition items_of_state_395 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_395 => "assert false".

Definition items_of_state_396 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_396 => "assert false".

Definition items_of_state_397 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_397 => "assert false".

Definition items_of_state_398 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_398 => "assert false".

Definition items_of_state_399 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_399 => "assert false".

Definition items_of_state_400 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_400 => "assert false".

Definition items_of_state_401 : list item :=
  [ {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_401 => "assert false".

Definition items_of_state_402 : list item :=
  [ {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_402 => "assert false".

Definition items_of_state_403 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_403 => "assert false".

Definition items_of_state_404 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_404 => "assert false".

Definition items_of_state_405 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_405 => "assert false".

Definition items_of_state_406 : list item :=
  [ {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_406 => "assert false".

Definition items_of_state_407 : list item :=
  [ {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_407 => "assert false".

Definition items_of_state_408 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_408 => "assert false".

Definition items_of_state_409 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_409 => "assert false".

Definition items_of_state_410 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_410 => "assert false".

Definition items_of_state_411 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_411 => "assert false".

Definition items_of_state_412 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_412 => "assert false".

Definition items_of_state_413 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_413 => "assert false".

Definition items_of_state_414 : list item :=
  [ {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_414 => "assert false".

Definition items_of_state_415 : list item :=
  [ {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_415 => "assert false".

Definition items_of_state_416 : list item :=
  [ {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_416 => "assert false".

Definition items_of_state_417 : list item :=
  [ {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_417 => "assert false".

Definition items_of_state_418 : list item :=
  [ {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_418 => "assert false".

Definition items_of_state_419 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_419 => "assert false".

Definition items_of_state_420 : list item :=
  [ {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_420 => "assert false".

Definition items_of_state_421 : list item :=
  [ {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_421 => "assert false".

Definition items_of_state_422 : list item :=
  [ {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_422 => "assert false".

Definition items_of_state_423 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_423 => "assert false".

Definition items_of_state_424 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_424 => "assert false".

Definition items_of_state_425 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_425 => "assert false".

Definition items_of_state_426 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_426 => "assert false".

Definition items_of_state_427 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_427 => "assert false".

Definition items_of_state_428 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_428 => "assert false".

Definition items_of_state_429 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_429 => "assert false".

Definition items_of_state_430 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_430 => "assert false".

Definition items_of_state_431 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_431 => "assert false".

Definition items_of_state_432 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_432 => "assert false".

Definition items_of_state_433 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_433 => "assert false".

Definition items_of_state_434 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_434 => "assert false".

Definition items_of_state_435 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_435 => "assert false".

Definition items_of_state_436 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_436 => "assert false".

Definition items_of_state_437 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_437 => "assert false".

Definition items_of_state_438 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_438 => "assert false".

Definition items_of_state_439 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_439 => "assert false".

Definition items_of_state_440 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_440 => "assert false".

Definition items_of_state_441 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_441 => "assert false".

Definition items_of_state_442 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_442 => "assert false".

Definition items_of_state_443 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_443 => "assert false".

Definition items_of_state_444 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_444 => "assert false".

Definition items_of_state_445 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_445 => "assert false".

Definition items_of_state_446 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_446 => "assert false".

Definition items_of_state_447 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_447 => "assert false".

Definition items_of_state_448 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_448 => "assert false".

Definition items_of_state_449 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_449 => "assert false".

Definition items_of_state_450 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_450 => "assert false".

Definition items_of_state_451 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_451 => "assert false".

Definition items_of_state_452 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_452 => "assert false".

Definition items_of_state_453 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_453 => "assert false".

Definition items_of_state_454 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_454 => "assert false".

Definition items_of_state_455 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 9;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_455 => "assert false".

Definition items_of_state_456 : list item :=
  [ {| prod_item := Prod'declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; EQ't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |} ].
Extract Inlined Constant items_of_state_456 => "assert false".

Definition items_of_state_457 : list item :=
  [ {| prod_item := Prod'declaration'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_457 => "assert false".

Definition items_of_state_458 : list item :=
  [ {| prod_item := Prod'declaration'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_458 => "assert false".

Definition items_of_state_459 : list item :=
  [ {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; EQ't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |} ].
Extract Inlined Constant items_of_state_459 => "assert false".

Definition items_of_state_460 : list item :=
  [ {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_460 => "assert false".

Definition items_of_state_461 : list item :=
  [ {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_461 => "assert false".

Definition items_of_state_462 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_462 => "assert false".

Definition items_of_state_463 : list item :=
  [ {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_463 => "assert false".

Definition items_of_state_464 : list item :=
  [ {| prod_item := Prod'init_declarator_list'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_464 => "assert false".

Definition items_of_state_465 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_465 => "assert false".

Definition items_of_state_466 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_466 => "assert false".

Definition items_of_state_467 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_467 => "assert false".

Definition items_of_state_468 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_468 => "assert false".

Definition items_of_state_469 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_469 => "assert false".

Definition items_of_state_470 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_470 => "assert false".

Definition items_of_state_471 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_471 => "assert false".

Definition items_of_state_472 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_472 => "assert false".

Definition items_of_state_473 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_473 => "assert false".

Definition items_of_state_474 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_474 => "assert false".

Definition items_of_state_475 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_475 => "assert false".

Definition items_of_state_476 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_476 => "assert false".

Definition items_of_state_477 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_477 => "assert false".

Definition items_of_state_478 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_478 => "assert false".

Definition items_of_state_479 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_479 => "assert false".

Definition items_of_state_480 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_480 => "assert false".

Definition items_of_state_481 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_481 => "assert false".

Definition items_of_state_482 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_482 => "assert false".

Definition items_of_state_483 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_483 => "assert false".

Definition items_of_state_484 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_484 => "assert false".

Definition items_of_state_485 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_485 => "assert false".

Definition items_of_state_486 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_486 => "assert false".

Definition items_of_state_487 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_487 => "assert false".

Definition items_of_state_488 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_488 => "assert false".

Definition items_of_state_489 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_489 => "assert false".

Definition items_of_state_490 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_490 => "assert false".

Definition items_of_state_491 : list item :=
  [ {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_491 => "assert false".

Definition items_of_state_492 : list item :=
  [ {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_492 => "assert false".

Definition items_of_state_493 : list item :=
  [ {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_493 => "assert false".

Definition items_of_state_494 : list item :=
  [ {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_494 => "assert false".

Definition items_of_state_495 : list item :=
  [ {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_495 => "assert false".

Definition items_of_state_496 : list item :=
  [ {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_496 => "assert false".

Definition items_of_state_497 : list item :=
  [ {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_497 => "assert false".

Definition items_of_state_498 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_498 => "assert false".

Definition items_of_state_499 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_499 => "assert false".

Definition items_of_state_500 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_500 => "assert false".

Definition items_of_state_501 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_501 => "assert false".

Definition items_of_state_502 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_502 => "assert false".

Definition items_of_state_503 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_503 => "assert false".

Definition items_of_state_504 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_504 => "assert false".

Definition items_of_state_505 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_505 => "assert false".

Definition items_of_state_506 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_506 => "assert false".

Definition items_of_state_507 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_507 => "assert false".

Definition items_of_state_508 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_508 => "assert false".

Definition items_of_state_509 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_509 => "assert false".

Definition items_of_state_510 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_510 => "assert false".

Definition items_of_state_511 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_511 => "assert false".

Definition items_of_state_512 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_512 => "assert false".

Definition items_of_state_513 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_513 => "assert false".

Definition items_of_state_514 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_514 => "assert false".

Definition items_of_state_515 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_515 => "assert false".

Definition items_of_state_516 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_516 => "assert false".

Definition items_of_state_517 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_517 => "assert false".

Definition items_of_state_518 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_518 => "assert false".

Definition items_of_state_519 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_519 => "assert false".

Definition items_of_state_520 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_520 => "assert false".

Definition items_of_state_521 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_521 => "assert false".

Definition items_of_state_522 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_522 => "assert false".

Definition items_of_state_523 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_523 => "assert false".

Definition items_of_state_524 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 9;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_524 => "assert false".

Definition items_of_state_525 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_525 => "assert false".

Definition items_of_state_526 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_526 => "assert false".

Definition items_of_state_527 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_527 => "assert false".

Definition items_of_state_528 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_528 => "assert false".

Definition items_of_state_529 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_529 => "assert false".

Definition items_of_state_530 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_530 => "assert false".

Definition items_of_state_531 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_531 => "assert false".

Definition items_of_state_532 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_532 => "assert false".

Definition items_of_state_533 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_533 => "assert false".

Definition items_of_state_534 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_534 => "assert false".

Definition items_of_state_535 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_535 => "assert false".

Definition items_of_state_536 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_536 => "assert false".

Definition items_of_state_537 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_537 => "assert false".

Definition items_of_state_538 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_538 => "assert false".

Definition items_of_state_539 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_539 => "assert false".

Definition items_of_state_540 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_540 => "assert false".

Definition items_of_state_541 : list item :=
  [ {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_541 => "assert false".

Definition items_of_state_542 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_542 => "assert false".

Definition items_of_state_543 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_543 => "assert false".

Definition items_of_state_544 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_544 => "assert false".

Definition items_of_state_545 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_545 => "assert false".

Definition items_of_state_546 : list item :=
  [ {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_546 => "assert false".

Definition items_of_state_547 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_547 => "assert false".

Definition items_of_state_548 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_548 => "assert false".

Definition items_of_state_549 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_549 => "assert false".

Definition items_of_state_550 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_550 => "assert false".

Definition items_of_state_551 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_551 => "assert false".

Definition items_of_state_552 : list item :=
  [ {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_552 => "assert false".

Definition items_of_state_553 : list item :=
  [ {| prod_item := Prod'block_item'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_553 => "assert false".

Definition items_of_state_554 : list item :=
  [ {| prod_item := Prod'block_item'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_554 => "assert false".

Definition items_of_state_555 : list item :=
  [ {| prod_item := Prod'block_item'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_555 => "assert false".

Definition items_of_state_556 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item_list'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_556 => "assert false".

Definition items_of_state_557 : list item :=
  [ {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_557 => "assert false".

Definition items_of_state_558 : list item :=
  [ {| prod_item := Prod'block_item_list'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_558 => "assert false".

Definition items_of_state_559 : list item :=
  [ {| prod_item := Prod'block_item_list'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_559 => "assert false".

Definition items_of_state_560 : list item :=
  [ {| prod_item := Prod'declaration_list'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_560 => "assert false".

Definition items_of_state_561 : list item :=
  [ {| prod_item := Prod'function_definition'1;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_561 => "assert false".

Definition items_of_state_562 : list item :=
  [ {| prod_item := Prod'old_function_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_562 => "assert false".

Definition items_of_state_563 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_563 => "assert false".

Definition items_of_state_564 : list item :=
  [ {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_564 => "assert false".

Definition items_of_state_565 : list item :=
  [ {| prod_item := Prod'function_definition'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_565 => "assert false".

Definition items_of_state_566 : list item :=
  [ {| prod_item := Prod'external_declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_566 => "assert false".

Definition items_of_state_567 : list item :=
  [ {| prod_item := Prod'translation_unit'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_567 => "assert false".

Definition items_of_state (s:state) : list item :=
  match s with
    | Init Init'0 => items_of_state_0
    | Ninit Nis'1 => items_of_state_1
    | Ninit Nis'2 => items_of_state_2
    | Ninit Nis'3 => items_of_state_3
    | Ninit Nis'4 => items_of_state_4
    | Ninit Nis'5 => items_of_state_5
    | Ninit Nis'6 => items_of_state_6
    | Ninit Nis'7 => items_of_state_7
    | Ninit Nis'8 => items_of_state_8
    | Ninit Nis'9 => items_of_state_9
    | Ninit Nis'10 => items_of_state_10
    | Ninit Nis'11 => items_of_state_11
    | Ninit Nis'12 => items_of_state_12
    | Ninit Nis'13 => items_of_state_13
    | Ninit Nis'14 => items_of_state_14
    | Ninit Nis'15 => items_of_state_15
    | Ninit Nis'16 => items_of_state_16
    | Ninit Nis'17 => items_of_state_17
    | Ninit Nis'18 => items_of_state_18
    | Ninit Nis'19 => items_of_state_19
    | Ninit Nis'20 => items_of_state_20
    | Ninit Nis'21 => items_of_state_21
    | Ninit Nis'22 => items_of_state_22
    | Ninit Nis'23 => items_of_state_23
    | Ninit Nis'24 => items_of_state_24
    | Ninit Nis'25 => items_of_state_25
    | Ninit Nis'26 => items_of_state_26
    | Ninit Nis'27 => items_of_state_27
    | Ninit Nis'28 => items_of_state_28
    | Ninit Nis'29 => items_of_state_29
    | Ninit Nis'30 => items_of_state_30
    | Ninit Nis'31 => items_of_state_31
    | Ninit Nis'32 => items_of_state_32
    | Ninit Nis'33 => items_of_state_33
    | Ninit Nis'34 => items_of_state_34
    | Ninit Nis'35 => items_of_state_35
    | Ninit Nis'36 => items_of_state_36
    | Ninit Nis'37 => items_of_state_37
    | Ninit Nis'38 => items_of_state_38
    | Ninit Nis'39 => items_of_state_39
    | Ninit Nis'40 => items_of_state_40
    | Ninit Nis'41 => items_of_state_41
    | Ninit Nis'42 => items_of_state_42
    | Ninit Nis'43 => items_of_state_43
    | Ninit Nis'44 => items_of_state_44
    | Ninit Nis'45 => items_of_state_45
    | Ninit Nis'46 => items_of_state_46
    | Ninit Nis'47 => items_of_state_47
    | Ninit Nis'48 => items_of_state_48
    | Ninit Nis'49 => items_of_state_49
    | Ninit Nis'50 => items_of_state_50
    | Ninit Nis'51 => items_of_state_51
    | Ninit Nis'52 => items_of_state_52
    | Ninit Nis'53 => items_of_state_53
    | Ninit Nis'54 => items_of_state_54
    | Ninit Nis'55 => items_of_state_55
    | Ninit Nis'56 => items_of_state_56
    | Ninit Nis'57 => items_of_state_57
    | Ninit Nis'58 => items_of_state_58
    | Ninit Nis'59 => items_of_state_59
    | Ninit Nis'60 => items_of_state_60
    | Ninit Nis'61 => items_of_state_61
    | Ninit Nis'62 => items_of_state_62
    | Ninit Nis'63 => items_of_state_63
    | Ninit Nis'64 => items_of_state_64
    | Ninit Nis'65 => items_of_state_65
    | Ninit Nis'66 => items_of_state_66
    | Ninit Nis'67 => items_of_state_67
    | Ninit Nis'68 => items_of_state_68
    | Ninit Nis'69 => items_of_state_69
    | Ninit Nis'70 => items_of_state_70
    | Ninit Nis'71 => items_of_state_71
    | Ninit Nis'72 => items_of_state_72
    | Ninit Nis'73 => items_of_state_73
    | Ninit Nis'74 => items_of_state_74
    | Ninit Nis'75 => items_of_state_75
    | Ninit Nis'76 => items_of_state_76
    | Ninit Nis'77 => items_of_state_77
    | Ninit Nis'78 => items_of_state_78
    | Ninit Nis'79 => items_of_state_79
    | Ninit Nis'80 => items_of_state_80
    | Ninit Nis'81 => items_of_state_81
    | Ninit Nis'82 => items_of_state_82
    | Ninit Nis'83 => items_of_state_83
    | Ninit Nis'84 => items_of_state_84
    | Ninit Nis'85 => items_of_state_85
    | Ninit Nis'86 => items_of_state_86
    | Ninit Nis'87 => items_of_state_87
    | Ninit Nis'88 => items_of_state_88
    | Ninit Nis'89 => items_of_state_89
    | Ninit Nis'90 => items_of_state_90
    | Ninit Nis'91 => items_of_state_91
    | Ninit Nis'92 => items_of_state_92
    | Ninit Nis'93 => items_of_state_93
    | Ninit Nis'94 => items_of_state_94
    | Ninit Nis'95 => items_of_state_95
    | Ninit Nis'96 => items_of_state_96
    | Ninit Nis'97 => items_of_state_97
    | Ninit Nis'98 => items_of_state_98
    | Ninit Nis'99 => items_of_state_99
    | Ninit Nis'100 => items_of_state_100
    | Ninit Nis'101 => items_of_state_101
    | Ninit Nis'102 => items_of_state_102
    | Ninit Nis'103 => items_of_state_103
    | Ninit Nis'104 => items_of_state_104
    | Ninit Nis'105 => items_of_state_105
    | Ninit Nis'106 => items_of_state_106
    | Ninit Nis'107 => items_of_state_107
    | Ninit Nis'108 => items_of_state_108
    | Ninit Nis'109 => items_of_state_109
    | Ninit Nis'110 => items_of_state_110
    | Ninit Nis'111 => items_of_state_111
    | Ninit Nis'112 => items_of_state_112
    | Ninit Nis'113 => items_of_state_113
    | Ninit Nis'114 => items_of_state_114
    | Ninit Nis'115 => items_of_state_115
    | Ninit Nis'116 => items_of_state_116
    | Ninit Nis'117 => items_of_state_117
    | Ninit Nis'118 => items_of_state_118
    | Ninit Nis'119 => items_of_state_119
    | Ninit Nis'120 => items_of_state_120
    | Ninit Nis'121 => items_of_state_121
    | Ninit Nis'122 => items_of_state_122
    | Ninit Nis'123 => items_of_state_123
    | Ninit Nis'124 => items_of_state_124
    | Ninit Nis'125 => items_of_state_125
    | Ninit Nis'126 => items_of_state_126
    | Ninit Nis'127 => items_of_state_127
    | Ninit Nis'128 => items_of_state_128
    | Ninit Nis'129 => items_of_state_129
    | Ninit Nis'130 => items_of_state_130
    | Ninit Nis'131 => items_of_state_131
    | Ninit Nis'132 => items_of_state_132
    | Ninit Nis'133 => items_of_state_133
    | Ninit Nis'134 => items_of_state_134
    | Ninit Nis'135 => items_of_state_135
    | Ninit Nis'136 => items_of_state_136
    | Ninit Nis'137 => items_of_state_137
    | Ninit Nis'138 => items_of_state_138
    | Ninit Nis'139 => items_of_state_139
    | Ninit Nis'140 => items_of_state_140
    | Ninit Nis'141 => items_of_state_141
    | Ninit Nis'142 => items_of_state_142
    | Ninit Nis'143 => items_of_state_143
    | Ninit Nis'144 => items_of_state_144
    | Ninit Nis'145 => items_of_state_145
    | Ninit Nis'146 => items_of_state_146
    | Ninit Nis'147 => items_of_state_147
    | Ninit Nis'148 => items_of_state_148
    | Ninit Nis'149 => items_of_state_149
    | Ninit Nis'150 => items_of_state_150
    | Ninit Nis'151 => items_of_state_151
    | Ninit Nis'152 => items_of_state_152
    | Ninit Nis'153 => items_of_state_153
    | Ninit Nis'154 => items_of_state_154
    | Ninit Nis'155 => items_of_state_155
    | Ninit Nis'156 => items_of_state_156
    | Ninit Nis'157 => items_of_state_157
    | Ninit Nis'158 => items_of_state_158
    | Ninit Nis'159 => items_of_state_159
    | Ninit Nis'160 => items_of_state_160
    | Ninit Nis'161 => items_of_state_161
    | Ninit Nis'162 => items_of_state_162
    | Ninit Nis'163 => items_of_state_163
    | Ninit Nis'164 => items_of_state_164
    | Ninit Nis'165 => items_of_state_165
    | Ninit Nis'166 => items_of_state_166
    | Ninit Nis'167 => items_of_state_167
    | Ninit Nis'168 => items_of_state_168
    | Ninit Nis'169 => items_of_state_169
    | Ninit Nis'170 => items_of_state_170
    | Ninit Nis'171 => items_of_state_171
    | Ninit Nis'172 => items_of_state_172
    | Ninit Nis'173 => items_of_state_173
    | Ninit Nis'174 => items_of_state_174
    | Ninit Nis'175 => items_of_state_175
    | Ninit Nis'176 => items_of_state_176
    | Ninit Nis'177 => items_of_state_177
    | Ninit Nis'178 => items_of_state_178
    | Ninit Nis'179 => items_of_state_179
    | Ninit Nis'180 => items_of_state_180
    | Ninit Nis'181 => items_of_state_181
    | Ninit Nis'182 => items_of_state_182
    | Ninit Nis'183 => items_of_state_183
    | Ninit Nis'184 => items_of_state_184
    | Ninit Nis'185 => items_of_state_185
    | Ninit Nis'186 => items_of_state_186
    | Ninit Nis'187 => items_of_state_187
    | Ninit Nis'188 => items_of_state_188
    | Ninit Nis'189 => items_of_state_189
    | Ninit Nis'190 => items_of_state_190
    | Ninit Nis'191 => items_of_state_191
    | Ninit Nis'192 => items_of_state_192
    | Ninit Nis'193 => items_of_state_193
    | Ninit Nis'194 => items_of_state_194
    | Ninit Nis'195 => items_of_state_195
    | Ninit Nis'196 => items_of_state_196
    | Ninit Nis'197 => items_of_state_197
    | Ninit Nis'198 => items_of_state_198
    | Ninit Nis'199 => items_of_state_199
    | Ninit Nis'200 => items_of_state_200
    | Ninit Nis'201 => items_of_state_201
    | Ninit Nis'202 => items_of_state_202
    | Ninit Nis'203 => items_of_state_203
    | Ninit Nis'204 => items_of_state_204
    | Ninit Nis'205 => items_of_state_205
    | Ninit Nis'206 => items_of_state_206
    | Ninit Nis'207 => items_of_state_207
    | Ninit Nis'208 => items_of_state_208
    | Ninit Nis'209 => items_of_state_209
    | Ninit Nis'210 => items_of_state_210
    | Ninit Nis'211 => items_of_state_211
    | Ninit Nis'212 => items_of_state_212
    | Ninit Nis'213 => items_of_state_213
    | Ninit Nis'214 => items_of_state_214
    | Ninit Nis'215 => items_of_state_215
    | Ninit Nis'216 => items_of_state_216
    | Ninit Nis'217 => items_of_state_217
    | Ninit Nis'218 => items_of_state_218
    | Ninit Nis'219 => items_of_state_219
    | Ninit Nis'220 => items_of_state_220
    | Ninit Nis'221 => items_of_state_221
    | Ninit Nis'222 => items_of_state_222
    | Ninit Nis'223 => items_of_state_223
    | Ninit Nis'224 => items_of_state_224
    | Ninit Nis'225 => items_of_state_225
    | Ninit Nis'226 => items_of_state_226
    | Ninit Nis'227 => items_of_state_227
    | Ninit Nis'228 => items_of_state_228
    | Ninit Nis'229 => items_of_state_229
    | Ninit Nis'230 => items_of_state_230
    | Ninit Nis'231 => items_of_state_231
    | Ninit Nis'232 => items_of_state_232
    | Ninit Nis'233 => items_of_state_233
    | Ninit Nis'234 => items_of_state_234
    | Ninit Nis'235 => items_of_state_235
    | Ninit Nis'236 => items_of_state_236
    | Ninit Nis'237 => items_of_state_237
    | Ninit Nis'238 => items_of_state_238
    | Ninit Nis'239 => items_of_state_239
    | Ninit Nis'240 => items_of_state_240
    | Ninit Nis'241 => items_of_state_241
    | Ninit Nis'242 => items_of_state_242
    | Ninit Nis'243 => items_of_state_243
    | Ninit Nis'244 => items_of_state_244
    | Ninit Nis'245 => items_of_state_245
    | Ninit Nis'246 => items_of_state_246
    | Ninit Nis'247 => items_of_state_247
    | Ninit Nis'248 => items_of_state_248
    | Ninit Nis'249 => items_of_state_249
    | Ninit Nis'250 => items_of_state_250
    | Ninit Nis'251 => items_of_state_251
    | Ninit Nis'252 => items_of_state_252
    | Ninit Nis'253 => items_of_state_253
    | Ninit Nis'254 => items_of_state_254
    | Ninit Nis'255 => items_of_state_255
    | Ninit Nis'256 => items_of_state_256
    | Ninit Nis'257 => items_of_state_257
    | Ninit Nis'258 => items_of_state_258
    | Ninit Nis'259 => items_of_state_259
    | Ninit Nis'260 => items_of_state_260
    | Ninit Nis'261 => items_of_state_261
    | Ninit Nis'262 => items_of_state_262
    | Ninit Nis'263 => items_of_state_263
    | Ninit Nis'264 => items_of_state_264
    | Ninit Nis'265 => items_of_state_265
    | Ninit Nis'266 => items_of_state_266
    | Ninit Nis'267 => items_of_state_267
    | Ninit Nis'268 => items_of_state_268
    | Ninit Nis'269 => items_of_state_269
    | Ninit Nis'270 => items_of_state_270
    | Ninit Nis'271 => items_of_state_271
    | Ninit Nis'272 => items_of_state_272
    | Ninit Nis'273 => items_of_state_273
    | Ninit Nis'274 => items_of_state_274
    | Ninit Nis'275 => items_of_state_275
    | Ninit Nis'276 => items_of_state_276
    | Ninit Nis'277 => items_of_state_277
    | Ninit Nis'278 => items_of_state_278
    | Ninit Nis'279 => items_of_state_279
    | Ninit Nis'280 => items_of_state_280
    | Ninit Nis'281 => items_of_state_281
    | Ninit Nis'282 => items_of_state_282
    | Ninit Nis'283 => items_of_state_283
    | Ninit Nis'284 => items_of_state_284
    | Ninit Nis'285 => items_of_state_285
    | Ninit Nis'286 => items_of_state_286
    | Ninit Nis'287 => items_of_state_287
    | Ninit Nis'288 => items_of_state_288
    | Ninit Nis'289 => items_of_state_289
    | Ninit Nis'290 => items_of_state_290
    | Ninit Nis'291 => items_of_state_291
    | Ninit Nis'292 => items_of_state_292
    | Ninit Nis'293 => items_of_state_293
    | Ninit Nis'294 => items_of_state_294
    | Ninit Nis'295 => items_of_state_295
    | Ninit Nis'296 => items_of_state_296
    | Ninit Nis'297 => items_of_state_297
    | Ninit Nis'298 => items_of_state_298
    | Ninit Nis'299 => items_of_state_299
    | Ninit Nis'300 => items_of_state_300
    | Ninit Nis'301 => items_of_state_301
    | Ninit Nis'302 => items_of_state_302
    | Ninit Nis'303 => items_of_state_303
    | Ninit Nis'304 => items_of_state_304
    | Ninit Nis'305 => items_of_state_305
    | Ninit Nis'306 => items_of_state_306
    | Ninit Nis'307 => items_of_state_307
    | Ninit Nis'308 => items_of_state_308
    | Ninit Nis'309 => items_of_state_309
    | Ninit Nis'310 => items_of_state_310
    | Ninit Nis'311 => items_of_state_311
    | Ninit Nis'312 => items_of_state_312
    | Ninit Nis'313 => items_of_state_313
    | Ninit Nis'314 => items_of_state_314
    | Ninit Nis'315 => items_of_state_315
    | Ninit Nis'316 => items_of_state_316
    | Ninit Nis'317 => items_of_state_317
    | Ninit Nis'318 => items_of_state_318
    | Ninit Nis'319 => items_of_state_319
    | Ninit Nis'320 => items_of_state_320
    | Ninit Nis'321 => items_of_state_321
    | Ninit Nis'322 => items_of_state_322
    | Ninit Nis'323 => items_of_state_323
    | Ninit Nis'324 => items_of_state_324
    | Ninit Nis'325 => items_of_state_325
    | Ninit Nis'326 => items_of_state_326
    | Ninit Nis'327 => items_of_state_327
    | Ninit Nis'328 => items_of_state_328
    | Ninit Nis'329 => items_of_state_329
    | Ninit Nis'330 => items_of_state_330
    | Ninit Nis'331 => items_of_state_331
    | Ninit Nis'333 => items_of_state_333
    | Ninit Nis'334 => items_of_state_334
    | Ninit Nis'335 => items_of_state_335
    | Ninit Nis'336 => items_of_state_336
    | Ninit Nis'337 => items_of_state_337
    | Ninit Nis'338 => items_of_state_338
    | Ninit Nis'339 => items_of_state_339
    | Ninit Nis'340 => items_of_state_340
    | Ninit Nis'341 => items_of_state_341
    | Ninit Nis'342 => items_of_state_342
    | Ninit Nis'343 => items_of_state_343
    | Ninit Nis'344 => items_of_state_344
    | Ninit Nis'345 => items_of_state_345
    | Ninit Nis'346 => items_of_state_346
    | Ninit Nis'347 => items_of_state_347
    | Ninit Nis'348 => items_of_state_348
    | Ninit Nis'349 => items_of_state_349
    | Ninit Nis'350 => items_of_state_350
    | Ninit Nis'351 => items_of_state_351
    | Ninit Nis'352 => items_of_state_352
    | Ninit Nis'353 => items_of_state_353
    | Ninit Nis'354 => items_of_state_354
    | Ninit Nis'355 => items_of_state_355
    | Ninit Nis'356 => items_of_state_356
    | Ninit Nis'357 => items_of_state_357
    | Ninit Nis'358 => items_of_state_358
    | Ninit Nis'359 => items_of_state_359
    | Ninit Nis'360 => items_of_state_360
    | Ninit Nis'361 => items_of_state_361
    | Ninit Nis'362 => items_of_state_362
    | Ninit Nis'363 => items_of_state_363
    | Ninit Nis'364 => items_of_state_364
    | Ninit Nis'365 => items_of_state_365
    | Ninit Nis'366 => items_of_state_366
    | Ninit Nis'367 => items_of_state_367
    | Ninit Nis'368 => items_of_state_368
    | Ninit Nis'369 => items_of_state_369
    | Ninit Nis'370 => items_of_state_370
    | Ninit Nis'371 => items_of_state_371
    | Ninit Nis'372 => items_of_state_372
    | Ninit Nis'373 => items_of_state_373
    | Ninit Nis'374 => items_of_state_374
    | Ninit Nis'375 => items_of_state_375
    | Ninit Nis'376 => items_of_state_376
    | Ninit Nis'377 => items_of_state_377
    | Ninit Nis'378 => items_of_state_378
    | Ninit Nis'379 => items_of_state_379
    | Ninit Nis'380 => items_of_state_380
    | Ninit Nis'381 => items_of_state_381
    | Ninit Nis'382 => items_of_state_382
    | Ninit Nis'383 => items_of_state_383
    | Ninit Nis'384 => items_of_state_384
    | Ninit Nis'385 => items_of_state_385
    | Ninit Nis'386 => items_of_state_386
    | Ninit Nis'387 => items_of_state_387
    | Ninit Nis'388 => items_of_state_388
    | Ninit Nis'389 => items_of_state_389
    | Ninit Nis'390 => items_of_state_390
    | Ninit Nis'391 => items_of_state_391
    | Ninit Nis'392 => items_of_state_392
    | Ninit Nis'393 => items_of_state_393
    | Ninit Nis'394 => items_of_state_394
    | Ninit Nis'395 => items_of_state_395
    | Ninit Nis'396 => items_of_state_396
    | Ninit Nis'397 => items_of_state_397
    | Ninit Nis'398 => items_of_state_398
    | Ninit Nis'399 => items_of_state_399
    | Ninit Nis'400 => items_of_state_400
    | Ninit Nis'401 => items_of_state_401
    | Ninit Nis'402 => items_of_state_402
    | Ninit Nis'403 => items_of_state_403
    | Ninit Nis'404 => items_of_state_404
    | Ninit Nis'405 => items_of_state_405
    | Ninit Nis'406 => items_of_state_406
    | Ninit Nis'407 => items_of_state_407
    | Ninit Nis'408 => items_of_state_408
    | Ninit Nis'409 => items_of_state_409
    | Ninit Nis'410 => items_of_state_410
    | Ninit Nis'411 => items_of_state_411
    | Ninit Nis'412 => items_of_state_412
    | Ninit Nis'413 => items_of_state_413
    | Ninit Nis'414 => items_of_state_414
    | Ninit Nis'415 => items_of_state_415
    | Ninit Nis'416 => items_of_state_416
    | Ninit Nis'417 => items_of_state_417
    | Ninit Nis'418 => items_of_state_418
    | Ninit Nis'419 => items_of_state_419
    | Ninit Nis'420 => items_of_state_420
    | Ninit Nis'421 => items_of_state_421
    | Ninit Nis'422 => items_of_state_422
    | Ninit Nis'423 => items_of_state_423
    | Ninit Nis'424 => items_of_state_424
    | Ninit Nis'425 => items_of_state_425
    | Ninit Nis'426 => items_of_state_426
    | Ninit Nis'427 => items_of_state_427
    | Ninit Nis'428 => items_of_state_428
    | Ninit Nis'429 => items_of_state_429
    | Ninit Nis'430 => items_of_state_430
    | Ninit Nis'431 => items_of_state_431
    | Ninit Nis'432 => items_of_state_432
    | Ninit Nis'433 => items_of_state_433
    | Ninit Nis'434 => items_of_state_434
    | Ninit Nis'435 => items_of_state_435
    | Ninit Nis'436 => items_of_state_436
    | Ninit Nis'437 => items_of_state_437
    | Ninit Nis'438 => items_of_state_438
    | Ninit Nis'439 => items_of_state_439
    | Ninit Nis'440 => items_of_state_440
    | Ninit Nis'441 => items_of_state_441
    | Ninit Nis'442 => items_of_state_442
    | Ninit Nis'443 => items_of_state_443
    | Ninit Nis'444 => items_of_state_444
    | Ninit Nis'445 => items_of_state_445
    | Ninit Nis'446 => items_of_state_446
    | Ninit Nis'447 => items_of_state_447
    | Ninit Nis'448 => items_of_state_448
    | Ninit Nis'449 => items_of_state_449
    | Ninit Nis'450 => items_of_state_450
    | Ninit Nis'451 => items_of_state_451
    | Ninit Nis'452 => items_of_state_452
    | Ninit Nis'453 => items_of_state_453
    | Ninit Nis'454 => items_of_state_454
    | Ninit Nis'455 => items_of_state_455
    | Ninit Nis'456 => items_of_state_456
    | Ninit Nis'457 => items_of_state_457
    | Ninit Nis'458 => items_of_state_458
    | Ninit Nis'459 => items_of_state_459
    | Ninit Nis'460 => items_of_state_460
    | Ninit Nis'461 => items_of_state_461
    | Ninit Nis'462 => items_of_state_462
    | Ninit Nis'463 => items_of_state_463
    | Ninit Nis'464 => items_of_state_464
    | Ninit Nis'465 => items_of_state_465
    | Ninit Nis'466 => items_of_state_466
    | Ninit Nis'467 => items_of_state_467
    | Ninit Nis'468 => items_of_state_468
    | Ninit Nis'469 => items_of_state_469
    | Ninit Nis'470 => items_of_state_470
    | Ninit Nis'471 => items_of_state_471
    | Ninit Nis'472 => items_of_state_472
    | Ninit Nis'473 => items_of_state_473
    | Ninit Nis'474 => items_of_state_474
    | Ninit Nis'475 => items_of_state_475
    | Ninit Nis'476 => items_of_state_476
    | Ninit Nis'477 => items_of_state_477
    | Ninit Nis'478 => items_of_state_478
    | Ninit Nis'479 => items_of_state_479
    | Ninit Nis'480 => items_of_state_480
    | Ninit Nis'481 => items_of_state_481
    | Ninit Nis'482 => items_of_state_482
    | Ninit Nis'483 => items_of_state_483
    | Ninit Nis'484 => items_of_state_484
    | Ninit Nis'485 => items_of_state_485
    | Ninit Nis'486 => items_of_state_486
    | Ninit Nis'487 => items_of_state_487
    | Ninit Nis'488 => items_of_state_488
    | Ninit Nis'489 => items_of_state_489
    | Ninit Nis'490 => items_of_state_490
    | Ninit Nis'491 => items_of_state_491
    | Ninit Nis'492 => items_of_state_492
    | Ninit Nis'493 => items_of_state_493
    | Ninit Nis'494 => items_of_state_494
    | Ninit Nis'495 => items_of_state_495
    | Ninit Nis'496 => items_of_state_496
    | Ninit Nis'497 => items_of_state_497
    | Ninit Nis'498 => items_of_state_498
    | Ninit Nis'499 => items_of_state_499
    | Ninit Nis'500 => items_of_state_500
    | Ninit Nis'501 => items_of_state_501
    | Ninit Nis'502 => items_of_state_502
    | Ninit Nis'503 => items_of_state_503
    | Ninit Nis'504 => items_of_state_504
    | Ninit Nis'505 => items_of_state_505
    | Ninit Nis'506 => items_of_state_506
    | Ninit Nis'507 => items_of_state_507
    | Ninit Nis'508 => items_of_state_508
    | Ninit Nis'509 => items_of_state_509
    | Ninit Nis'510 => items_of_state_510
    | Ninit Nis'511 => items_of_state_511
    | Ninit Nis'512 => items_of_state_512
    | Ninit Nis'513 => items_of_state_513
    | Ninit Nis'514 => items_of_state_514
    | Ninit Nis'515 => items_of_state_515
    | Ninit Nis'516 => items_of_state_516
    | Ninit Nis'517 => items_of_state_517
    | Ninit Nis'518 => items_of_state_518
    | Ninit Nis'519 => items_of_state_519
    | Ninit Nis'520 => items_of_state_520
    | Ninit Nis'521 => items_of_state_521
    | Ninit Nis'522 => items_of_state_522
    | Ninit Nis'523 => items_of_state_523
    | Ninit Nis'524 => items_of_state_524
    | Ninit Nis'525 => items_of_state_525
    | Ninit Nis'526 => items_of_state_526
    | Ninit Nis'527 => items_of_state_527
    | Ninit Nis'528 => items_of_state_528
    | Ninit Nis'529 => items_of_state_529
    | Ninit Nis'530 => items_of_state_530
    | Ninit Nis'531 => items_of_state_531
    | Ninit Nis'532 => items_of_state_532
    | Ninit Nis'533 => items_of_state_533
    | Ninit Nis'534 => items_of_state_534
    | Ninit Nis'535 => items_of_state_535
    | Ninit Nis'536 => items_of_state_536
    | Ninit Nis'537 => items_of_state_537
    | Ninit Nis'538 => items_of_state_538
    | Ninit Nis'539 => items_of_state_539
    | Ninit Nis'540 => items_of_state_540
    | Ninit Nis'541 => items_of_state_541
    | Ninit Nis'542 => items_of_state_542
    | Ninit Nis'543 => items_of_state_543
    | Ninit Nis'544 => items_of_state_544
    | Ninit Nis'545 => items_of_state_545
    | Ninit Nis'546 => items_of_state_546
    | Ninit Nis'547 => items_of_state_547
    | Ninit Nis'548 => items_of_state_548
    | Ninit Nis'549 => items_of_state_549
    | Ninit Nis'550 => items_of_state_550
    | Ninit Nis'551 => items_of_state_551
    | Ninit Nis'552 => items_of_state_552
    | Ninit Nis'553 => items_of_state_553
    | Ninit Nis'554 => items_of_state_554
    | Ninit Nis'555 => items_of_state_555
    | Ninit Nis'556 => items_of_state_556
    | Ninit Nis'557 => items_of_state_557
    | Ninit Nis'558 => items_of_state_558
    | Ninit Nis'559 => items_of_state_559
    | Ninit Nis'560 => items_of_state_560
    | Ninit Nis'561 => items_of_state_561
    | Ninit Nis'562 => items_of_state_562
    | Ninit Nis'563 => items_of_state_563
    | Ninit Nis'564 => items_of_state_564
    | Ninit Nis'565 => items_of_state_565
    | Ninit Nis'566 => items_of_state_566
    | Ninit Nis'567 => items_of_state_567
  end.
Extract Constant items_of_state => "fun _ -> assert false".

End Aut.

Require Import Main.

Module Parser := Main.Make Aut.
Theorem safe:
  Parser.safe_validator () = true.
Proof eq_refl true<:Parser.safe_validator () = true.

Theorem complete:
  Parser.complete_validator () = true.
Proof eq_refl true<:Parser.complete_validator () = true.

Definition translation_unit_file := Parser.parse safe Aut.Init'0.

Theorem translation_unit_file_correct iterator buffer:
  match translation_unit_file iterator buffer with
    | Parser.Inter.Parsed_pr sem buffer_new =>
      exists word,
        buffer = Parser.Inter.app_str word buffer_new /\
        inhabited (Gram.parse_tree (NT translation_unit_file'nt) word sem)
    | _ => True
  end.
Proof. apply Parser.parse_correct. Qed.

Theorem translation_unit_file_complete (iterator:nat) word buffer_end (output:      (list definition)):
  forall tree:Gram.parse_tree (NT translation_unit_file'nt) word output,
  match translation_unit_file iterator (Parser.Inter.app_str word buffer_end) with
    | Parser.Inter.Fail_pr => False
    | Parser.Inter.Parsed_pr output_res buffer_end_res =>
      output_res = output /\ buffer_end_res = buffer_end  /\
      le (Gram.pt_size tree) iterator
    | Parser.Inter.Timeout_pr => lt iterator (Gram.pt_size tree)
  end.
Proof. apply Parser.parse_complete with (init:=Aut.Init'0); exact complete. Qed.

